-- 公共语言包

LANGUAGE_TIPS_LOCALERROR = "本地文件错误"
LANGUAGE_TIPS_PROGRESS = "下载进度"
LANGUAGE_TIPS_DOWNLOADERRO = "下载过程失败"
LANGUAGE_TIPS_GETTINGERROR = "解析配置文件失败"
LANGUAGE_TIPS_UNPACKING = "正在解压安装，请勿退出游戏"
LANGUAGE_TIPS_UPDATEOK = "更新完成!"
LANGUAGE_TIPS_UPDATEERROR = "更新失败!"
LANGUAGE_TIPS_WEBERROR = "网络请求失败"
LANGUAGE_OTHER_TXTPACKAGESIZE = "补丁包大小："

LANGUAGE_TIPS_BATTLE_SKIP = APP_REVIEW and "主角12级或至尊2开启跳过战斗功能" or "主角12级或VIP2开启跳过战斗功能"
LANGUAGE_TIPS_BATTLE_SPEED_2 = "主角" .. BATTLE_SPEED_2_FLAG_LEVEL .. "级开启加速战斗功能"
LANGUAGE_TIPS_BATTLE_SPEED_3 = "主角" .. BATTLE_SPEED_3_FLAG_LEVEL .. "级开启3倍加速战斗功能"

LANGUAGE_KEY_PASSTOWER_CONDITION = 
{        
    [1] = "我方总血量不低于",
    [2] = "主角不能死亡",
    [3] = "回合数不超过",
    [4] = "阵亡人数不超过",
    [5] = "敌方全灭",

}

function LANGUAGE_GETERRORTIP( errMsg )
    local _errMsg = "服务器异常，请重试"
    if type(errMsg) == "string" then
        _errMsg = errMsg
    end
    return _errMsg
end
function LANGUAGE_GET_CONDITION_BY_ID(_id, _needHead)
    local condition = (LANGUAGE_KEY_PASSTOWER_CONDITION[tonumber(_id)] or LANGUAGE_KEY_PASSTOWER_CONDITION[1])
    if _needHead then
        condition = "战斗胜利且"..condition
    end
    return condition
end

function LANGUAGE_KEY_BATTLE_ROUND_TXT(roundNow, roundAll)
    return "第"..tostring(roundNow).."/"..tostring(roundAll).."回合"
end

function LANGUAGE_KEY_BATTLE_WAVE_TXT(waveNow, waveAll)
    return "第"..tostring(waveNow).."/"..tostring(waveAll).."波"
end

function LANGUAGE_getReousrceNameById(_id)
    local _id = tonumber(_id) or 1
    local resourceName = {
        [1] = "元宝",
        [2] = "银币",
        [3] = "声望",
        [4] = "蓝宝石",
        [5] = "黄宝石",
        [6] = "紫宝石",
        [7] = "体力",
        [8] = "税金",
        [9] = "木材",
        [10] = "矿石",
        [11] = "武魂",
        [12] = "名将册体力",
        [13] = "将领技能点",
        [14] = "战功",
        [15] = "荣誉",
        [16] = "兑换",
        [17] = "粮食",
        [18] = "",
        [19] = "主线星数",
        [20] = "特训积分",
        [21] = "突破石",
        [22] = "挑战令",
        [23] = "武神榜积分",
        [24] = "灯灵",
    }
    local _text = resourceName[_id] or resourceName[1]
    return _text
end

function LANGUAGE_getGemAttrByType(_id)
    local __type = tonumber(_id) or 0
    local _config = {
        [4]  = "生命",
        [8]  = "物防",
        [12] = "策防",
        [30] = "攻击",
    }
    return _config[__type] or ""
end

function LANGUAGE_getReousrceDescById(_id) --资源的描述，暂时没有先用名字代替
    local _id = tonumber(_id) or 0
    local resourceDesc = { 
        [1] = "金灿灿的元宝，代表着财富的象征",
        [2] = "世界流通的基础货币。",
        [3] = "用于声望商店兑换道具的重要物资。",
        [4] = "发亮的宝石，用于购买突飞卡以及将领。",
        [5] = "发亮的宝石，用于购买突飞卡以及将领。",
        [6] = "发亮的宝石，用于购买突飞卡以及将领。",
        [7] = "体力代表着行动力的多少。",
        [8] = "在国家商店中进行兑换的重要物资。",
        [9] = "主城建造消耗的重要物资。",
        [10] = "主城建造消耗的重要物资。",
        [11] = "群雄兑换将领卡的重要物资。",
        [12] = "用于挑战群雄的门票。",
        [13] = "用于升级将领技能等级的物资。",
        [14] = "用于军功商店购买道具的物资。",
        [15] = "无。",
        [16] = "无。",
        [17] = "无。",
        [18] = "武神试炼中换取特殊效果的资源。",
        [19] = "用于激活或升级命格的重要物资。",
        [20] = "用于解锁极限挑战副本的重要物资。",
        [21] = "用于将领突破的重要物资。",
        [22] = "用于挑战兵器库副本的重要物资",
        [23] = "用于酒馆五虎上将卡包招募将领的重要物资",
        [24] = "用于灯魂商店兑换灯魂的重要物资",
    }
    local _text = resourceDesc[_id] or resourceDesc[1]
    return _text
end

--悍将属性定义名称 id与顺序一一对应， _isBase表示作用层级是不是自身
function LANGUAGE_getAttributeTextById(_id, _isBase)
    local _id = tonumber(_id) or 1
    local _isBase = _isBase
    local attributeText = { 
        [1] = "武力",--1.  武力(整数)
        [2] = "智力",--2.  智力(整数)
        [3] = "体力",--3.  体力(整数)
        [4] = "生命",-- 4.  生命值上限(整数)
        [5] = "生命",-- 5.  生命值上限加成(百分比)
        [6] = "物攻",-- 6.  物理攻击力(整数)
        [7] = "物攻",-- 7.  物理攻击力加成(百分比)
        [8] = "物防",-- 8.  物理防御力(整数)
        [9] = "物防",-- 9.  物理防御力加成(百分比)
        [10] = "策攻",-- 10. 策略攻击力(整数)
        [11] = "策攻",-- 11.  策略攻击力加成(百分比)
        [12] = "策防",-- 12.  策略防御力(整数)
        [13] = "策防",-- 13.  策略防御力加成(百分比)
        [14] = "命中",-- 14.  命中率(百分比)
        [15] = "闪避",-- 15.  闪避率(百分比)
        [16] = "精准",-- 16.  精准率(百分比)
        [17] = "识破",-- 17.  识破率(百分比)
        [18] = "暴击",-- 18.  暴击率(百分比)
        [19] = "暴伤",-- 19.  暴击效果值(百分比)
        [20] = "抗暴",-- 20.  抗暴率(百分比)
        [21] = "眩晕",-- 21.  眩晕率(百分比)
        [22] = "抗晕",-- 22.  抗晕率(百分比)
        [23] = "增伤",-- 23.  伤害加成(百分比)
        [24] = "减伤",-- 24.  伤害减免(百分比)
        [25] = "技能伤害加成",-- 25.  技能效果加成(百分比)
        [26] = "技能伤害减免",-- 26.  技能效果减免(百分比)
        [27] = "初始士气",-- 27.  初始士气值(整数)
        [28] = "抗清气率",-- 28.  减士气抵抗(百分比)
        [29] = "反伤",-- 29.  反伤抵抗比率(百分比)
        [30] = "攻击力",-- 30.  攻击力(物理攻击或者策略攻击, 由类型决定)
        [31] = "防御力",-- 31. 防御力（全部防御包括物防和策防）
        [32] = "攻击力",--  32. 全部攻击力（百分比）
        [33] = "防御力",--  32. 全部防御力（百分比）
        [34] = "速度",--  34. 速度
        [101] = "国家人数",-- 101.  提升国家人数
        [102] = "掠夺次数上限",-- 102.  提升掠夺次数上限
        [103] = "占领次数上限",-- 103.  提升占领次数上限
        [104] = "仓库容量",-- 104.  仓库容量
        [105] = "国家商品数量",-- 105.  国家商品数量
        [106] = "国战获取速度",-- 106.  国战获取速度
        [107] = "主城建筑cd",-- 107.  主城建筑cd减少（百分比）
        [108] = "额外帮助减少时间",-- 106.  额外帮助减少时间
    }
    local _text = attributeText[_id] or attributeText[1]
    if _isBase then
        _text = "基础".._text
    end
    return _text
end

function LANGUAGE_getTargetTextById(_target)
    local _target = tonumber(_target) or 0
    local targetText = {
        [0] = "全队",
        [1] = "主角",
        [2] = "",
        [3] = "上阵将领",
    }
    return targetText[_target]
end
--获取熟练度玩法说明
function LANGUAGE_GET_RULE_SHULIANDU( desc, _str1,_str2,_str3)
    local _desc = clone( desc )
    local needFormatStr = _desc[4] or ""
    _desc[4] = string.format(needFormatStr,_str1,_str2,_str3)
    return _desc
end


-- 演武榜
LANGUAGE_ARENA = {
    arena_over = "演武榜赛事结束，周一5:00重新开启！",
    arena_final = "正在将参赛玩家分配至天地榜，周日上午十点开启决赛！",
    arena_type_0 = "",
    arena_type_1 = "青龙组",
    arena_type_2 = "朱雀组",
    arena_type_3 = "玄武组",
    arena_type_11 = "天榜",
    arena_type_12 = "地榜",
    rank_mine = "我的排名",
    un_rank = "未上榜",
    score_mine = "我的积分",
    btn_hallFame = "名人榜",
    btn_rank = "排行榜",
    times_left = "剩余次数",
    times_to_limit = "挑战次数已达到上限",
    btn_change = "换一批",
    btn_defence = "防守阵容",
    btn_record = "战报",
    btn_shop = "军功商店",
    times_not_enough = "剩余挑战次数不足",
    challenged_player = "已挑战过该玩家",
    score = "积分",
    -- 名人榜
    to_current = "至当前届",
    share = "分享",
    -- 排行榜
    rank = "排名",
    name = "名字",
    reward_preview = "奖励预览",
    rule = "规则说明",
    -- 战报
    share_success = "分享成功",
    -- 查看信息
    get_score_when_win = "战胜可获得积分",
    send_email = "发邮件",
    ignore = "屏蔽",
    make_friend = "加好友",
    lookup = "查看信息",
    fight = "切磋",
    chat_private = "私聊",
    no_hallFame = "本次演武榜为开服首届，冠军未产生",
    defence = "防守",
    attack = "进攻",
    bang_text1 = "青龙组",
    bang_text2 = "朱雀组",
    bang_text3 = "玄武组",
    bang_text11 = "天榜",
    bang_text12 = "地榜",
    un_into = "您未进入",

}

function LANGUAGE_WEEK( day )
    local _day = {
        "一","二","三","四","五","六","日"
    }
    return _day[tonumber(day)] or ""
end
-- 演武榜结束提示
function LANGUAGE_ARENA_OVER( day, time )
    return "演武榜赛事结束，周" .. LANGUAGE_WEEK(day) .. time .. "重新开启！"
end
-- 演武榜
function LANGUAGE_ARENA_FINAL( day, time )
    return "正在将参赛玩家分配至天地榜，周" .. LANGUAGE_WEEK(day) .. time .. "开启决赛！"
end

function LANGUAGE_ITEMNODE_USERBOX( num )
    return "使用宝箱后可从以下" .. tostring(num) .. "种奖励选择一个获取"
end

function LANGUAGE_UNLOCK_CHAPTER_TIP( typeName, chapterId, chapterName )
    -- return "通关" .. tostring(typeName) .. "第".. tostring(chapterId) .. "章" .. tostring(chapterName) .. "解锁"
    return "通关" .. tostring(typeName) .. tostring(chapterName) .. "解锁"
end

function LANGUAGE_UNLOCK_FUNCTION_TIP( chapterId, tollgateId, level )
    if level then
        return tostring(level) .. "级开启"
    else
        return "通关" .. chapterId .. "章" .. tollgateId .. "关开启"
    end
end

function LANGUAGE_BAG_CHOOSE_TIP( num )
    return "从以下[color=ffff0000]" .. tostring(num) .. "种[/color]选择一个"
end


function LANGUAGE_GET_RULE_SHULIANDU( desc, _str1,_str2,_str3)
    local _desc = clone( desc )
    local needFormatStr = _desc[4] or ""
    _desc[4] = string.format(needFormatStr,_str1,_str2,_str3)
    return _desc
end
--汉字数字(小于100的)
function LANGUAGE_GET_CHINESE_NUM( _time )
    local _time = tonumber(_time) or 0
    local nums = {"一","二","三","四","五","六","七","八","九","十"} --135 "一百三十五"
    local _nums = ""
    local function getWord(_pos)
        return nums[_pos] or ""
    end
    if _time % 10 == 0 then
        local _pos = math.floor(_time/10)
        if _pos == 1 then
            _nums = "十"
        else
            _nums = (getWord(_pos) or "").. "十"
        end
    else
        local _gewei = _time % 10
        local _shiwei = math.floor(_time/10)
        if _shiwei == 0 then
            _nums = getWord(_gewei)
        elseif _shiwei == 1 then
            _nums = "十"..getWord(_gewei)
        else
            _nums = getWord(_shiwei).."十"..getWord(_gewei)
        end
    end
    return _nums
end

--打造购买
function LANGUAGE_DAZAO_BUY(_price)
    return "是否花费".._price.."元宝购买1次打造?"
end

-- 购买挑战次数提示
function LANGUAGE_ARENA_BUY( _price )
    return "是否花费".._price.."元宝购买1次挑战次数"
end
-- 总届数
function LANGUAGE_ARENA_PERIOD( _cur, _total )
    return "总届数: ".._cur.."/".._total.."届"
end

function LANGUAGE_RECHARGE_OWNRIGHT( _vip )
    local _str = APP_REVIEW and "拥有至尊" or "拥有VIP"
    return _str.._vip.."所有特权"
end

function LANGUAGE_RECHARGE_BUYGOLD( _price, _gold )
    local _text = "是否花费" .. zc.getGtMoneyFlag() .. _price .. " 购买"
    if _gold then
        _text = _text .. _gold .. "元宝"
    end
    return _text
end

function LANGUAGE_SEIZE_BUYGOLD( price )
    return "是否花费"..price.."元宝购买一次抢占次数？"
end

function LANGUAGE_BATTLE_RESULT_SHARE( name, key, sType )
    print("··sType·" .. sType)
    local _text = ""
    if sType == 1 then
        _text ="在与".. name .."的比武中胜利{key=".. key .."}"
    elseif sType == 2 then
        _text = "在与".. name .."的比武中失败{key=".. key .."}"
    elseif sType ==  3 then
        _text = "击败了关卡".. name .."{key=".. key .."}"   
    elseif sType ==  4 then
         _text = "在挑战关卡".. name .."时失利{key=".. key .."}"
    elseif sType == 5 then
        _text = "在武神榜击败了" .. name .. "{key=".. key .."}" 
    elseif sType == 6 then
        _text = "在武神榜中挑战" .. name .. "失利{key=".. key .."}" 
    end
    return _text
end

function LANGUAGE_SWEEP_COST_TIPS( cost, times )
    return "是否花费" .. tostring(cost) .. "元宝，扫荡" .. tostring(times) .. "次？"
end

-- 分享战报数据
function LANGUAGE_ARENA_SHAREDATA( _type, _data )
    local shareData = {}
    if _type == 1 then
        -- 进攻方胜利，玩家失败
        shareData = {
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "在与",
            },
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "的比武中失败",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 2 then
        -- 进攻方失败，玩家胜利
        shareData = {
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "在"..LANGUAGE_ARENA["arena_type_".._data.type].."中战胜了",
            },
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 3 then
        -- 玩家胜利，防守方失败，前六天
        shareData = {
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "在"..LANGUAGE_ARENA["arena_type_".._data.type].."中战胜了",
            },
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 4 then
        -- 玩家胜利，防守方失败，最后一天
        shareData = {
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "击败了",
            },
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "升至"..LANGUAGE_ARENA["arena_type_".._data.type]..( "第".._data.attackerAfterRank or 0 ).."名",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 5 then
        -- 玩家失败，防守方胜利
        shareData = {
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "在与",
            },
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "的比武中失败",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 6 then
        -- 进攻方胜利，玩家失败
        shareData = {
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "在粮草先行中，被",
            },
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "抢夺了粮草",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 7 then
        -- 进攻方失败，玩家胜利
        shareData = {
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "在粮草先行中，抵御了",
            },
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "的抢夺",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 8 then
        -- 玩家胜利，防守方失败
        shareData = {
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "在粮草先行中，成功抢夺了",
            },
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "的粮草",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 9 then
        -- 玩家失败，防守方胜利
        shareData = {
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "在粮草先行中，未能成功抢夺",
            },
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "的粮草",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    end
    return shareData
end

-- 商店
LANGUAGE_SHOP = {
    shop = "商店",
    shop_arena = "军功商店",
    shop_expCard = "突飞卡",
    buy_space = "购 买",
    discount = "折扣",
    own = "拥有",
    total_refresh_times = "今日总刷新次数",
    no_refresh_times = "今日刷新次数用完",
    no_free_refresh_times = "免费刷新次数用完",
    free_refresh = "免费刷新",
    refresh_space = "刷 新",
    refresh = "刷新",
    buy = "购买",
    bought = "已购买",
    shop_gem = "勾玉",
    shop_time = "限时商城",
    goods_shop = "道具商城",
    shengwang = "声望",
}

-- 充值，特权
LANGUAGE_RECHARGE = {
    current_level = "当前等级",
    vip_level_max = APP_REVIEW and "已达最高至尊等级" or "已达最高VIP等级",
    recharge_more = "再充值",
    can_up_to = "可升级到",
    recharge_space = "充 值",
    right_space = "特 权",
    recharge_success_tx = "恭喜您，购买成功！您本次花费%s元，获得%s元宝，您当前的账户余额为%s元。(元宝到账时间可能会有短暂延迟，请您耐心等待。)",
    recharge_unenough = "余额不足，还需要充值%s元，是否立即充值？",
    recharge_success = "恭喜您，成功充值%s元，元宝到账时间可能会有短暂延迟，请您耐心等待",     
    recharge_success2 = "恭喜您，获得%s元宝，您当前的账户余额为%s元。元宝到账时间可能会有短暂延迟，请您耐心等待。",  
    recharge_fail = "扣款失败，请稍后再试",
    order_fail = "请求订单失败",
    recharge_fail2 = "充值失败，请重试",
    tip_5 = "解锁第二把神兵，开启主角变身功能",
    tip_6 = "可在特权礼包中购买A级将领宝箱",
}

LANGUAGE_RECIEVEENERGY_TIPS = {
    tip_group1 = {
        "美食还没做好,",
        "过会再来吧",
        "",
    },
    tip_1 = {"正在准备丰盛的午餐", "正在准备丰盛的晚餐", "正在准备丰盛的宵夜"},
    tip_group2 = {  "美食已经做好,",
        "赶紧过来吃吧",
        "",
    },
    tip_2 = {"每份午餐可以获得       60", "每份晚餐可以获得       60", "每份宵夜可以获得       60"},
    tip_group3 = {
        "本次免费领取时",
        "段已过,%s点-%s点",
        "可再次领取哦",
    },
    tip_3 = "花费       %s可补领       60",
    tip_4 = "错过免费供应时间，请消耗元宝购买"
}



LANGUAGE_GAME_START_INFO = {
    name = "序章",
    desc = "公元184年，奸臣当道，战乱不断。而此时天降玄铁，传闻，以玄铁铸就神兵，可横扫千军，终结这汉末乱世，故事就由此拉开了帷幕……",
}

LANGUAGE_GAME_EIGHT_WORDS = {
    title = "健康游戏忠告",
    desc = "抵制不良游戏，拒绝盗版游戏。注意自我保护，谨防受骗上当。\n适度游戏益脑，沉迷游戏伤身。合理安排时间，享受健康生活。",
}

LANGUAGE_UPDATE_INFO = {
    tip1 = "需要有",
    tip2 = "的更新内容，请在网络",
    tip3 = "条件好的情况下进行更新哦~",
    tip4 = "全新资源更新中",
    tip5 = "前往下载",
    tip6 = "立即更新",
}

-- 将领界面
LANGUAGE_ROLE = {
    -- 培养
    not_enough = "不足",
    keep = "保留",
    culture = "培养",
    attribute_level_max = "属性已达到当前等级最大值",
    -- 羁绊
    no_fetter = "该将领没有羁绊",
    in_battle_team = "已上阵",
    free_space = "解 除",
    fetter_space = "羁 绊",
    fetter = "羁绊",
    no_hero = "尚未拥有",
    fetter_to_other = "已羁绊到其他将领",
    fetter_effect = "羁绊效果",
    attribute_total_addition = "属性总加成",
    choose_fetter_object = "选择羁绊对象",
    -- 升星
    consume = "需要材料",
    activate_space = "装 备",
    one_key_activate = "一键装备",
    no_equip = "当前没有可以镶嵌的装备",
    starup = "升星",
    activate_all_to_starup = "全部装备才可升星",
    consume_not_enough = "升星石不足",
    unlock = "解锁",
    lock = "锁定",
    have_locked = "已锁定",
    not_locked = "未锁定",
}

-- 名将副本
LANGUAGE_TOLLGATEHERO = {
    challenge_times_today = "今日可挑战",
    chance_drop = "概率掉落",
    win_drop = "胜利获得",
    general_exp = "将领经验",
    mainrole_exp = "主角经验",
    copy_consume = "副本消耗",
    consume = "消耗",
    challenge_once_one_day = "每日只可挑战一次",
    no_challenge_times = "挑战次数不足",
    not_open = "未开启",
    fetch_reward = "领取奖励",
    fetched = "已领取",
    can_not_fetch = "不可领取",
    can_fetch = "可领取",
    first_drop = "首杀掉落",
    common_drop = "概率掉落",
}

function LANGUAGE_condition_uimatrix( stype )
    local _stype = tonumber(stype)
    local _text = ""
    if _stype == 1 then
        _text = "击杀全部敌方"
    elseif _stype == 2 then
        _text = "回合内上阵角色还有存活"
    elseif _stype == 3 then
        _text = "回合内击杀全部敌方"
    elseif _stype == 4 then
        _text = "击杀全部敌方"
    end
    return _text
end


function LANGUAGE_KEY_GETQUNXIONGNAME_BY_ID(_id)
    local qunxiongName = {
        [1] = "同符合契",
        [2] = "势如破竹",
        [3] = "三国无双",
        [4] = "名将册4",
        [5] = "名将册5",
        [6] = "名将册6",
    }
    return qunxiongName[tonumber(_id)] or ""
end

function LANGUAGE_getCountryLogByType( type )
    local _type = tonumber(type) or 1
    local _countryLog = {
        [1] = "%s将国家科技%s升级为%s级！",
        [2] = "%s加入了国家，大家欢迎！",
        [3] = "%s退出了国家.",
        [4] = "%s通过藏宝图获得了%s！",
        [5] = "%s在藏宝图中被国家%s的%s驱逐，惨遭损失！",
        [6] = "国家%s对%s战场发起掠夺，%s分钟后开始战斗，大家准备迎敌！",
        [7] = "国家%s对%s战场发起攻占，%s分钟后开始战斗，大家准备迎敌！",
        [8] = "国家%s在%s战场的战争中被我方击败",
        [9] = "%s战场遭到国家%s掠夺，损失%s的%s。",
        [10] = "%s战场遭到国家%s掠夺，物资受国家仓库保护，没有损失。",
        [11] = "国家%s攻占了我方%s战场！重整旗鼓，夺回失地！",
    } 
    local _log = _countryLog[tonumber(_type)] or _countryLog[1]
    return _log
end

function LANGUAGE_getHouseNameById( _id )
    local str = ""
    _id = tonumber(_id)
    if _id == 1 then 
        str = "主城"
    elseif _id == 2 then
        str = "城墙"
    elseif _id == 3 then
        str = "码头"
    elseif _id == 4 then
        str = "重生塔"
    elseif _id == 5 then
        str = "农田"
    elseif _id == 6 then
        str = "木场"
    elseif _id == 7 then
        str = "矿场"
    elseif _id == 8 then
        str = "校场"
    elseif _id == 9 then
        str = "酒馆"
    elseif _id == 10 then
        str = "灯市"
    elseif _id == 11 then
        str = "铁匠铺"
    elseif _id == 12 then
        -- str = "仓库"
        str = "商店"
    elseif _id == 13 then
        str = "演武榜"
    elseif _id == 14 then
        str = "研究院"
    elseif _id == 15 then
        str = "挑战"
    elseif _id == 16 then
        str = "市政"
    end
    return str
end

function LANGUAGE_getTipColorNameByType( type )
    local _str = "普通"
    local _type = tonumber(type)
    if _type == 1 then   --白
        _str = "普通"
    elseif _type == 2 then --绿
        _str = "精良"
    elseif _type == 3 then --蓝
        _str = "稀有"
    elseif _type == 4 then --紫
        _str = "史诗"
    elseif _type == 5 then --金
        _str = "特殊"
    elseif _type == 6 then --红
        _str = "传说"
    end
    return _str
end

-- 根据装备进阶等级获取名称
function LANGUAGE_get_advance_color_text( advance )
    local _advance = tonumber( advance ) or 0
    local _config = {
        "绿色", "蓝色", "蓝色+1", "紫色", "紫色+1", "紫色+2", "金色", "金色+1", "金色+2", "红色","红色+1","红色+2","黑色","黑色+1",
    }
    return _config[_advance] or ""
end

function LANGUAGE_get_color_text( qualifications )
    local _qualifications = tonumber( qualifications ) or 0
    local _config = {
        "白色", "绿色", "蓝色", "蓝色+1", "紫色", "紫色+1", "紫色+2", "金色", "金色+1", "金色+2","红色","红色+1","红色+2","黑色","黑色+1",
    }
    return _config[_qualifications] or ""
end

function LANGUAGE_get_server_status_name( status )
    local _state = tonumber( status ) or 0
    local stateText = ""
    local stateColor = display.COLOR_RED
    if _state == 0 then
        -- 运行中
        stateText = "火爆"
        stateColor = display.COLOR_RED
    elseif _state == 1 then
        -- 维护中
        stateText = "维护中"
        stateColor = display.COLOR_GRAY
    elseif _state == 2 then
        -- 待开服
        stateText = "即将开启"
        stateColor = cc.c3b(248, 238, 0)
    elseif _state == 3 then
        -- 已关服
        stateText = "停服"
        stateColor = display.COLOR_GRAY
    elseif _state == 10 then
        -- 新服
        stateText = "新服"
        stateColor = display.COLOR_GREEN
    end
    return stateText, stateColor
end

function LANGUAGE_get_weapon_type_name()
    return {"长柄", "钝器", "法杖", " 剑", "扇子", "法球"}
end

function LANGUAGE_get_bag_tabs()
    return {"全 部", "兵 器", "兵器碎片","消耗品", "材 料", "勾 玉"}
end

function LANGUAGE_get_weapon_random_effect_name( color )
    local _color = tonumber(color)
    local _text = "白色品质随机属性"
    if _color == 2 then
        _text = "绿色品质随机属性"
    elseif _color == 3 then
        _text = "蓝色品质随机属性"
    elseif _color == 4 then
        _text = "紫色品质随机属性"
    elseif _color == 5 then
        _text = "金色品质随机属性"
    elseif _color == 6 then
        _text = "红色品质随机属性"
    elseif _color == 7 then
        _text = "随机品质随机属性"
    end
    return _text
end

function LANGUAGE_get_buff_show_text( id )
    local ret = nil
    if id == 1 then
        ret = "眩晕"
    elseif id == 2 then
        ret = "中毒"
    elseif id == 21 then
        ret = "流血"
    elseif id == 35 then
        ret = "魅惑"
    elseif id == 3 then--[[伤害增加]]
        ret = "伤害加深"
    elseif id == 4 then
        ret = "伤害减免"
    elseif id == 5 then--[[提升精准率]]
        ret = "精准"
    elseif id == 6 then--[[-降低精准率]]
        ret = "精准"
    elseif id == 7 then--[[提升命中]]
        ret = "命中"
    elseif id == 8 then--[[降低命中]]
        ret = "命中"
    elseif id == 9 then--提升暴击抗性
        ret = "抗暴"
    elseif id == 10 then--降低物理攻击力
        ret = "物理攻击"
    elseif id == 11 then--降低策略攻击力
        ret = "策略攻击"
    elseif id == 12 then--提升物理攻击力
        ret = "物理攻击"
    elseif id == 13 then--提升策略攻击力
        ret = "策略攻击"
    elseif id == 14 then--降低物理攻击力加成
        ret = "物理攻击"
    elseif id == 15 then--降低策略攻击力加成
        ret = "策略攻击"
    elseif id == 16 then--提升物理攻击力加成
        ret = "物理攻击"
    elseif id == 17 then--提升策略攻击力加成
        ret = "策略攻击"
    elseif id == 18 then--提升暴击
        ret = "暴击"
    elseif id == 19 then--降低暴击
        ret = "暴击"
    elseif id == 20 then
        ret = "暴击流血"
    elseif id == 21 then
        ret = "流血"
    elseif id == 22 then
        ret = "提升暴击"
    elseif id == 23 then
        ret = "护盾"
    elseif id == 24 then--[[降低物理防御力]]
        ret = "物理防御"
    elseif id == 25 then--降低策略防御力
        ret = "策略防御"
    elseif id == 26 then--提升物理防御力
        ret = "物理防御"
    elseif id == 27 then--提升策略防御力
        ret = "策略防御"
    elseif id == 28 then--降低物理防御力加成
        ret = "物理防御"
    elseif id == 29 then--降低策略防御力加成
        ret = "策略防御"
    elseif id == 30 then--提升物理防御力加成
        ret = "物理防御"
    elseif id == 31 then--提升策略防御力加成
        ret = "策略防御"
    elseif id == 34 then
        ret = "降低输出"
    elseif id == 38 then
        ret = "伤害输出"
    elseif id == 39 then
        ret = "命中"
    elseif id == 40 then
        ret = "精准"
    elseif id == 41 then
        ret = "物理防御"
    elseif id == 42 then
        ret = "策略防御"
    elseif id == 45 then
        ret = "闪避"
    elseif id == 46 then
        ret = "识破"
    elseif id == 47 then
        ret = "沉默"
    elseif id == 48 then --攻击上升
        ret = "攻击"
    elseif id == 49 then --攻击下降
        ret = "攻击"
    elseif id == 50 then -- 降低暴击抗性
        ret = "抗暴"
    elseif id == 51 then -- 增加速度属性
        ret = "速度"
    elseif id == 52 then -- 降低速度属性
        ret = "速度"
    elseif id == 53 then -- 提升暴击伤害属性
        ret = "暴击伤害"
    elseif id == 54 then -- 降低暴击伤害属性
        ret = "暴击伤害"
    elseif id == 55 then -- 必定识破X次谋士攻击
        ret = "识破"
    elseif id == 100 then--[[士气上升]]
        ret = "士气"
    elseif id == 101 then--[[士气下降]]
        ret = "士气"
    elseif id == 102 then--[[识破]]
        ret = "识破"
    elseif id == 103 then--[[闪避]]
        ret = "闪避"
    elseif id == 104 then--[[连击]]
        ret = "连击"
    end
    return ret
end

function LANGUAGE_line_choose_tips()
    return {
        "可获得兵器洗练的重要材料",
        "可获得装备进阶的重要材料",
        "可获得将领升星的重要材料",
    }
end

function LANGUAGE_heti_skill_tip( name, desc )
    return "【与[color=ff5ba6d4]" .. tostring(name) .."[/color]同时上阵可触发】" .. desc
end

function LANGUAGE_heti_skill_unrich_tip( name, desc )
    return "与" .. tostring(name) .."同时上阵可触发" .. desc
end

function LANGUAGE_get_levy_tip()
    return "[size=18][color=ffdeb05d]每日[/size][/color][size=18][color=ffff0000]上午7:00[/size][/color][size=18][color=ffdeb05d]恢复12次免费征收次数[/size][/color]"
end

function LANGUAGE_get_country_tech_types()
    return {[1] = "低级科技",[2] = "中级科技",[3] = "高级科技"}, {[1] = "",[2] = "：全部低级科技达到满级解锁",[3]="：全部中级科技达到满级解锁"}
end

function LANGUAGE_get_country_join_condition()
    return  {
        [1] = "允许任何人",
        [2] = "需要批准",
        [3] = "不允许任何人",
    }
end

function LANGUAGE_get_qunxiong_tabs()
    return {[1]="总览",[2]="图鉴",[3]="兑换"}
end

function LANGUAGE_get_country_main_tabs()
    return {[1]="国家总览",[2]="国家人员",[3]="国家排名",[4]="国家帮助",[5]="国家日志",[6]="国家设置"}
end

function LANGUAGE_get_dart_open_time( _time1, _time2 )
    return "[color=ffe6e0a3]中午[/color][color=ffff3644]".. _time1 .."[/color][color=ffe6e0a3]，晚上[/color][color=ffff3644]".. _time2 .."[/color][color=ffe6e0a3]开放[/color]"
end

function LANGUAGE_get_multicopy_open_time( _time1, _time2 )
    return "[color=ffe6e0a3]中午[/color][color=ffff3644]".._time1.."[/color][color=ffe6e0a3]，晚上[/color][color=ffff3644]".._time2.."[/color][color=ffe6e0a3]开放[/color]"
end

function LANGUAGE_dart_get_times_tip( leftTimes, maxTimes )
    return "[color=ffdeb05d]剩余次数[/color][color=ff00ff66]"..leftTimes.."/"..maxTimes.."[/color]  [color=ffdeb05d]领取后限[/color][color=ffff3644]30[/color][color=ffdeb05d]分钟内完成[/color]" 
end

function LANGUAGE_grabmine_get_chat_tips()
    return {
        "准备好，速度开！",
        "速买次数",
        "我强我先手",
        "难度较大，人满开车",
    }
end

function LANGUAGE_culture_tips()
    return {
        [1] = "普通培养",
        [2] = "超级培养",
        [3] = "极限培养",
        [4] = "至尊培养",
    }
end

function LANGUAGE_talent_showinfo()
    return {
        [0] = "[color=ff746548]对[/color][color=ffff0000]全体英雄[/color][color=ff746548]进行加成[/color]",
        [1] = "[color=ff746548]对[/color][color=ffff0000]主角[/color][color=ff746548]进行加成[/color]",
        [2] = "[color=ffff0000]主角[/color][color=ff746548]将获得全新天赋[/color]",
    }
end

function LANGUAGE_task_tabs()
    return {"主线", "日常", "成就"}
end

function LANGUAGE_wushen_resoult_baoji_type()
    return {[1]="暴击",[2]="大暴击",[3]="幸运暴击"}
end

function LANGUAGE_get_rank_list_basedatas()
    return {
        {
            [1]={name="战力榜",moreRank=true,rankTabNum=2},
            [2]={name="武神榜",moreRank=false,rankTabNum=0},
            [3]={name="演武榜",moreRank=true,rankTabNum=5}, --特殊处理
            [4]={name="国家榜",moreRank=true,rankTabNum=1},
            [5]={name="群雄逐鹿",moreRank=true,rankTabNum=3},    
            [6]={name="粮草榜",moreRank=false,rankTabNum=0},
            [7]={name="抢夺榜",moreRank=false,rankTabNum=0},      
            
        },
        {
            [1]={
                [1]={name="队伍",infoTag=2},
                [2]={name="主角",infoTag=1},
            },        
            [2]={
                [1]={name="武神榜",infoTag=19},
            },
            [3]={
                [1]={name="青龙组",infoTag=3},
                [2]={name="朱雀组",infoTag=4},
                [3]={name="玄武组",infoTag=5},
                [4]={name="天榜",infoTag=6},
                [5]={name="地榜",infoTag=7},
            },
            [4]={
                [1]={name="全员战力",infoTag=8},
            },
            [5]={
                [1]={name="黄巾军",infoTag=16},
                [2]={name="西凉军",infoTag=17},
                [3]={name="蜀军",infoTag=18},
            },
            [6]={
                [1]={name="粮草榜",infoTag=20},
            },
            [7]={
                [1]={name="抢夺榜",infoTag=21},
            },
        },
        {
            [1] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="主角战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [2] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="小队战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [3] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [4] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [5] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [6] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [7] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [8] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="国家",pos=cc.p(223, 438)},
                [3] = {name="君主",pos=cc.p(365+56, 438)},
                [4] = {name="全员战力",pos=cc.p(485+120, 438)},
                [5] = {name="",pos=cc.p(617, 438)},
            },
            [9] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [10] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [11] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [12] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [13] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [14] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [15] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [16] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="个人最高伤害",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [17] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="个人最高伤害",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [18] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="个人最高伤害",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [19] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="职业",pos=cc.p(365, 438)},
                [4] = {name="将领总战力",pos=cc.p(485, 438)},
                [5] = {name="获得称号",pos=cc.p(617, 438)},
            },
            [20] = {
                [1] = {name="排名",pos=cc.p(76,436)},
                [2] = {name="名字",pos=cc.p(223, 436)},
                [3] = {name="粮草数量",pos=cc.p(380, 436)},
                [4] = {name="排名奖励",pos=cc.p(500, 436)},
                [5] = {name="",pos=cc.p(617, 436)},
            },
            [21] = {
                [1] = {name="排名",pos=cc.p(76,436)},
                [2] = {name="名字",pos=cc.p(223, 436)},
                [3] = {name="抢夺数量",pos=cc.p(380, 436)},
                [4] = {name="排名奖励",pos=cc.p(500, 436)},
                [5] = {name="",pos=cc.p(617, 436)},
            },
        }
    }
    -- 1    排名 名字 职业 主角战力 获得称号
    -- 2    排名 名字 职业 小队战力 获得称号
    -- 3    排名 名字 职业 将领总战力 获得称号
    -- 4    排名 名字 职业 将领总战力 获得称号
    -- 5    排名 名字 职业 将领总战力 获得称号
    -- 6    排名 名字 职业 将领总战力 获得称号
    -- 7    排名 名字 职业 将领总战力 获得称号
    -- 8    排名 名字 职业 将领总战力 获得称号
    -- 9    排名 名字 职业 关卡数 获得称号
    -- 10   排名 名字 职业 将领总战力 获得称号
    -- 11   排名 名字 职业 将领总战力 获得称号
    -- 12   排名 名字 职业 将领总战力 获得称号
    -- 13   排名 名字 职业 将领总战力 获得称号
    -- 14   排名 名字 职业 将领总战力 获得称号
    -- 15   排名 名字 职业 将领总战力 获得称号
    -- 16   排名 名字 职业 个人最高伤害 获得称号
    -- 17   排名 名字 职业 个人最高伤害 获得称号
    -- 18   排名 名字 职业 个人最高伤害 获得称号
    -- 19   排名 名字 职业 将领总战力 获得称号
end

function LANGUAGE_get_randomNames()
    return {
        {
            "司马","欧阳","端木","上官","独孤","夏侯","尉迟","赫连","皇甫","公孙","慕容","长孙","宇文",
            "司徒","轩辕","百里","呼延","令狐","诸葛","南宫","东方","西门","李","王","张","刘","陈","杨","赵","黄","周","胡",
            "林","梁","宋","郑","唐","冯","董","程","曹","袁","许","沈","曾","彭","吕","蒋","蔡","魏","叶","杜","夏","汪",
            "田","方","石","熊","白","秦","江","孟","龙","万","段","雷","武","乔","洪","鲁","葛","柳","岳","梅","辛","耿",
            "关","苗","童","项","裴","鲍","霍","甘","景","包","柯","阮","华","滕","穆","燕","敖","冷","卓","花","蓝","楚",
            "荆","思","冰","夜","痴","依","小","香","绿","向","映","含","曼","春","醉","之","新","雨","天","如","若","涵",
            "亦","采","安","芷","绮","雅","飞","又","寒","忆","晓","乐","笑","妙","元","碧","翠","初","怀","幻","慕","秋",
            "语","觅","幼","灵","傲","冷","沛","念","寻","水","紫","易","惜","诗","青","雁","盼","尔","以","雪","夏","凝",
            "丹","迎","问","宛","梦","怜","听","巧","凡","静"
        },
        {
            "之","梦","慕","尔","初","沛","傲","曼","乐","惜","香","新","语",
            "海","夜","涵","水","醉","语","从","傲","语","又","碧","元","怜","紫","妙","曼",
            "南","紫","雨","易","如","若","寻","晓","向","慕","以","映","雪","海","凝","沛",
            "寒","冰","宛","绿","晓","碧","夏","曼","若","半","雅","冰","灵","平","书","翠",
            "代","梦","幼","听","梦","醉","访","亦","凌","访","怀","笑","靖","夜","冰","梦",
            "书","乐","念","靖","从","觅","静","凡","以","念","芷","千","新","代","新","雁",
            "冷","紫","千","傲","盼","怀","冰","山","翠","问","白","问","如","半","丹","冰",
            "亦","之","冰","尔","谷","乐","涵","海","傲","青","易","惜","宛","之","夏","亦",
            "妙","紫","幻","元","冰","访","芷","凡","凡","安","天","含","书","雅","书","从",
            "夏","念","代","幻","谷","秋","白","海","代","含","书","听","灵","雪","乐","含",
            "涵","平","雅","傲","灵","含","从","从","初","听","语","夏","凌","忆","幻","怜",
            "紫","依","妙","访","怜","映","友","冰","惜","凌","芷","雁","迎","元","代","紫",

            "千青","凌寒","紫安","寒安","怀蕊","秋荷","涵雁","以山","凡梅","盼曼","翠彤","谷冬","冷安","千萍","冰烟","雅阳",
            "友绿","南松","诗云","飞风","寄灵","书芹","幼蓉","以蓝","笑寒","忆寒","秋烟","芷巧","水香","映之","醉波","幻莲",
            "夜山","芷卉","向彤","小玉","幼南","凡梦","尔曼","念波","迎松","青寒","笑天","涵蕾","碧菡","映秋","盼烟","忆山",
            "以寒","寒香","小凡","代亦","梦露","映波","友蕊","寄凡","怜蕾","雁枫","水绿","曼荷","笑珊","寒珊","谷南","慕儿",
            "夏岚","友儿","小萱","紫青","妙菱","冬寒","曼柔","语蝶","青筠","夜安","觅海","问安","晓槐","雅山","访云","翠容",
            "寒凡","晓绿","以菱","冬云","含玉","访枫","含卉","夜白","冷安","灵竹","醉薇","元珊","幻波","盼夏","元瑶","迎曼",
            "水云","访琴","谷波","笑白","妙海","紫霜","凌旋","孤丝","怜寒","凡松","青丝","翠安","如天","凌雪","绮菱","代云",
            "香薇","冬灵","凌珍","沛文","紫槐","幻柏","采文","雪旋","盼海","映梦","安雁","映容","凝阳","访风","天亦","觅风",
            "小霜","雪萍","半雪","山柳","谷雪","靖易","白薇","梦菡","飞绿","如波","又晴","友易","香菱","冬亦","问雁","海冬",
            "秋灵","凝芙","念烟","白山","从灵","尔芙","迎蓉","念寒","翠绿","翠芙","靖儿","妙柏","千凝","小珍","妙旋","思淼",
            "败","悔","南","宝","仞","刀","斐","德","云","天","仁","岳","宵","忌","爵","权","敏","阳","狂","冠","康","平",
            "刚","强","凡","邦","福","歌","国","和","康","澜","民","宁","然","顺","翔","晏","宜","怡","易","志","雄","佑",
            "斌","河","元","墨","松","林","之","翔","竹","宇","轩","荣","哲","风","霜","山","炎","罡","盛","睿","达","洪",
            "武","耀","磊","寒","冰","潇","痕","岚","空"
        },
        {
            "桃","琪","青","岚","夏","菡","珊","文","菱","文","寒","柔","蓉",
            "安","蓉","柏","桃","蓝","琴","彤","晴","兰","菱","彤","霜","梦","寒","彤","易",
            "莲","翠","寒","烟","萱","南","真","亦","珊","灵","蕊","易","柳","云","天","珊",
            "云","旋","儿","真","霜","凡","菡","香","烟","梦","绿","蓝","槐","安","翠","风",
            "云","曼","翠","寒","柏","易","旋","玉","萱","卉","亦","蓝","柏","蕾","夏","松",
            "雪","枫","薇","雁","寒","波","曼","旋","亦","露","蕾","兰","波","真","蕾","玉",
            "卉","山","琴","芙","山","蝶","兰","柏","萱","旋","易","筠","霜","芹","丹","彤",
            "寒","瑶","露","珍","雪","萱","菡","莲","蕾","槐","梦","雪","海","柔","夏","瑶",
            "菡","蓝","柏","风","枫","蕊","蕊","蕾","柔","蕾","荷","玉","兰","琴","书","安",
            "槐","芹","曼","珊","丝","翠","晴","露","荷","玉","蕾","白","雁","青","乐","烟",
            "双","蝶","蕊","之","薇","蕾","梦","蓉","丹","蓉","芙","彤","瑶","翠","幻","菡",
            "南","珊","竹","烟","蕾","寒","绿","萍","霜","香","蕾","卉","梦","柏","萱","真"
        }
    }
end


local langConfig = {
    -- 操作提示
    build                 = "建造",
    copy                  = "副本",
    lineup                = "布阵",
    bag                   = "背包",
    task                  = "任务",
    logout                = "注销",
    remove                = "拆除",
    speed_up              = "提速",
    speed_up_left         = "提速还剩",
    enter                 = "进入",
    enter_2               = "进 入",
    friend                = "好友",
    apply_for             = "申请",
    apply_for2            = "申 请",
    have_apply_for        = "已申请",
    black_list            = "黑名单",
    details               = "详情",
    dismantle             = "拆除",
    gold_speed_up         = "元宝加速",
    prop_speed_up         = "道具加速",
    god_weapon            = "神兵",
    weapon_cast           = "锻造",
    fightEnter            = "征战",
    smithy                = "兵器",
    smithy_clear          = "洗练",
    smithy_clear_2        = "洗 练",
    smithy_book           = "兵器谱",
    limitChallenge        = "极限挑战",
    challenge             = "挑战",
    challenge_2           = "挑 战",
    fetterRegionalMap     = "地域羁绊",
    use                   = "使用",
    begin_drill           = "开始训练",
    reincarnate           = "转生",
    confirm               = "确定",
    cancel                = "取消",
    sweep                 = "扫荡",
    sell                  = "出售",
    gather                = "收取",
    sell_2                = "出 售",
    one_key_sell          = "一键出售",
    one_key_gather        = "一键收取",
    xilian                = "洗炼",
    transfer              = "转移",
    suit                  = "套装",
    stop                  = "终止",
    back                  = "返回",
    back_2                = "返 回",
    buy                   = "购买",
    go_recruit            = "招募",
    go_train              = "训练",
    go_transaction        = "交易",
    go_wharf              = "码头",
    send                  = "发送",
    delete                = "删除",
    reply                 = "回复",
    unblock               = "解除屏蔽",
    fight_1               = "切磋",
    house_help            = "帮助",
    multi_copy            = "多人副本",
    weapon_copy           = "兵器副本",
    hero_copy             = "名将传",
    cailiao_copy          = "武神试练",
    qunxiong_copy         = "群雄",
    qinmidu               = "好友度",
    bingfa                = "兵法",
    bingfa_2              = "兵 法",
    fetch                = "领取",
    equip                = "装备",
    no_equip             = "无装备",
    on_line              = "在线",
    off_line              = "离线",
    prompt               = "提示",
    unload               = "卸下",
    see_info             = "查看信息",
    confirm2              = "确 定",
    confirm2_              = "确 认",
    cancel2               = "取 消",
    close2               = "关 闭",
    buy2                  = "购 买",
    recruit_2             = "招 募",
    challenge_2           = "出 战",
    check_2               = "查 看",
    create_2              = "创 建",
    fetch_2               = "领 取",
    upgrade_2             = "升 级",
    xilian_2              = "洗 炼",
    finish_2              = "完 成",
    transfer_2            = "转 移",
    already_transfer      = "已转移",
    revoke_2              = "撤 销",
    exchange              = "兑 换",
    change_name           = "改名",

    --资源名称
    gold                 = "元宝",
    money                = "银币",
    prestige             = "声望",
    sapphire             = "蓝宝石",
    topaz                = "黄宝石",
    amethyst             = "紫宝石",
    energy               = "体力",
    tax                  = "税金",
    wood                 = "木材",
    ore                  = "铁矿",
    heroSoul             = "武魂",
    captainEnergy        = "名将册体力",
    skillPoint           = "技能点",
    grain                = "粮食",

    -- -- 一级属性
    wuli                 = "武力",
    wisdom               = "智力",
    tili                 = "体力",

    -- -- 二级属性
    attack               = "攻击力",
    physics_attack       = "物攻",
    physics_defense      = "物防",
    strategy_attack      = "策攻",
    strategy_defense     = "策防",
    hp_1                 = "生命",
    hp                   = "生命值",
    defense_force        = "防御力",

    -- -- 三级属性
    hit_rate             = "命中率",
    dodge_rate           = "闪避率",
    see_through_rate     = "识破率",
    accurate_rate        = "精准率",
    crit_rate            = "暴击率",
    crit_hurt            = "暴击伤害",
    vertigo_rate         = "晕眩率",
    anti_vertigo_rate    = "抗晕率",
    anti_crit_rate       = "抗暴率",
    physics_attack_add    = "物攻加成",
    physics_defense_add   = "物防加成",
    strategy_attack_add   = "策攻加成",
    strategy_defense_add  = "策防加成",
    hp_add                = "生命加成",
    hurt_deep             = "伤害加成",
    hurt_reduction        = "伤害减免",
    skill_hurt_deep       = "技能增伤",
    skill_hurt_reduction  = "技能减伤",
    init_shiqi            = "初始士气",
    anti_air_rate         = "抗清气率",
    rebound_hurt_rate     = "反伤率",
    speed                 = "速度",

    -- 时间
    date_seconds         = "秒",
    minute               = "分",
    date_minute          = "分钟",
    date_hours           = "小时",
    date_day             = "天",
    date_day_1             = "日",
    date_month           = "月",
    date_year            = "年",

    -- 其他说明性文字
    discount_text        = "折",
    front                = "前",
    middle               = "中",
    back_1               = "后",
    individual           = "个",
    piece                = "件",
    level_1              = "级",
    advancedNum          = "阶",
    reward               = "奖励",
    level                = "等级",
    player_name          = "姓名",
    attribute            = "属性",
    base_attribute       = "基础属性",
    append_attribute     = "附加属性",
    limit_attribute      = "极限属性",
    building_next_level_effect    = "下一级效果",
    building_description = "建筑说明",
    building_condition   = "建造条件",
    building_function    = "建筑功能",
    more_information     = "更多信息",
    protect_money_number = "银币保护",
    protect_wood_number  = "木材保护",
    protect_ore_number   = "矿石保护",
    daily_activity       = "每日活跃度",
    active_degree        = "活跃度",
    task_name            = "任务名称",
    task_description     = "任务描述",
    completion_degree    = "完成度",
    upgrade              = "升级",
    upgrade_condition    = "升级条件",
    upgrade_success      = "升级成功",
    is_building          = "建造中",
    speed_up_time        = "加速时间",
    curr_have            = "当前拥有",
    chip_compose         = "碎片合成",
    compose              = "合成",
    beat_checkpoint      = "击败了关卡",
    max_level            = "已升至最高等级",
    drill_time           = "训练时间",
    drill_pay            = "训练花费",
    pay                  = "花费",
    victory_gain         = "胜利获得",
    cishu                = "次数",
    talent               = "天赋",
    skill                = "技能",
    create_weapon_sub_time  = "减少时间",
    discount             = "当前折扣",
    hero_number          = "解锁将领数量",
    output               = "产出",
    accumulation_max     = "累积上限",
    update_buy_number    = "刷新购买次数",
    loot_recovery_time   = "掠夺恢复时间",
    building_no_details  = "此建筑暂无详情",
    equiped              = "已装备",
    need_level           = "需求等级",
    matrix_level         = "阵法等级",
    upgrade_matrix_need_level = APP_REVIEW and "(升级阵法需要主公等级 " or "(升级阵法需要主公Lv.",
    already_full_level   = "已满级",
    full_level           = "满级",
    enable_matrix        = "启用阵法",
    need_vip             = APP_REVIEW and "需要至尊" or "需要VIP",
    need_lord_level      = "需要主公",
    upgrade_consume      = "升级消耗",
    matrix_effect        = "阵法效果",
    special_effect       = "特殊效果",
    number_position      = "号位",
    can_not_recruit      = "不可招募",
    already_recruit      = "已招募",
    recruit_success      = "招募成功",
    xilian_finish        = "洗炼完成",
    sell_can_gain        = "出售可获得",
    origin_property      = "原属性",
    new_property         = "新属性",
    empty                = "空",
    finish               = "完成",
    revoke               = "撤销",
    sell_number          = "出售数量",
    sell_price           = "出售单价",
    gain_money           = "获得金币",
    please_sell_number   = "选择出售数量",
    skill_level          = "技能等级",
    achievement_level    = "成就等级",
    activated            = "激活",
    already_activated    = "已激活",
    not_activated        = "未激活",
    property_add         = "属性加成",
    need_material        = "需求材料",
    material             = "材料",
    please_select_equip  = "请先选择装备",
    activate_success     = "激活成功",
    back_pay             = "返还费用",
    reborn_gain          = "重生获得",
    smelt_gain           = "分解获得",
    reborn_weapon_to_origin = "重生后，兵器将回到初始状态",
    reborn_solider_to_origin = "重生后，将领将回到初始状态",
    please_select_property_xilian = "选择一条属性进行洗炼",
    xilian_cover_origin_property  = "洗炼后将改变原有属性",
    please_select_use_number      = "选择使用数量",
    weapon               = "兵器",
    weapon_copy          = "兵器库",
    weapon_advanced      = "兵器进阶",
    weapon_advanced_skill      = "兵器进阶后技能",
    weapon_advanced_replace_skill = "注意：兵器进阶后新技能将会替换旧技能并重置技能等级。",
    advanced             = "进阶",
    advanced_2             = "进 阶",
    advanced_success     = "进阶成功",
    select_weapon        = "选择兵器",
    zhuanjing            = "专精",
    combatValue          = "战斗力",
    proficiency          = "熟练度",
    weapon_combat        = "兵器战力",
    replace              = "更换",
    replace_2            = "更 换",
    strength_weapon      = "强化兵器",
    equip_strength       = "装备强化",
    strength             = "强化",
    strength_2           = "强 化",
    all                  = "全部",
    long_handle          = "长柄",
    single_hand          = "钝器",
    staff                = "法杖",
    sword                = "剑",
    fan                  = "扇子",
    magic_ball           = "法球",
    talent_scroll        = "兵器卷轴",
    scroll               = "卷轴",
    common               = "普通",
    easy                 = "简单",
    hard                 = "困难",
    owned_soldier        = "已拥有的将领",
    not_owned_soldier    = "未拥有的将领",
    rest                 = "休息",
    go_out_to_battle     = "出征",
    active_skill         = "主动技能",
    talent_skill         = "被动技能",
    overplus_skill_point = "技能剩余点数",
    consume              = "消耗",
    consumables          = "消耗品",
    combineSkill_Title   = "奥义",
    moraleSkill_Title    = "超必杀",
    commonSkill_Title    = "必杀",
    talentSkill_Title    = "天赋技",
    res_num_limit        = "最大容量",
    select_up_speed_card = "选择加速卡",
    cur_building_time    = "当前建造时间",
    can_sub_building_time = "可减少建造时间",
    unlock_castle = "解锁的命格",
    open_position_number  = "开启位置个数",
    max_exp_add          = "最大经验加成",
    unlock_general_manual = "解锁将领图鉴",
    general_manual = "图鉴",
    friends_num_person_level_limit = "好友度人物等级上限",
    qunxiong_challenge_limit = "群雄挑战次数上限",
    qunxiong_open = "开启群雄",
    unlock_weaponcopy = "解锁兵器库",
    unlock_multicopy = "解锁多人副本",
    weaponcopy_challengetimes_limit = "挑战令上限",
    single_levy_money = "单次征收银币",
    single_levy_wood = "单次征收木材",
    single_levy_mineral = "单次征收矿石",
    weapon_order         = "兵器品级",
    open_spectra_num     = "兵器谱激活数",
    smithy_practice_level = "熟练度上限",
    open_businessman_name = "开启商人名称",
    delete_the_read      =  "删除已读",
    one_key_receive      =  "一键领取",
    drill_pos_quality    = "训练位品质",
    drill_pos_time_count    = "训练倒计时",
    drill_pos_time_total    = "训练总时长",
    soldier_exp          = "将领经验值",
    get_exp              = "获得经验",
    exp                  = "经验",
    add_team             = "加入队伍",
    free                 = "免费",
    free_2               = "免 费",
    after_free           = "后免费",
    overplus_time        = "剩余时间",
    physics_attack_1     = "物理攻击",
    strategy_attack_1    = "策略攻击",
    curr_level           = "当前等级",
    curr_vip             = "当前特权",
    next_level           = "下一级",
    next_level_deng      = "下一等级级",
    curr_property        = "当前属性",
    limit_property       = "极限属性",
    next_level_property  = "下一级属性",
    next_level_property1  = "下级属性",
    attack_type          = "攻击类型",
    weapon_type          = "兵器类型",
    weapon_name          = "兵器名称",
    all_attr_look        = "总属性预览",
    sell_goods           = "物品出售",
    drillField           = "校场",
    drillSettlement        = "训练结算",
    --聊天
    chat_world           = "世界",
    chat_country         = "国家",
    chat_private         = "私聊",
    chat_system          = "系统",
    chat_battleField     = "战报",
    chat_customerService = "客服",
    view_playback        = "查看回放",
    chat_you             = "你",
    chat_you_to          = "你对",
    chat_say             = "说",
    chat_to_you          = "对你说",
    max_enter_tips       = "最多输入50个字",
    max_enter_tips_7     = "最多输入7个字",
    send2                = "发 送",
    --铁匠铺
    success_rate         = "成功率",
    strength_level       = "强化等级",
    advanced_desc        = "进阶后属性大幅度增加，兵器技能也会随之增强。",
    cur_strength_success_rate    = "当前强化成功率",
    smith_synthesis      = "合 成",
    one_key_synthesis    = "一键合成",
    material_unenough    = "材料不足",
    -- -- 国家
    country              = "国家",
    country_name         = "国家名称",
    country_name_1       = "国号",
    country_notice       = "国家公告",
    country_member       = "国家成员",
    country_build        = "建国",
    country_modify       = "修改",
    country_overview     = "总览",
    country_member_1     = "国家人员",
    country_rank         = "国家排名",
    personal_rank        = "个人排名",
    country_help         = "国家帮助",
    country_log          = "国家日志",
    country_setting      = "国家设置",
    country_war          = "国家战争",
    country_shop         = "国家商城",
    country_warehouse    = "国家仓库",
    country_technology   = "国家科技",
    country_shop         = "国家商店",
    country_dart         = "押镖",
    country_dartrob      = "打劫",
    country_dartwanted   = "通缉",
    country_worldboss    = "群雄逐鹿",
    country_nightWuchao  = "夜袭乌巢",
    country_monarch      = "君主",
    country_number       = "人数",
    country_add          = "加入",
    country_add2          = "加 入",
    country_create       = "创建国家",
    country_direct_add   = "快速加入",
    country_quit         = "叛 国",
    country_tichu        = "踢出",
    country_shanrang     = "禅让",
    country_contribution = "总贡献",
    country_today_contribution = "今日贡献",
    country_tech_num     = "国家科技%s阶",
    country_clear        = "清理",
    country_warehouse_level = "国家等级",
    country_position     = "官职",
    country_salary       = "国家俸禄",
    country_money_reserves    = "银币仓库",
    country_wood_reserves    = "木材仓库",
    country_ore_reserves    = "铁矿仓库",
    country_give         = "即将发放",
    country_time_desc    = "24小时发放俸禄",
    country_look_detial  = "查看详情",
    country_warehouse_up_to  = "国库升级至",
    country_reserves_up_limit_to  = "后储量上限提升至",
    country_res_protect  = "资源保护",
    country_join_condition  = "加入条件",
    country_rank         = "排名",
    country_name_1       = "国号",
    country_level_above  = "级以上",
    country_level_limit  = "等级要求",
    country_onekey_help  = "一键帮助",
    country_helper       = "帮助者",
    country_help_me_create  = "帮我建造",
    country_help_me_upgrade = "帮我升级",
    country_log_info        = "日志信息",
    system_mail          = "系统邮件",
    general              = "将领",
    role                 = "角色",
    lord                 = "领主",
    leading_actor        = "主角",
    leading_trinket      = "饰品",
    identify             = "鉴定",
    reincarnate_desc_1   = "将领50级起转生，每隔5级转生一次",
    reincarnate_desc_2   = "转生后，将领变为1级，将领等级上限提升5级",
    reincarnate_desc_3   = "每次转生，将领攻击、防御、生命值的等级成长均获得提升",
    reincarnate_desc_4   = "转生次数越多，将领提升的幅度越大",    
    turn                    = "转",
    to_up_general_level        = "用于提高将领的等级。",
    to_up_mainrole_level        = "用于提高主角的等级。",
    no_desc        = "暂无描述",
    private_chat        = "私 聊",
    wan        = "私 聊",
    wan        = "私 聊",
    ten_thousand   = "万",
    a_hundred_million   = "亿",
    level_achieve   = "等级达到",
    level_unlock   = "级解锁",
    star_unlock   = "星解锁",
    noraml_chapter   = "普通副本",
    elite_chapter   = "精英副本",
    is_or_not_buy   = "是否花费",
    activity_time   = "活动时间",
    get_reward_time   = "领奖时间",
    activity_reward   = "活动奖励",
    join2   = "参 加",
    time   = "时间",
    need_join_country   = "需加入国家",
    hole_day = "全天",
    not_limit = "不限",
    rank_locked = "榜单已锁定",
    activity_time_count_down = "活动倒计时",
    get_award_time_count_down = "领奖倒计时",
    my_fight_num_now = "我的当前战力",
    di_x_ming = "第%s名",
    di_x_x_ming = "第%s-%s名",
    rank = "排行",
    userName = "角色名",
    fighting = "战力值",
    canbuy = "可购买",
    signIn = "签到",
    di_x_day = "第%s天",
    double = "双倍",
    zi_bei = "倍",
    shengyu = "剩余",
    yuan = "元",
    can_get_next_reward = "即可领取下一阶段奖励",
    recharge_count_achieve_all = "累计充值奖励已全部达成",
    have_recharged = "已充值",
    recharge_count = "累计充值",
    un_finish = "未完成", 
    qianwang = "前往", 
    qianwang_2 = "前 往",
    preview = "预览",
    preview_2 = "预 览",
    have_finished = "已结束",
    limit_num = "限量",
    old_price = "原价",
    now_price = "现价",
    discount_time = "折扣倒计时",
    presented = "送",
    un_finish_tollgate = "未通关",
    finish_tollgate = "通关",
    already_finish_tollgate = "已通关",
    finish_tollgate_achieve = "通关达成",
    refresh_reward = "刷新奖励",
    refresh_success = "刷新成功",
    turn_ten_times = "转10次",
    open_one_times = "转一次",
    open_ten_times = "转十次",
    godfight_nums = "武神榜挑战次数",
    godfight = "武神榜",
    un_enough = "不足",
    score_recruit = "积分招募",
    get_score = "领取积分",
    rank_reward = "排名奖励",
    now_can_challange = "当前可挑战",
    time_count_down = "倒计时",
    kaiqi = "开启",
    to_get = "去获取",
    compound_cost = "合成花费",
    full = "满",
    smelt_weapon_will_get = "熔炼该兵器将获得",
    smelt = "熔炼",
    qiangzhanshengli = "抢占胜利",
    resurgence2 = "复 活",
    helibuzhen = "合理布阵",
    i_want_to_strong = "我要变强",
    level_up_to = "恭喜您等级升到",
    now_tili = "当前体力",
    max_tili = "体力上限",
    main_role_fight = "主角战斗力",
    zhuzhan_hero = "助战英雄",
    matrix = "阵法",
    levelup_effect = "升级效果",
    role_choose = "角色选择",
    elite_chapter_challenge_times = "精英副本挑战次数",
    now_left_free_times = "今日剩余免费次数",
    left_free_times = "剩余免费次数",
    left_challenge_times = "剩余挑战次数",
    haicha = "还差",
    have_already_get = "已获得",
    get = "获得",
    have_already_enough = "已足够",
    ci = "次",
    now_sweeping = "正在扫荡",
    type_tollaget_drop = "此类型关卡掉落",
    godweapon_advance_scroll = "神兵进阶卷轴",
    tollgate_introduce = "关卡介绍",
    drop = "掉落",
    cost_tili = "消耗体力",
    force_attact = "强攻",
    auto_sell = "自动出售",
    get_success = "领取成功",
    chuangguan = "闯关",
    shouguan = "守关",
    achieve = "达到",
    star_reward = "星奖励",
    num_zhang = "章",
    num_di = "第",
    num_chong = "重",
    num_guan = "关",
    num_ceng = "层",
    goto_rightnow = "立即前往",
    breakthrough = "突破",
    breakthrough_2 = "突 破",
    already1 = "已",
    is_stop_train = "是否终止训练",
    qing_zhuansheng = "请转生",
    lang_press_to_tufei = "长按可连续突飞",
    recieve_email_box = "收件箱",
    write_email = "写信",
    notice = "公告",
    title = "标题",
    receiver = "收件人",
    enter_title = "请输入标题",
    enter_receiver_name = "请输入收件人名称",
    enter_email_text = "请输入邮件内容",
    enter_text = "请输入信息",
    add = "添加",
    friends_num = "好友数量",
    renqi = "人气",
    youqing = "友情",
    tongyi_2 = "同 意",
    jujue_2 = "拒 绝",
    yichu_2 = "移 除",
    add_friend = "添加好友",
    all_tongyi = "全部同意",
    one_key_jujue = "一键拒绝",
    jump_guide = "跳过引导",
    jump_story = "跳过剧情",
    reborn = "重生",
    can_reborn_hero = "可重生将领",
    smelt = "分解",
    smelt2 = "分 解",
    can_smelt_hero_card = "可分解将领卡",
    reborn_need_off_line = "将领需下阵后才可重生",
    smelt_gain_breakthroughstone = "分解将获得突破石",
    smelt_can_get_after_things = "级将领的碎片，将获得以下奖励",
    today_have_levy = "今日已征收",
    single_levy = "单次征收",
    levy_2 = "征 收",
    force_levy_1 = "强征",
    force_levy_10 = "强征10次",
    levy_gain = "征收获得",
    earnings = "收益",
    tactical_analysis = "战术分析",
    unlock_need_score = "解锁需要特训积分",
    quit_2 = "退 出",
    to_choose_server = "请选择服务器",
    area = "区",
    login_fail = "登录失败",
    recommend = "推荐",
    all_server = "所有服务器",
    last_login_server = "上次登录服务器",
    server = "服务器",
    huangjin_army = "黄巾军",
    xiliang_army = "西凉军",
    shu_army = "蜀军",
    worldboss_reward_send_tips = "国家奖励在活动结束后发放到国家仓库",
    hurt = "伤害",
    my_hurt = "我的伤害",ips = "国家奖励在活动结束后发放到国家仓库",
    hurt = "伤害",
    player = "玩家",
    rank_change = "排行切换",
    unlock_condition = "解锁条件",
    no = "无",
    fighting = "战力",
    give_up = "放弃",
    give_up_2 = "放 弃",
    reserve_totle_num = "储备总量",
    send_count_time = "发放倒计时",
    my_salary = "我的俸禄",
    country_reserve = "国家储备",
    luoyang = "洛阳",
    luoyang_city = "洛阳城",
    changan_city = "长安城",
    level_up_time_count_down = "升级倒计时",
    items2 = "道 具",
    limit_time_2 = "限 时",
    reward_2 = "奖 励",
    left_fresh_time = "剩余刷新时间：",
    today_can_buy = "今日可买",
    need_country_tech = "需要国家科技",
    country_left = "国家剩余",
    save = "保存",
    see_apply_for = "查看申请",
    leixing = "类型",
    my_promotion = "我的官职",
    panguo_tips = "叛国之后24小时不可加入其他国家",
    promotion = "升 官",
    direct_promotion = "直接升官",
    promotio_need_fight = "升官需要战胜",
    is_to_fight = "是否发起战斗",
    not_conform_to_promotion_candition = "不符合升官条件",
    not_conform_to_promotion_candition2 = "贡献不足不可挑战",
    country_permission_unenough = "国家权限不够",
    seized = "抢占了",
    defended = "驻守的",
    zi_de = "的",
    seized_mycountry_defended = "抢占了本国驻守的",
    in_time_success_defended = "在结算时间内成功驻守",
    recieve_huge_money = "获得大量银币",
    cannot_join = "不可加入",
    dart_help_tip = "建造可减少时间，可提升押镖安全",
    level_dart_help_apply_for = "级押镖申请押镖支援",
    now_have_no_dartwanted_player = "暂无被通缉的玩家",
    now_have_no_dartrob_player = "暂无可劫掠的镖车",
    dartrob_tips = APP_REVIEW and "[color=ff4c1212]首次劫掠至尊级[/color][color=ffff3644]免费[/color]" or "[color=ff4c1212]首次劫掠S级[/color][color=ffff3644]免费[/color]",
    dart_result_success_tip = "押镖完成，获得如下物资",
    dart_result_rob_success = "成功劫掠了来自",
    such_goods = "如下物资",
    dart_result_be_robed_success = "打劫了你的镖车，损失了如下物资",
    dart_apply_your_help = "同意了您的帮助请求",
    dart_main_tips = "\t\t\t\t\t本次押镖失败！\n\n注意：在押镖过程中退出押镖页面，会被判定为本次押镖失败。",
    dart_left_help_time = "剩余支援次数",
    chufa = "出发",
    dart_now_have_no_can_help_member = "暂无可支援的国家成员!",
    dart_today_have_no_help_times = "今日已无被支援次数",
    get_dart = "接镖",
    dartget_tips = APP_REVIEW and "[color=ffdeb05d]首次接取至尊级任务[/color][color=ffff3644]免费[/color]" or "[color=ffdeb05d]首次接取S级任务[/color][color=ffff3644]免费[/color]",
    country_tech_level_up_tip = "只有君主、丞相可以升级国家科技",
    country_tech_max_level = "已达到最大等级",
    country_tech_level_up_time = "升级时间",
    country_tech_desc = "科技描述",
    country_member_ask_for_member = "申请成员",
    country_member_ask_for_time = "申请时间",
    congratulations_extra_to_get_reward = "恭喜你额外获得如下奖励",
    congratulations_to_get_reward = "恭喜你获得如下奖励",
    dismissTeam = "解散队伍",
    start_fight = "开始挑战",
    outTeam = "退出队伍",
    seize_times = "抢占次数",
    SEND_INVITE = "发送邀请",
    SENDTOWORLD = "发送世界",
    SENDTOCOUNTRY = "发送国家",
    unReady = "取消准备",
    doReady = "准备",
    start_seize = "开始抢占",
    team_to_fight = "带队攻打",
    heros_to_join = "各路英雄快来加入",
    heros_to_join = "各路英雄快来加入",
    reward_after_clearing = "结算后获得",
    may_reward = "概率获得",
    may_reward_after_clearing = "结算后有概率获得",
    may_reward_after_seize = "抢占后有概率获得",
    may_reward_after_seize = "抢占后有概率获得",
    seize_country = "占领国",
    un_seize = "未被占领",
    clearing_count_time = "结算倒计时",
    for_country_reward_after_clearing = "结算后为占领国家提供",
    for_member_reward_after_clearing = "结算后为驻守成员提供",
    defend_2 = "驻 守",
    seize_2 = "抢 占",
    invite_country_member_seize = "邀请国家成员抢占",
    invite_country_member_defend = "邀请国家成员驻守",
    invite_success = "邀请成功",
    today_left_buy_times = "今日剩余购买次数",
    today_already_buy_times = "今日已购买次数",
    buy_energy_tips = "[color=ffff0000]注：[/color]每两小时恢复一个挑战令",
    sure_to_double_in_1day = "确定在1天内加倍",
    dechanliang = "的产量么",
    have_already_ask_for_country_help = "已请求国家帮助",
    main_line = "主线",
    back_to_city = "回城",
    activity = "活动",
    new_server_activity = "新手活动",
    sevenday_activity = "七日活动",
    give_caohong = "送曹洪",
    recharge = "充值",
    fisrt_recharge = "首充",
    leisure = "空闲",
    see_fightreport = "查看战报",
    next_tiao = "下一条",
    jieshou_2 = "接 受",
    invite_to_defend = "邀请你驻守",
    denfend_now = "立即驻守",
    invite_to_seize = "邀请你加入抢占",
    func = "功能",
    coming_soon = "即将开放",
    challenge_house = "挑战建筑",
    copy_open_week = "本副本星期",
    open = "开放",
    autoJoin = "自动加入",
    createTeam = "创建队伍",
    possible_to_get_rewards = "可能获得以下奖励",
    known = "知道了",
    mainhero_achieve_space_level = "主角等级达到     级",
    and_house_level_achieve_space_level_open = "且酒馆等级达到     级开启",
    single_chou_2 = "单 抽",
    shilian_2 = "十 连",
    shilian = "十连",
    must_get = "必得",
    is_or_not_zhaomu_hero = "是否招募该将领",
    copy_drop = "副本掉落",
    duihuan = "兑换",
    duihuan_2 = "兑 换",
    shilianchou = "十连抽",
    today_can_duihuan_space_ci = "今日可兑换      次",
    goods_box = "宝箱",
    bangwai = "榜外",
    rank_title_tip1 = "获取途径：成为本榜单第",
    rank_title_tip2 = "时间期限：仍占据本榜单第",
    num_ming = "名",
    to_get_right_now = "立即获得",
    to_get_every_day = "每日领取",
    right_now_have_buy = "当前已购买",
    is_or_not_to_get = "是否前往领取",
    vip = "至尊",
    shengjie_2 = "升 阶",
    right_now = "当前",
    num_unenough = "数量不足",
    reset = "重置",
    reset_2 = "重 置",
    use_bingfa = "启用兵法",
    tingzhi_2 = "停 止",
    bingshutexing = "兵法特性",
    all_active_can_jinjie = "全部激活可进阶",
    already_full_jie = "已满阶",
    fubing_level = "兵法等级",
    use_effect = "启用效果",
    use_special = "启用特性",
    base = "基础",
    reset_will_back_all_resource = "重置该兵法返还所有培养物资",
    biyuexiuhua = "闭月羞花",
    yuanshenfenjie = "元神分解",
    sell_hero_card_get = "出售将获得",
    can_free_fresh = "可免费刷新",
    and_yanjiuyaun_achieve_level = "且研究院等级达到",
    attack_times = "进攻次数",
    enter_active_code = "请输入激活码",
    enter_name = "请输入姓名",
    id_card = "身份证",
    enter_id_card_num = "请输入身份证号",
    commit_2 = "提 交",
    game_name = "昵称",
    no_have_for_now = "暂无",
    items_preview = "道具预览",
    resource_preview = "资源预览",
    zhaomujuan = "招募卷",
    kuangshi_chang = "矿石场",
    mucai_chang = "木材场",
    nums = "数量",
    totle_capacity = "总容量",
    tili_recover_time = "体力恢复时间",
    tili_all_recover = "体力全部恢复",
    sount_effect_ctrl = "音效开关",
    sount_music_ctrl = "音乐开关",
    exchange_code = "兑换码",
    change_account = "切换账号",
    true_name_certification = "实名认证",
    beijiangli = "倍奖励",
    main_role_advance_to = "主角资质进阶为",
    new = "新",
    attribute_up = "属性提升",
    all_heros = "全体",
    reset_all = "重置全部",
    reset_castle = "重置命格",
    can_active = "可激活",
    need_prefore = "需前置",
    active_condition = "激活条件",
    house_level = "建筑等级",
    through_now_chapter_can_get = "通关当前章节可领取",
    friendship_plus = "亲密度加成",
    friendship = "亲密度",
    level_more_plus_more = "等级越高，属性越高",
    use_love_can_plus_50 = "使用爱心标记的礼物会获得50%的加成",
    tongquetai_house_level_achieve =  "铜雀台建筑达到",
    goto_jiuguan = "前往酒馆",
    use_gold_can_get_rare_gem = "使用元宝可获得稀有宝石",
    greetings = "问候",
    patronize = "宠幸",
    endear = "亲近",
    every_week = "每周",
    may_trigger_boss_fight = "有几率触发BOSS战",
    disappear_time = "消失时间",
    dazhao_weapon = "打造兵器",
    valuate = "评价",
    star = "星",
    can = "可以",
    yuji_time = "预计时间",
    zhengtao = "征讨",
    zhengtao_2 = "征 讨",
    immediately_complete = "立即完成",
    can_zhengtao_times = "可征讨次数",
    zhengtao_can_get_unless_equip_resource_and_all_rewards = "征讨可获得除装备进阶卷轴外的所有关卡奖励",
    left_zhengtao_times = "剩余征讨次数",
    now_zhengtao = "正在征讨",
    un_equiped = "未装备",
    can_advance_to = "可进阶为",
    cur_level_up_success_rate = "当前升级成功率",
    up_strength_success_rate = "提升成功率",
    daozao = "打造",
    daozao_ing = "正在打造",
    base_attack = "基础攻击",
    append_attack = "附加攻击",
    base_defence= "基础防御",
    append_defence = "附加防御",
    base_hp = "基础生命",
    append_hp = "附加生命",
    level_limit = "等级上限",
    use_xinde = "使用心得",
    yanxi_2 = "研 习",
    long_press_can_yanxi = "长按可连续研习",
    all_pactice_reach_level = "所有熟练度都达到",
    can_goon_yanxi = "级后才可继续研习",
    re_choose = "重新选择",
    weapon_list = "兵器列表",
    need = "需要",
    num_ba = "把",
    un_casted = "未锻造过",
    de_weapon = "的兵器",
    merit_reward = "成就奖励",
    grab_food_rank = "抢粮榜",
    grab_food_times = "抢粮次数",
    cur_foodroom_level = "当前粮仓等级",
    up_limit = "上限",
    zi_wo = "我",
    zi_de = "的",
    zi_pai = "排",
    zi_ming = "名",
    zi_shang = "上",
    zi_qi = "期",
    already_have_role = "已拥有的角色",
    un_have_role = "未拥有的角色",
    general_is_lock = "该将领暂未解锁",
    already_achieved_limit = "已达上限",
    advance_to = "进阶至",
    quality = "品质",
    can_goon_strength = "可继续强化",
    achieve_to_max_level = "已达到最大进阶等级",
    fetter_unactive = "羁绊尚未激活",
    next_level_need = "下一级需要",
    attribute_plus_for_all = "属性加成针对所有",
    general_fetter = "将领羁绊",
    regional_map = "地域版图",
    fetters_up_tips = "提升将领的等级和星级可增加羁绊属性的加成",
    fetter_list = "羁绊列表",
    un_deblocking = "未解锁",
    fetters_achieve = "羁绊达成",
    collect = "收集",
    un_achieve = "未达成",
    white_color = "白色",
    get_gem = "获取勾玉",
    one_key_inlay = "一键镶嵌",
    inlay = "镶嵌",
    please_choose_level = "请选择武器",
    have_no_can_inlay_gem = "无可镶嵌的勾玉",
    have_no_can_inlay_herosoul = "无可装备的灯魂",
    same_type_herosoul_can_inlay_onlyone = "同类型灯魂只能装备一个",
    already_max_level_gem = "已是顶级勾玉",
    already_max_level_herosoul = "已是顶级灯魂",
    choose_gem = "请选择勾玉",
    have_num = "拥有数量",
    equiped_by = "装备于",
    already_choosed = "已选择",
    one_key_choose = "一键选取",
    choose_gem_to_max_num = "选取勾玉达到上限",
    choose_herosoul_to_max_num = "选取灯魂达到上限",
    already_up_to_max_star = "已升至最高星级",
    up_to = "升至",
    star_unlock_skill = "星解锁技能",
    position_un_equip_trinket = "该位置未装备饰品",
    trinket_totle_num = "饰品总数",
    level_unenough = "等级不足",
    main_role = "男主",
    woman_role = "女主",
    qiecuo_2 = "切 磋",
    weapon_quality = "兵器资质",
    count_food_num_achieve = "累计粮草数量达到",
    food = "粮草",
    already_be_defeated = "已经被击败",
    achieve_conditions_can_get = "达到指定条件就可领取相应奖励",
    go_zhaomu = "去招募",
    zhaomu_times = "招募次数 [color=ffffffff]%d次[/color]",
    hero_detail = "将领详情>>",
    zhaomujilei_pop_discribe_1 = "活动期间，所有消耗招募券的卡包都",
    zhaomujilei_pop_discribe_2 = "有概率招募到",
    zhaomujilei_pop_dis_name = "马超",
    zhaomujilei_pop_dis_chenghao = "【神威的天将军】",
    shijian = "时间：",
    can_exchange_times = "可兑换%d次",
    soulfete = "猎魂",
    include_equiped = "含已装备",
    light_heroSoul = "灯魂",
    zengjia = "增加",
    retry_2 = "重 试",
    zi_zhejia = "折价",
    person = "个  人",
    country_ = "国  家",
    xiazhen = "将领需下阵后才可重生,是否将其下阵?",
    yangcheng = "养成",
    zhanfa = "战法",
    xiaoguoyulan = "效\n果\n预\n览",
    xiaoguoyulan_ = "效 果 预 览",
    weaponType = "武器类型",
    gailv = "概率",
    mainTarget = "主目标",
    huihe = "回合",
    xiqu = "吸取",
    life = "的生命值",
    clear = "清除",
    shiqi = "的士气",
    shi_ = "使",
    pugong = "普攻",
    jiang = "将",
    cjnxx = "从技能上卸下吗？",
    xxfh = "卸下只返回升级花费的所有将领碎片及",
    sjzy = "升级资源",
    tupoLimit = "突破",
    xiaohao = "消\n耗",
    success = "成功",
    gongji = "攻\n击\n型",
    fuzhu = "辅\n助\n型",
    isUseThisSKill = "是否启用该奥义?",
    fujiashuxing = "附加属性",
    manji = "战法已达上限",
    jiefeng = "解封",
    thisHeroUsing = "该武将已被使用!",
    zhanfa_xiazhen = "该武将已上阵，是否下阵？",
    zhaungbeied = "已被装备于",
    isXiexia = "是否前往卸下？",
    sameRole = "同一类型武将只能镶嵌两个",
    other_role = "已经装备了其他将领战法，是否前往卸下？",
    tips_duihuan_success = "兑换成功！",
    openInfo = "战法功能开启后解锁",

    limitTimeHot = "限时热点",
    zmkdh = "招募该将领后可兑换",
    xiaofeiCount = "累计消费",
    tishengVip = "提升VIP可获得更多刷新次数",
    tisheng_ = "提升VIP",
    fuli = "福利",
    vip_max = "刷新次数已达上限",
    daozaoFJ = "打造附加产量",
    dancong = "每日单笔充值金额达到指定额度即可领取丰厚大礼",
    danbi_cong = "单笔充值",
    can_get_times = "可领取",
    target = "目标",
    meichongzhi = "每充值",
    getChange = "获得一次抽奖机会",
    againCz = "再充值",
    cangetChange = "可获得抽奖次数",

    herocopy_countLimit = "今日购买次数已达上限",
    herocopy_country1 = "魏",
    herocopy_country2 = "蜀",
    herocopy_country3 = "吴",
    herocopy_country4 = "群雄",
    herocopy_noTimes = "次数已用完!",
    herocopy_firstReward = "首杀奖励",
    herocopy_get = "得",
    herocopy_reward = "奖励",
    herocopy_cannot = "不允许出战武将所属:",
    herocopy_star = "本章得星达",
    herocopy_unlock = "关卡未解锁",
    zmkdh = "招募该将领后可兑换",
    heroCopy_copyName = "一骑当千",
    Make_breakItem = "进阶材料",
    Make_starItem = "升星材料",
    Make_making = "打造中...",
    Make_canGet = "可收获...",
    Make_leftTime = "倒计时: ",
    Make_makeFinish = "打造完成",
    Make_pleaseUplevel = "请提升铁匠铺等级，开启该位置",
    Make_startMake = "开始打造",
    Make_selectItem = "请选择材料",
    Make_add = "增加",
    Make_baseNum = "基础产量",
    Make_topTitle = "提示：提升铁匠铺可增加附加产量",
    Make_freeFreshTime = "免费刷新时间:",
    Make_freshNow = "立即刷新",
    Make_getNow = "立即收获",
    Make_get = "收获",
    Make_houseLv = "铁匠铺Lv",
    active_date = "活动日期",
    active_recharge = "活动内充值：",
    change_name_card = "改名卡",
    change_name_hou = "来修改",
    -- 分享
    share_txt_1 = "微信",
    share_txt_2 = "朋友圈",
    share_txt_3 = "facebook",
    share_part_1 = "服务器：",
    share_part_2 = "地址：qlzj.zhanyougame.com",
    -- 神兵改
    change_shenbing = "切换神兵",
    change_shenbing_cost = "切换花费：",
    unlock_shenbing = "打造神兵",
    -- 提示语言包
    tips_send_success           = "发送成功",
    tips_function_not_open      = "功能暂未开放",
    tips_resourse_deficiency    = "资源不足",
    tips_lord_level_deficiency  = "领主等级不足",
    tips_buy_payqueue           = "是否要花费 250元宝 购买一个付费队列？（持续24小时）",
    tips_buildingQueue_full     = "建筑队列已满",
    tips_please_build_pub        = "请先创建酒馆",
    tips_please_build_smithy     = "请先创建铁匠铺",
    tips_please_select_private_chat_user     = "请选择私聊对象",
    tips_please_join_country     = "请先加入国家",
    tips_speed_up_finish        = "加速完成",
    tips_speed_up_success       = "提速成功",
    tips_user_level_deficiency  = "玩家等级不足",
    tips_house_level_deficiency  = "建筑等级不足",
    tips_battle_field_success   = "分享战报成功",
    tips_buy_success            = "购买成功",
    tips_max_level              = "已达最高等级，无法继续升级",
    tips_max_level_only         = "已达最高等级",
    tips_contribution_full      = "捐献已满，无法继续捐献",
    tips_country_name_empty     = "国家名称为空",
    tips_country_notice_empty   = "国家公告为空",
    tips_country_create_success = "创建国家成功",
    tips_country_notice_identical      = "国家公告与之前相同，不需要修改",
    tips_modify_success         = "修改成功",
    tips_money_deficiency       = "银币不足!",
    tips_gold_deficiency        = "元宝不足",
    tips_please_drill_time      = "请选择训练时间",
    tips_checkpoint_not_open    = "关卡未开启",
    tips_matrix_full_level      = "阵法已满级",
    tips_need_player            = "需要玩家",
    tips_soldier_activation     = "将领尚未激活，无法招募",
    tips_no_trinkets_sell       = "无可饰品可卖",
    tips_no_prop_can_sell       = "道具数量过少，无法售出",
    tips_solider_level_reach_main_role_level  = "将领等级已达到主角等级",
    tips_please_select_hero = "请先选择英雄",
    tips_no_have_this_type_goods = "无此类型商品",
    tips_go_to_soldier_view = "没有可训练将领",
    tips_mail_open_faild = "邮件打开失败",
    tips_country_contributeCD_clear = "您捐献的过于热情，请稍后再捐献，您也可以花费一些元宝直接清除冷却时间！",
    tips_network_failed             = "无法连接到服务器，请稍后重试！",
    tips_http_error_1               = "暂时无法连接，请稍后重试！",
    tips_downloadmanager_fail       = "下载失败",
    tips_network_error              = "当前网络不佳！正在努力重连！",
    tips_network_not_reachable      = "无法获取网络连接，请检查网络后重试！",
    tips_data_error                 = "解析数据出错，请稍后再试",
    tips_response_error             = "请求错误：状态值异常",
    tips_click_empty_continue       = "点击空白区域继续",
    tips_add_friend_send_already    = "请求已发送，请耐心等待...",
    tips_info_error                 = "信息错误！",
    tips_delete_friend_success      = "删除好友成功！",
    tips_besure_delete_friend      = "你确定要删除好友吗？",
    tips_chapter_no_open      = "章节未开启！",
    tips_login_error     = "登录异常，请重试！",
    tips_game_version_low     = "您安装的游戏版本过低，请下载最新游戏安装包重试！",
    tips_clean_warning  = "注意：清除数据后可能需要重新下载补丁包，但不会影响游戏数据、账号等相关信息，建议该功能只在游戏出现异常状况时使用，您确定清除缓存吗？",
    tips_chapter_unlock = "该副本暂未解锁！",
    tips_multicopy_unopen = "多人副本尚未开启！",
    tips_unjoin_country = "尚未加入国家！",
    tips_armyshop_unopen = "军功商店未开启",
    tips_expcardshop_unopen = "突飞卡商店未开启",
    tips_shop_unopen = "商店未开启",
    tips_activity_finished = "活动已结束！",
    tips_buyTollgate_times = "是否重置关卡挑战次数 %s 次",
    tips_recharge_unopen = "充值暂未开放",
    tips_general_unopen = "该将领暂未开启",
    tips_black_player_already = "已屏蔽该玩家...",
    tips_unblack_player_already = "已从黑名单移出该玩家...",
    tips_unable_look_player = "无法查看该角色信息",
    tips_unable_look_self = "无法查看自己的信息",
    tips_relogin = "请重新登录!",
    tips_fight_data_unexit = "战斗数据不存在！!",
    tips_fight_report_outoftime = "战报信息已过期!",
    tips_synchronization_info = "正在同步充值信息，请稍后...",
    tips_have_no_uninlay_gem = "没有未镶嵌勾玉",
    tips_occupation_success = "占领成功！",
    tips_blackmarket_fresh = "您的商品列表中还有紫色商品为购买哦！确定刷新么？\n（点击“勾选后刷新不变”不再提示！）",
    tips_blackmarket_countfresh = "您已锁定全部商品，无法刷新！",
    tips_can_get_after_buy = "购买后可领取！",
    tips_less_level_cannot_get = "等级不足！当前不可领取！",
    tips_buy_growup_canget = "购买基金，达到相应等级，可领取",
    tips_click_box_can_preview = "点击可预览礼包奖励",
    tips_sign_buqian = "是否花费%s元宝补签？",
    tips_mouthcard_tip1 = "月卡和终身卡可 [image=res/Main/activity/mounthCard/bothHave.png offsety=-10][/image] 哦！",
    tips_mouthcard_tip2 = "每天可领取[color=ffffff00]%s[/color]元宝",
    tips_sevenday = "完成指定任务越多获得奖励越丰富",
    tips_weaponday = "只可以从六种兵器中选择一把，选择后无法更改",
    tips_weaponday_tip = "(提示：长按可查看兵器属性)",
    tips_weaponday_need_choose = "请选择一把兵器!",
    tips_gold_unenough = "元宝不足!",
    tips_godfight_cding = "挑战冷却中!",
    tips_godfight_clearcd = "是否花费%s元宝清除挑战CD",
    tips_godfight_clear_success = "清除成功!",
    tips_qiangzhanzhushou_success = "抢占【%s】驻守的“%s”成功",
    tips_result_challenge_success_unlock_train_position = "挑战成功，训练位解锁!",
    tips_resurgence = "选择一个属性加成，然后复活",
    tips_only_mainrole_online = "只有主角可上阵！",
    tips_same_general_online = "只有主角可上阵！",
    tips_no_position_online = "没有阵位可以上阵!",
    tips_online_num_limit = "上阵将领数量已达上限!",
    tips_vip_unenough_to_open_zhen = APP_REVIEW and "至尊等级不足，阵法无法开启!" or "vip等级不足，阵法无法开启!",
    tips_level_unenough_to_open_zhen = "等级不足，阵法无法开启!",
    tips_mainrole_cannot_offline = "主角不能下阵!",
    tips_same_hero_online = "已有相同的英雄在阵上",
    tips_tili_unenough = "体力不足！",
    tips_trinkets_full = "饰品背包已满，请先整理饰品!",
    tips_send_words = APP_REVIEW and "至尊1及以上玩家才可在世界发言" or "VIP1及以上玩家才可在世界发言",
    tips_unopen_fornow = "暂未开启",
    tips_unselected_train_position = "未选择训练位!",
    tips_tufei_not_enough_tobuy = "突飞卡不足，是否前往商店购买？",
    tips_have_no_email_to_delete = "没有可删除的邮件",
    tips_have_no_rewards_to_get = "当前没有可领取的物品！",
    tips_search_info_cannot_empty = "查找信息不可为空！",
    tips_search_empty = "抱歉！没有查找到相关玩家",
    tips_add_friend_waiting = "好友申请正在处理中，请稍候...",
    tips_already_friend_no_add = "已经是好友不需要再次添加！",
    tips_player_in_black_list = "该玩家正在黑名单中！",
    tips_today_have_send = "今日已赠送！",
    tips_tili_send_success = "体力赠送成功！",
    tips_sure_to_delete_friend = "你确定要删除好友吗？",
    tips_sure_to_remove_player_black_list = "你确定要将该玩家移除黑名单吗？",
    tips_add_friend_fail_in_black_list = "添加失败, 你在对方的黑名单中!",
    tips_add_friend_fail_in_list_full = "添加失败, 对方好友数量已达上限!",
    tips_friend_num_limit = "好友数量已达上限!",
    tips_friend_now_have_no_response = "当前没有好友申请请求!",
    tips_friend_tips1 = "众里寻她千百度，一枝红杏出墙来",
    tips_friend_tips2 = "好友这么多，大人真是好人缘~",
    tips_to_choose_reborn_target = "请选择重生对象",
    tips_no_need_to_reborn = "无需重生",
    tips_to_choose_smelt_target = "请选择分解对象",
    tips_to_choose_preview_target = "请选择预览对象",
    tips_no_smelt_target = "没有可分解的对象！",
    tips_to_choose_smelt_targets_level = "请选择可分解的将领卡品级！",
    tips_free_levy_times_have_over = "今日征收次数已用完!",
    tips_unlock_success = "解锁成功!",
    tips_sure_to_quit = "你确定要退出游戏吗？",
    tips_get_serverlist_success = "获取服务器信息成功",
    tips_get_serverlist_fail = "无法获取服务器信息！",
    tips_worldboss_unopen = "群雄逐鹿未开启!",
    tips_country_tech_full_level = "当前科技已经满级!",
    tips_country_tech_cannnot_donate = "当前科技不能捐献!",
    tips_set_success = "设置成功!",
    tips_is_out_country = "您确定要叛国吗？（叛国后贡献清空，且24小时内不可加入其他国家）",
    tips_kick_out_success = "踢出成功!",
    tips_is_to_kick_out = "确定将该玩家踢出国家吗？",
    tips_demise_success = "禅让成功！",
    tips_is_to_demise_to = "确定将君主禅让给该 %s 吗？",
    tips_apply_for_success = "申请成功!",
    tips_dart_finished = "押镖已结束！",
    tips_dart_to_help_success = "支援成功!",
    tips_country_to_help_success = "帮助成功!",
    tips_country_have_no_to_help = "没有可帮助的建筑!",
    tips_dart_quit = "退出后会浪费一次押镖的机会，且消耗的物品也不返还，是否退出？",
    tips_darting = "正在押镖!",
    tips_dart_out_of_time = "本次押镖已超时，请重新接镖!",
    tips_country_member_no_ask_player = "没有申请玩家！",
    tips_do_success = "操作成功！",
    tips_is_to_quit_team = "是否要退出队伍",
    tips_quit_team_success = "退出队伍！",
    tips_is_to_dissolve_team = "是否要解散队伍",
    tips_dissolve_team_success = "队伍解散！",
    tips_kicked_out_team = "你被踢出队伍！",
    tips_leader_can_use_func = "队长才可使用该功能",
    tips_send_words_cding = "发送消息cd中，请稍候...",
    tips_invite_cding = "邀请cd中，请稍候...",
    tips_kick_out_player = "提出玩家！",
    tips_is_kick_out_team = "是否要将玩家“%s”踢出队伍",
    tips_buy_times_limit = "购买次数达到上限!",
    tips_sure_to_dismantle_house = "是否确定要拆除改建筑？",
    tips_worldboss_iscoming = "群雄逐鹿即将开放，请主公快来大显身手！",
    tips_dart_ask_for_help = "国家成员正在押镖，请求你的支援！",
    tips_dart_start = "押镖开始了，请主公快来护送吧！",
    tips_field_resourse_full = "野外物资已达累计上限，快去收取吧！",
    tips_have_no_team_to_join = "暂无可加入的队伍！",
    tips_wait_to_jion = "正在挑战\"%s\",请求其他协助者加入。",
    tips_fight_less_2_player = "玩家人数小于2人不能开始战斗！",
    tips_fight_player_not_ready = "有玩家未准备，请稍候！",
    -- tips_duihuan_success = "对话成功！",
    tips_juanzhou_unopen = "所属卷轴未开启！",
    tips_rank_fresh_time = "排行榜每小时更新一次",
    tips_recharge_success = "恭喜您，充值成功！",
    tips_bingfa_max_level = "当前兵法已经进阶到最大等级!",
    tips_bingfa_un_active = "该兵法还未激活!",
    tips_choose_one_bingfa = "请选择一件兵法！",
    tips_now_cannot_reset = "当前不可重置！",
    tips_use_success = "启用成功!",
    tips_tingyong_bingfa = "停用兵法!",
    tips_sure_to_reset_bingfa = "是否重置该兵法？",
    tips_no_more_hero_cards = "没有多余的将领卡!",
    tips_qunxiong_unopen = "该群雄未开启!",
    tips_hero_card_unenough = "将领卡组合未凑齐!",
    tips_challenge_times_over = "当前挑战次数已经用完!",
    tips_recover_every_hour = "每小时恢复一次！",
    tips_sure_to_get_card = "你确定要兑换该将领卡吗？",
    tips_renzheng_success = "认证成功！",
    tips_renzheng_fail = "认证失败，请重试！",
    tips_have_already_pass_certification = "您已通过了实名认证！",
    tips_shop_unopen = "该商店未开启!",
    tips_no_need_to_reset_castle = "暂无激活命格，无需重置!",
    tips_isto_castle_reback_all = "重置命格，所有消耗将全部返还。是否重置?",
    tips_need_active_prefore_castle = "需要激活前置命格!",
    tips_castle_ceng_unopen = "该层命格未开启!",
    tips_castle_need_resource_unenough = "所需资源不足!",
    tips_level_unenough_to_look = "等级不足，当前无法查看！",
    tips_now_main_task_all_finish = "当前主线任务已全部完成",
    tips_reward_fight_can_only_attack_once = "奖励战役只能攻打一次",
    tips_through_tollgate_condition_unenough =  "过关条件未达成！",
    tips_today_reset_times_over =  "今日重置次数已用完！",
    tips_tostrart_new_challenge = "是否开始新一轮挑战？当前进度会被重置",
    tips_now_cannot_sweep = "当前不能扫荡！",
    tips_now_cannot_zhengtao = "当前不可征讨！",
    tips_zhengtao_time_unenough_back_tomorrow = "征讨次数不足，请明日再来！",
    tips_zhengtao_time_unenough_up_vip = "征讨次数不足，请先提升VIP等级！",
    tips_first_breakthrough_chapter_can_get = "首次通关章节可获得",
    tips_to_choosse_cost_weapon = "请选择消耗的兵器！",
    tips_congratulation_achieve_full_level = "恭喜将该成就升至满级！",
    tips_after_advance_godweapon_tip = "进阶后属性大幅度增加，兵器技能也会随之增强。",
    tips_congratulation_godweapon_full_level = "恭喜已达到满级！",
    tips_godweapon_strength_fail = "强化失败!",
    tips_godweapon_levelup_fail = "升级失败!",
    tips_practice_desc = "兵器品级越高，收益越高。",
    tips_practice_reach_full_level = "已达最大等级上限!",
    tips_practice_up_house_can_yanxiu = "提升铁匠铺等级才可继续研习!",
    tips_goods_unenough = "物品不足！",
    tips_not_selected_weapon = "尚未选择兵器！",
    tips_weapon_cast_to_limit = "该兵器已锻造至等级上限！",
    tips_click_right_to_choose_weapon_cast = "点击右侧兵器图标，选择要锻造的兵器",
    tips_player_have_already_be_robed = "该玩家已被抢夺过！",
    tips_challenge_mainline_or_weaponcopy_can_get_is_go = "挑战主线或兵器库副本都可获得兵器，是否前往？",
    tips_challenge_eaponcopy_can_get_is_go = "挑战兵器库副本可获得各类兵器，是否立即前往？",
    tips_hero_fragment_unenough = "将领碎片不足！",
    tips_left_times_unenough = "剩余次数不足！",
    tip_zhaomu_discribe = "本卡包招募 [color=ffff0000]%s[/color] 次,必得 [image=%s offsety=-8 w=%d h=%d][/image] 级将领",
    tip_exchange_activity_desc = "活动期间，挑战 [color=ffff0000][size=17]%s[/size][/color] 即有概率获得招财猫！",
    tip_exchange_tip = "是否要兑换%s？",
    tip_exchange_unenough = "道具不足！",
    tip_exchange_herosoul_ask = "是否要兑换该灯魂？",
    tip_no_soul_to_gather_fornow = "暂无可收取的灯魂！",
    tip_no_soul_to_sell_fornow = "暂无可出售的灯魂！",
    tip_soulbag_is_full_to_tidy = "拥有灯魂数量已达上限，请先升级灯魂！",
    tip_bubble_godfight_canreward = "武神榜奖励已经可领取，请主公前往领取！",
    tip_jiejiegao = "活动期间内充值达到相应档位，可按比例获得元宝返利，返利元宝直接为您添加上",
    tip_change_name = "点击输入你的新名字",
    tip_change_name_tip = "(每七天可以修改一次)",
    tip_buy_card = "是否话费%s元宝购买改名卡？",
    tip_changename_2 = "用户名不能为空",
    tip_changename_3 = "修改成功",
    tip_share_failed = "分享失败",

    selet_shoushi = "请先选择手势！",
    now_caiquan = "正在猜拳中！",
    current_jifen = "当前积分:",
    select_num = "请选择兑换数量！",
    ci_noenough = "次数不足！",
    tip_xiandazao  = "请先打造一把神兵",

    tip_discount_tip = "限时特卖结束后将恢复为",
    tip_limit_buy = "限购[color=ffff0000]%d[/color]次",
    tip_limit_buy2 = "，剩余[color=ff00ff00]%d[/color]个",
    tip_limit_0 = "全服",
    tip_limit_1 = "单服",
    tip_limit_2 = "个人",
    tip_limit_over = "限时特卖已结束",
    tip_limit_unstart = "即将开场",
    tip_buy_limit_goods = "是否花费%d元宝购买？",
    getReward = "达到指定等级就可领取相应奖励",
    buyed = "已购买人数",
    levelLabel1 = "等级越高",
    levelLabel2 = "奖励越丰盛",
    continuity = "每天登录即可获得奖励",
    continuity_ = "登录游戏",
    libao = "礼包",
    gouyu = "勾玉",
    activityend = "活动结束",
    -- 切换神兵
    change_shenbing_tip = "是否花费%d元宝切换该神兵？",
}

zc = zc or {}
function zc.lang( ... )
    local arg = { ... }
    if #arg == 0 then
        return ""
    end
    local langKey = arg[1] or ""
    local langVal = arg[2] or ""
    return langConfig[langKey] or ""
end