--[[
物品类型:
1.  资源
2.  将领
3.  兵器
4.  道具
5.  将领经验
6.  玩家经验
7.  升星材料碎片
8.  将领卡
9.  饰品
10. 升星材料
11. 装备
12. 宝石
资源子类型:
1. 元宝
2. 银币
3. 声望
4. 蓝宝石
5. 黄宝石
6. 紫宝石
7. 体力
8. 税金
9. 木材
10. 矿石
11. 武魂
12. 名将册体力
]]

scheduler = requires("src/framework/scheduler.lua")
--主类型
zc.mainTypeResource = 1 --资源
zc.mainTypeSoldier = 2  --将领
zc.mainTypeWeapon = 3    --兵器
zc.mainTypeProp = 4     --道具
zc.mainTypeSoldierExp = 5    --将领经验
zc.mainTypePlayerExp = 6     --玩家经验
zc.mainTypeSarmsChip = 7     --升星材料碎片
zc.mainTypeSoldierCard = 8   --将领卡
zc.mainTypeTrinket = 9       --饰品
zc.mainTypeSarms = 10 --升星材料
zc.mainTypeEquip = 11 --装备
zc.mainTypeGem = 12 --宝石
zc.mainTypeSoldierFragment = 13 --将领碎片
zc.mainTypeHeroSoul = 14 --将领碎片
--前端自定义
zc.mainTypeSkill  = 111  --技能
zc.mainTypeOthers = 112 --其他
zc.mainTypeTech = 113 --国家科技
-- zc.mainTypeBusiness = 114 --商人
--副类型
zc.subTypeFragment = 5001  --道具的装备碎片
zc.subTypeWeaponFragment = 5002  --道具的装备碎片
zc.subTypeBox      = 1002  --道具宝箱

zc.cardExtractPopId = 630 --抽将道具id
zc.cardExtractPopFragmentId = 631 --抽将道具碎片id
zc.cardExtractPopSmallImg = "res/Main/common/common_item_630.png" --抽将道具小icon
zc.cardExtractPopFragmentSmallImg = "res/Main/common/common_item_631.png" --抽将道具碎片小icon

-- 数据常量
zc.dataTypeGold           = 1 -- 元宝
zc.dataTypeMoney          = 2 -- 钱币
zc.dataTypePrestige       = 3 --3. 声望
zc.dataTypeSapphire       = 4 --4. 蓝宝石
zc.dataTypeTopaz          = 5 --5. 黄宝石
zc.dataTypeAmethyst       = 6 --6. 紫宝石
zc.dataTypeEnergy         = 7 --7. 体力
zc.dataTypeTax            = 8 --8. 税金
zc.dataTypeWood           = 9 --9. 木材
zc.dataMineral            = 10 --10. 矿石
zc.dataTypeHeroSoul       = 11 --11. 武魂
zc.dataTypeCaptainEnergy  = 12 --12. 名将册体力
zc.dataMilitarySkillPoints= 13--13战功分
zc.dataServicePoints      = 14--14
zc.dataHonor              = 15--15荣誉
zc.dataExchangeVolume     = 16--16兑换卷
zc.dataTypeGrain          = 17--17粮食
zc.dataTypeNoUse          = 18--暂时没有用
zc.dataGridPoint          = 19--副本星数
zc.dataSpecialPoint       = 20--特训积分
zc.dataBreakthroughStone  = 21--突破石
zc.dataWeaponTollgateTimes= 22--挑战令
zc.dataArenaRankPoint     = 23--武神榜积分
zc.dataLightSoul          = 24--灯灵
zc.dataCaiquanBi          = 25--猜拳币

-- 获取富文本格式的资源图片和数量
function zc.getResRichText( typeId, num )
    return "[image=" .. zc.getImgByType(typeId) .. " offsety=-12][/image]x" .. num
end
-- 根据类型获取图片
function zc.getImgByType(typeid)
    typeid = tonumber(typeid)
    local imgList = {
        "res/Main/common/common_icon_gold.png", 
        "res/Main/common/common_icon_money.png", 
        "res/Main/common/common_icon_prestige.png", 
        "res/Main/common/common_icon_sapphire.png", 
        "res/Main/common/common_icon_topaz.png", 
        "res/Main/common/common_icon_amethyst.png", 
        "res/Main/common/common_icon_energy.png", 
        "res/Main/common/common_icon_tax.png",
        "res/Main/common/common_icon_wood.png", 
        "res/Main/common/common_icon_iron.png", --10. 矿石
        "res/Main/common/common_icon_heroSoul.png",--11
        "res/Main/common/common_icon_captainEnergy.png",--12
        "res/Main/common/common_icon_amethyst.png", 
        "res/Main/common/common_icon_battlescore.png",--14
        "res/Main/common/common_icon_exp.png",--15
        "res/Main/common/common_icon_amethyst.png", 
        "res/Main/common/common_icon_grain.png",--17
        "res/Main/common/common_icon_grain.png",--18--暂时没有用
        "res/Main/common/common_hero_star_1.png",--19
        "res/Main/common/common_icon_specialpoint.png",--20
        "res/Main/common/common_icon_breakThroughStone.png",--21
        "res/Main/common/common_icon_tiaozhanling.png",--22
        "res/Main/common/common_icon_arenarankpoint.png",--23
        "res/Main/common/common_icon_lightSoul.png",--24
        "res/Main/common/common_icon_caiqaun.png",--25
    }
    return imgList[typeid]
end

function zc.getImgBigByType(typeid)
    typeid = tonumber(typeid)
    local imgList = {
        "res/Main/common/iconBig/common_icon_gold.png", 
        "res/Main/common/iconBig/common_icon_money.png", 
        "res/Main/common/iconBig/common_icon_prestige.png", 
        "res/Main/common/iconBig/common_icon_sapphire.png", 
        "res/Main/common/iconBig/common_icon_topaz.png", 
        "res/Main/common/iconBig/common_icon_amethyst.png", 
        "res/Main/common/iconBig/common_icon_energy.png", 
        "res/Main/common/iconBig/common_icon_tax.png",
        "res/Main/common/iconBig/common_icon_wood.png", 
        "res/Main/common/iconBig/common_icon_iron.png", --10. 矿石
        "res/Main/common/iconBig/common_icon_heroSoul.png",--11
        "res/Main/common/iconBig/common_icon_captainEnergy.png",--12
        "res/Main/common/iconBig/common_icon_amethyst.png", 
        "res/Main/common/iconBig/common_icon_battlescore.png",--14
        "res/Main/common/iconBig/common_icon_exp.png",--15
        "res/Main/common/iconBig/common_icon_amethyst.png", 
        "res/Main/common/iconBig/common_icon_grain.png",--17
        "res/Main/common/iconBig/common_icon_grain.png",--18--暂时没有用
        "res/Main/common/common_hero_star_1.png",--19
        "res/Main/common/iconBig/common_icon_specialpoint.png",--20
        "res/Main/common/iconBig/common_icon_breakThroughStone.png",--21
        "res/Main/common/iconBig/common_icon_tiaozhanling.png",--22
        "res/Main/common/iconBig/common_icon_arenarankpoint.png",--23
        "res/Main/common/iconBig/common_icon_lightSoul.png",--24
    }
    return imgList[typeid]
end

local resourceTypeList = {
    "gold", 
    "money", 
    "prestige", 
    "sapphire", 
    "topaz", 
    "amethyst", 
    "energy", 
    "tax",
    "wood", 
    "ore", --10. 矿石
    "heroSoul",--11
    "captainEnergy",--12
    "",--13
    "battleScore",--14
    "",--15
    "",--16
    "grain",--17粮食
    "NoUse",
    "gridPoint",--19命格点数
    "specialPoint",--20命格点数
    "advanceStore",--21突破石头
    "weaponTollgateTimes",--22
    "arenaRankPoint",--23
    "lightsoul",--24
} 
-- 根据类型获取英文
function zc.getTypeByType(typeid)
    typeid = tonumber(typeid)
    return resourceTypeList[typeid]
end
function zc.getNameById(typeid)
    return LANGUAGE_getReousrceNameById(typeid)
end
function zc.getItemIdByName(name)
    for i=1,#resourceTypeList do 
        if name == resourceTypeList[i] then 
            return i
        end
    end
    return nil
end
-- 根据属性整理属性数值
function zc.getAttributeNumById( id, num )
    local _id = tonumber(id) or 1
    local _num = tonumber(num) or 1
    local _text = ""
    if _id == 1 then
        _text = math.ceil( _num )--1.  武力(整数)
    elseif _id == 2 then
        _text = math.ceil( _num )--2.  智力(整数)
    elseif _id == 3 then
        _text = math.ceil( _num )--3.  体力(整数)
    elseif _id == 4 then
        _text = math.ceil( _num )-- 4.  生命值上限(整数)
    elseif _id == 5 then
        _text = tostring( _num*100 ).."%"-- 5.  生命值上限加成(百分比)
    elseif _id == 6 then
        _text = math.ceil( _num )-- 6.  物理攻击力(整数)
    elseif _id == 7 then
        _text = tostring( _num*100 ).."%"-- 7.  物理攻击力加成(百分比)
    elseif _id == 8 then
        _text = math.ceil( _num )-- 8.  物理防御力(整数)
    elseif _id == 9 then
        _text = tostring( _num*100 ).."%"-- 9.  物理防御力加成(百分比)
    elseif _id == 10 then
        _text = math.ceil( _num )-- 10. 策略攻击力(整数)
    elseif _id == 11 then
        _text = tostring( _num*100 ).."%"-- 11.  策略攻击力加成(百分比)
    elseif _id == 12 then
        _text = math.ceil( _num )-- 12.  策略防御力(整数)
    elseif _id == 13 then
        _text = tostring( _num*100 ).."%"-- 13.  策略防御力加成(百分比)
    elseif _id == 14 then
        _text = tostring( _num*100 ).."%"-- 14.  命中率(百分比)
    elseif _id == 15 then
        _text = tostring( _num*100 ).."%"-- 15.  闪避率(百分比)
    elseif _id == 16 then
        _text = tostring( _num*100 ).."%"-- 16.  精准率(百分比)
    elseif _id == 17 then
        _text = tostring( _num*100 ).."%"-- 17.  识破率(百分比)
    elseif _id == 18 then
        _text = tostring( _num*100 ).."%"-- 18.  暴击率(百分比)
    elseif _id == 19 then
        _text = tostring( _num*100 ).."%"-- 19.  暴击效果值(百分比)
    elseif _id == 20 then
        _text = tostring( _num*100 ).."%"-- 20.  抗暴率(百分比)
    elseif _id == 21 then
        _text = tostring( _num*100 ).."%"-- 21.  眩晕率(百分比)
    elseif _id == 22 then
        _text = tostring( _num*100 ).."%"-- 22.  抗晕率(百分比)
    elseif _id == 23 then
        _text = tostring( _num*100 ).."%"-- 23.  伤害加成(百分比)
    elseif _id == 24 then
        _text = tostring( _num*100 ).."%"-- 24.  伤害减免(百分比)
    elseif _id == 25 then
        _text = tostring( _num*100 ).."%"-- 25.  技能效果加成(百分比)
    elseif _id == 26 then
        _text = tostring( _num*100 ).."%"-- 26.  技能效果减免(百分比)
    elseif _id == 27 then
        _text = math.ceil( _num )-- 27.  初始士气值(整数)
    elseif _id == 28 then
        _text = tostring( _num*100 ).."%"-- 28.  减士气抵抗(百分比)
    elseif _id == 29 then
        _text = tostring( _num*100 ).."%"-- 29.  反伤抵抗比率(百分比)
    elseif _id == 30 then
        _text = math.ceil( _num )-- 30.  攻击力(物理攻击或者策略攻击, 由类型决定)
    elseif _id == 31 then
        _text = math.ceil( _num )-- 31.  防御力（全部防御包括物防和策防）
    elseif _id == 32 then
        _text = tostring( _num*100 ).."%"-- 32. 全部攻击力（百分比）
    elseif _id == 33 then
        _text = tostring( _num*100 ).."%"-- 33. 全部防御力（百分比）
    elseif _id == 34 then
        _text = math.ceil( _num )-- 34. 速度
    elseif _id == 101 then
        _text = math.ceil( _num )-- 101.  提升国家人数
    elseif _id == 102 then
        _text = math.ceil( _num )-- 102.  提升掠夺次数上限
    elseif _id == 103 then
        _text = math.ceil( _num )-- 103.  提升占领次数上限
    elseif _id == 104 then
        _text = math.ceil( _num )-- 104.  仓库容量
    elseif _id == 105 then
        _text = math.ceil( _num )-- 105.  国家商品数量
    elseif _id == 106 then
        _text = _num-- 106.  国战获取速度(待定)
    elseif _id == 107 then
        _text = tostring( _num*100 ).."%"-- 107.  主城建筑cd减少（百分比）
    elseif _id == 108 then
        _text = math.ceil( _num )-- 106.  额外帮助减少时间
    end
    return _text
end

-- 封装一个根据物品的类型和id获取玩家当前物品数量的函数，目前只支持了一部分类型，大家一起来维护啊
function zc.getNumByTypeId( mainType, id )
    local mainType = tonumber( mainType )
    local id = tonumber( id )
    local num = 0
    if mainType == zc.mainTypeResource then
        -- 1 资源 id为资源的子类型
        if id == zc.dataTypeGold then
            -- 1 元宝
            num = PlayerData.resourcesInfo.gold
        elseif id == zc.dataTypeMoney then
            -- 2 钱币
            num = PlayerData.resourcesInfo.money
        elseif id == zc.dataTypePrestige then
            -- 3 声望
            num = PlayerData.resourcesInfo.prestige
        elseif id == zc.dataTypeSapphire then
            -- 4 蓝宝石
            num = PlayerData.resourcesInfo.sapphire
        elseif id == zc.dataTypeTopaz then
            -- 5 黄宝石
            num = PlayerData.resourcesInfo.topaz
        elseif id == zc.dataTypeAmethyst then
            -- 6 紫宝石
            num = PlayerData.resourcesInfo.amethyst
        elseif id == zc.dataTypeEnergy then
            -- 7 体力
            num = PlayerData.resourcesInfo.energy
        elseif id == zc.dataTypeTax then
            -- 8 税金
            num = PlayerData.resourcesInfo.tax
        elseif id == zc.dataTypeWood then
            -- 9 木材
            num = PlayerData.resourcesInfo.wood
        elseif id == zc.dataMineral then
            -- 10 矿石
            num = PlayerData.resourcesInfo.ore
        elseif id == zc.dataTypeHeroSoul then
            -- 11 武魂
            num = PlayerData.resourcesInfo.heroSoul
        elseif id == zc.dataTypeCaptainEnergy then
            -- 12 名将册体力
            num = PlayerData.resourcesInfo.captainEnergy
        elseif id == zc.dataMilitarySkillPoints then
            -- 13 将领技能点
            num = PlayerData.resourcesInfo.skillPoint
        elseif id == zc.dataServicePoints then
            -- 14 战功分
            num = PlayerData.resourcesInfo.battleScore
        elseif id == zc.dataHonor then
            -- 15 荣誉
            num = PlayerData.resourcesInfo.honor
        elseif id == zc.dataExchangeVolume then
            -- 16 兑换卷
            --num = PlayerData.resourcesInfo.skillPoint
        elseif id == zc.dataTypeGrain then
            -- 17 粮食
            num = PlayerData.resourcesInfo.grain
        elseif id == zc.dataTypeNoUse then
            -- 18 暂时没有用
        elseif id == zc.dataSpecialPoint then
            num = PlayerData.resourcesInfo.specialPoint
        elseif id == zc.dataBreakthroughStone then
            num = PlayerData.resourcesInfo.advanceStore
        elseif id == zc.dataWeaponTollgateTimes then
            num = PlayerData.resourcesInfo.weaponTollgateTimes
        elseif id == zc.dataArenaRankPoint then
            num = PlayerData.resourcesInfo.arenaRankPoint
        elseif id == zc.dataLightSoul then
            num = PlayerData.resourcesInfo.lightsoul
        end
    elseif mainType == zc.mainTypeSoldier then
        -- 2 将领 id为将领的静态id
        for i, v in ipairs( PlayerData.generalinfo ) do
            if id == tonumber( v.heroId or 0 ) then
                num = num + 1
            end
        end
    elseif mainType == zc.mainTypeWeapon then
        -- 3 兵器 id为兵器的静态id
        for i, v in ipairs( PlayerData.weapons ) do
            if id == tonumber( v.weaponId or 0 ) then
                num = num + 1
            end
        end
    elseif mainType == zc.mainTypeProp then
        -- 4 道具 id为道具的静态id
        for i, v in ipairs( PlayerData.baginfo ) do
            if id == tonumber( v.itemId or 0 ) then
                num = num + tonumber( v.num or 0 )
            end
        end
    elseif mainType == zc.mainTypeSoldierExp then
        -- 5 将领经验 id为将领的主键id
        for i, v in ipairs( PlayerData.generalinfo ) do
            if id == tonumber( v.id or 0 ) then
                num = tonumber( v.exp or 0 )
            end
        end
    elseif mainType == zc.mainTypePlayerExp then
        -- 6 玩家经验
        num = tonumber( PlayerData.info.exp or 0 )
    elseif mainType == zc.mainTypeSarmsChip then
        -- 7 装备碎片
    elseif mainType == zc.mainTypeSoldierCard then
        -- 8 装备卡
    elseif mainType == zc.mainTypeTrinket then
        -- 9 饰品 id为饰品的静态id
        for i, v in ipairs( PlayerData.trinketsInfo ) do
            if id == tonumber( v.trinketId or 0 ) then
                num = num + 1
            end
        end
    elseif mainType == zc.mainTypeSarms then
        -- 10 装备
    elseif mainType == zc.mainTypeSkill then
        -- 11 技能
    elseif mainType == zc.mainTypeGem then
        -- 12 宝石
        for k, v in pairs( PlayerData.gemInfo ) do
            if id == tonumber( v.gemId or 0 ) then
                num = num + 1
            end
        end
    elseif mainType == zc.mainTypeHeroSoul then
        -- 14 将魂
        for k, v in pairs( PlayerData._heroSoul) do
            if id == tonumber(v.heroSoulId) then
                num = num + 1
            end
        end
    end

    return tonumber( num or 0 ) or 0
end
-- 道具有些是根据type和subType来进行分类的，需要特殊处理
function zc.getBagNumByType( type_1, type_2 )
    local type_1 = type_1 or 1
    local type_2 = type_2 or 1
    local num = 0
    for i, v in ipairs( PlayerData.baginfo ) do
        if tonumber( v.type ) == tonumber( type_1 ) and tonumber( v.subType ) == tonumber( type_2 ) then 
            num = num + tonumber( v.num or 0 )
        end
    end
    return num
end

function zc.createFntLabel(params)
    local label = cc.Label:createWithBMFont(params.fnt, params.text)  
    label:setAnchorPoint(params.ap or cc.p(0.5, 0.5))
    label:setAdditionalKerning(params.addwidth or 0)
    label:setPosition(params.pos or cc.p(0, 0))
    label:setLocalZOrder(params.zorder or 1)
    label:setScale(params.scale or 1)
    return label
end
function zc.createImgLabel(params)
    local label = ccui.TextAtlas:create()
    local defaultParams = {
        img = "",--图片地址
        pos = cc.p(0,0),--位置
        num = "",--现实的数字
        firstnum = "0",--第一个数字
        w = 0,--宽
        h = 0--高
    }
    if params == nil then params = {} end
    for k, v in pairs(defaultParams) do
        if params[k] == nil then
            params[k] = v
        end
    end
    label:setProperty(params.num, (params.img), params.w, params.h, params.firstnum)
    label:setPosition(params.pos)
    return label
end

-- 创建侧边栏pushBtn按钮
-- params.pos 位置
-- params.text 按钮上的文字   
function zc.createTypeBtn(params)

    params.normalNode = cc.Sprite:create("res/Main/common/button/common_btn7_u.png")
    params.selectedNode = cc.Sprite:create("res/Main/common/button/common_btn7_d.png")
    params.touchScale = 0.7
    local normalLab = zc.createLabel({
        text = params.btnText,
        fontSize = 26,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(params.normalNode:getContentSize().width/2, params.normalNode:getContentSize().height/2),
        stroke = true,
        color = display.COLOR_BLACK,
        color2 = display.COLOR_WHITE,
        pixel = 1,

    })
    normalLab:setName("normalLab")
    params.normalNode:addChild(normalLab)

    local selectedLab = zc.createLabel({
        text = params.btnText,
        fontSize = 28,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(params.selectedNode:getContentSize().width/2, params.selectedNode:getContentSize().height/2),
        outLine = true,
        color = display.COLOR_WHITE,
        color2 = cc.c3b(130,85,23),
        pixel = 2,
    })
    selectedLab:setName("selectedLab")
    params.selectedNode:addChild(selectedLab)

    local btn = zc.createPushButton(params)

    function btn:setText( text )
        params.normalNode:getChildByName("normalLab"):setText( text )
        params.selectedNode:getChildByName("selectedLab"):setText(text)
    end

    return btn
end

-- 创建通用按钮
-- tag = 1,橙色按钮颜色：文字cc.c3b(255,241,121),描边cc.c3b(98,17,17),
-- tag = 2,蓝色按钮颜色：文字白色，描边color2 = cc.c3b(4,47,59),
-- 其余参数与zc.createButton相同
function zc.createCommomBtn( params )
    local _color1, _color2, _color3
    local _tag = tonumber(params.tag) or 1
    if not inArray( _tag, { 1, 2, 3, 4, 5 } ) then
        _tag = 1
    end
    if _tag == 1 then 
        params.normalNode = zc.createSprite("res/Main/common/button/common_btn_warm.png")
        params.selectedNode = zc.createSprite("res/Main/common/button/common_btn_warm_down.png")
        params.disableNode = zc.createSprite("res/Main/common/button/common_btn_gray.png")
        _color2 = zc.labelWarmColor
    elseif _tag == 2 then
        params.normalNode = zc.createSprite("res/Main/common/button/common_btn_cold.png")
        params.selectedNode = zc.createSprite("res/Main/common/button/common_btn_cold_down.png")
        params.disableNode = zc.createSprite("res/Main/common/button/common_btn_gray.png")
        _color2 = zc.labelColdColor
    elseif _tag == 3 then
        params.normalNode = zc.createSprite("res/Main/common/button/btn_sec_u.png")
        params.selectedNode = zc.createSprite("res/Main/common/button/btn_sec_d.png")
        params.disableNode = zc.createSprite("res/Main/common/button/btn_sec_g.png")
        _color2 = zc.labelWarmColor
    elseif _tag == 4 then
        params.normalNode = zc.createSprite("res/Main/common/button/btn_sec_small_u.png")
        params.selectedNode = zc.createSprite("res/Main/common/button/btn_sec_small_d.png")
        params.disableNode = zc.createSprite("res/Main/common/button/btn_sec_small_d.png")
        _color2 = zc.labelWarmColor
    elseif _tag == 5 then
        params.normalNode = zc.createSprite("res/Main/common/button/btn_blue_u.png")
        params.selectedNode = zc.createSprite("res/Main/common/button/btn_blue_d.png")
        params.disableNode = zc.createSprite("res/Main/common/button/btn_sec_g.png")
        _color2 = zc.labelColdColor
    end
    if params.listener then
        params.endCallback = params.listener
    end
    local _text = params.text
    if params.btnText then
        _text = params.btnText
    end

    _color1 = display.COLOR_WHITE
    _color3 = cc.c3b(59, 59, 59)
    params.fontSize = params.fontSize or 20
    params.outLine = nil
    params.text = nil
    params.btnText = nil
    params.shadow = nil
    params.stroke = nil

    local normalLab = zc.createLabel({
        text = _text,
        fontSize = params.fontSize,
        pos = cc.pMul(cc.pFromSize(params.normalNode:getContentSize()), 0.5),
        color = _color1,
        color2 = _color2,
        pixel = 2,
        outLine = true
    })
    normalLab:setName("normalLab")
    params.normalNode:addChild(normalLab)

    local selectedLab = zc.createLabel({
        text = _text,
        fontSize = params.fontSize,
        pos = cc.pMul(cc.pFromSize(params.selectedNode:getContentSize()), 0.5),
        color = _color1,
        color2 = _color2,
        pixel = 2,
        outLine = true
    })
    selectedLab:setName("selectedLab")
    params.selectedNode:addChild(selectedLab)

    local disableLab = zc.createLabel({
        text = _text,
        fontSize = params.fontSize,
        pos = cc.pMul(cc.pFromSize(params.disableNode:getContentSize()), 0.5),
        color = _color1,
        color2 = _color3,
        pixel = 2,
        outLine = true
    })
    disableLab:setName("disableLab")
    params.disableNode:addChild(disableLab)

    local _btnPartPos = params.btnPartPos or cc.p(0, 0)
    normalLab:setPosition(normalLab:getPositionX() + _btnPartPos.x, normalLab:getPositionY() + _btnPartPos.y)
    selectedLab:setPosition(selectedLab:getPositionX() + _btnPartPos.x, selectedLab:getPositionY() + _btnPartPos.y)
    disableLab:setPosition(disableLab:getPositionX() + _btnPartPos.x, disableLab:getPositionY() + _btnPartPos.y)

    if params.labScale then
        local _scale = params.scale or 1
        normalLab:setScale( 1/_scale )
        selectedLab:setScale( 1/_scale )
        disableLab:setScale( 1/_scale )
    end

    local btn = zc.createPushButton(params)
    function btn:setText( text )
        if btn:isEnable() then
            params.normalNode:getChildByName("normalLab"):setText( text )
            params.selectedNode:getChildByName("selectedLab"):setText(text)
        elseif params.disableNode then
            params.disableNode:getChildByName("disableLab"):setText( text )
        end
    end
    function btn:setString( text )
        if btn:isEnable() then
            params.normalNode:getChildByName("normalLab"):setText( text )
            params.selectedNode:getChildByName("selectedLab"):setText(text)
        elseif params.disableNode then
            params.disableNode:getChildByName("disableLab"):setText( text )
        end
    end
    return btn
end

--边栏tab背景
function zc.createTabButtonBg(params)
    local params = params or {}
    local tag    = params.tag or 1
    local tabBtnBg
    if tag == 1 then
        tabBtnBg = zc.createSprite("res/Main/common/common_tab_bg1.png")
    elseif tag == 2 then
        tabBtnBg = zc.createSprite("res/Main/common/common_tab_bg2.png")
    elseif tag == 3 then
        tabBtnBg = zc.createSprite("res/Main/common/common_tab_bg3.png")
    end
    return tabBtnBg
end

--边栏tab按钮
function zc.createComTabButton(params)
    -- 按钮上的文字
    local params = params or {}
    local text = params.btnText or ""
    params.btnText = nil
    params.text = nil
    if params.tag == 1 then
        -- 小
        params.normalNode   = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(123,72))
        params.selectedNode = zc.getScaleNode("res/Main/common/button/btn_light_small.png", cc.size(123,72))
        params.disableNode  = zc.getScaleNode("res/Main/common/button/btn_light_small.png", cc.size(123,72))
    elseif params.tag == 2 then
        -- 大
        params.normalNode   = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(170,85))
        params.selectedNode = zc.getScaleNode("res/Main/common/button/btn_light_big.png", cc.size(170,85))
        params.disableNode  = zc.getScaleNode("res/Main/common/button/btn_light_big.png", cc.size(170,85))
    elseif params.tag == 3 then
        -- 中
        params.normalNode   = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(153,88))
        params.selectedNode = zc.getScaleNode("res/Main/common/button/btn_light_middle.png", cc.size(153,88))
        params.disableNode  = zc.getScaleNode("res/Main/common/button/btn_light_middle.png", cc.size(153,88))
    elseif params.tag == 4 then
        -- new
        params.normalNode   = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(153,74))
        params.selectedNode = zc.getScaleNode("res/Main/common/button/btn_light_new.png", cc.size(153, 74))
        params.disableNode  = zc.getScaleNode("res/Main/common/button/btn_light_new.png", cc.size(153, 74))
    elseif params.tag == 5 then
        -- new
        params.normalNode   = zc.getScaleNode("res/Main/activity/btn_u.png", cc.size(215,82))
        params.selectedNode = zc.getScaleNode("res/Main/activity/btn_d.png", cc.size(215, 82))
        params.disableNode = zc.getScaleNode("res/Main/activity/btn_d.png", cc.size(215, 82))
    elseif params.tag == 6 then
        params.normalNode   = zc.getScaleNode("res/Main/activity/sele.png", cc.size(215,82))
        params.selectedNode = zc.getScaleNode("res/Main/activity/unsele.png", cc.size(215, 82))
        params.disableNode = zc.getScaleNode("res/Main/activity/unsele.png", cc.size(215, 82))
    elseif params.tag == 7 then
        params.normalNode   = zc.getScaleNode("res/Main/limittimehot/unselect.png", cc.size(193,90))
        params.selectedNode = zc.getScaleNode("res/Main/limittimehot/select.png", cc.size(193,90))
        params.disableNode = zc.getScaleNode("res/Main/limittimehot/select.png", cc.size(193,90))
    end

    -- params.touchScale = 0.9
    local textPosN = params.posNormal  or cc.p(params.normalNode:getContentSize().width/2, params.normalNode:getContentSize().height/2)
    local textPosS = params.posSelect  or cc.p(params.selectedNode:getContentSize().width/2, params.selectedNode:getContentSize().height/2)
    local textPosD = params.posDisable or cc.p(params.disableNode:getContentSize().width/2, params.disableNode:getContentSize().height/2)
    local textAnchor = params.textAnchor or cc.p(0.5,0.5)
    local normal_color2 = cc.c3b(96, 33, 33)
    local normal_color = cc.c3b(230, 224, 163)
    if params.limittimehot then
        textPosN.y = textPosN.y + 8
        textPosS.y = textPosS.y + 10
        textPosD.y = textPosD.y + 5
        params.fontSize = 26
        normal_color = cc.c3b(255, 191, 116)
        -- normal_color = cc.c3b(82,8,8)
        normal_color2 =  cc.c3b(45, 39, 66)
        -- normal_color2 = cc.c3b(82,8,8)
    end
    local normalLab = zc.createLabel({
        text = text,
        fontSize = params.fontSize or 26,
        ap = textAnchor,
        pos = textPosN,
        color = normal_color,
        color2 = normal_color2,
        outLine = true,
        pixel = 2
    })
    local select_color = cc.c3b(255, 250, 206)
    local select_color2 =  cc.c3b(84, 44, 44)
    local _pixel = 3
    if params.limittimehot then
        local normalLabsize = normalLab:getContentSize()
        local distance = math.abs(193 - normalLabsize.width)
        textPosN.x = textPosN.x - distance/4
        normalLab:setPositionX(textPosN.x)
        params.fontSize = 28
        select_color = cc.c3b(250,250,250)
        select_color2 =  cc.c3b(82,8,8)
        _pixel = 2
    end
    normalLab:setName("normalLab")
    params.normalNode:addChild(normalLab)

    local selectedLab = zc.createLabel({
        text = text,
        fontSize = params.fontSize or 28,
        ap = textAnchor,
        pos = textPosS,
        color = select_color,
        color2 = select_color2,
        outLine = true,
        pixel = _pixel
    })
    selectedLab:setName("selectedLab")
    if params.limittimehot then
        local selectedLabsize = selectedLab:getContentSize()
        local width = 193
        local distance = math.abs(193 - selectedLabsize.width)
        textPosS.x = textPosS.x - distance/4
        selectedLab:setPositionX(textPosS.x)
    end
    params.selectedNode:addChild(selectedLab)

    if params.disableNode then
        local disable_color = cc.c3b(76, 18, 18)
        local disable_color2
        local _outLine
        if params.limittimehot then
            params.fontSize = 28
            disable_color =  cc.c3b(255, 250, 206)
            disable_color2 =  cc.c3b(255,255,255)
            _outLine = true
        end
        local disableLab = zc.createLabel({
            text = text,
            fontSize = params.fontSize or 30,
            ap = textAnchor,
            pos = textPosD,
            color = disable_color,
            color2 = disable_color2,
            outLine = _outLine,
        })
        disableLab:setName("disableLab")
        params.disableNode:addChild(disableLab)
        if params.limittimehot then
            local size = disableLab:getContentSize()
            local width = 193
            local distance = math.abs(193 - size.width)
            textPosD.x = textPosD.x - distance/4
            disableLab:setPositionX(textPosD.x)
        end
    end
    

    local btn = zc.createPushButton(params)
    function btn:setText( text )
        if btn:isEnable() then
            params.normalNode:getChildByName("normalLab"):setText( text )
            params.selectedNode:getChildByName("selectedLab"):setText(text)
        elseif params.disableNode then
            params.disableNode:getChildByName("disableLab"):setText( text )
        end
    end
    function btn:setString( text )
        if btn:isEnable() then
            params.normalNode:getChildByName("normalLab"):setText( text )
            params.selectedNode:getChildByName("selectedLab"):setText(text)
        elseif params.disableNode then
            params.disableNode:getChildByName("disableLab"):setText( text )
        end
    end
    return btn
end

--[[
    快速创建Layout
]]
function zc.createLayout( params )
    local layout = ccui.Layout:create()

    if params.pos then
        layout:setPosition(params.pos)
    end

    if params.size then
        layout:setContentSize(params.size)
    end

    if params.mask then
        layout:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
        layout:setBackGroundColor(display.COLOR_BLACK)
        layout:setBackGroundColorOpacity(255)
        if params.opacity then
            layout:setBackGroundColorOpacity(params.opacity)
        end
    end

    if params.listener then
        layout:setTouchEnabled(true)
        layout:setSwallowTouches(params.swallTouch or false)
        layout:addTouchEventListener(function ( sender, eventType )
            if eventType == ccui.TouchEventType.began then 
            elseif eventType == ccui.TouchEventType.moved then 
            elseif eventType == ccui.TouchEventType.ended then
                params.listener(sender, eventType)
            end
        end)
    end

    if params.name then
        layout:setName(params.name)
    end

    if params.tag then
        layout:setTag(params.tag)
    end

    if params.actionTag then
        layout:setActionTag(params.actionTag)
    end


    return layout
end
function zc.createLayer(params)
    local layout = cc.LayerColor:create()
    if params then
        if params.pos then
            layout:setPosition(params.pos)
        end
        if params.size then
            layout:setContentSize(params.size)
        end
        if params.mask then
            layout:setColor(display.COLOR_BLACK)
            layout:setOpacity(255)
        end
    end
    return layout
end
function zc.createScale9Sprite(params)
    local rect = params.rect or cc.rect(30,30,1,1)
    local Bg = ccui.Scale9Sprite:create(rect, params.file)
    Bg:setAnchorPoint(params.ap or cc.p(0.5, 0.5))
    Bg:setContentSize(params.size)
    Bg:setPosition(params.pos or cc.p(0, 0))

    return Bg
end
--[[
    快速创建ImageView
    0==TOUCH_EVENT_BEGAN                      = ccui.TouchEventType.began 
    1==TOUCH_EVENT_MOVED                      = ccui.TouchEventType.moved
    2==TOUCH_EVENT_ENDED                      = ccui.TouchEventType.ended
    3==TOUCH_EVENT_CANCELED                   = ccui.TouchEventType.canceled
]]
function zc.createImageView( params )
    local imageView = ccui.ImageView:create()
    if params.src then
        if params.plist == true and cc.SpriteFrameCache:getInstance():getSpriteFrameByName(params.src) then
            imageView:loadTexture(params.src, ccui.TextureResType.plistType)
        else
            imageView:loadTexture(params.src)
        end
    end
    imageView:setPosition(params.pos or cc.p(0, 0))
    imageView:setAnchorPoint(params.ap or cc.p(0.5, 0.5))
    imageView:setScale(params.scale or 1)

    -- imageView:setFlipX(params.flipX or false)
    -- imageView:setFlipY(params.flipY or false)

    if params.scale9 then
        imageView:setScale9Enabled(true)
        if params.capInsets then
            imageView:setCapInsets(params.capInsets)
        end
    end

    if params.size then
        imageView:setContentSize(params.size)
    end
    if params.name then
        imageView:setName(params.name)
    end

    if params.tag then
        imageView:setTag(params.tag)
    end

    if params.actionTag then
        imageView:setActionTag(params.actionTag)
    end
    if params.flipX then 
        imageView:setScaleX(-1)
    end
    if params.listener then
        local curscale = params.scale or 1
        imageView:setTouchEnabled(true)
        imageView:setSwallowTouches(params.swallTouch or false)
        imageView:addTouchEventListener(function ( sender, eventType )
            if params.touchScale then 
                --点击缩小还是放大 
                if eventType == ccui.TouchEventType.began then
                    if imageView._selectd == false then 
                        imageView:setScale(curscale)
                    else
                        imageView:setScale(params.touchScale * curscale)
                    end 
                elseif eventType == ccui.TouchEventType.ended then
                    imageView:setScale(curscale)
                    params.listener(sender, eventType)
                elseif eventType == ccui.TouchEventType.moved then 
                elseif eventType == ccui.TouchEventType.canceled then 
                    imageView:setScale(curscale)
                end 
            else
                if eventType == ccui.TouchEventType.began then 
                elseif eventType == ccui.TouchEventType.moved then 
                elseif eventType == ccui.TouchEventType.ended then
                    params.listener(sender, eventType)
                end
            end
        end)
    end

    if params.opacity then
        imageView:setOpacity(params.opacity)
    end


    return imageView
end

--[[
    创建一个EditBox
]]
function zc.createEditBox( params )
    local pos = params.pos or cc.p(0, 0)
    local ap = params.ap or cc.p(0.5, 0.5)
    local size = params.size or cc.size(160, 35)
    local editBg = params.editBg or CCScale9Sprite:create("res/Main/common/img_empty.png")
    local touchPriority = params.touchPriority or -9999
    local inputFlag = params.inputFlag or 1
    local placeHolder = params.placeHolder or ""
    local placeholderFont = params.placeholderFont or zc.getFont(1)
    local placeholderFontSize = params.placeholderFontSize or 17
    local text = params.text or ""
    local fontColor = params.fontColor or ccc3(228, 218, 182)
    local font = params.font or zc.getFont(1)
    local fontSize = params.fontSize or 20
    local returnType = params.returnType or kKeyboardReturnTypeSend

    local newEditBox = CCEditBox:create(size, editBg)
    newEditBox:setAnchorPoint(ap)
    newEditBox:setPosition(pos)
    newEditBox:setTouchPriority(touchPriority)
    newEditBox:setFontColor(fontColor)
    newEditBox:setInputFlag(inputFlag)
    newEditBox:setFont(font,fontSize)
    newEditBox:setPlaceHolder(placeHolder)
    newEditBox:setPlaceholderFont(placeholderFont,placeholderFontSize)
    newEditBox:setText(text)
    if params.handler then
        newEditBox:registerScriptEditBoxHandler(params.handler)
    end
    if params.name then
        newEditBox:setName(params.name)
    end
    if params.maxLength then
        newEditBox:setMaxLength(params.maxLength)
    end
    newEditBox:setReturnType(returnType)
    return newEditBox

end

--[[
commonUI

GUI相关
动画相关

]]
--[[
----------------------------------------------------------------------------------------------------GUI相关
]]
local childTag = {popTag=21, tipTag=31, usertopTag=11}

--[[
    获取touchLayer的单例
    注：每个场景切换后，实例会被销毁，在新场景需要重新获取。
]]
local touchLayerInstance = nil
zc.sceneList = {}
function zc.getTouchLayer()
    return touchLayerInstance
end

function zc.createScene( name, params )
    local _source = "src/scene/"..name.."Scene.lua"
    return zc.createSourceScene(name, _source, params)
end

function zc.createSourceScene(name, source, params)
    if name == LAYER_NAME_TAG.LAYER_MAINCITY then
        LayerManager.pushModule(LAYER_NAME_TAG.LAYER_MAINCITY)
        return LayerManager.getBaseLayer()
    else
        local curRoot = LayerManager.getCurRootLayer()
        if curRoot then
            local layer = curRoot:getChildByName(name)
            if layer then
                LayerManager.backToMainCity(false)
            end
        end
        params = params or {}
        params.layerName = name
        return LayerManager.addLayout(source, params)
    end
end

function zc.createBattleScene(name, params)
    local _source = "src/battle/"..name.."Scene.lua"
    return zc.createSourceScene(name, _source, params)
end

function zc.getScene(name)
    local _rootLay = LayerManager.getCurRootLayer()
    if not _rootLay then return nil end
    local layer = _rootLay:getChildByName(name)
    if layer then
        return layer
    else 
        return nil
    end
end
function zc.getBattleScene(name)
    local _rootLay = LayerManager.getCurRootLayer()
    local layer = _rootLay:getChildByName(name)
    if layer then
        return layer
    else 
        local layer = _rootLay:getChildByName("hero")
        if not layer then
             layer = _rootLay:getChildByName("drillField")
        end
        return layer
    end
end

function zc.createPop(name, params )
    local _source = "src/pop/"..name.."Pop.lua"
    return zc.createSourcePop(name, _source, params)
end

function zc.createSourcePop(name, source, params)
    params = params or {}
    params.layerName = name
    params.isPop = true
    params.noHide = true
    return LayerManager.addLayout(source, params)
end

function zc.getPop(name)
    local _runningScene = cc.Director:getInstance():getRunningScene()
    if not _runningScene then
        return
    end
    local _name = _runningScene:getName()
    if _name == LAYER_NAME_TAG.LAYER_MAINCITY then
        local _rootLay = LayerManager.getCurRootLayer()
        if tolua.isnull(_rootLay) then 
            return nil 
        end
        local layer = _rootLay:getChildByName(tostring(name))
        if tolua.isnull(layer) then
            return nil
        end
        return layer
    elseif name and type(name) == "string" and name ~= "" then
        local _pop = _runningScene:getChildByName(name)
        return _pop
    end
    return nil
end
function zc.closePop(name)
    local _runningScene = cc.Director:getInstance():getRunningScene()
    if not _runningScene then
        return
    end
    local _name = _runningScene:getName()
    if _name == LAYER_NAME_TAG.LAYER_MAINCITY then
        LayerManager.removeLayout(true)
    elseif name and type(name) == "string" and name ~= "" then
        local _pop = _runningScene:getChildByName(name)
        if _pop then
            _pop:removeFromParent()
        end
    end
end

--[[
SCROLLVIEW_EVENT_SCROLL_TO_TOP         = ccui.ScrollViewDir.none
SCROLLVIEW_DIR_VERTICAL                = ccui.ScrollViewDir.vertical
SCROLLVIEW_DIR_HORIZONTAL              = ccui.ScrollViewDir.horizontal
SCROLLVIEW_DIR_BOTH                    = ccui.ScrollViewDir.both
]]
function zc.createScrollview(params)
    local defaultParams = {
        pos = cc.p(0, 0),
        size = cc.size(100, 100),
        innerSize = cc.size(100,200),
        touchEnable = true,
        bounceEnable = false,
        name = "scrollView",
        dir = ccui.ScrollViewDir.horizontal,--横向
        bar = false,
    }
    for k, v in pairs(defaultParams) do
        if params[k] == nil then
            params[k] = v
        end
    end

    local scrollView = ccui.ScrollView:create()
    scrollView:setTouchEnabled(params.touchEnable)
    scrollView:setBounceEnabled(params.bounceEnable)
    scrollView:setContentSize(params.size)
    scrollView:setPosition(params.pos)
    scrollView:setName(params.name)
    scrollView:setDirection(params.dir)
    scrollView:setScrollBarEnabled(params.bar)
    scrollView:setInnerContainerSize(params.innerSize)
    return scrollView
end
--返回键
function zc.createBackButton(params)
    local backbutton = zc.createPushButton({
        normalFile = "res/Main/common/button/common_close_btn_u.png",
        selectedFile = "res/Main/common/button/common_close_btn_d.png",
        needSwallow = params.needSwallow or false, --是否需要吞噬
        endCallback = params.listener, 
        btnEff = zc.effect.btnClose,
        pos = params.pos
    })
    return backbutton
end
function zc.createTopBackButton(params)
    local backbutton = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btnback_u.png",
        selectedFile = "res/Main/common/button/common_btnback_d.png",
        endCallback = params.listener,
        btnEff = zc.effect.btnClose,
        pos = params.pos
    })
    backbutton:setAnchorPoint(cc.p(1, 1))
    backbutton:setPosition(cc.p(zc.width, zc.height))
    return backbutton
end

--自己创建的tabbtn 按下字体颜色变化 用imageview实现 
function zc.createTabBtn(params)
    local tabbtn = zc.createImageView({
        src = params.normal,
        pos = params.pos,
        listener = function () end,
        touchScale = 0.9,
        scale = params.scale
    })
    local _scale = params.scale or 1.0
    tabbtn:addTouchEventListener(function ( sender, eventType )
        if eventType == ccui.TouchEventType.began then  
            tabbtn:runAction(cc.ScaleTo:create(0.1, 0.8*_scale))
        elseif eventType == ccui.TouchEventType.moved then 
        elseif eventType == ccui.TouchEventType.ended then
            tabbtn:runAction(cc.ScaleTo:create(0.1, 1.0*_scale))
            params.listener()
        elseif eventType == ccui.TouchEventType.canceled then  
            tabbtn:runAction(cc.ScaleTo:create(0.1, 1.0*_scale))
        end 
    end)
    local title = zc.createLabel({
        text = params.title,
        fontSize = 25,
        ttf = zc.getFont(1),
        ap = cc.p(0.5, 0.5),
        pos = params.namepos,
        stroke = true,
        color = display.COLOR_BLACK,
        color2 = display.COLOR_WHITE
    })
    tabbtn._title = title
    tabbtn:addChild(title)
    function tabbtn:setBright(flag)
        tabbtn._selectd = flag
        if flag == false then 
            tabbtn:loadTexture(params.pressed)
            tabbtn._title:setPosition(cc.p(params.namepos.x, tabbtn:getContentSize().height/2))
            tabbtn._title:setColor(display.COLOR_WHITE)
            tabbtn._title:disableEffect()
            tabbtn:setScale(1 * tabbtn:getScale())
            if tabbtn:getChildByName("itemimg") then 
                tabbtn:getChildByName("itemimg"):setPositionX(100)
                tabbtn:getChildByName("itemimg"):setPositionY(tabbtn:getContentSize().height/2)
            end
        else
            tabbtn:loadTexture(params.normal)
            tabbtn._title:setPosition(cc.p(params.namepos.x+10, tabbtn:getContentSize().height/2))
            tabbtn._title:setColor(display.COLOR_BLACK)
            -- tabbtn._title:enableShadow(display.COLOR_WHITE)
            tabbtn:setScale(1 * tabbtn:getScale())
            if tabbtn:getChildByName("itemimg") then 
                tabbtn:getChildByName("itemimg"):setPositionX(110)
                tabbtn:getChildByName("itemimg"):setPositionY(tabbtn:getContentSize().height/2)
            end
        end
    end
    return tabbtn
end


function zc.createBtnClose(callBack)
    local close_btn = zc.createPushButton({
        normalFile = "common/button/btn_close_normal.png",
        selectedFile = "common/button/btn_close_selected.png",
        endCallback = callBack,
        btnEff = zc.effect.btnClose,
    })
    return close_btn
end

--[[action]]
--[[创建窗口弹出的动画]]
function zc.runActionPop(targetNode, _callBack)
    targetNode:setScale(0)
    targetNode:runAction(
        cc.Sequence:create(
            cc.EaseOut:create(cc.ScaleTo:create(0.15,1),3),
            cc.CallFunc:create(function()
                if _callBack then
                    _callBack()
                end
            end)
        )
    )
end

function zc.runHidePop(targetNode)
    targetNode:runAction(cc.EaseIn:create(cc.ScaleTo:create(0.15,0),3))
end


--[[
    策划新需求，toast永远只保留一条
]]
function zc.tipInfo(str, posY)
    if str == nil then 
        return
    end
    local scene = cc.Director:getInstance():getRunningScene()
    if not scene then
        return
    end
    local _tipLab = scene:getChildByTag(childTag.tipTag)
    if _tipLab then
        _tipLab:stopAllActions()
        _tipLab._label:setText(str)
    else
        _tipLab = zc.createSprite( "res/Main/common/tipResource/bg.png" )
        _tipLabel = zc.createLabel({
            text = str,
            fontSize = 30,
            shadow = true,
            pos = cc.p( _tipLab:getContentSize().width/2, _tipLab:getContentSize().height/2 ),
        })
        _tipLabel:setCascadeOpacityEnabled( true )
        _tipLab:addChild( _tipLabel )
        _tipLab:setTag(childTag.tipTag)
        _tipLab._label = _tipLabel
        scene:addChild(_tipLab, childTag.tipTag+99)
    end
    _tipLab:setOpacity(255)
    local _posY = tonumber( posY ) or ( zc.height/2 + 60 )
    _tipLab:setPosition(zc.width/2, _posY)


    _tipLab:runAction(
        cc.Sequence:create(
            cc.EaseIn:create(
                cc.MoveBy:create(0.264, cc.p(0, 45)),
                0.264),
            cc.DelayTime:create(0.8),
            cc.Spawn:create(
                cc.FadeOut:create(0.176),
                cc.MoveBy:create(0.176, cc.p(0, 35))
            ),
            cc.CallFunc:create(function()
                if tolua.isnull(_tipLab) then
                    return
                end
                _tipLab:removeFromParent()
            end)
        )
    )
end

-- 获取物资统一弹窗
function zc.tipResource( data )
    if not data then
        return
    end
    -- 整理资源数据
    local resourceData = {}
    for i, v in ipairs( data ) do
        if v.itemType == zc.mainTypeResource then
            -- 资源
            resourceData[#resourceData + 1] = {
                path = zc.getImgByType( v.itemId ),
                num = v.changeNum or 0,
                scale = 1.2,
            }
        elseif v.itemType == zc.mainTypePlayerExp then
            -- 经验值
            resourceData[#resourceData + 1] = {
                path = "res/Main/common/common_icon_exp.png",
                num = v.changeNum or 0,
                scale = 1.2,
            }
        elseif v.itemType == zc.mainTypeProp and v.itemId == 1 then
            local _db = gameData.getDataFromCacheWithPrimaryKey("item", v.itemId)
            resourceData[#resourceData + 1] = {
                path = "res/Main/bag/gem/" .. tostring(_db.icon) .. ".png",
                num = v.changeNum or 0,
                scale = 0.44,
            }
        elseif v.itemType == zc.mainTypeProp and v.itemId == zc.cardExtractPopId then
            resourceData[#resourceData + 1] = {
                path = zc.cardExtractPopSmallImg,
                num = v.changeNum or 0,
                scale = 1.0,
            }
        elseif v.itemType == zc.mainTypeProp and v.itemId == zc.cardExtractPopFragmentId then
            resourceData[#resourceData + 1] = {
                path = zc.cardExtractPopFragmentSmallImg,
                num = v.changeNum or 0,
                scale = 1.0,
            }
        elseif v.itemType == zc.mainTypeSoldierFragment and v.heroData then
            resourceData[#resourceData + 1] = {
                heroData = v.heroData,
                num = v.changeNum or 0,
                scale = 0.4,
            }
        end
    end
    if #resourceData == 0 then
        return
    end
    -- 创建
    local scene = cc.Director:getInstance():getRunningScene()
    if not scene then
        return
    end
    local num = 3
    local tip = {}
    for i = 0, math.ceil( #resourceData/num ) - 1 do
        local bg = cc.Sprite:create( "res/Main/common/tipResource/bg.png" )
        bg:setCascadeOpacityEnabled( true )
        bg:setPosition( -1000, -1000 )
        local resNum = 0
        local spTable = {}
        local numTable = {}
        for j = 1, 3 do
            local data = resourceData[3*i + j]
            if data then
                resNum = resNum + 1
                if data.heroData then
                    local _item = zc.createIconByData({
                        data = {
                            mainType = zc.mainTypeSoldierFragment,
                            type = data.heroData.heroId, 
                            id = data.heroData.heroId,
                        }, 
                        quality = data.heroData.quality,
                    })
                    _item:setScale(data.scale)
                    bg:addChild(_item)
                    spTable[j] = _item
                    local num = zc.createLabel({
                        text = "x"..zc.getWan( data.num ),
                        fontSize = 28,
                        ap = cc.p(0, 0.5),
                        stroke = true,
                        pixel = 1,
                    })
                    num:setCascadeOpacityEnabled( true )
                    bg:addChild( num )
                    numTable[j] = num
                else
                    local sp = cc.Sprite:create( data.path )
                    sp:setScale( data.scale )
                    bg:addChild( sp )
                    spTable[j] = sp
                    local num = zc.createLabel({
                        text = "x"..zc.getWan( data.num ),
                        fontSize = 28,
                        ap = cc.p(0, 0.5),
                        stroke = true,
                        pixel = 1,
                    })
                    num:setCascadeOpacityEnabled( true )
                    bg:addChild( num )
                    numTable[j] = num
                end
            end
        end
        for j = 1, resNum do
            spTable[j]:setPosition( 10 + ( 3 - resNum )*85 + 170*j, bg:getContentSize().height/2 )
            numTable[j]:setPosition( spTable[j]:getPositionX() + spTable[j]:getBoundingBox().width*0.5 + 5, spTable[j]:getPositionY() )
        end
        scene:addChild( bg )
        tip[i + 1] = bg
    end
    -- 动作
    for i, v in ipairs( tip ) do
        v:runAction(
            cc.Sequence:create(
                cc.CallFunc:create(
                    function()
                        v:setOpacity( 255 )
                        v:setPosition( scene:getBoundingBox().width/2, scene:getBoundingBox().height/2 )
                    end
                ),
                cc.DelayTime:create(
                    0.75*( i - 1 )
                ),
                cc.EaseIn:create(
                    cc.MoveBy:create(0.264, cc.p(0, 45)),
                    0.264),
                cc.DelayTime:create(0.8),
                cc.Spawn:create(
                    cc.FadeOut:create(0.176),
                    cc.MoveBy:create(0.176, cc.p(0, 35))
                ),
                cc.RemoveSelf:create(true)
            )
        )
    end
end

function zc.getFont(fontname)
    -- local _idx = tonumber(cc.Application:getInstance():getCurrentLanguage()) or 1
    -- if _idx == 19 then
    --     fontname = 3
    -- else
        fontname = 1
    -- end
    if fontname == 1 then  
        return "res/font/yuanti.ttf"
    elseif fontname == 2 then 
        return "res/font/font2.ttf"
    else
        return ""
    end
end

function zc.getFontName(fontname)
    -- local _idx = tonumber(cc.Application:getInstance():getCurrentLanguage()) or 1
    -- if _idx == 19 then
    --     fontname = 3
    -- else
        fontname = 1
    -- end
    if fontname == 1 then  
        return "FZCuYuan-M03"
    elseif fontname == 2 then 
        return "VAGRounded BT"
    else
        return ""
    end
end 




--[[
----------------------------------------------------------------------------------------------------动画相关
]]
-- 异步创建
function zc.asyncShow(parent, buffName, callBack, scale, addType, opacity)
    local buff, buffAnimation = display.getAnimation(buffName)

    if buff then
        callBack(buff, buffAnimation)
        return buff
    else
        parent:runAction(cc.Sequence:create(cc.DelayTime:create(0.1), cc.CallFunc:create(function ()
            local buff = zc.asyncShow(parent, buffName, callBack, scale, addType, opacity)

            if buff then
                buff:setOpacity(0)
                local opacity = opacity or 255
                buff:runAction(cc.FadeTo:create(1, opacity))
            end
        end)))
    end
end

--[[
    返回带颜色框的头像图片,
    参数：params.data = data ！ (data为物品的数据)
         params.type = 12 ！  (type是我们自定义的物品类型，如下表)
                            type[ 5.道具 7.英雄 12.装备 13.装备碎片]
         params.listener = listener  同时开启touchEnabled和touchListener
         params.scale = scale  缩放
         params.pos -- 位置
         params.ap -- 锚点

]]

--- 创建通用颜色框图片
-- @param params data(table), listener, hideCount, showLevel, attrLabel, showName, showStatic, pos, scale, delayTime ...
-- @return 返回图片实例, 图片Info
-- @see zc.updateIconByData
-- @see zc._showIconStatic
-- @usage zc.createIconByData({data = {id = 11, level = 12, type = zc.dataTypeHero}, pos = cc.p(85, -70), hideCount = true, showLevel = true})
function zc.createIconByData( params )
    local _itemNode = ItemNode:createWithParams(params)
    return _itemNode, _itemNode._info
end

--- 更新带颜色框的图标
-- @param iconBg 图标实例
-- @param params data(table), listener, hideCount, showLevel, attrLabel, showName, showStatic, pos, scale, delayTime ...
-- @return 图片的Info
-- @see zc.createIconByData
-- @usage zc.updateIconByData(picBg, {data = {id = myData.eid, type = zc.dataTypeEquip, level = myData.level}, hideCount = true, showLevel = true})
function zc.updateIconByData( iconBg, params )
    iconBg:updatByData(params)
    return iconBg._info
end

function zc._getIconInfo( params )
    local info = {
        templateId  = "", -- 模板ID
        static      = "", -- 静态表数据
        infoType    = "", -- 类型(跟DataType一致)--子类型
        name        = "", -- 名称
        star        = "", -- 星级
        quality     = nil, -- 品质
        bigImg      = "", --icon大图
        img         = "", -- 图片地址(小图)
        bgImg       = "", -- 背景地址
        borderImg   = nil, -- 外框地址
        locationImg = nil, -- 英雄Location
        fragmentImg = nil, --碎片角标
        reincarnateImg = nil, --转生角标
        num         = "", -- 物品数目
        level       = "", -- 等级（暂只有装备）
        reincarnate = "", -- 转数（暂只有将领)
        desc        = "", -- 描述
        suitId      = 0, -- 是否是套装（暂只有装备）
        scale       = 1, -- 图片缩放
        mainType    = 1, --物品类型
    }

    -- 物品主类型
    local mainType = tonumber(params.data.mainType) or 1
    -- 物品类型
    -- local myType = tonumber(params.type) or tonumber(params.data.package_type) or tonumber(params.data.type) or tonumber(params.data.res_type)
    local myType = tonumber(params.data.type)
    -- 模板Id
    -- local templateId = params.data.picture_id or params.data.item_id or params.data.gem_id or params.data.heroid or params.data.protoid or params.data.id
    local templateId = tonumber(params.data.id)

    -- 物品数量
    -- local myCount = params.data.num or params.data.count or ""
    local myCount =  tonumber(params.data.num)

    -- 将领转
    local reincarnate = tonumber(params.data.reincarnate) or 0
    -- 物品品质
    local quality = tonumber(params.data.quality) or 1

    if mainType == zc.mainTypeResource then
        assert(myType, "please define your (type) keyWord in (data) table ")
        info.star = 3
        info.img = zc.getImgByType(myType)
        info.bigImg = zc.getImgBigByType(myType)
        info.num = myCount
        if myType == zc.dataTypeTopaz then
            info.bgImg = "res/Main/hero/hero_item4.png"
        elseif myType == zc.dataTypeAmethyst
          or myType == zc.dataTypeEnergy
          or myType == zc.dataTypeTax then
            info.bgImg = "res/Main/hero/hero_item5.png"
        else
            info.bgImg = "res/Main/hero/hero_item3.png"
        end
        info.name = LANGUAGE_getReousrceNameById(myType) --名字
    elseif mainType == zc.mainTypeSoldierExp then
        --将领经验
        info.star = 3
        info.img = "res/Main/common/common_icon_generalEnergy.png"
        info.bgImg = "res/Main/hero/hero_item3.png"
        info.bigImg = "res/Main/common/iconBig/common_icon_generalEnergy.png"
        info.num = myCount
        info.scale = 1
    elseif mainType == zc.mainTypePlayerExp then 
        --玩家经验
        info.star = 3
        info.img = "res/Main/common/common_icon_exp.png"
        info.bgImg = "res/Main/hero/hero_item3.png"
        info.bigImg = "res/Main/common/iconBig/common_icon_exp.png"
        info.num = myCount
        info.scale = 1
    elseif mainType == zc.mainTypeTrinket then  
        --饰品
        info.star = quality
        local itemData = gameData.getDataFromCacheWithPrimaryKey("trinket", templateId)
        if itemData then
            info.img =  string.format("res/Main/ornaments/icon/%d.png", itemData.icon) 
            info.bgImg = string.format("res/Main/hero/hero_item%d.png", itemData.color) 
            info.name = itemData.name
            info.star = itemData.color
        else
            info.img =  "res/Main/ornaments/icon/1.png"
            info.bgImg =  "res/Main/hero/hero_item1.png"
        end
        info.scale = 1
    elseif mainType == zc.mainTypeWeapon then
        --兵器(传递兵器id,通过表查询兵器)
        info.star = quality
        local itemData = gameData.getDataFromCacheWithPrimaryKey("weapon", templateId)
        if itemData and itemData.id then
            info.img = string.format("res/Main/weapon/%d.png", itemData["iconId"])
            info.bgImg = string.format("res/Main/equip/equip_bg_%d.png", itemData["quality"])
            info.star = itemData["color"]
            info.name = itemData["name"]
        else
            info.img = "res/Main/weapon/1.png"
            info.bgImg = "res/Main/hero/hero_item1.png"
        end
        info.num = myCount
        info.scale = 1
        info.grade = params.data.grade
        info.level = params.data.level
    elseif mainType == zc.mainTypeProp then 
        --背包
        info.star = quality
        info.num = myCount
        local itemData = gameData.getDataFromCacheWithPrimaryKey("item", templateId)
        if myType == zc.subTypeFragment or myType == zc.subTypeWeaponFragment then --如果是装备碎片(背景图不一样)
            info.bgImg = string.format("res/Main/hero/fragment_%d.png", info.star) 
            info.fragmentImg = "res/Main/hero/fragment_item.png"
        else
            info.bgImg = string.format("res/Main/hero/hero_item%d.png", info.star or 1) 
        end
        if itemData then
            info.star = itemData.color
            myType = tonumber(itemData.subType)
            info.name = itemData.name
            info.type = itemData.type
            info.desc = itemData.desc
            local __quality = tonumber(itemData.quality) or 0
            if __quality ~= 0 then
                if myType == zc.subTypeFragment or myType == zc.subTypeWeaponFragment then --如果是装备碎片(背景图不一样)
                    info.bgImg = string.format("res/Main/equip/equip_fragment_%d.png", __quality) 
                    info.fragmentImg = "res/Main/hero/fragment_item.png"
                else
                    info.bgImg = string.format("res/Main/equip/equip_bg_%d.png", __quality) 
                end
            elseif __quality == 0 then
                info.bgImg = string.format("res/Main/equip/equip_bg_%d.png", info.star or 1) 
            end
        end
        if myType == zc.subTypeWeaponFragment then
            info.img = string.format("res/Main/weapon/%s.png", tostring(itemData.icon) or "1") -- bag_gem_
            if not zc.checkFileExist(info.img) then
                info.img = "res/Main/weapon/1.png"
            end
        else
            info.img = string.format("res/Main/bag/gem/%s.png", tostring(itemData.icon) or "1") -- bag_gem_
            if not zc.checkFileExist(info.img) then
                info.img = "res/Main/bag/gem/1.png"
            end
        end
        info.scale = 0.9
    elseif mainType == zc.mainTypeSoldier then 
        --将领
        info.reincarnate = reincarnate
        info.star = quality
        templateId = templateId or 1
        local itemData = gameData.getDataFromCacheWithPrimaryKey("hero", templateId)
        info.quality = 1
        if table.nums( itemData ) > 0 then
            info.star = itemData.star
            info.name = itemData.name
            -- info.quality = params.quality and params.quality or itemData.qualifications --固定背景
            info.quality = params.quality and params.quality or 1 --固定背景
            info.quality = info.quality < 1 and 1 or info.quality
            info.img = string.format("res/Main/hero/head/hero_head_%s.png", tostring(itemData.iconId))
            local hero_talent = gameData.getDataFromCacheWithPrimaryKey("hero_talent", itemData.talentId)  
            info.desc = hero_talent.desc or ""
            if tonumber(itemData.iconId) == 101 or tonumber(itemData.iconId) == 102 then
                info.img = PlayerData:getMainRoleHeadImg()
                --默认情况创建主角的icon是根据当前玩家的模型，但是查看别的玩家时头像icon需要主动传入mainRoleIcon
                --mainRoleIcon（1->101,2->102,3->103,4->104）
                if params.mainRoleIcon then
                    info.img = string.format("res/Main/hero/head/hero_head_10%s.png", tostring(params.mainRoleIcon))
                end
            end
        end
        if not zc.checkFileExist(info.img) then
            info.img = "res/Main/hero/head/hero_head_1.png"
        end
        -- 将领头像背景跟资质有关
        local __quality = zc.getQualityByQualifications(info.quality)
        info.bgImg = string.format("res/Main/equip/equip_bg_%d.png", tonumber(info.quality) or 1)
        info.reincarnateImg = string.format("res/Main/hero/jiao_%d.png", __quality)
        info.num = myCount
        info.scale = 1.3
        info.level = params.data.level

        --主人公需要传下资质等级，
        local _qualifications = params.data.qualifications or itemData.qualifications
       
        if params.showQuality then --显示左下角的资质
            info.qualificationImg = zc.getHeroQualificationsPath(_qualifications, 3)
        end
    elseif mainType == zc.mainTypeEquip then
        -- 装备
        local equipData = gameData.getDataFromCacheWithPrimaryKey("equip", templateId)
        if equipData then
            -- 颜色
            info.star = equipData.color
            info.name = equipData.name
            info.desc = equipData.desc
            -- 品质
            info.quality = equipData.quality
        end
        info.bgImg = string.format("res/Main/equip/equip_bg_%d.png", info.quality)
        info.img = string.format("res/Main/equip/equipIcon/%s.png", tostring(equipData.iconId)) -- bag_gem_
        if not zc.checkFileExist(info.img) then
            info.img = "res/Main/equip/equipIcon/1.png"
        end
        info.num = myCount
        info.scale = 1
        info.level = params.data.level
    elseif mainType == zc.mainTypeGem then
        -- 宝石
        local gemData = gameData.getDataFromCacheWithPrimaryKey("gem", templateId)
        if gemData then
            -- 颜色
            info.star = gemData.color
            info.name = gemData.name
            info.desc = gemData.desc
            -- 品质
            info.quality = gemData.quality
        end
        info.bgImg = string.format("res/Main/equip/equip_bg_%d.png", info.quality)
        info.img = string.format("res/Main/gem/gemIcon/%s.png", tostring(gemData.icon)) -- bag_gem_
        if not zc.checkFileExist(info.img) then
            info.img = "res/Main/gem/gemIcon/gem_blue_1.png"
        end
        info.num = myCount
        info.scale = 1
        info.level = params.data.level
    elseif mainType == zc.mainTypeHeroSoul then
        -- 将魂
        local gemData = gameData.getDataFromCacheWithPrimaryKey("heroSoul", templateId)
        if gemData then
            -- 颜色
            info.star = gemData.color
            info.name = gemData.name
            info.desc = gemData.desc
            -- 品质
            info.quality = gemData.quality
        end
        info.bgImg = string.format("res/Main/equip/equip_bg_%d.png", info.quality)
        info.img = string.format("res/Main/heroSoul/icons/%s.png", tostring(gemData.iconId)) -- bag_gem_
        if not zc.checkFileExist(info.img) then
            info.img = "res/Main/heroSoul/icons/1.png"
        end
        info.num = myCount
        info.scale = 1
        info.level = params.data.level
    elseif mainType == zc.mainTypeSkill then 
        --技能
        info.star = 1
        local itemData = nil
        if templateId < 10000 then
            -- 普通技能(相同模型的男女主角的技能图标不相同，只有男女主角的不相同，所以需要特殊处理，)
            itemData = gameData.getDataFromCacheWithPrimaryKey("skill", templateId)
            local imageId = 1
            if type(itemData.image) == "number" then --一般将领的image是数字，主角的是"41|300101"需要解析出来第一个是男主角的图标后一个是女主角的图标
                imageId = itemData.image
            else
                local skillTable = string.split(itemData.image,"|")
                if params.sexId then --传入性别id --（查看别人的信息和创建角色的时候不能确定当前是男女主角，需要主动传入性别id--->1男主角、2女主角）
                    imageId = skillTable[tonumber(params.sexId)]
                else
                    imageId = skillTable[tonumber(PlayerData.info["seigniorId"])]
                end
            end
            info.img = string.format("res/Main/hero/skill/%s.jpg", tostring(imageId) )
            info.name = itemData.name
        else
            -- 升星技能
            itemData = gameData.getDataFromCache("hero_star_level", {skills = templateId.."|1"})
            info.img = "res/Main/role/starup/icon/"..( itemData.icon or 1 )..".jpg"
            info.name = itemData.name
        end
        if myType == -1 then
            info.bgImg = "res/Main/hero/hero_item1.png"
        else
            info.bgImg = "res/Main/role/fetter/fetterItemBg.png"
        end
        info.scale = 95/80
        info.justY = 2
    elseif mainType == zc.mainTypeOthers then 
        --其他
        info.star = 1
        info.img = string.format("res/Main/common/common_itemother_%d.png", templateId)--common_itemother
        info.bgImg = string.format("res/Main/hero/hero_item%d.png", quality) 
        info.scale = 2
    elseif mainType == zc.mainTypeTech then
        --国家科技
        info.star = 1
        local itemData = gameData.getDataFromCacheWithPrimaryKey("country_tech", templateId)
        if itemData then
            info.img = string.format("res/Main/country/techinfo/icon/%s.png", tostring(itemData["icon"]) )--common_itemother
        else
            info.img = "res/Main/country/techinfo/icon/1.png"
        end
        info.bgImg = string.format("res/Main/hero/hero_item%d.png", quality) 
        info.num = myCount
        info.scale = 1.4
        info.level = params.data.level
    elseif mainType == zc.mainTypeSoldierCard then
        --将领卡
        info.star = quality
        local itemData = gameData.getDataFromCacheWithPrimaryKey("heroCard", templateId)
        if itemData then
            info.star = itemData.quality
            info.name = itemData.name
            info.img = string.format("res/Main/hero/head/hero_head_%d.png", itemData.icon or 1)
        else
            info.img = "res/Main/hero/head/hero_head_1.png"
        end
        info.bgImg = string.format("res/Main/hero/fragment_%d.png", tonumber(info.star) or 1) 
        info.fragmentImg = string.format("res/Main/research/qunxiong/hun_%d.png", tonumber(info.star) or 1)
        info.num = myCount
        info.scale = 1.3
    elseif mainType == zc.mainTypeSoldierFragment then
        templateId = templateId or 1
        local itemData = gameData.getDataFromCacheWithPrimaryKey("hero", templateId)
        local _star = 1
        if table.nums( itemData ) > 0 then
            info.name = itemData.name
            _star = itemData.qualifications
            info.img = string.format("res/Main/hero/head/hero_head_%s.png", tostring(itemData.iconId))
            local hero_talent = gameData.getDataFromCacheWithPrimaryKey("hero_talent", itemData.talentId)  
            info.desc = hero_talent.desc or ""
            if tonumber(itemData.iconId) == 101 or tonumber(itemData.iconId) == 102 then
                info.img = PlayerData:getMainRoleHeadImg()
                --默认情况创建主角的icon是根据当前玩家的模型，但是查看别的玩家时头像icon需要主动传入mainRoleIcon
                --mainRoleIcon（1->101,2->102,3->103,4->104）
                if params.mainRoleIcon then
                    info.img = string.format("res/Main/hero/head/hero_head_10%s.png", tostring(params.mainRoleIcon))
                end
            end
        end
        info.bgImg = "res/Main/equip/equip_bg_1.png"
        info.fragmentImg = "res/Main/hero/fragment_item.png"
        info.qualificationImg = zc.getHeroQualificationsPath(_star, 3)
        info.num = myCount
        info.scale = 1.3
    end
    info.templateId = templateId
    info.infoType = myType
    info.mainType = mainType
    return info
end
-- 通过星级获取文字颜色
function zc.nameColor( starNum )
    local curColor = display.COLOR_WHITE
    local num = tonumber(starNum) or 1
    if num == 2 then curColor = display.COLOR_GREEN   end
    if num == 3 then curColor = display.COLOR_BLUE    end
    if num == 4 then curColor = display.COLOR_PURPLE  end
    if num == 5 then curColor = display.COLOR_GOLD    end
    if num == 6 or num > 6 then curColor = display.COLOR_RED     end

    return curColor
end

function zc.createChapterTimeBar()
    -- 剩余次数背景
    local challengeBg = cc.Sprite:create("res/Main/copy/leftTimesBg.png")
    challengeBg:setPosition(105, 38)
    -- 剩余次数文字
    local challengeText = zc.createLabel({
        text = LANGUAGE_ARENA.times_left,
        fontSize = 20,
        shadow = true,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 35, challengeBg:getContentSize().height/2 ),
    })
    challengeBg:addChild( challengeText )
    -- 剩余次数数字
    local challengeLabel = zc.createLabel({
        text = 0,
        fontSize = 23,
        color = display.COLOR_GREEN,
        shadow = true,
        ap = cc.p(0, 0.5),
        pos = cc.p( challengeText:getPositionX() + challengeText:getContentSize().width + 10, challengeText:getPositionY() ),
    })
    challengeBg:addChild( challengeLabel )
    challengeBg._updateTimeFunc = function( ... )
        local _info = PlayerData:getEliteBuyInfo()
        challengeLabel:setText(tonumber(_info.challengeTimes) < 0 and 0 or _info.challengeTimes)
    end
    challengeBg._updateTimeFunc()
    -- 购买次数按钮
    local challengeBuyBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn2_u.png",
        selectedFile = "res/Main/common/button/common_btn2_d.png",
        disableFile = "res/Main/common/button/common_btn2_g.png",
        endCallback = function()
            local _params = {callBack = challengeBg._updateTimeFunc}
            zc.createSourcePop("ChapterBuy", "src/layer/chapter/ChapterBuyPop.lua", _params)
        end,
        pos = cc.p(challengeBg:getContentSize().width + 30, challengeText:getPositionY() ),
    })
    challengeBg:addChild(challengeBuyBtn)  

    return challengeBg
end

----------------组件、效果相关 end----------------------


----------------其他----------------------

--- 过万转换数字，七位数
-- @param value 转换值
-- @param ntype 转换类型,1:金币 2:钻石
-- @return 返回转换后的数值
-- @see zc.reverseWan

function zc.getWan( value, ntype )
    local ntype = ntype or  1

    value = tonumber( value ) or 0

    if value >= 10000000000 then 
        return math.floor( value / 100000000) .. zc.lang("a_hundred_million")
    elseif value >= 1000000 then 
        return math.floor( value / 10000) .. zc.lang("ten_thousand")
    else
        return value
    end
end
--- 过万转换数字，五位数
-- @param value 转换值
-- @param ntype 转换类型,1:金币 2:钻石
-- @return 返回转换后的数值

function zc.getShopWan( value, ntype )
    local ntype = ntype or  1

    value = tonumber( value )

    if value >= 100000000 then
        return math.floor( value / 100000000) .. zc.lang("a_hundred_million")
    elseif value >= 10000 then
        return math.floor( value / 10000) .. zc.lang("ten_thousand")
    else
        return value
    end
end

--- 数字转换过万
-- @param value 待转换值
-- @return 返回转换后的数值
-- @see zc.getWan

function zc.reverseWan( value )
    if type(value) == "string" then
        if tonumber(value) then
            return tonumber(value)
        end

        local wan = 0
        local z1, z2 = string.gsub(value, "[%d]+", function ( a )
            wan = a
        end)

        return wan * 10000
    end
    return value
end


function zc.zeroPad(timeseconds, nums)
    local len = string.len(tostring(timeseconds))
    local str = tostring(timeseconds)
    for i = len, nums - 1 do
        str = "0" .. str
    end
    return str
end


--- 秒数转成 x小时x分钟x秒
-- @param timeseconds 时间戳
-- @param sp 是否少于一分钟
-- @return 返回x小时x分钟x秒
-- @see zc.timeToClock
-- @usage
function zc.timeToString(timeseconds, sp)

    local timeseconds = tonumber(timeseconds)
    local sp = sp or false

    local str_s = zc.lang("date_seconds")
    local str_m = zc.lang("date_minute")
    local str_h = zc.lang("date_hours")
    local str_d = zc.lang("date_day")

    -- 少于一分钟
    if (sp) then
        if (timeseconds < 60) then
            return tostring(timeseconds) .. str_s
        end
    end

    if (timeseconds < 60) then
        return zc.zeroPad(timeseconds, 2) .. str_s
    end

    local secs = timeseconds % 60 -- 秒
    local mins = (timeseconds - secs) / 60 -- 分

    if (sp) then
        if (mins < 60) then
            return tostring(mins) .. str_m
        end
    end

    if (mins < 60) then -- 少于一小时
        return tostring(mins) ..str_m .. zc.zeroPad(secs, 2) .. str_s
    end

    -- 大于一小时
    local mins_new = mins % 60 -- 分
    local hous = (mins - mins_new) / 60 -- 小时

    -- 只返回最接近的最大时间
    if (sp) then
        if (hous > 24) then
            return tostring(math.floor(hous / 24)) .. str_d
        else
            return tostring(hous) .. str_h
        end
    end

    if (hous <= 24) then
        return tostring(hous) .. str_h .. tostring(mins_new) .. str_m .. tostring(secs) .. str_s
    else
        return tostring(math.floor(hous / 24)) .. str_d .. ' ' .. tostring(hous % 24) .. str_h .. tostring(mins_new) .. str_m .. tostring(secs) .. str_s
    end
end


--- 秒数转成 00:00:00
-- @param timeseconds 描述
-- @param day 是否显示天
-- @return 00:00:00
-- @see zc.timeToString
-- @usage zc.timeToClock(time, true)
function zc.timeToClock(timeseconds, day)
    local day = day or false

    local timeseconds = tonumber(timeseconds) or 0
    local str_d = zc.lang("dayTime", "")

    if not day then
        -- 小于0
        if(timeseconds < 0) then
            return '00:00:00'
        end
        -- 少于一分钟
        if (timeseconds < 60) then
            return '00:00:' .. zc.zeroPad(timeseconds, 2)
        end

        local secs = timeseconds % 60 -- 秒
        local mins = (timeseconds - secs) / 60 -- 分
        if (mins < 60) then -- 少于一小时
            return '00:' .. zc.zeroPad(mins, 2) .. ':' .. zc.zeroPad(secs, 2)
        end
        -- 大于一小时
        local mins_new = mins % 60 -- 分
        local hous = (mins - mins_new) / 60 -- 小时
        return zc.zeroPad(hous, 2) .. ':' .. zc.zeroPad(mins_new, 2) .. ':' .. zc.zeroPad(secs, 2)
    else
        -- 小于0
        if(timeseconds < 0) then
            return '00:00:00'
        end
        -- 少于一分钟
        if (timeseconds < 60) then
            return '00:00:' .. zc.zeroPad(timeseconds, 2)
        end

        local secs = timeseconds % 60 -- 秒
        local mins = (timeseconds - secs) / 60 -- 分
        if (mins < 60) then -- 少于一小时
            return '00:' .. zc.zeroPad(mins, 2) .. ':' .. zc.zeroPad(secs, 2)
        end

        -- 大于一小时
        local mins_new = mins % 60 -- 分

        local hous = (mins - mins_new) / 60 -- 小时

        if hous<24 then
            return zc.zeroPad(hous, 2) .. ':' .. zc.zeroPad(mins_new, 2) .. ':' .. zc.zeroPad(secs, 2)
        end
        local days = math.floor(hous/24)

        return '' .. days .. zc.lang("dayTime", "D") .. " "..zc.zeroPad(math.fmod(hous,24), 2) .. ':' .. zc.zeroPad(mins_new, 2) .. ':' .. zc.zeroPad(secs, 2)
    end
end
--变换颜色的字体
function zc.setLabelTTFColor(label, nextnum, backColor)
    local _backColor = backColor or cc.c3b(255,255,255)
    local function setBackColor()
        label:setColor(_backColor)
    end
    local function setColorGreen()
        label:setColor(cc.c3b(35,243,0))
    end
    local function setColorWhite()
        label:setColor(cc.c3b(255,255,255))
    end
    local fadeout = cc.FadeOut:create(0.1)
    local greenfunc = cc.CallFunc:create(setColorGreen)
    local fadein = cc.FadeIn:create(0.1)
    local whitefunc = cc.CallFunc:create(setColorWhite)
    local backfunc = cc.CallFunc:create(setBackColor)
    if label then
        local seq = cc.Sequence:create(fadeout,greenfunc,fadein,whitefunc,fadeout,greenfunc,fadein,whitefunc,fadeout,greenfunc,fadein,whitefunc,backfunc)
        label:runAction(seq)
        label:setText(nextnum)
    end
end
--- 时间戳转成日期
-- @param time 时间戳
-- @return 返回日期

function zc.timeToDate(time)
   return os.date("*t", time);
end

-- 随机数
function zc.random( m, n )
    math.newrandomseed()
    return math.random(m, n)
end

--判断背包中是否有加速道具 --返回道具列表
function zc.judgeHouseSpeedUpProp()
    local _flag = false
    local _SpeedUpPropList = {}
    local bagInfo = PlayerData:getBagInfo()
    for k,v in pairs(bagInfo) do
        if tonumber(v.subType) == 1003 then 
            table.insert(_SpeedUpPropList,v)
            _flag = true
        end
    end
    -- dump(_SpeedUpPropList, "---_SpeedUpPropList--")
    if #_SpeedUpPropList > 1 then
        table.sort(_SpeedUpPropList,function (a,b)
            return tonumber(a.color) < tonumber(b.color)
        end)
    end
    return _flag, _SpeedUpPropList
end

--创建将领星级
function zc.createHeroStar(_bg,_star,_pos)
    zc.removeHeroStar( _bg )
    local starNum = tonumber( _star or 0 )
    local starShowNum = ( starNum - 1 )%5 + 1
    local starSrcData = {
        "res/Main/common/common_hero_star_2.png",
        "res/Main/common/common_hero_star_1.png",
        "res/Main/role/starup/star_blue.png",
        "res/Main/role/starup/star_purple.png",
    }
    local starSrc = starSrcData[math.ceil( starNum/5 ) + 1]
    for i = 1, starShowNum do
        local star = cc.Sprite:create( starSrc )
        star:setPosition( _pos.x, _pos.y-i*27 )
        star:setName("star_"..i)
        star:setScale( 0.83 )
        _bg:addChild( star )
    end
    local starDarkSrc = "res/Main/common/common_hero_star_2.png"
    for i = starShowNum + 1, 5 do
        local star = cc.Sprite:create( starDarkSrc )
        star:setPosition( _pos.x, _pos.y-i*27 )
        star:setName("star_"..i)
        star:setScale( 0.83 )
        _bg:addChild( star )
    end
end
-- 删除将领星级
function zc.removeHeroStar( _bg )
    for i = 1, 5 do
        local star = _bg:getChildByName( "star_"..i )
        if star then
            star:removeFromParent()
        end
    end
end

--任务跳转
function zc.toReceiveRewardsView(conditions)
    print("----conditions----",conditions)
    local _str = conditions
    local datas = {}
    local data = {}
    if tonumber(_str) ~= 0 then 
        datas = string.split(_str,",")
        data = string.split(datas[1],"|")
    else
        data = nil
    end
    if data then 
        local _tagetType = tonumber(data[1]) or 0
        if _tagetType == 1 
          or _tagetType == 12
          or _tagetType == 72 then       --当前fb关卡
            local i,j,k = PlayerData:getNextOpenTollGate()
            if i ~= nil then
                zc.createTollgateLayer({enemyid = k,tollgateId = j, nationId = j, isOpenEnemy = true}) 
            end
        elseif _tagetType == 2 
          or _tagetType == 3 then   --国家 
            zc.createCountryScene()
        elseif _tagetType == 4 then   --关卡
            local _tollgateId = PlayerData:getChapterIdByEnemyId(data[2])
            local _chapterData = PlayerData:getCopyInfoByChapterId(_tollgateId)
            if not _chapterData then
                zc.tipInfo(zc.lang("tips_chapter_no_open"))
                return
            end
            zc.createTollgateLayer({enemyid = tonumber(data[2]),tollgateId = tonumber(_tollgateId), nationId = 1, newScene = true})
        elseif _tagetType == 5 then   --命格
            zc.createTalentScene()
        elseif _tagetType == 6 
          or _tagetType == 24
          or _tagetType == 47 then   --校场
            zc.createDrillFieldLayer()
        elseif _tagetType == 7 then   --建筑
            local mainCity = zc.getScene("mainCity")
            if mainCity then 
                mainCity:showHouseInMyVision(data[2])
            end
        elseif _tagetType == 8 
          or _tagetType == 9
          or _tagetType == 58 then   --酒馆招募
            zc.createPubLayer()
        elseif _tagetType == 10 
          or _tagetType == 11 
          or _tagetType == 36 
          or _tagetType == 56  then  --兵器打造
            zc.createSmithMakeLayer()
        elseif _tagetType == 15 then  --兵器强化
            zc.createSmithCastingLayer()
        elseif _tagetType == 16
          or _tagetType == 43
          or _tagetType == 55 then  --神兵
            zc.createSmithGodWeaponLayer()
        elseif _tagetType == 17 then   --建筑建造
            local mainCity = zc.getScene("mainCity")
            if mainCity then 
                mainCity:showHouseInMyVision(data[2], true)
            end
        elseif _tagetType == 18
         or _tagetType == 19 then   --布阵
            zc.createBuzhenLayer()
        elseif _tagetType == 20 then   --洗炼饰品
            zc.createRoleTrinket()
        elseif _tagetType == 21
          or _tagetType == 42
          or _tagetType == 60
          or _tagetType == 82 then   --武神塔
            zc.createWushenshilian()
        elseif _tagetType == 23 then   --贸易
            zc.createTradeLayer()
        elseif _tagetType == 25 then   --征收
            zc.createLevy(_data)
        elseif _tagetType == 26 then   --名将FB
            zc.createTollgateHeroMainLayer()
        elseif _tagetType == 27 then   --多人FB
            zc.createMultiCopyMainScene()
        elseif _tagetType == 28
          or _tagetType == 85 then   --演武榜
            zc.createArenaScene()
        elseif _tagetType == 29
          or _tagetType == 35 then   --群雄
            zc.createResearchQunXiong()
        elseif _tagetType == 30
          or _tagetType == 53 then   --精英FB
            if not zc.getFunctionStatus( 15, true ) then
                return
            end
            local i,j,k = PlayerData:getNextOpenTollGate(2)
            if i ~= nil then 
                zc.createTollgateLayer({enemyid = k,tollgateId = j, nationId = i, isOpenEnemy = true})
            end
        elseif _tagetType == 31 then   --军功商店
            zc.createArenaShopLayer()
        elseif _tagetType == 32 then   --培养
            if not zc.getFunctionStatus(13, true) then
                return
            end
            zc.createRoleScene({isMainRole = true, id = PlayerData.info.heroId, tab = 2})
        elseif _tagetType == 33 then   --将领升星
            -- 判断是否开启
            if not zc.getFunctionStatus( 14, true ) then
                return
            end
            local maxStar = nil
            local maxStarData = nil
            for i, v in ipairs( PlayerData:getGeneralInfo() ) do
                local _star = tonumber( v.star ) or 0
                if maxStar then
                    if maxStar < _star then
                        maxStar = _star
                        maxStarData = v
                    end
                else
                    maxStar = _star
                    maxStarData = v
                end
            end
            local isMainRole = false
            if tonumber( PlayerData.info.heroId ) == tonumber( maxStarData.id ) then
                isMainRole = true
            end
            zc.createRoleScene({isMainRole = isMainRole, id = maxStarData.id, tab = 4})
        elseif _tagetType == 34
          or _tagetType == 57 then   --激活兵器成就
            zc.createSmithBookLayer()
        elseif _tagetType == 37 then   --兵书
            zc.createResearchBingFa()
        elseif _tagetType == 38
          or _tagetType == 41 then   --演武榜
            zc.createArenaScene()
        elseif _tagetType == 45 then  --充值
            zc.createRechargePop()
        elseif _tagetType == 46 then  --好友
            zc.createFriendScene()
        elseif _tagetType == 49 
          or _tagetType == 50 
          or _tagetType == 69 then  --世界boss
            zc.createWorldBossLayer() 
        elseif _tagetType == 51 then -- 鉴定
            zc.createTenEvenPumpLayer()
        elseif _tagetType == 54
          or _tagetType == 67 then -- 兵器洗炼
            zc.createSmithClearLayer()
        elseif _tagetType == 61
          or _tagetType == 68 then -- 跳转到熟练度
            zc.createSmithPracticeLayer()
        elseif _tagetType == 62 
          or _tagetType == 63
          or _tagetType == 70
          or _tagetType == 73
          or _tagetType == 74 then -- 跳转到角色列表
            zc.createHeroListLayer()  
        elseif _tagetType == 64
          or _tagetType == 77
          or _tagetType == 81 then -- 跳转到兵器副本
            zc.createWeaponCopy()
        elseif _tagetType == 65 
          or _tagetType == 66 or _tagetType == 92 
          or _tagetType == 93 or _tagetType == 100 then -- 跳转到押镖
            zc.createCountryDartMainLayer()
        elseif _tagetType == 71 or _tagetType == 97 then -- 跳转到国家科技页面
            zc.createCountryScene({toFun=2})
        elseif _tagetType == 75
          or _tagetType == 76 then -- 跳转到主角勾玉
            zc.createRoleScene({isMainRole = true, id = PlayerData.info.heroId, tab = 5})
        elseif _tagetType == 78 then -- 突破
            zc.createRoleScene({id = PlayerData.info.heroId, goBreak = true})
        elseif _tagetType == 79 then -- 锻造
            zc.createWeaponCastLayer()
        elseif _tagetType == 80 then -- 主线章节
            zc.createChapter()
        elseif _tagetType == 83 then -- 极限挑战
            zc.createLimitChallengeCopy()
        elseif _tagetType == 84
          or _tagetType == 99 then -- 武神榜
            zc.createGodFightScene()
        elseif _tagetType == 86 or _tagetType == 95 or _tagetType == 96
         or _tagetType == 101 or _tagetType == 102  then -- 乌巢
            zc.createGrabMineMain()
        elseif _tagetType == 88
          or _tagetType == 89 then -- 猎魂
            zc.createHeroSoulRand()
        elseif _tagetType == 90 then
            LayerManager.backToMainCity()
            local mainCity = zc.getScene("mainCity")
            if mainCity then
                mainCity:createFarm()
            end
        elseif _tagetType == 91 
          or _tagetType == 98 then -- 粮草
            zc.createGrabFoodMain()
        end
    end
end

--返回登录界面
function zc.goReturnLogin( isForce )
    print("----------------登出回调函数----------------")
    if g_LoginFlag then
        return
    end
    g_LoginFlag = true
    LayerManager.backToMainCity()
    --返回登录时移除小喇叭
    local node = cc.Director:getInstance():getNotificationNode() 
    if node then
        node:removeChildByName("announcement")
    end
    zc.gotoLogin(true, isForce)
end

--[[该方法为全局方法，用于sdk调用lua全局函数]]
function _G_doGlobalToLoginForSdk_G_( param )
    print("_G_doGlobalToLoginForSdk_G_")
    local data     = json.decode(_param_) or {}
    local isLogout = data["isLogout"]
    if isLogout then
        isLogout = true
    else
        isLogout = false
    end
    zc.gotoLogin( isLogout, isForce )
end

function zc.gotoLogin( isLogout, isForce )
    local platform = cc.Application:getInstance():getTargetPlatform()
    if APP_SERVER == 0 and not IS_EX_TEST_SERVER and GAME_CHANNEL ~= CHANNEL.Android.CHANNEL_CODE_YJ then
        platform = cc.PLATFORM_OS_MAC--测试
    end
    if IS_TOKEN_LOGIN then
        platform = cc.PLATFORM_OS_MAC--测试
    end
    local director = cc.Director:getInstance()
    director:resume()

    local function _toLogin()
        LayerManager.reset()
        clearGlobalObject()
        PlayerData:clean()
        local scene = cc.Scene:create()
        local _autoLogin = isLogout == nil and true or false
        local _params = {autoLogin = _autoLogin}
        local _path = ""
        if platform == cc.PLATFORM_OS_ANDROID or platform == cc.PLATFORM_OS_IPAD or platform == cc.PLATFORM_OS_IPHONE then        
            _path = "src/layer/login/LoginLayer.lua"
        else
            -- _path = "src/layer/login/LoginLayer.lua"
            _path = "src/layer/login/LoginScene.lua"
        end
        local loginLayer = requires(_path):create(_params)
        loginLayer:setName("login")
        scene:addChild(loginLayer)
        director:replaceScene(scene)
        if isLogout then
            zc.logoutSdk()
        end
        if isForce then
            zc.tipInfo(zc.lang("tips_login_error"), scene)
        end
    end

    zc.preLoadLogin(_toLogin)
end

function zc.preLoadLogin( callback )
    local _runningScene = cc.Director:getInstance():getRunningScene()
    if not tolua.isnull(_runningScene) then
        local _loadingNode = LoadingCircleLayer:create()
        _runningScene:addChild(_loadingNode, 1000)
    end
    local _count = 0
    local function _asyncCallback()
        _count = _count + 1
        if _count == 4 then
            if not tolua.isnull(_loadingNode) then
                _loadingNode:removeFromParent()
            end
            zc.getSpine("beijing_renwu")
            if callback then
                callback()
            end
        end
    end
    for i=1, 4 do
        local _name = i == 1 and "beijing_renwu" or ("beijing_renwu" .. i)
        cc.Director:getInstance():getTextureCache():addImageAsync("res/animation/beijing_renwu/" .. _name .. ".png", _asyncCallback) 
    end
end

function zc.createProgressWithParams( params )
    local _isPlist = params.plist == nil and false or params.plist
    local _funC = _isPlist and zc.createSpriteWithFrameName or zc.createSprite

    local expImgBg = _funC(params.src1)
    expImgBg:setAnchorPoint(0, 0.5)
    local expGressImg = _funC(params.src2)
    local expPrgress = cc.ProgressTimer:create(expGressImg)
    expPrgress:setAnchorPoint(0.5, 0.5)
    expPrgress:setType(cc.PROGRESS_TIMER_TYPE_BAR)
    expPrgress:setBarChangeRate(cc.p(1, 0))
    expPrgress:setMidpoint(cc.p(0, 0))
    expPrgress:setPosition(params.pos)
    expImgBg:setPosition(params.offX or 0, expPrgress:getContentSize().height*0.5)
    expPrgress:addChild(expImgBg, -1)
    params.bg:addChild(expPrgress)
    if params.scale then
        expPrgress:setScale(params.scale)
    end
    return expPrgress
end

--进度条创建
function zc.createProgress(bg,src1,src2,pos,scale)
    return zc.createProgressWithParams({
            bg = bg,
            src1 = src1,
            src2 = src2,
            pos = pos,
            scale = scale,
        })
end

-- 数值变化动画，将需要变化的label和变化后的回调函数
function zc.numChangeAnimation( params )
    local label = params.label
    local pos = params.pos
    local callback = params.callback
    if label then
        -- 动画
        local _scale = label:getScale()
        local armature = zc.createSpine({
            fileName = "chuxiantexiao",
            actName = "idle",
            loop = false,
            autoRemove = true,
            removeCallback = function()
                local textureCache = cc.Director:getInstance():getTextureCache()
                textureCache:removeTextureForKey("res/animation/chuxiantexiao/chuxiantexiao.png")
            end,
        })
        armature:setAnchorPoint( 0.5, 0.5 )
        armature:setPosition( pos )
        label:addChild( armature )
        label:setScale(_scale*2)
        if label._scaleAction then
            label:stopAction(label._scaleAction)
        end
        label._scaleAction = cc.Sequence:create(
            cc.ScaleTo:create(0.3, _scale),
            cc.CallFunc:create(function()
                label._scaleAction = nil
            end)
        )
        label:runAction(label._scaleAction)
        if callback then
            callback()
        end
    end
end

-- 获取兵器的等级
function zc.getWeaponLevel( id )
    local weaponId = tonumber( id ) or 0 
    -- 先找到兵器数据
    local weaponData = PlayerData:getWeaponInfoInfoById(weaponId)

  
    -- dump(weaponData, id)
    if weaponData then
        if weaponData.isUser and tonumber( weaponData.isUser ) == 1 then
            -- 主角兵器
            return tonumber( weaponData.strengthenLevel ) or 0
        else
            local __level = tonumber(weaponData.trained) or -1
            if __level ~= - 1 then
                return __level
            end
            -- 非主角兵器
            local levelTotal = 0
            local levelNum = 0
            for i = 1, 6 do
                if weaponData["effectId"..i] and weaponData["effectValue"..i] and weaponData["effectInfo"..i] and weaponData["effectInfo"..i]["valueLimit"] then
                    local min = tonumber( weaponData["effectInfo"..i]["valueMin"] ) or 0
                    local max = tonumber( weaponData["effectInfo"..i]["valueMax"] ) or 0
                    local cur = tonumber( weaponData["effectValue"..i] ) or 0
                    levelTotal = levelTotal + math.ceil( ( cur - min )/( ( max - min )/100 ) )
                    levelNum = levelNum + 1
                end
            end
            -- print("levelTotal = ", levelTotal, " levelNum = ", levelNum )
            if levelNum == 0 then
                return 0
            else
                local level = math.floor( levelTotal/levelNum )
                if level < 1 then
                    level = 1
                elseif level > 100 then
                    level = 100
                end
                return level
            end
        end
    else
        -- 没有兵器数据
        return 0
    end
end
-- 根据兵器的品质获得兵器名字的颜色
function zc.getColorByQuality( quality )
    local _quality = tonumber(quality) or 1
    local color = {
        cc.c3b( 197, 195, 197 ),
        cc.c3b( 98, 192, 50 ),
        cc.c3b( 91, 167, 214 ),
        cc.c3b( 221, 89, 221 ),
        cc.c3b( 240, 240, 3 ),
        zc.COLOR_RED,
        ccc3(0, 0, 0),
    }
    return color[_quality]
end
-- 根据兵器的品质获得ARGB(16进制)
function zc.getColorARGBByQuality( quality )
    local _quality = tonumber(quality) or 1
    local colorArgb = {
        "ffc5c3c5", --cc.c3b( 197, 195, 197 ),
        "ff62c032", --cc.c3b( 98, 192, 50 ),  
        "ff5ba7d6", --cc.c3b( 91, 167, 214 ), 
        "ffdd59dd", --cc.c3b( 221, 89, 221 ), 
        "fff0f003", --cc.c3b( 240, 240, 3 ),  
        "ffff3644", --cc.c3b( 255, 54, 68 ),  
        "ff000000", --cc.c3b(255,111,0 ),     
    }
    return colorArgb[_quality]
end
-- 获取将领的技能，非普通攻击,data={id or heroId},noStar不需要升星技能
function zc.getHeroSkillData( data )
    -- 将领静态id
    local heroId = tonumber(data.heroId) or 0
    -- 将领星级
    local heroStar = tonumber(data.star) or 0
    -- 将领突破
    local heroAdvance = tonumber(data.newAdvance) or 0
    -- 将领后端数据
    local heroData = data.heroData
    -- 将领技能数据
    local heroDb = gameData.getDataFromCacheWithPrimaryKey("hero", heroId)
    
    local _stageSkillId = 0
    local _advanceSkillActiveStage = 0
    local skillData = {}
    local _tmpMap = {}
    local _moraleSkillId = heroData and heroData.moraleSkillId or heroDb.moraleSkillId
    local _moraleSkillLevel = heroData and heroData.moraleSkillLevel or 1
    local combineSkillLevel = heroData and heroData.combineSkillLevel or 1
    local combineSkillLevel2 = heroData and heroData.combineSkillLevel2 or 1
    local combineSkillLevelList
    if data.jineng then
        combineSkillLevelList = data.combineSkillLevelList
    end

    local _combineSkillList = {}
    for i=1,2 do
        _combineSkillList[i] = {}
        if i == 1 then
            _combineSkillList[i]["combineSkillId"] = heroData and heroData.combineSkillId or heroDb.combineSkillId
            _combineSkillList[i]["combineSkillLevel"] = heroData and heroData.combineSkillLevel or 1
            _combineSkillList[i]["isFirst"] = 1
        else
            _combineSkillList[i]["combineSkillId"] = heroData and heroData["combineSkillId" .. i] or heroDb["combineSkillId" .. i]
            _combineSkillList[i]["combineSkillLevel"] = heroData and heroData["combineSkillLevel" .. i] or heroDb["combineSkillLevel" .. i]
            _combineSkillList[i]["isFirst"] = 0
        end
    end
   
    -- 小技能
    if heroData then
        for i = 1, 5 do
            local _skillId = tonumber( heroData["commonSkillId"..i] ) or 0
            local _skillLevel = tonumber( heroData["commonSkillLevel"..i] ) or 0
            local _subType = tonumber( gameData.getDataFromCacheWithPrimaryKey("skill", _skillId).subType ) or 1
            if _subType ~= 1 then
                skillData[#skillData + 1] = {
                    id = _skillId,
                    level = _skillLevel,
                    skillType = _subType,
                }
            end
        end
    elseif heroDb and next(heroDb) then
        -- 小技能
        local _stageDbs = gameData.getDataFromCache("hero_stage", {heroId = heroId})
        for k,v in pairs(_stageDbs) do
            local _skillId = tonumber(v.skill) or 0
            local _stage = tonumber(v.stage) or 1
            if _skillId ~= 0 then
                _stageSkillId = _skillId
                _stageSkillActive = _stage
                break
            end
        end
        if _stageSkillId ~= 0 then
            local _subType = tonumber( gameData.getDataFromCacheWithPrimaryKey("skill", _stageSkillId).subType ) or 1
            if _subType ~= 1 then
                skillData[#skillData + 1] = {
                    id = _stageSkillId,
                    level = 1,
                    skillType = _subType,
                    stageSkillActive = _stageSkillActive
                }
                _tmpMap[_stageSkillId] = #skillData
            end
        else
            for i = 1, 3 do
                local _skillDb = gameData.getDataFromCacheWithPrimaryKey("skill", heroDb["commonSkillId" .. i])
                local _subType = tonumber(_skillDb.subType) or 1
                if _subType ~= 1 then
                    skillData[#skillData + 1] = {
                        id = _skillDb.id,
                        level = 1,
                        skillType = _subType,
                    }
                    _tmpMap[_skillDb.id] = #skillData
                end
            end
        end
    end
    -- 士气技能，必杀
    do
        local _skillDb = gameData.getDataFromCacheWithPrimaryKey("skill", _moraleSkillId)
        local _subType = tonumber(_skillDb.subType) or 1
        local _hitType = _skillDb.hitType or 1
        if _subType ~= 1 then
            skillData[#skillData + 1] = {
                id = _moraleSkillId,
                level = _moraleSkillLevel,
                skillType = _subType,
                hitType = _hitType
            }
            _tmpMap[_skillDb.id] = #skillData
        end
    end
    -- 合体技能，奥义
    do
        local _skillDb = {}
        for i = 1,2 do
            _skillDb = gameData.getDataFromCacheWithPrimaryKey("skill", _combineSkillList[i].combineSkillId)
            local _subType = tonumber(_skillDb.subType) or 1
            local _hitType = _skillDb.hitType or 1
            local level
            if data.jineng then
                level = combineSkillLevelList[i]
            else
                level = _combineSkillList[i].combineSkillLevel
            end
            if _subType ~= 1 then
                skillData[#skillData + 1] = {
                    id = _combineSkillList[i].combineSkillId,
                    level = level,
                    skillType = _subType,
                    hitType = _hitType,
                    isFirst = _combineSkillList[i].isFirst,
                    combineSkillId = _combineSkillList[1].combineSkillId,
                }
                _tmpMap[_skillDb.id] = #skillData
            end
        end
    end

    -- 处理升星技能及所有技能的等级
    local starupList = gameData.getDataFromCache("hero_star_level", {heroId = heroId} )
    if #starupList == 0 and next( starupList ) then
        starupList = {starupList}
    end
    table.sort(starupList, function( a, b )
        return tonumber( a.level ) < tonumber( b.level )
    end)

    for i = 1, #starupList do
        local _data = starupList[i]
        local _skillData = string.split(_data.skills, "|")
        local _skillId = tonumber(_skillData[1]) or 0
        local _skillLevel = tonumber(_skillData[2]) or 0
        local _key = _tmpMap[_skillId] or 0
        -- 没有有技能
        if _key == 0 then
            local _subType = 5
            if _skillId < 10000 then
                local _skillDb = gameData.getDataFromCacheWithPrimaryKey("skill", _skillId)
                _subType = tonumber(_skillDb.subType) or 1
            end
            if i > heroStar then
                _skillLevel = 0
            end
            if _subType ~= 1 then
                skillData[#skillData + 1] = {
                    id = _skillId,
                    level = _skillLevel,
                    skillType = 5,
                }
                _tmpMap[_skillId] = #skillData
            end
        elseif i <= heroStar then
            skillData[_key].level = skillData[_key].level < _skillLevel and _skillLevel or skillData[_key].level
        end
    end

    -- 技能类型对应排序优先级
    --[[
        1.普通攻击
        2.小技能
        3.士气技能
        4.合体技能
        5.被动技能专用——战斗初始化时触发一次
        6.被动技能专用——每次被攻击时触发
    ]]
    local _sort = {
        1, 3, 4, 5, 2, 6,
    }
    table.sort(skillData, function( a, b )
        if tonumber(a.skillType) == 4 and b.skillType == 4 then
            return a.isFirst > b.isFirst
        end

        return _sort[a.skillType] > _sort[b.skillType]
    end)

    return skillData
end


-- 功能开放函数
-- 判断功能开启函数，id：功能的id，类型定义文件里，isToast：如果没开是否弹出解锁条件
function zc.getFunctionStatus( id, toast )
    local status = false
    local data = gameData.getDataFromCacheWithPrimaryKey("functions", id)
    if data and next(data) then
        -- 等级
        local _level = tonumber(data.userLevel) or 0
        if PlayerData:getUserLevel() >= _level then
            status = true
        else
            if toast then
                zc.tipInfo(zc.lang("level_achieve") .. _level .. zc.lang("level_unlock"))
            end
            return false
        end
        -- 关卡
        local tollgateStatus,_type,_chapter,_tollgate = zc.getTollgateStatus( data.tollgateId )
        local _tollgateData = gameData.getDataFromCacheWithPrimaryKey("tollgate", data.tollgateId)
        local _name = ""
        if next(_tollgateData) ~= nil then
            _name = _tollgateData.name
        end

        if tollgateStatus == 2 then
            status = true
        else
            if toast then
                local typeData = {
                    zc.lang("noraml_chapter"),
                    zc.lang("elite_chapter")
                }
                zc.tipInfo(LANGUAGE_UNLOCK_CHAPTER_TIP(typeData[_type], _chapter, _name))
            end
            return false
        end
        return status
    end
    return status
end



-- 跳转函数，id：功能id
function zc.gotoFunction( id, params, isGuide )
    local _isGuide = isGuide == nil and false or isGuide
    local _params = params or {}
    -- 先回到主城
    local _id = tonumber( id ) or 0
    if _id == 1 then

    elseif _id == 2 then
        -- 布阵
        LayerManager.backToMainCity()
        zc.createBuzhenLayer()
    elseif _id == 3 then
        -- 酒馆
        LayerManager.backToMainCity()
        zc.createPubLayer()
    elseif _id == 4 then
        -- 阵法升级
        LayerManager.backToMainCity()
        zc.createBuzhenLayer()
    elseif _id == 5 then
        -- 
        -- LayerManager.backToMainCity()
    elseif _id == 6 then
    elseif _id == 7 then
        -- 神兵强化
        LayerManager.backToMainCity()
        zc.createSmithGodWeaponLayer()
    elseif _id == 8 then
    elseif _id == 9 then    --装备饰品
        LayerManager.backToMainCity()
        zc.createRoleTrinket()
    elseif _id == 10 then   --洗练饰品
        LayerManager.backToMainCity()
        zc.createRoleTrinket()
    elseif _id == 11 then
        LayerManager.backToMainCity()
        zc.createTaskView()
    elseif _id == 12 then   --兵器谱
        LayerManager.backToMainCity()
        zc.createSmithBookLayer()
    elseif _id == 13 then   --培养
        LayerManager.backToMainCity()
        zc.createRoleScene({id = _params.id or PlayerData.info.heroId, tab = 2})
    elseif _id == 14 then   --升星
        LayerManager.backToMainCity()
        zc.createRoleScene({id = _params.id or PlayerData.info.heroId, tab = 4})
    elseif _id == 16 then   --名将FB
        LayerManager.backToMainCity()
        local _data = PlayerData:getHouseInfoByHouseId(15)
        if _data then
            zc.createTollgateHeroMainLayer()
        else
            local mainCity = zc.getScene("mainCity")
            if mainCity then 
                mainCity:showHouseInMyVision(15,true)
            end
        end
    elseif _id == 18 then   --羁绊
        LayerManager.backToMainCity()
        local _heros = PlayerData:getGeneralInfo() or {}
        local _id = nil
        local _heroId = PlayerData:getBaseInfoByTag("heroId")
        for k,v in pairs(_heros) do
            if v.id ~= _heroId and v.qualifications >= 3 then
                _id = v.id
                break
            end
        end
        zc.createRoleScene({id = _id, tab = 3}) 
    elseif _id == 19 then   --多人FB
        LayerManager.backToMainCity()
        local _data = PlayerData:getHouseInfoByHouseId(15)
        if _data then
            zc.createMultiCopyMainScene()
        else
            local mainCity = zc.getScene("mainCity")
            if mainCity then 
                mainCity:showHouseInMyVision(15,true)
            end
        end
    elseif _id == 20 then   --研究院
        local _data = PlayerData:getHouseInfoByHouseId(14)
        if _data then
            LayerManager.backToMainCity()
            zc.createResearchBingFa()
        else
            LayerManager.backToMainCity()
            local mainCity = zc.getScene("mainCity")
            if mainCity then 
                mainCity:showHouseInMyVision(14,true)
            end
        end
    elseif _id == 21 then   --命格
        LayerManager.backToMainCity()
        zc.createTalentScene()
    elseif _id == 22 then   --演武榜
        LayerManager.backToMainCity(not _isGuide)
        local _data = PlayerData:getHouseInfoByHouseId(13)
        if _data then
            zc.createArenaScene()
        else
            local mainCity = zc.getScene("mainCity")
            if mainCity then 
                mainCity:showHouseInMyVision(13,true)
            end
        end
    elseif _id == 23 then   --武神试炼
        LayerManager.backToMainCity()
        local _data = PlayerData:getHouseInfoByHouseId(15)
        if _data then
            zc.createWushenshilian()
        end
    elseif _id == 25 or _id == 94 then   --群雄
        LayerManager.backToMainCity()
        zc.createResearchQunXiong()
    elseif _id == 26 then   --好友度
        LayerManager.backToMainCity()
        local _data = PlayerData:getHouseInfoByHouseId(10)
        if _data then
            zc.createTradeFriendshipLayer( _params )
        end
    elseif _id == 27 then   --校场
        LayerManager.backToMainCity()
        zc.createDrillFieldLayer()
    elseif _id == 29 then   --武器洗练
        LayerManager.backToMainCity()
        zc.createSmithClearLayer()
    elseif _id == 31 then
        LayerManager.backToMainCity()
        local _data = PlayerData:getHouseInfoByHouseId(10)
        if _data then
            zc.createTradeLayer()
        end
    elseif _id == 34 then
        LayerManager.backToMainCity()
        -- 装备进阶
        zc.createRoleScene({id = _params.id or PlayerData.info.heroId, tab = 1})
    elseif _id == 35 then   --熟练度
        LayerManager.backToMainCity()
        zc.createSmithPracticeLayer()
    elseif _id == 36 then
        LayerManager.backToMainCity()
        -- 装备强化
        zc.createRoleScene({id = _params.id or PlayerData.info.heroId, tab = 1})
    elseif _id == 37 then
        -- 勾玉
        LayerManager.backToMainCity()
        zc.createRoleScene({id = _params.id or PlayerData.info.heroId, tab = 5})
    elseif _id == 39 then
        -- 勾玉
        LayerManager.backToMainCity()
        zc.createLimitChallengeCopy(_params.goIdx)
    elseif _id == 43 then
        -- 突破
        LayerManager.backToMainCity()
        zc.createRoleScene({id = _params.id or PlayerData.info.heroId, goBreak = true})
    end
end

-- 获取关卡状态
function zc.getTollgateStatus( tollgateId )
    -- 开启条件
    local tollgateId = tonumber( tollgateId or 0 ) or 0
    -- 副本类型
    local _type = math.floor( tollgateId/1000000 )
    -- 章
    local _chapter = math.floor( ( tollgateId%1000000 )/1000 ) - ( _type - 1 )*1000
    -- 关
    local _tollgate = tollgateId%1000
    -- 玩家的关卡数据
    local tollgateList = PlayerData:getCopyInfo()
    local tollgateData = ( ( tollgateList[_type] or {} )[_chapter] or {} )["tollgates"] or {}
    local myTollgate = 0
    for i, v in ipairs( tollgateData ) do
        if tonumber( v.tollgateId ) == tollgateId then
            myTollgate = tonumber( v.status )
            break
        end
    end
    return myTollgate,_type,_chapter,_tollgate
end

-- 进入主城提前加载
function zc.removePreloadMainCity()
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/home/homeUI.pvr.ccz")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/home/homeMain.pvr.ccz")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/home/homeBg.pvr.ccz")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/home/farBg.png")
end

-- 进入主城提前加载
function zc.preloadMainCity(lay, delay)
    -- local _fileName = zc.getWritablePath() .. "formationInfo.data"
    local _heroTa = zc.LoadTable("formationInfo") or {}
    if next(_heroTa) ~= nil then
        for k,v in pairs(_heroTa) do
            local hero = zc.createArmature({
                fileName = k,
                async = true,
            })
        end
    end

    g_LoginFlag = false


    local function _doLoad()
        local _loadLay = LoadingCircleLayer:create(true)
        lay:addChild(_loadLay, 100)

        local _time = os.clock()
        local _totleCount = 4
        local _count = 0
        local function _async()
            _count = _count + 1
            if _count == _totleCount then
                if not tolua.isnull(_loadLay) then
                    _loadLay:removeFromParent()   
                end
            end
        end
        --提前加载主城大地图
        cc.Director:getInstance():getTextureCache():addImageAsync("res/Main/home/homeUI.pvr.ccz", function()
            cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
            _async()
        end) 
        cc.Director:getInstance():getTextureCache():addImageAsync("res/Main/home/homeMain.pvr.ccz", function()
            cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeMain.plist", "res/Main/home/homeMain.pvr.ccz")
            _async()
        end) 
        cc.Director:getInstance():getTextureCache():addImageAsync("res/Main/home/homeBg.pvr.ccz", function()
            cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeBg.plist", "res/Main/home/homeBg.pvr.ccz")
            _async()
        end) 
        cc.Director:getInstance():getTextureCache():addImageAsync("res/Main/home/farBg.png", _async)
    end

    local _delay = tonumber(delay) or 0.01
    if _delay == 0 then
        _doLoad()
    else
        performWithDelay(lay, _doLoad, _delay)
    end
end

function zc.getFirstGuideData()
    local _data = cc.FileUtils:getInstance():getStringFromFile(zc.getFightDatasFilePath() .. "battle.data")
    _data = json.decode(_data)
    return _data
end


function zc.doFirstGuide( par, uId )
    local cleanArmatures = function ( ... )
        local manager = ccs.ArmatureDataManager:getInstance()
        manager:removeArmatureFileInfo("res/image/battle/hero/liubei.csb")
        manager:removeArmatureFileInfo("res/image/battle/hero/zhangfei.csb")
        manager:removeArmatureFileInfo("res/image/battle/hero/guanyu.csb")
        manager:removeArmatureFileInfo("res/image/battle/hero/zhangjiao.csb")
        manager:removeArmatureFileInfo("res/image/battle/hero/boss.csb",true)
        helper.collectMemory(true)
    end

    local function _startBattle( ... )
        local director = cc.Director:getInstance()                    
        director:getTextureCache():removeTextureForKey("res/Main/copy/newChapterBg.png")
        director:getTextureCache():removeTextureForKey("res/animation/guochangzhangjie/guochangzhangjie.png")
        local _data = zc.getFirstGuideData()
        local scene = cc.Scene:create()
        _data.guide = 1
        -- _data.fightScene = 3
        _data.bgNode = zc.getFightScene( 3 )
        local battle = requires("src/layer/battle/core/BattleLayer.lua"):createWithParams({data = _data,battleEndCallback = function (data,battle)
            local guideScriptLayer = GuideScriptLayer:createWithParams({storyId = 100009,callback = function ( ... )
                for k,hero in pairs(battle:getAllHeroes()) do
                    if hero:getResourceId() == "zhangjiao" then
                        hero:setVisible(false)
                        break;
                    end
                end
                --[[清除技能特效文件]]
                local manager = ccs.ArmatureDataManager:getInstance()
                manager:removeArmatureFileInfo("res/image/battle/hero/liubei_atk.csb",true)
                manager:removeArmatureFileInfo("res/image/battle/hero/liubei_atk3.csb",true)
                manager:removeArmatureFileInfo("res/image/battle/hero/guanyu_atk0_1.csb",true)
                manager:removeArmatureFileInfo("res/image/battle/hero/guanyu_atk3.csb",true)
                manager:removeArmatureFileInfo("res/image/battle/hero/guanyu_Fit2.csb",true)
                manager:removeArmatureFileInfo("res/image/battle/hero/change.csb",true)
                manager:removeArmatureFileInfo("res/image/battle/hero/chuchang.csb",true)
                manager:removeArmatureFileInfo("res/image/battle/hero/change_2.csb",true)
                helper.collectMemory(true)
                local guideScriptLayer = GuideScriptLayer:createWithParams({storyId = 100010,callback = function ( ... )
                    for k,hero in pairs(battle:getAllHeroes()) do
                        if hero:getResourceId() == "guanyu" or hero:getResourceId() == "liubei" then
                            hero:setVisible(false)
                        end
                    end
                    local guideScriptLayer = GuideScriptLayer:createWithParams({storyId = 100011,callback = function ( ... )
                        scene:removeAllChildren()
                        cleanArmatures()
                        local CreateRoleLayer = requires("src/layer/createRole/CreateRoleLayer.lua")
                        local scene = cc.Scene:create()
                        scene:addChild(CreateRoleLayer:create({portId=uId}))
                        director:replaceScene(scene) 
                        -- zc.tipInfo("xxxx")
                    end})
                    scene:addChild(guideScriptLayer)
                end})
                scene:addChild(guideScriptLayer)
            end})
            scene:addChild(guideScriptLayer)
        end})
        scene:addChild(battle)

        director:replaceScene(scene)
        local guideScriptLayer = GuideScriptLayer:createWithParams({storyId = 100001,callback = function ( ... )
             battle:play()
        end})
        scene:addChild(guideScriptLayer)

        for k,hero in pairs(battle:getAllHeroes()) do
            if hero:getResourceId() == "liubei"
            or hero:getResourceId() == "guanyu" 
            or hero:getResourceId() == "zhangfei"
            or hero:getResourceId() == "boss"
            or hero:getResourceId() == "zhangjiao"
            or hero:getResourceId() == "nanzhu_shan"
            or hero:getResourceId() == "nvzhujue" then
                hero:setVisible(false)
            end
        end
    end

    local function _showDialog()
        zc.createJuanzhouTips({
            name = LANGUAGE_GAME_START_INFO.name,
            desc = LANGUAGE_GAME_START_INFO.desc,
            enCall = _startBattle,
            par = par,
            autoEnd = true,
        })
    end

    print("前往选角色")
    zc.removePreloadMainCity()
    local function _loadStartBattleGuide()
        local _loadLay = LoadingCircleLayer:create()
        par:addChild(_loadLay, 100)
        local num = 0
        local done = 0
        local _asyncCallback = function ( ... )
            num = num + 1
            if num > 12 and done == 0 then
                done = 1
                _loadLay:removeFromParent()
                _showDialog()
            end
        end
        --部分动画预加载
        zc.createArmature({fileName = "liubei" , async = true , asyncCallback = _asyncCallback})
        zc.createArmature({fileName = "zhangfei" , async = true , asyncCallback = _asyncCallback})
        zc.createArmature({fileName = "guanyu" , async = true , asyncCallback = _asyncCallback})
        zc.createArmature({fileName = "zhangjiao" , async = true , asyncCallback = _asyncCallback})
        zc.createArmature({fileName = "boss" , async = true , asyncCallback = _asyncCallback})
        zc.createArmature({fileName = "nanzhu_shan" , async = true , asyncCallback = _asyncCallback})
        zc.createArmature({fileName = "nvzhujue" , async = true , asyncCallback = _asyncCallback})
        zc.createArmature({fileName = "nanzhu" , async = true , asyncCallback = _asyncCallback})
        zc.createArmature({fileName = "hjxb" , async = true , asyncCallback = _asyncCallback})
        zc.createArmature({fileName = "hjms" , async = true , asyncCallback = _asyncCallback})
        zc.createArmature({fileName = "nvzhuqiang" , async = true , asyncCallback = _asyncCallback})

        local director = cc.Director:getInstance()
        local textureCache = director:getTextureCache()
        textureCache:addImageAsync("res/Main/hero/body/15.png", _asyncCallback)
        textureCache:addImageAsync("res/image/guide/talkBar.png", _asyncCallback)
    end
    _loadStartBattleGuide()
end

-- 根据将领资质获取对应颜色，多种资质对应一种颜色
function zc.getHeroColorByQuality( value )
    local _color = {
        "white",--"c",
        "green",--"b",
        "blue",--"b+",
        "blue",--"a",
        "purple",--"a+",
        "purple",--"s",
        "purple",--"s+",
        "orange",--"ss",
        "orange",--"ss+",
        "orange",--"ss+",
    }
    local _max = #_color
    local _value = tonumber( value ) or 1
    _value = _value < 1 and 1 or _value
    _value = _value > _max and _max or _value
    return _color[_value]
end

-- 根据将领资质获取对应品质数值
function zc.getQualityByQualifications( value )
    local _qualifications = {
        1,--"c",
        2,--"b",
        3,--"b+",
        3,--"a",
        4,--"a+",
        4,--"s",
        4,--"s+",
        5,--"ss",
        5,--"ss+",
        5,--"ss+",
    }
    local _max = #_qualifications
    local _value = tonumber( value ) or 1
    _value = _value < 1 and 1 or _value
    _value = _value > _max and _max or _value
    return _qualifications[_value]
end
-- 根据将领资质获取对应将领碎片的颜色
function zc.getQualityByQualificationsSoldierFrag( value )
    local _qualifications = {
        2,--"c",
        3,--"b",
        3,--"b+",
        4,--"a",
        4,--"a+",
        5,--"s",
        5,--"s+",
        6,--"ss",
        6,--"ss+",
        6,--"ss+",
    }
    local _max = #_qualifications
    local _value = tonumber( value ) or 1
    _value = _value < 1 and 1 or _value
    _value = _value > _max and _max or _value
    return _qualifications[_value]
end
-- 获取将领的资质的文字描述
function zc.getHeroQualificationsBig( value )
    local _qualifications = {
        "C",
        "B",
        "B+",
        "A",
        "A+",
        "S",
        "S+",
        "SS",
        "SS+",
        "SS+",
    }
    local _max = #_qualifications
    local _value = tonumber( value ) or 1
    _value = _value < 1 and 1 or _value
    _value = _value > _max and _max or _value

    return _qualifications[_value]
end
-- 获取将领的资质的文字描述
function zc.getHeroQualifications( value )
    local _qualifications = {
        "c",
        "b",
        "b+",
        "a",
        "a+",
        "s",
        "s+",
        "ss",
        "ss+",
        "ss+",
    }
    local _max = #_qualifications
    local _value = tonumber( value ) or 1
    _value = _value < 1 and 1 or _value
    _value = _value > _max and _max or _value

    return _qualifications[_value]
end
-- 获取将领资质的图片路径
function zc.getHeroQualificationsPath( value, type )
    local _qualifications = {
        "c",
        "b",
        "b+",
        "a",
        "a+",
        "s",
        "s+",
        "ss",
        "ss+",
        "ss+",
    }
    local _max = #_qualifications
    local _value = tonumber( value ) or 1
    local _type = tonumber(type) or 1
    _value = _value < 1 and 1 or _value
    _value = _value > _max and _max or _value
    local _path = "res/Main/common/qualifications/".._qualifications[_value]
    if _type == 2 then
        _path = _path.."_s.png"
    elseif _type == 1 then
        _path = _path.."_b.png"
    elseif _type == 3 then
        _path = _path..".png"
    end

    return _path
end
-- 获取提示弹窗的标题
function zc.getTipPopTitle( _text )
    local _path = "res/Main/common/tipTitle/"..tostring( _text )..".png"
    if not zc.checkFileExist( _path ) then
        _path = "res/Main/common/tipTitle/tishi.png"
    end
    local _title = cc.Sprite:create( _path )
    local _titleBg = cc.Sprite:create( "res/Main/common/popBg/tipDi.png" )
    _title:setPosition( _titleBg:getContentSize().width/2, _titleBg:getContentSize().height/2 + 4 )
    _titleBg:addChild( _title )
    
    return _titleBg
end

function zc.getNextOpenFuncInfo( level )
    local _tmpDb = gameData.getDataFromCache("functions", {userLevel = level})
    if next(_tmpDb) ~= nil then
        return _tmpDb
    end
    return zc.getNextOpenFuncInfoNew(level)
end

function zc.getNextOpenFuncInfoNew( level )
    local functionData = gameData.getAllDataWithNoClone("functions")
    local _table = {}
    for k,v in pairs(functionData) do
        if v.userLevel ~= 1 or v.tollgateId ~= 1001001 then
            table.insert(_table, v)
        end
    end
    table.sort(_table, function( a, b )
        return a.id < b.id
    end)

    local _myLevel = tonumber(PlayerData:getUserLevel()) or 1
    if tonumber(level) then
        _myLevel = level
    end

    for i=1, #_table do
        local _vLevel = tonumber(_table[i].userLevel) or 1
        if _vLevel ~= 1 then
            if _myLevel < _vLevel then
                return _table[i]
            end
        else
            local _vTollgateId = tonumber(_table[i].tollgateId) or 1
            local _status = PlayerData:getCurTollGateStatus(_vTollgateId)
            if _status ~= 2 then
                return _table[i]
            end
        end
    end
    return nil
end

function zc.doFuncForAllChild( sNode, sFunc )
    local function _func_( _node ) 
        sFunc(_node)
        local _children = _node:getChildren()
        for k,node in pairs(_children) do
            _func_(node)
        end
    end
    _func_(sNode)
end

function zc.getAnnouncement()
    local announce = PlayerData["announcement"]
    if not announce or not next(announce) then
        return ""
    end
    local platform = GAME_CHANNEL
    local _packageId = zc.getAndroidChangedPackageId()
    local announcement = {}
    local _flag = false
    local _channelTb = {}
    for k,v in pairs(announce) do
        local _channel = v.channel or ""
        _flag = false
        if _channel == "" then 
            _flag = true
        else
            _channelTb = string.split(_channel, ",")
            for i=1,#_channelTb do
                if _channelTb[i] == platform or
                  tonumber(_channelTb[i]) == _packageId then 
                    _flag = true
                    break
                end
            end
        end
        if _flag then
            announcement[#announcement + 1] = v
        end
    end
    if #announcement == 0 then
        return ""
    end
    local contents = ""
    for i=1,#announcement do
        contents = contents .. announcement[i].content
        if i ~= #announcement then
            contents = contents .. "</br></br></br>"
        end
    end

    return contents, announcement
end

function zc.createJuanzhouTips( params )
    local _lay = ZCDialog:create()
    local _di = ZCSprite:create("res/Main/copy/newChapterBg.png")
    _di:setAnchorPoint(0.5, 0.5)
    _di:setPosition(zc.width*0.5, zc.height*0.5)
    _lay:addChild(_di)
    zc.setBgSize(_di)
    if params.par then
        params.par:addChild(_lay, 100)
    else
        LayerManager.addNode(_lay, {isPop = true})
    end
    local _juanzhou = zc.getSpine("bjgsjz")
    _juanzhou:setPosition(zc.width*0.5, zc.height*0.5)
    _juanzhou:playAction("animation2", false)
    _lay:addChild(_juanzhou)

    _juanzhou:registerSpineEventHandler( function ( event )
        if event.animation == "animation2" then
            _juanzhou:playAction("animation", true)
        end
    end, sp.EventType.ANIMATION_COMPLETE)

    local _name = zc.createLabel({
        text = params.name,
        fontSize = 36,
        width = 25,
        pos = cc.p(-10, -80),
    })
    -- _name:setRotation(-90)
    local _title = _juanzhou:getNodeForSlot("wenzi2")
    _title:addChild(_name)

    local _text = "\t\t" .. params.desc
    local _desc = zc.createRichLabel({
        text = "",
        color = cc.c3b(85, 45, 45),
    })
    _desc:setDimensions(cc.size(500, 300))
    _desc:setAnchorPoint(0, 1)
    _desc:setPosition(0, 30)
    _desc:setFontSize(28)
    _desc:setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
    _desc:setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP)
    local _title = _juanzhou:getNodeForSlot("wenzi")
    _title:addChild(_desc)

    local _haveOver = false
    local function _gotobattle( isRightNow )
        _desc:setOpacity(255)
        _desc:stopLoopDisplay()
        _desc:setString(_text)
        _di:stopAllActions()
        if isRightNow == true then
            _di:setTouchEndedCallback(function()
            end)
            if params.par then
                _lay:removeFromParent()
            else
                LayerManager.removeLayout(true)
            end
            if params.enCall then
                params.enCall()
            end
        else
            performWithDelay(_di, function()
                if params.enCall then
                    params.enCall()
                end
            end, 3.0)
        end
        _haveOver = true
    end
    _di:setTouchEndedCallback(function()
        if not _haveOver then
            _gotobattle()
        else
            _gotobattle(true)
        end
    end)
    _desc:setString("")
    local _array = {}
    _array[#_array + 1] = cc.FadeOut:create(0.2)
    _array[#_array + 1] = cc.CallFunc:create(function() 
        _desc:setString(_text)
        _haveOver = true
    end)
    _array[#_array + 1] = cc.FadeIn:create(0.5)
    if params.autoEnd then
        _array[#_array + 1] = cc.CallFunc:create(_gotobattle)
    end
    _desc:runAction(cc.Sequence:create(_array))
end

--根据消费类型获取付费表里的对应一档数据，subType 不存在可默认获取最大的
function zc.getConsumePriceData( sType, subType )
    local _costData = gameData.getDataFromCache("consume_price", {type=sType, subtype = subType})
    if next(_costData) ~= nil and #_costData == 0 then
        return _costData
    else
        _costData = gameData.getDataFromCache("consume_price", {type=sType})
        if next(_costData) ~= nil and #_costData == 0 then
            _costData = {_costData}
        end
        if #_costData > 0 then
            table.sort(_costData, function(a, b)
                if not a or not b then
                    return false
                end
                local _sA = tonumber(a.subtype) or 0
                local _sB = tonumber(b.subtype) or 0
                return  _sA < _sB
            end)
            return _costData[#_costData]
        end 
    end
    return {}
end


function zc.buildSkillDesc(skillId, skillLevel)
    local _skillId = tonumber(skillId) or 1
    local _skillLevel = tonumber(skillLevel) or 1
    _skillLevel = _skillLevel < 1 and 1 or _skillLevel
    local _skillData, _desc
    if _skillId < 10000 then
        -- 普通技能，技能表
        _skillData = gameData.getDataFromCacheWithPrimaryKey("skill", _skillId)
        _desc = _skillData.desc1
        -- 只有普通技能需要
        if string.find( _desc, "|" ) then
            local _strList = string.split( _desc, "|" )
            local _num = ( #_strList - 1 )/2
            for i = 1, _num do
                local _str = string.gsub( _strList[2*i], "lv", _skillLevel)
                local _script = "return ".._str
                local _value = loadstring( _script )()
                _strList[2*i] = _value
            end
            _desc = "" 
            for i, v in ipairs( _strList ) do
                _desc = _desc..v
            end
        end
    else
        -- 升星技能，升星表
        _skillData = gameData.getDataFromCache("hero_star_level", {skills = _skillId .. "|" .. _skillLevel})
        _desc = _skillData.desc
    end
    return _desc, _skillData
end

function zc.getBreakThroughInfo( params )
    local _id = params.id
    local _heroId = params.heroId
    local _qualifications = params.qualifications
    local _stageLevel = params.stageLevel

    local _dbs = {}
    if _id == PlayerData.info.heroId or inArray(_heroId, {101, 102, 103, 104}) then
        _dbs = gameData.getDataFromCache("hero_stage_cardlimit", {stageLevel = _stageLevel})
    else
        local _tmpDb = gameData.getDataFromCacheWithPrimaryKey("hero", _heroId)
        local _flag = tonumber(_tmpDb.specialStage) or 0
        if _flag == 0 then
            local _qualifications = tonumber(_tmpDb.qualifications) or 1
            _dbs = gameData.getDataFromCache("hero_stage_cost", {stageLevel = _stageLevel, qualifications = _qualifications})
        else
            _dbs = gameData.getDataFromCache("specialTollgateHeroCost", {stageLevel = _stageLevel, heroId = _heroId})
        end
    end

    return _dbs
end

function zc.getLevelTipShow()
    return APP_REVIEW and (zc.lang("level") .. " ") or "Lv."
end

--注册刷新红点 
function zc.registerAndRefreshRedDot(target, status, offseX, offSetY)
    if not target then
        return
    end

    local redDot = target:getChildByName("redDot")
    
    local _offseX = offseX or -20
    local _offSetY = offSetY or -20

    if not redDot then
        redDot = zc.createSprite("res/Main/common/common_red_point.png")
        redDot:setName("redDot")
        redDot:setPosition(ccp(target:getContentSize().width + _offseX, target:getContentSize().height + _offSetY))
        target:addChild(redDot,10)
    end

    redDot:setVisible(status == 1)

end

--因为加了跨服， 所以id要处理下，本方法仅用于对人副本相关
function zc.getRealId(id)
    local length = string.len(tostring(id))

    local uid = 0
    local serverId = 0

    if length == 18 then
        serverId = tonumber(string.sub(tostring(id), 1, 5)) - 10000
        uid = tonumber(string.sub(tostring(id), 6, -1))
    elseif length == 19 then
        serverId = tonumber(string.sub(tostring(id), 1, 5)) - 10000
        uid = tonumber(string.sub(tostring(id), 6, -1)) - 10000000000000 - 100000000*serverId
    end
    return uid, serverId
end

function zc.getFightDatasFilePath()
    local _path = ""
    if zc.isGt() then
        _path = "src/layer/battle/fightDatasGt/"
    else
        _path = "src/layer/battle/fightDatas/"
    end
    return _path
end