-- FileName: BlackMarketLayer.lua
-- Author: wangming
-- Date: 2016-12-01
-- Purpose: 黑市
--[[TODO List]]
local BlackMarketLayer = class("BlackMarketLayer", function()
	local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function BlackMarketLayer:create( params )
	return BlackMarketLayer.new( params )
end

function BlackMarketLayer:ctor( params )
	local _params = params or {}
	self._awards = _params.awards
	self._lockInfo = _params.lockInfo or {}
	self._flushTime = tonumber(_params.flushTimes) or 0
	self._cellDis = {}
	self._infos = {}

    local _openTime, _endTime = 0, 0
    local _turnInfo = PlayerData:getActivityInfoById(5)
	if _turnInfo.openTime and _turnInfo.endTime then
        _openTime = os.date("%m" .. zc.lang("date_month") .. "%d" .. zc.lang("date_day_1"), _turnInfo.openTime)
        _endTime = os.date("%m" .. zc.lang("date_month") .. "%d" .. zc.lang("date_day_1"), _turnInfo.endTime)
    end

	local _size = self:getContentSize()
	-- 背景
	local bg = zc.createSprite("res/Main/activity/blackMarket/bg.png")
	bg:setAnchorPoint(0.5, 1)
	bg:setPosition(_size.width*0.5, _size.height + 10)
	self:addChild(bg)
	local _bgSize = bg:getContentSize()

	local _w, _h = 180, 350
	for i=1, 3 do
		local _touchNode = cc.Node:create()
		_touchNode:setAnchorPoint(0.5, 0.5)
		_touchNode:setContentSize(_w, _h)
		local _node = zc.createPushButton({
			normalNode = _touchNode,
			noScaleAction = true,
			needEnableWhenMoving = true,
			pos = cc.p(_bgSize.width*0.5 + 220*(i-2), _bgSize.height - 50 - _h*0.5),
			endCallback = function() 
				local _info = self._infos[i] or {}
				local _db = _info.db or {}
				local _name = _info.name
				local _costNum = tonumber(_db.costNum) or 0
				local _costId = tonumber(_db.costId) or 1
				local _discount = tonumber(_db.discount)/10 or 1
				_discount = _discount == 0 and 1 or _discount
				_costNum = tostring(math.ceil(_costNum*_discount)) .. " " .. LANGUAGE_getReousrceNameById(_costId)
				local _tips = zc.lang("is_or_not_buy") .. " " .. _costNum.. " " .. zc.lang("buy")
				if _db.itemType == zc.mainTypeSoldier then
					_tips = _tips .. " " .. zc.lang("general") .. " “" .. _tips.name .. "”"
				else
					local _num = tonumber(_db.itemNum) or 0
					_tips = _tips .. " “" .. tostring(_name) .. "” X " .. _num
				end
				zc.createBuyPop({
                    tip = _tips,
                    special = {
                        {
                            begin = 5,
                            length = string.len(_costNum) - 2,
                            color = display.COLOR_YELLOW,
                        }
                    },
                    callback = function( isAliPay, isWeixin )
						self:doRecieve(i)
                    end
                })
			end,
		})
		bg:addChild(_node)

		local _nodeSize = _node:getContentSize()

		local _nameDi = zc.createSprite("res/Main/activity/blackMarket/nameDi.png")
		_nameDi:setPosition(_w*0.5, _h - 45)
		_node:addChild(_nameDi, 1)
		local _nameLab = zc.createLabel({
	        fontSize = 20,
	        pos = cc.p(_nameDi:getPosition()),
	        outLine = true,
	        color = cc.c3b(248, 206, 186),
	    })  
	    _node:addChild(_nameLab, 1)

	    for j = 1, 2 do
		    local wenlu = zc.createSprite("res/Main/activity/blackMarket/wenlu.png")
		    wenlu:setAnchorPoint(0.5, 0.5)
		    wenlu:setPosition(_nodeSize.width*0.5 - 69 + (j-1)*137 , _nodeSize.height - 130)
		    _touchNode:addChild(wenlu)
	    end

		local _numLab = zc.createLabel({
	        fontSize = 20,
	        pos = cc.p(_w*0.5, 145),
	        outLine = true,
	        pixel = 2,
	    })  
	    _node:addChild(_numLab, 1)

		local _gold1 = zc.createSprite()
		_gold1:setAnchorPoint(0, 0.5)
		_gold1:setPosition(_w*0.5 - 50, 105)
		_gold1:setScale(0.8)
	    _node:addChild(_gold1, 1)
		local _oldCost = zc.createLabel({
	        ap = cc.p(0, 0.5),
	        fontSize = 20,
	        pos = cc.p(_w*0.5 - 10, _gold1:getPositionY()),
	        color = cc.c3b(40, 21, 14),
	    })  
	    _node:addChild(_oldCost, 1)
	    local _redLine = zc.createSprite("res/Main/activity/blackMarket/redLine.png")
	    _redLine:setPosition(_w*0.5, _gold1:getPositionY())
	    _node:addChild(_redLine, 1)

	    local timeBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(120, 35))
	    timeBg:setPosition(_w*0.5, _gold1:getPositionY() - 35)
	    _node:addChild(timeBg, 1)
		local _gold2 = zc.createSprite()
		_gold2:setAnchorPoint(0, 0.5)
		_gold2:setPosition(_gold1:getPositionX(), timeBg:getPositionY())
		_gold2:setScale(0.8)
		_node:addChild(_gold2, 1)
		local _nowCost = zc.createLabel({
	        ap = cc.p(0, 0.5),
	        fontSize = 20,
	        pos = cc.p(_oldCost:getPositionX(), _gold2:getPositionY()),
	    })
	    _node:addChild(_nowCost, 1)

		local _selectedPic = zc.createSprite("res/Main/home/home_reachCondition.png")
		_selectedPic:setPosition(25, 15)
		_node:addChild(_selectedPic, 2)
		_selectedPic:setVisible(false)
		
		local _touchNode = cc.Node:create()
		_touchNode:setAnchorPoint(0.5, 0.5)
		_touchNode:setContentSize(_w, 40)
		local _buyBtn = zc.createPushButton({
			normalNode = _touchNode,
			anchor = cc.p(0.5, 0),
			pos = cc.p(_nodeSize.width*0.5, 0),
			endCallback = function()
				self:doSetLock(i)
			end
		})
		_node:addChild(_buyBtn, 1)

		local _discountDi = zc.createSprite("res/Main/activity/blackMarket/corner.png")
		_discountDi:setAnchorPoint(0, 1)
		_discountDi:setPosition(0, _h - 5)
		_node:addChild(_discountDi, 2)

		local _discountLab = zc.createLabel({
	        fontSize = 22,
	        outLine = true,
	        color2 = cc.c3b(233, 64, 28),
	        pos = cc.p( _discountDi:getContentSize().width/2 - 12, _discountDi:getContentSize().height/2 + 12),
	    })  
        _discountLab:setRotation( -45 )
	    _discountDi:addChild(_discountLab, 1)

		_node._numLab = _numLab
		_node._nameLab = _nameLab
		_node._oldType = _gold1
		_node._oldCost = _oldCost
		_node._nowType = _gold2
		_node._nowCost = _nowCost
		_node._buyStatus = _buyStatus
		_node._selectedPic = _selectedPic
		_node._discountDi = _discountDi
		_node._discountLab = _discountLab
		self._cellDis[i] = _node
	end
	
	-- 底
	local _diSize = cc.size(728, 75)
	local bottom = ccui.Scale9Sprite:create(cc.rect(20, 10, 549, 71), "res/Main/role/trinket/sellDi.png")
	bottom:setContentSize(_diSize)
    bottom:setAnchorPoint(0, 0)
    bottom:setPosition(-2, -5) 
    self:addChild(bottom, 1)

    local timeBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(300, 33))
    timeBg:setAnchorPoint(0, 0.5)
    timeBg:setPosition(40, _diSize.height*0.5)
    bottom:addChild(timeBg)

    local timeLab = zc.createLabel({
        text = zc.lang("activity_time") .. "：" .. _openTime .. " ~ " .. _endTime,
        fontSize = 20,
        pos = cc.p(timeBg:getContentSize().width*0.5, timeBg:getContentSize().height*0.5),
        color = cc.c3b(230, 224, 163),
    })
    timeBg:addChild(timeLab)

    local _freshBtn = zc.createCommomBtn({
		tag = 2,
		text = LANGUAGE_SHOP.refresh_space,
		pos = cc.p(_diSize.width - 90, _diSize.height*0.5),
		endCallback = function()
			local _flag = false
			for i=1, 3 do
				if not self:isLocked(i) then
					local _data = self._awards[tostring(i)] or {}
					local _db = gameData.getDataFromCacheWithPrimaryKey("black_market", _data.id)
					local _level = tonumber(_db.level) or 0
					if _level >= 4 then
						_flag = true
						break
					end
				end
			end
			if _flag then
				 local comfirm =  ZCConfirmDialog:createWithParams({
                    title = zc.lang("prompt"),
                    msg = zc.lang("tips_blackmarket_fresh"),
                    showDi = true,
                    rightCallback = function()
                        self:doFresh()
                    end
                })
                self:getParent():getParent():addChild(comfirm, 11)
			else
				self:doFresh()
			end
		end
	})
	bottom:addChild(_freshBtn)
	local _costLab = zc.createRichLabel({
        anchor = cc.p(1, 0.5),
        fontSize = 20,
    })  
    _costLab:setPosition(cc.p(_freshBtn:getPositionX() - _freshBtn:getContentSize().width*0.5 - 10, _diSize.height*0.5))
    _costLab:enableStroke(cc.c3b(0, 0, 0), 1.0)
    bottom:addChild(_costLab)
    self._costLab = _costLab

    self:freshUI()
end

function BlackMarketLayer:freshUI()
	local _costData = zc.getConsumePriceData(47, self._flushTime + 1)
    local _costNum = tonumber(_costData.price) or 0
    if _costNum > 0 then
    	self._costLab:setVisible(true)
    	self._costLab:setString(zc.getResRichText(zc.dataTypeGold, _costNum))
    else
    	self._costLab:setVisible(false)
    end

    for i=1, 3 do
    	local _cellDi = self._cellDis[i]
    	local _icon = _cellDi._icon
    	local _data = self._awards[tostring(i)] or {}
		local _db = gameData.getDataFromCacheWithPrimaryKey("black_market", _data.id)
		self._infos[i] = self._infos[i] or {}
		if _icon then
			_icon:removeFromParent()
			_cellDi._icon = nil
			if next(_db) == nil 
			  or self._infos[i].templateId ~= tonumber(_db.itemId) 
			  or self._infos[i].mainType ~= tonumber(_db.itemType)
			  then
	            local _spine = zc.createSpine({
	                fileName = "fanye",
	                actName = "animation",
	                autoRemove = true,
	                loop = false,
	                removeCallback = function() end
	            })
	            _spine:setPosition(_cellDi:getContentSize().width*0.5, _cellDi:getContentSize().height - 160)
		        _cellDi:addChild(_spine, 5)
		    end
		end
    	self._infos[i] = _db
		if next(_db) ~= nil then
			_cellDi:setEnable(true)
			_cellDi:setVisible(true)
			local _info = zc._getIconInfo({
				data = {
	                mainType = _db.itemType,
	                type = _db.itemId, 
	                id = _db.itemId,
	                num = _db.itemNum,
	            }
			})
			_info.db = _db
			self._infos[i] = _info

	        _cellDi._nameLab:setString(_info.name)
	        _cellDi._numLab:setString("X" .. tostring(_info.num))
			local _costNum = tonumber(_db.costNum) or 0
			local _costId = tonumber(_db.costId) or 1
			local _discount = tonumber(_db.discount)/10 or 1
			_discount = _discount == 0 and 1 or _discount
			_cellDi._oldType:setTexture(zc.getImgByType(_costId))
			_cellDi._oldCost:setString(_costNum)
			_cellDi._nowType:setTexture(zc.getImgByType(_costId))
			_cellDi._nowCost:setString(math.ceil(_costNum*_discount))
			_cellDi._discountLab:setString(tostring(_db.discount) .. zc.lang("discount_text"))
			_cellDi._selectedPic:setVisible(self:isLocked(i))

			if _db.itemType ~= zc.mainTypeSoldier then
				_cellDi._numLab:setVisible(true)
				_cellDi._icon = zc.getSprite({
					src = _info.img,
		            pos = cc.p(_cellDi:getContentSize().width*0.5, _cellDi:getContentSize().height - 128), 
		        })
		        _cellDi._icon:setScale(0.85)
		        _cellDi:addChild(_cellDi._icon)
		    else
		    	_cellDi._numLab:setVisible(false)
		    	local _heroInfo = gameData.getDataFromCacheWithPrimaryKey("hero", _db.itemId)
		    	local hero = zc.createArmature({
		    		fileName = _heroInfo.modelId,
		    		async = true, 
		    		asyncCallback = function( _armature )
			    		if tolua.isnull(_armature) then
			    			return
			    		end
			    		_armature:getAnimation():play("idle", -1, 1) 
				    end,
				})  
				hero:setScale(0.9)
			    hero:setPosition(_cellDi:getContentSize().width*0.5, _cellDi:getContentSize().height - 210)
			    _cellDi:addChild(hero)
			    _cellDi._icon = hero
		    end
		else
			self._infos[i] = {db = _db}
			_cellDi:setEnable(false)
			_cellDi:setVisible(false)
		end	
    end
end

function BlackMarketLayer:isLocked( idx )
	for k,v in pairs(self._lockInfo) do
		if tonumber(v) == idx then
			return true
		end
	end
	return false
end

function BlackMarketLayer:doFresh()
	if table.nums(self._lockInfo) == 3 then
		zc.tipInfo(zc.lang("tips_blackmarket_countfresh"))
		return
	end
	zc.sendHttp({
        apiName = "BlackMarket_fresh",
        successCallback = function(backData)
	        if tolua.isnull(self) then
	        	return
	        end
        	PlayerData:updataData(backData)
        	self._awards = backData.awards or {}
        	self._flushTime = self._flushTime + 1
        	self:freshUI()
        end
    })
end

function BlackMarketLayer:doSetLock(idx)
	local _table = {}
	for i=1, 3 do
		local _flag = self:isLocked(i)
		if i == idx then
			_flag = not _flag
		end
		if _flag then
			table.insert(_table, i)
		end
	end
	local _lockInfo = table.concat(_table, "|")
	if string.len(_lockInfo) == 0 then
		_lockInfo = nil
	end
	zc.sendHttp({
        apiName = "BlackMarket_set",
        params = {ids = _lockInfo},
        successCallback = function(backData)
	        if tolua.isnull(self) then
	        	return
	        end
        	self._lockInfo = backData.lockInfo or {}
			local _cellDi = self._cellDis[idx]
        	_cellDi._selectedPic:setVisible(self:isLocked(idx))
        end
    })
end

function BlackMarketLayer:doRecieve( id )
	zc.sendHttp({
        apiName = "BlackMarket_buy",
        params = {id = id},
        successCallback = function(backData)
	        if tolua.isnull(self) then
	        	return
	        end
        	PlayerData:updataData(backData)
        	self._awards = backData.awards
        	self._lockInfo = backData.lockInfo or {}
        	self:freshUI()
        	LayerManager.removeLayout(true)
        	zc.createShowReward(backData)
        end
    })
end

return BlackMarketLayer
