--[[
出售弹出框
jiangyan
2015-05-06
SellPop.lua
]]

local SellPop = class("SellPop",function()
	return ZCPopLayer:create()
end);

function SellPop:create(data)
    return SellPop.new(data)
end

function SellPop:ctor(data)
    self:initData(data)
	self:initUI()
end

function SellPop:initData( data )
    self._info = data.info--物品信息
    self._maxNum = data.maxNum --使用的最大数量
    self._leftBtnText = data.leftBtnText or zc.lang("cancel")
    self._rightBtnText = data.rightBtnText or zc.lang("sell")
    self._leftFunc = data.leftFunc or nil
    self._rightFunc = data.rightFunc or nil
    self._useNum = 1
end

function SellPop:initUI()
    local bg = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
        pos = cc.p(zc.width/2, zc.height/2),
    })
    self:addContent(bg)

    local title = zc.getTipPopTitle( "wupinchushou" )
    title:setPosition( bg:getContentSize().width/2, bg:getContentSize().height - 30 )
    bg:addChild(title,2)
    
    local _bgSize = bg:getContentSize()
    local contentBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    contentBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 30)
    bg:addChild(contentBg)

    local backButton = zc.createBackButton({
        pos = cc.p(bg:getContentSize().width-10, bg:getContentSize().height-10),
        listener = function () 
            self:hide()
        end,
    })
    bg:addChild(backButton)

    --道具
	local item = nil
    if tonumber(self._info["mainType"]) == zc.mainTypeWeapon then 
        item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeWeapon,
                type = 1, 
                id = self._info["weaponId"],
                -- num = 1,
                quality = self._info["color"],
            }, 
        })
    else
        item = zc.createIconByData({
            data = {
                mainType = self._info["mainType"],
                type = 1, 
                id = self._info["itemId"],
                -- num = self._info["num"],
                quality = self._info["color"],
            }, 
        })
    end
    item:setPosition(contentBg:getContentSize().width*0.5, 145)
    item:setScale(0.75)
    contentBg:addChild(item)
   
    local name = zc.createLabel({
    	text = self._info["name"],
    	fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(contentBg:getContentSize().width*0.5, 80),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    contentBg:addChild(name)
    local num = zc.createLabel({
    	text = zc.lang("curr_have")..":",
    	fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(10, 170),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    contentBg:addChild(num)
    local num2 = zc.createLabel({
    	text = self._info["num"],
    	fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(num:getPositionX() + num:getContentSize().width + 10, 170),
        outLine = true,
        color =display.COLOR_YELLOW,
    })
    contentBg:addChild(num2)
    self._num2 = num2
    
    local addBg = zc.createScale9Sprite({
        size = cc.size(360, 65),
        rect = cc.rect(50, 50, 1, 1),
        file = "res/Main/common/img_empty.png",
        pos = cc.p(contentBg:getContentSize().width/2, 40),
    })
    contentBg:addChild(addBg)
    --   -1
    local plusOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn8_u.png",
        selectedFile = "res/Main/common/button/common_btn8_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(-1)
        end,
        pos = cc.p(110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(plusOneBtn,2)
    local subTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "Min",
        endCallback = function()
            self:setMinNum(1)
        end,
        pos = cc.p(45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(subTenBtn,2)
    --   +1
    local addOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn2_u.png",
        selectedFile = "res/Main/common/button/common_btn2_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(1)
        end,
        pos = cc.p(addBg:getContentSize().width -  110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addOneBtn,2)
    --   +10
    local addTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "Max",
        endCallback = function()
            self:setMaxNum(self._maxNum)
        end,
        pos = cc.p(addBg:getContentSize().width - 45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addTenBtn,2)

    local numBg =  zc.createScale9Sprite({
            size = cc.size(120, 40),
            file = "res/Main/bag/new/bag_text_bg_s.png",
            pos = cc.p(addBg:getContentSize().width/2, addBg:getContentSize().height/2),
        })
    addBg:addChild(numBg)
    local num = zc.createLabel({
        text = self._useNum,
        fontSize = 20,
        pos = cc.p(numBg:getContentSize().width/2, numBg:getContentSize().height/2),
        outLine = true,
        color = display.COLOR_YELLOW
    })
    numBg:addChild(num)
    self._num = num
    
    --使用按钮
    local useBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(bg:getContentSize().width/2, 60), 
        text = self._rightBtnText,
        endCallback = function () 
            if self._rightFunc then 
                local newinfo = table.copy(self._info)
                newinfo["sellnum"] = self._useNum
                self._maxNum = self._maxNum - self._useNum
                if tonumber(self._maxNum) <= 0 then 
                    self._num:setText(0)
                    self._sell_label:setText(0)
                    self._rightFunc(self._useNum) 
                    self:hide()
                else
                    self._num:setText(1)
                    local _str_num = self._info["price"]
                    self._sell_label:setText(_str_num)
                    self._num2:setText(self._maxNum)
                    self._rightFunc(self._useNum) 
                end
            end
        end,
    })
    bg:addChild(useBtn)

    local sellImg = zc.getSprite({
        src = "res/Main/common/common_icon_money.png",
        pos = cc.p(useBtn:getPositionX() - useBtn:getContentSize().width*0.5 + 30, useBtn:getPositionY() + useBtn:getContentSize().height*0.5 + 20),
        scale = 0.9
    })
    bg:addChild(sellImg)
    local sell2 = zc.createLabel({
        text = self._info["price"],
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(sellImg:getPositionX() + sellImg:getContentSize().width*0.5 + 5, sellImg:getPositionY()),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    bg:addChild(sell2)
    self._sell_label = sell2

end
function SellPop:addNum(addnum)
    self._useNum = self._useNum + addnum
    if self._useNum >= tonumber(self._maxNum) then 
        self._useNum = self._maxNum
    elseif self._useNum <= 1 then
        self._useNum = 1
    end
    self._num:setText(self._useNum)
    local _str_num = tostring(tonumber(self._info["price"])*tonumber(self._useNum))
    self._sell_label:setText(_str_num)
end
function SellPop:setMaxNum(maxNum)
    self._useNum = maxNum
    self._num:setText(maxNum)
    local _str_num = tostring(tonumber(self._info["price"])*tonumber(self._useNum))
    self._sell_label:setText(_str_num)
end
function SellPop:setMinNum(minNum)
    self._useNum = minNum
    self._num:setText(minNum)
    local _str_num = tostring(tonumber(self._info["price"])*tonumber(self._useNum))
    self._sell_label:setText(_str_num)
end
return SellPop