--  Created by zhangchao on 16-03-29.
BattleNodeFitSkill = class("BattleNodeFitSkill", function(params)
    return ZCDialog:create()
end)

function BattleNodeFitSkill:ctor( params )
	local winSize 		= self:getContentSize();
    local winWidth 		= winSize.width;
    local winHeight 	= winSize.height;
    local name 			= tostring(params.name)
    local callback      = params.completeCallback
    local beijing      	= params.beijing
    local skeletonActName      = params.skeletonActName
    local heroActName      = params.heroActName
    if beijing == nil then
    	beijing = "bejing"
    end
    if skeletonActName == nil then
    	skeletonActName = "guanyu"
    end
    if heroActName == nil then
    	heroActName = "animation"
    end
    local path = "res/image/battle/heti/"
    print("bg=["..tostring(path..tostring(beijing)..".json").."]")
    print("skeleton=["..path.."skeleton.json".."]")
    print("hero=["..tostring(path..tostring(name)..".json").."]")
	local bg = SpineBase:createWithParams({jsonFile = path..tostring(beijing)..".json" ,atlasFile = path..tostring(beijing)..".atlas"})
	bg:setPosition(cc.p(winWidth / 2,winHeight / 2))
	self:addChild(bg)
	local skeleton = SpineBase:createWithParams({jsonFile = path.."skeleton.json" ,atlasFile = path.."skeleton.atlas"})
	skeleton:setPosition(cc.p(winWidth / 2,winHeight / 2))

	local hero = SpineBase:createWithParams({jsonFile = path..name..".json" ,atlasFile = path..name..".atlas"})
	hero:setPosition(cc.p(winWidth / 2,winHeight / 2))
	self:addChild(hero)
	self:addChild(skeleton)
	
	bg:playAnimation("idle",false)
	skeleton:playAnimation(tostring(skeletonActName),false)
	hero:playAnimation(tostring(heroActName),false)

	hero:registerSpineEventHandler( function ( event )
		self:runAction(cc.Sequence:create(cc.DelayTime:create(0.02),cc.RemoveSelf:create(true),cc.CallFunc:create(function ( ... )
			if callback then
				callback()
			end
		end)))
		-- self:removeAllChildren()
		-- self:removeFromParent()
	end, sp.EventType.ANIMATION_COMPLETE)
end

function BattleNodeFitSkill:createWithParams( params )
	return BattleNodeFitSkill.new(params)
end