--  Created by zhangchao on 16-11-26.
local chengong = class("chengong", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function chengong:create(params)
	return chengong.new(params)
end

local armature = nil
local csbs = nil
function chengong:ctor(params)
	armature = nil
	csbs = {"chengong_atk3"}
	self:preloadCsbs(csbs)
end

function chengong:getCsbFiles()
	return csbs
end

function chengong:doTransformation()
	if not self._transformation and self:isAlive() then
		self:playAction(BATTLE_ANIMATION_ACTION.ATK0)
		self._transformation = true
		_flag = true
	end
	return 1.2
end

function chengong:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()

	if skillType == BATTLE_SKILL_TYPE.ATK then
		local _fileName = "chengong"
		local _actName  = "atk_1"
		-- if skillType == BATTLE_SKILL_TYPE.SUPER then
		-- 	_actName  = "atk3"
		-- end
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName , loop = true, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "eff_sj" or movementID == "atk_2" ) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
                end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 3000)
			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				if skillType == BATTLE_SKILL_TYPE.SUPER then
					armature:getAnimation():play("atk3_1")
				elseif skillType == BATTLE_SKILL_TYPE.ATK then
					armature:getAnimation():play("eff_sj")
				end
	    		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	    		if ret and _tmp_ == 1 then
	    			print("结束"..tostring(math.random(0,10)))
	    			self:doHurt(params)
	    		end
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 2},
			})
		end
	else
		self:doHurt(params)
	end
end

function chengong:shouldMoveAttack(atkName)
	local ret = false
	if atkName == BATTLE_ANIMATION_ACTION.SUPER
	  or atkName == BATTLE_ANIMATION_ACTION.SUPER_2 then
		ret = true
	end
	return ret
end
function chengong:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 10
	end
	return count
end

function chengong:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    if skillType == BATTLE_SKILL_TYPE.ATK then
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    end
end

function chengong:getAttackPoint(skillType,targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
	end
	local pos 				= cc.p(x,y)
	--[[大招单独处理]]
	if skillType == 3 then
		local tmp_side 		= targetHero:getSide()
	    local _pos_ 				= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 5})
	    pos.y = _pos_.y
	end
	return pos
end
return chengong