--  Created by zhangchao on 16-03-29.
local gongsunzan = class("gongsunzan", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function gongsunzan:create(params)
	return gongsunzan.new(params)
end

local csbs = nil
function gongsunzan:ctor(params)
	csbs = {"gongsunzan_atk0","gongsunzan_atk3"}
	self:preloadCsbs(csbs)
end

function gongsunzan:getCsbFiles()
	return csbs
end

function gongsunzan:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local _deadHeroes 	= {}
	local times 		= 0

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "gongsunzan_atk0" , actName = "atk0" , loop = true})
		    armature:setPosition(self:getPosition())
		    
		    local _arrow = armature
			--起始位置
		    local runningScene 		= cc.Director:getInstance():getRunningScene()
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end

		    _arrow:setScaleX(-1 * _arrow:getScaleX())

			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 3000)

			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
	    		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	    		if ret and _tmp_ == 1 then
	    			self:doHurt(params)
	    		end
			end),cc.RemoveSelf:create(true)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
		
	else
		self:doHurt(params)
	end
end

function gongsunzan:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK0 or atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = false
	end
	return ret
end

function gongsunzan:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget 	= params.firstTarget

	-- skillType = 2
	if skillType == 2 then--
	elseif skillType == 3 then--3.士气技能 大招
	    local armature = zc.battle.createBattleEffect({fileName = "gongsunzan_atk3" , actName = "atk3" , eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            zc.battle.doShockAndFlash(evt)
            if string.find(evt,"hit") then
            	params.evt = evt
            	self:doHurt(params)
            end
	    	--[[--大招1.01秒后需要移动到敌人面前]]
            if string.find(evt,"go") then
            	local pos   = self:getAttackPoint(skillType,firstTarget)
				self:setPosition(pos)
            end
        end})
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * self:getScaleX())
	    end
	    self:addChild(armature)
    end
end

function gongsunzan:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 4
	end
	return count
end
return gongsunzan




