--  Created by zhangchao on 16-03-29.
local nanzhu_shan = class("nanzhu_shan", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function nanzhu_shan:create(params)
	return nanzhu_shan.new(params)
end

function nanzhu_shan:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK then
		ret = false
	end
	return ret
end

function nanzhu_shan:doAnimationEvent(evt)
	if evt == "change" then
		local armature = self:getArmature()
		if armature:getBone("weapons") then
			do
				local _bone = armature:getBone("change")
				local armature = zc.battle.createBattleEffect({fileName = "change" , actName = "change" , autoRemove = true, completeCallback = function()					
				end})
			    _bone:addDisplay(armature, 0)
                _bone:changeDisplayWithIndex( 0, true )
                _bone:getDisplayRenderNode():setCascadeOpacityEnabled( false )
                _bone:setOpacity( 255 )
			end

			local data = {}
			zc.dispatchEvent({name = EVENT_NAME_BATTLE_GET_GUIDEINFO,data = data})
			local weaponId = 2004
			if data.guide1 
			  or data.guide2 
			  or data.guide3 
			  or data.guide5 
			  then
			  	weaponId = 42
		    elseif data.guide6 then
		    	weaponId = 2004
		    end
			zc.soldierChangeWeapon(armature, weaponId)
		else
	    	print(tostring(self:getHeroName()).."不存在weapons******************************************")
	    end
	elseif evt == "change2" then
		local data 	= {}
	    zc.dispatchEvent({name = EVENT_NAME_BATTLE_GET_ALL_HEROES,data = data})
		local all_heroes = data.heroes
		if all_heroes then
			for k,hero in pairs(all_heroes) do
				if hero:getResourceId() == "nanzhu" then
					hero:setVisible(true)
					self:setVisible(false)
					self:setAlive(false)
					hero:setColor(cc.c3b(255,255,255))
					break;
				end
			end
		end
	end
end
function nanzhu_shan:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
			local armature = zc.createSprite( "res/image/battle/nzzd.png" )
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    armature:setScale( 1.5 )
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)) + 180);
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)
			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				local armature = zc.battle.createBattleEffect({fileName = "nanzhu_shan_atk3" , actName = "atk" , moveCallback = function (armatureBack,movementType,movementID)
	                if movementType == ccs.MovementEventType.complete and (movementID == "atk" ) then
	                    xpcall(function() armatureBack:removeFromParent() end, function ()
	                            print("armatureBack已被删除")
	                        end)
	                end
	            end})
		    	armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature, zorder = hero:getLocalZOrder() + 1},
				})
	    		if ret and _tmp_ == 1 then
	    			print("结束"..tostring(math.random(0,10)))
	    			self:doHurt(params)
	    		end
			end),
			cc.RemoveSelf:create(true)
			))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function nanzhu_shan:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	if skillType == BATTLE_SKILL_TYPE.SUPER then--3.士气技能 大招
	    local armature = zc.battle.createBattleEffect({fileName = "nanzhu_shan_atk3" , actName = "atk3"})
	    armature:setPosition(self:getAttackPoint(3,firstTarget))
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = firstTarget:getLocalZOrder() + 1},
		})
    end
end

function nanzhu_shan:isSkillEventAllDone(skillType,evt)
	local ret = true
	if skillType == 3 then
		if not string.find(evt,"hit5") then
			ret = false
	    end 
	end
	-- 被打断了
	if self._interrupted then
		ret = true
	end
	return ret
end

function nanzhu_shan:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 2 then
		count = 2
	elseif skillType == 1 then
		count = 3
	elseif skillType == 3 then
		count = 5
	end
	return count
end


function nanzhu_shan:showDefenseEffect(params)
	local skillType 	= params.skillType
	local hero 			= params.hero
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		self:showCommonDefenseEffect(params)
	else
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	end
end

return nanzhu_shan