--  Created by zhangchao on 16-03-29.
local sunce = class("sunce", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function sunce:create(params)
	return sunce.new(params)
end


function sunce:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 11
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 5
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		count = 14
	end
	return count
end

function sunce:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing  = "bejing",
		skeletonActName = "sunce",
		name = "sunce",
		-- 合体技特效
		fileName = "sunce_fit2",
		actName = "Fit2",
	}
	return fitSrc
end

function sunce:getFitSkillPos( params )
	local armature = params.armature
	local firstTarget = params.firstTarget
	
    local tmp_side 	= self:getSide()
    local diffx = 50
    if tmp_side == BATTLE_SIDE.LEFT then
    	tmp_side = BATTLE_SIDE.RIGHT
    else
    	tmp_side = BATTLE_SIDE.LEFT
    	diffx = -50
    end
    local position = 5
    if firstTarget then
    	position = firstTarget:getBattlePosition()
    end
	local pos 		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = position})
	pos.x 			= pos.x + diffx
	pos.y 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 5}).y
    pos.y 			= pos.y + 50
    armature:setPosition(pos)
    if self:getSide() == BATTLE_SIDE.RIGHT then
    	armature:setScaleX(-1 * armature:getScaleX())
    end
end

function sunce:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		if evt == "do_atk3_hit2" then
			flag = flag + 1
			local _tmp_ = flag
			for k,hero in pairs(hurtTargets) do
				local point = hero:getInitialPoint()
				-- hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
				local _shadow = hero:getArmature():getBone(hero:getResourceId().."_shadow")
				if not tolua.isnull( _shadow ) then
					-- _shadow:getDisplayManager():setVisible( false )
					local _posX, _posY = _shadow:getPosition()
					_posX, _posY = 0, 0
					_shadow:stopAllActions()
					_shadow:runAction(
						cc.Sequence:create(
							cc.Spawn:create(
								cc.EaseExponentialOut:create( cc.MoveTo:create(0.5, cc.p(_posX, _posY - 100)) ),
								cc.ScaleTo:create( 0.5, 0.85 )
							),
							cc.Spawn:create(
								cc.EaseExponentialIn:create( cc.MoveTo:create(0.5, cc.p(_posX, _posY)) ),
								cc.ScaleTo:create( 0.5, 1 )
							)
						)
					)
				else
					print("~~~~~~~~~~~~~~~~~~~~~"..hero:getResourceId().."_shadow not exist")
				end
				hero:runAction(
					cc.Sequence:create(
						cc.EaseExponentialOut:create( cc.MoveTo:create(0.5, cc.p(point.x, point.y+100)) ),
						cc.EaseExponentialIn:create( cc.MoveTo:create(0.5, cc.p(point.x, point.y)) ),
						cc.CallFunc:create(function()
							if ret and _tmp_ == 1 then
				    			self:doHurt(params)
				    		end
						end)
					)
				)
			end
		else
			self:doHurt(params)
		end
	else
		self:doHurt(params)
	end
end

function sunce:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    if skillType == BATTLE_SKILL_TYPE.ATK0 or skillType == BATTLE_SKILL_TYPE.SUPER then
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    else
    	self:showCommonDefenseEffect(params)
    end
end


return sunce