--  Created by wangming on 17-03-20.
local sunquan = class("sunquan", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function sunquan:create(params)
	return sunquan.new(params)
end

function sunquan:getSkillHurtCount(skillType)
	local count = 2
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 4
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 10
	end
	return count
end


function sunquan:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		local armature = zc.battle.createBattleEffect({fileName = "sunquan", actName = "eff_atk3s", autoRemove = true, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
        	zc.battle.doShockAndFlash(evt)
        	print("evt: " .. evt)
        	if self:isAttackEvent(evt) then
        		params.evt = evt
				self:doHurt(params)
        	end
        end})

        local _position = hurtTargets[1]:getBattlePosition()

	    armature:setPosition(zc.battle.getInitialMatrixPoint({side = hurtTargets[1]:getSide(), position = _position}))
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = hurtTargets[1]:getLocalZOrder() + 30},
		})
	else
		self:doHurt(params)
	end
end

-- function BattleHero:isSkillEventAllDone(skillType,evt)
-- 	local ret 	= true
-- 	local count = self:getSkillHurtCount(skillType)
-- 	if count > 1 and evt then
-- 		print("isSkillEventAllDone  evt="..tostring(evt))
-- 		if not string.find(evt,"hit"..tostring(count)) then
-- 			ret = false
-- 	    end 
-- 	end
-- 	-- 被打断了
-- 	if self._interrupted then
-- 		ret = true
-- 	end
-- 	return ret
-- end

function sunquan:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = false
	end
	return ret
end

function sunquan:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

return sunquan