--  Created by zhangchao on 16-03-29.
local zhangbao = class("zhangbao", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function zhangbao:create(params)
	return zhangbao.new(params)
end

local csbs = nil
function zhangbao:ctor(params)
	csbs = {"zb_atk3"}
	self:preloadCsbs(csbs)
end

function zhangbao:getCsbFiles()
	return csbs
end

function zhangbao:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK then
		ret = false
	end
	return ret
end

function zhangbao:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 11
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 10
	end
	return count
end

function zhangbao:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		if evt == "do_atk_hit" then
			for k,hero in pairs(hurtTargets) do
				local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
				local armature = zc.createSprite( "res/image/battle/zb_zidan.png" )
			    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
			    local _arrow = armature
				--起始位置
				local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
				--目标位置
				local endPos 			= point
				--计算角度
				-- 判定斜率,非弓箭状态
				local deltaY = endPos.y - _targetSlot.y;
				local deltaX = endPos.x - _targetSlot.x;
				local angel = deltaX > 0 and 0 or 180;
				local K = deltaY / deltaX;
				if deltaX ~= 0 then
					_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)) + 180);
				end
				local pos_delta = cc.pGetDistance(endPos, _targetSlot)
				local dt = zc.getDynamicTime(pos_delta, 4000)
				_arrow:runAction(
					cc.Sequence:create(
						cc.MoveTo:create(dt,endPos),
						cc.CallFunc:create(function() self:doHurt(params) end),
						cc.RemoveSelf:create(true)
					)
				)
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
				})
			end
		end
	else
		self:doHurt(params)
	end
end

function zhangbao:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    --[[zhangbao大招给自己加血，所以如果对象是自身，就不需要播放受击动作]]
    if skillType == BATTLE_SKILL_TYPE.SUPER then
    	if self ~= hero then
	    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	    end
    else
    	self:showCommonDefenseEffect(params)
    end
end

function zhangbao:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	
	if skillType == BATTLE_SKILL_TYPE.SUPER and firstTarget then
 		local point  		= firstTarget:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		local armature = zc.battle.createBattleEffect({fileName = "zb_atk3" , actName = "Animation1", autoRemove = true})
	    armature:setPosition(point)
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = firstTarget:getLocalZOrder() + 1},
		})
    end
end

return zhangbao