--  Created by zhangchao on 16-08-03.
local zhouyu = class("zhouyu", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function zhouyu:create(params)
	return zhouyu.new(params)
end

local csbs = nil
function zhouyu:ctor(params)
	csbs = {"zy_atk"}
	self:preloadCsbs(csbs)
	self._fit2SkillId = 395
end

function zhouyu:getCsbFiles()
	return csbs
end

function zhouyu:shouldMoveAttack(atkName)
	local ret = false
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = true
	end
	return ret
end

function zhouyu:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 2 then
		count = 7
	elseif skillType == 3 then
		count = 3
	elseif skillType == 4 then
		count = self._isFit2 and 7 or 8
	end
	return count
end

function zhouyu:getAttackPoint(skillType,targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
	end
	local pos 				= cc.p(x,y)
	--[[大招单独处理]]
	if skillType == 3 then
	    local tmp_side 	= self:getSide()
	    pos 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 2})
	end
	return pos
end

function zhouyu:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	if skillType == 1 then
		local fileName = "zy_atk"
		local actName  = "atk"
		local armature = zc.battle.createBattleEffect({fileName = fileName , actName = actName})
	    local runningScene = cc.Director:getInstance():getRunningScene()
		local point = firstTarget:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		armature:setPosition( point )
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX( armature:getScaleX() * -1 )
	    end
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = firstTarget:getLocalZOrder() + 1},
		})
	elseif skillType == 2 then
		local fileName = "zy_atk"
		local actName  = "atk0"
		local armature = zc.battle.createBattleEffect({fileName = fileName , actName = actName})
	    local runningScene = cc.Director:getInstance():getRunningScene()
		local point = firstTarget:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT,runningScene)
		armature:setPosition( point )
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX( armature:getScaleX() * -1 )
	    end
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = firstTarget:getLocalZOrder() + 1},
		})
    end
end

function zhouyu:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	if skillType == 4 then
		if not self._isFit2 then
			local armature = zc.battle.createBattleEffect({fileName = "zhouyu_hetiji" , actName = "Fit_2", autoRemove})
		    local runningScene = cc.Director:getInstance():getRunningScene()
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
			armature:setPosition( point )
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX( armature:getScaleX() * -1 )
		    end
		    zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature , zorder = hero:getLocalZOrder() + 1},
			})
		else
			local armature = zc.battle.createBattleEffect({fileName = "zhugeliang_Fit0_A2" , actName = "Fit0_A2", autoRemove = true})
		    local runningScene = cc.Director:getInstance():getRunningScene()
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
			armature:setPosition( point )
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX( armature:getScaleX() * -1 )
		    end
		    zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature , zorder = hero:getLocalZOrder() + 1},
			})
		end
	end
end

function zhouyu:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "jxbejing",
		skeletonActName = "zhouyu",
		name = "zhouyu",
		heroActName = "idle",
		specialHandle = true,
	}

	-- if self._isFit2 then
	-- 	fitSrc.fileName = "zhouyu_Fit0_A2"
	-- 	fitSrc.actName = "Fit2"
	-- 	fitSrc.skeletonActName = fitSrc.skeletonActName .. "_fit2"
	-- 	specialHandle = false
	-- end

	return fitSrc
end

function zhouyu:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local hurtTargets   = params.hurtTargets
	local endFunction   = params.endFunction

	print("zhouyu:doAttack(params)")
	dump(params)

	if skillType ~= BATTLE_SKILL_TYPE.FIT then
		self:doHurt(params)
		return
	end

	if self._isFit2 then
		local armature_fit2 = zc.battle.createBattleEffect({fileName = "zhouyu_Fit0_A2", actName = "Fit0_A2", autoRemove = true, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
	    	zc.battle.doShockAndFlash(evt)
	        if self:isAttackEvent(evt) then
	        	params.evt = evt
				self:doHurt(params)
			elseif string.find(evt,"back") then
				if endFunction then
					performWithDelay(self, endFunction, 0.5)
				end
	        end
	    end})
		self:getFitSkillPos({armature = armature_fit2})
		armature_fit2:setPositionY(armature_fit2:getPositionY() + 50)
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature_fit2:setScaleX(-1 * armature_fit2:getScaleX())
	    	armature_fit2:setPositionX(armature_fit2:getPositionX() - 300)
	    else
	    	armature_fit2:setPositionX(armature_fit2:getPositionX() + 300)
	    end
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_fit2 , zorder = self:getLocalZOrder() + 30},
		})
	else
		local armature_fit2 = zc.battle.createBattleEffect({fileName = "zhouyu_hetiji", actName = "Fit_1", autoRemove = true, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
	    	zc.battle.doShockAndFlash(evt)
	        if self:isAttackEvent(evt) then
	        	params.evt = evt
				self:doHurt(params)
			elseif string.find(evt,"back") then
				if endFunction then
					performWithDelay(self, endFunction, 0.5)
				end
	        end
	    end})

		
	    self:getFitSkillPos({armature = armature_fit2})
	    
		armature_fit2:setPositionY(armature_fit2:getPositionY() + 50)
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature_fit2:setScaleX(-1 * armature_fit2:getScaleX())
	    	armature_fit2:setPositionX(armature_fit2:getPositionX() - 300)
	    else
	    	armature_fit2:setPositionX(armature_fit2:getPositionX() + 300)
	    end
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_fit2 , zorder = self:getLocalZOrder() + 30},
		})
	end
end


return zhouyu