--  Created by wangming on 17-03-15.
local zuoci = class("zuoci", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function zuoci:create(params)
	return zuoci.new(params)
end

function zuoci:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 1 then
		count = 2
	elseif skillType == 2 then
		count = 4
	elseif skillType == 3 then
		count = 4
	end
	return count
end

function zuoci:shouldMoveAttack(atkName)
	local ret = false
	return ret
end

function zuoci:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local hero = hurtTargets[1]

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	    local armature = zc.battle.createBattleEffect({fileName = "zuoci" , actName = "atk_1", loop = true, moveCallback = function (armatureBack,movementType,movementID)
            if movementType == ccs.MovementEventType.complete and (movementID == "atk_2") then
                xpcall(function() armatureBack:removeFromParent() end, function ()
                    print("armatureBack已被删除")
                end)
            end
        end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
        	if self:isAttackEvent(evt) then
        		params.evt = evt
				self:doHurt(params)
        	end
        end})
	    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
	    local _arrow = armature
		--起始位置
		local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
		--目标位置
		local endPos 			= point
		--计算角度
		-- 判定斜率,非弓箭状态
		local deltaY = endPos.y - _targetSlot.y;
		local deltaX = endPos.x - _targetSlot.x;
		local angel = deltaX > 0 and 0 or 180;
		local K = deltaY / deltaX;
		if deltaX ~= 0 then
			_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
		end
		local pos_delta = cc.pGetDistance(endPos, _targetSlot)
		local dt = zc.getDynamicTime(pos_delta, 4000)

		_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
			armature:getAnimation():play("atk_2")
		end)))
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
		})
	elseif skillType == BATTLE_SKILL_TYPE.SUPER or skillType == BATTLE_SKILL_TYPE.ATK0 then
		local _evts = {}
		local _act = "atk0_1"
		if skillType == BATTLE_SKILL_TYPE.SUPER then
			_act = "atk3_1"
		end

		local armature = zc.battle.createBattleEffect({fileName = "zuoci", actName = _act, loop = false, moveCallback = function (armatureBack,movementType,movementID)
            if movementType == ccs.MovementEventType.complete and (movementID == _act) then
                xpcall(function() armatureBack:removeFromParent() end, function ()
                    print("armatureBack已被删除")
                end)
            end
        end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
        	zc.battle.doShockAndFlash(evt)
        	if self:isAttackEvent(evt) then
        		if inArray(evt, _evts) then
            		return
            	end
            	print("evt:  ... " .. evt)
            	table.insert(_evts, evt)
        		params.evt = evt
				self:doHurt(params)
        	end
        end})
	    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = hero:getLocalZOrder() + 1},
		})
	else
		self:doHurt(params)
	end
end

function zuoci:isSkillEventAllDone(skillType,evt)
	local ret 	= true
	local count = self:getSkillHurtCount(skillType)
	if count > 1 and evt then
		-- print("isSkillEventAllDone  evt="..tostring(evt))
		if not string.find(evt,"hit"..tostring(count)) then
			ret = false
	    end 
	end

	if skillType ~= 3 then
		-- 被打断了
		if self._interrupted then
			ret = true
		end
	end
	
	return ret
end

function zuoci:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

return zuoci




