--[[
-- 国家捐献cd清理
-- @author lph
-- Creation  2016-4-12
]]
local CountryTechCdClearPop = class("CountryTechCdClearPop", function ()
    return ZCPopLayer:create() 
end);

function CountryTechCdClearPop:create(params)
	local _CountryTechCdClear = self.new(params)
	return _CountryTechCdClear
end

function CountryTechCdClearPop:ctor(params)
    self:initData(params)
	self:initUI()
end

function CountryTechCdClearPop:initData(params)
	self._need_gold = params.needGold
	self._callback = params.callback
end

function CountryTechCdClearPop:initUI()
	local bg = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
        pos = cc.p(zc.width/2,zc.height/2) 
    })
    self:addContent(bg)
    local _bgSize = bg:getContentSize()
    --标题
    local _title = zc.getTipPopTitle( "tishi" )
    _title:setPosition( _bgSize.width*0.5, _bgSize.height - 30 )
    bg:addChild(_title)

    local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    middleBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 30)
    bg:addChild(middleBg)
    --内容提示
    local _title = zc.createLabel({
        text = zc.lang("tips_country_contributeCD_clear"),
        fontSize = 24,
        shadow = false,
        pos = cc.p(middleBg:getContentSize().width*0.5, middleBg:getContentSize().height*0.5),
        outLine = true,
        width = 350,
    })
    middleBg:addChild(_title)
    --清理CD按钮
    local _btn = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("country_clear"),
        pos = cc.p( _bgSize.width*0.5, 60 ), 
        listener = function ()
            local _gold = PlayerData:getResourcesInfo().gold
            if tonumber(_gold) < tonumber(self._need_gold) then
                zc.tipInfo(zc.lang("tips_gold_unenough"))
                return
            end
        	---type = 1,suntype = 0 清理捐献CD
            zc.sendHttp({
                apiName = "User_clearCD",
                params = {type = 1,suntype = 0},
                successCallback = function (data)
		            PlayerData:updataData(data)
		            local _cd = {addTime = 100,cdEndTime = 0,limit = "14400",flag = 0,rate = 3,status = 0}
		            self._callback(_cd)
		            LayerManager.removeLayout(true)
		        end
		    })
        end,
    })
    bg:addChild(_btn)
    --所需元宝图标
    local _src = zc.getImgByType(1)
    local _goldImg = zc.getSprite({
        src = _src,
        ap = cc.p(0, 0.5),
        pos = cc.p(_btn:getPositionX()-42, _btn:getPositionY()+45) 
    })
    _goldImg:setScale(0.8)
    bg:addChild(_goldImg)
    --所需元宝数量
    local _need_gold_label = zc.createLabel({
        text = self._need_gold,
        fontSize = 20,
        outLine = true,
        ap = cc.p(0, 0.5),
        pos = cc.p(_goldImg:getPositionX() + _goldImg:getContentSize().width + 5, _goldImg:getPositionY()),
        color = display.COLOR_GOLD,
    })
    bg:addChild(_need_gold_label)
     
end

return CountryTechCdClearPop