-- FileName: GrabFoodMainLayer.lua
-- Author: wangming
-- Date: 2016-09-26
-- Purpose: 新主线章节列表界面  fbid 1.速度副本、2.生存副本、3.强攻副本、4.极限挑战
--[[TODO List]]

local GrabFoodMainLayer = class("GrabFoodMainLayer", function()
	return zc.createNormalDialog({
		src = "",
		showFlower = false
	})
end)

function GrabFoodMainLayer:create( params )
	return GrabFoodMainLayer.new(params)
end

function GrabFoodMainLayer:ctor( params )
	self._times = tonumber(params.times) or 0
	self._costMoney = tonumber(params.money) or 0
	self._buyTimes = tonumber(params.buyTimes) or 0
	self._ownGrabInfo = params.ownGrabInfo or {}
	self._target = params.target or {}

	local _bg = zc.createSprite("res/Main/grabFood/bg.jpg")
	_bg:setAnchorPoint(0.5, 0)
	_bg:setPosition(zc.width*0.5, 0)
	self:addChild(_bg)

	local _house_ceng = cc.Node:create()
	_bg:addChild(_house_ceng)
	-- left
	local _siteInfos = {
		cc.p(121, 357),
		cc.p(160, 153),
		cc.p(515, 415),
		cc.p(555, 175),
		cc.p(351, 296),
	}
	self._leftHouses = {}
	local _tmpTb = {}
	for i=1, 5 do
		local _node = cc.Node:create()
		_node:setPosition(_siteInfos[i])
		local _flag = 1
		if i == 3 or i == 4 then
			_flag = 2
		elseif i == 5 then
			_flag = 3
		end
		local _houseBtn = zc.createPushButton({
			normalFile = "res/Main/grabFood/leftHouse" .. _flag .. ".png",
			endCallback = function()
				local _data = self._target[i] or {}
				local _currentGID = getGuideManager():getCurrentGID()
				if tonumber(_data.status) ~= 0 then
					zc.tipInfo(zc.lang("tips_player_have_already_be_robed"))
					if _currentGID == GuideKey.KEY_14606 then
						getGuideManager():setFuncGuideOver()
					end
					return
				end
				if self._times <= 0 then
					zc.tipInfo(zc.lang("tips_left_times_unenough"))
					if _currentGID == GuideKey.KEY_14606 then
						getGuideManager():setFuncGuideOver()
					end
					return
				end
				zc.sendHttp({
                    apiName = "GodFight_getEnemyInfo",
                    params = {targetUserId = _data.userId},
                    successCallback = function(net_data)
	                    if _currentGID == GuideKey.KEY_14606 then
	                    	zc.setGuideFuncNextStep(_currentGID, false)
						end
                        local enemyData = {enemys = {}}
                        for i = 1, 9 do
                            local _data = net_data[tostring(i)]
                            enemyData.enemys[i] = {}
                            if _data then
                                enemyData.enemys[i] = _data
                            end
                        end
                        local _params = {
                            battleType= BattleType.GrabFight,
                            toUserId = i,
                            enemys = enemyData,
                            fightScene = 6,
                        }
                        zc.createMatrixBattle(_params)
                    end
                })
			end
		})
		_node:addChild(_houseBtn)
		_node.houseBtn = _houseBtn

		local _nameDiSize = cc.size(130, 26)
		local _nameDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _nameDiSize)
	    _nameDi:setAnchorPoint(0.5, 0)
	    _nameDi:setPosition(0, 60)
	    _node:addChild(_nameDi, 1)

	    local _nameLab = zc.createLabel({
	    	pos = cc.p(_nameDiSize.width*0.5, _nameDiSize.height*0.5),
	    	fontSize = 18,
	    	outLine = true,
	    	color = cc.c3b(222, 223, 165),
    	})
	    _nameDi:addChild(_nameLab)
	    _node.nameLab = _nameLab

		local _fightDi = zc.createSprite("res/Main/grabFood/fightDi.png")
	    _fightDi:setAnchorPoint(0.5, 0)
	    _fightDi:setPosition(_nameDi:getPositionX(), _nameDi:getPositionY() + _nameDiSize.height)
	    _node:addChild(_fightDi, 1)

	    local _zhanImg = zc.createSprite("res/Main/role/list/fight.png")
	    _zhanImg:setAnchorPoint(0, 0)
	    _zhanImg:setPosition(0 , 0)
	    _fightDi:addChild(_zhanImg)

	    local _powerLab = zc.createFntLabel({
	        fnt = "res/Main/common/fnt/fight_change.fnt",
	        text = "0",
	        ap = cc.p(0, 0.5),
	        pos = cc.p(_zhanImg:getPositionX() + _zhanImg:getContentSize().width, _fightDi:getContentSize().height*0.5),
	        addwidth = -14,
	        scale = 0.57,
	    })
	    _fightDi:addChild(_powerLab)
	    _node.powerLab = _powerLab

	    _nameDiSize.width = 100
	    local _foodDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _nameDiSize)
	    _foodDi:setAnchorPoint(0.5, 0)
	    _foodDi:setPosition(0, -60)
	    _node:addChild(_foodDi, 1)

	    local _foodImg = zc.createSprite("res/Main/common/common_icon_grain.png")
	    _foodImg:setPosition(0, _nameDiSize.height*0.5)
	    _foodDi:addChild(_foodImg)

	    local _foodNumLab = zc.createLabel({
	    	pos = cc.p((_foodDi:getContentSize().width - _foodImg:getContentSize().width*0.5)*0.5, _nameDiSize.height*0.5),
	    	fontSize = 18,
	    	outLine = true,
    	})
	    _foodDi:addChild(_foodNumLab)
	    _node.foodNumLab = _foodNumLab

	    local _pass = zc.createSprite("res/Main/country/worldBoss/pass.png")
		_pass:setScale(0.8)
	    _node:addChild(_pass)
	    _pass:setVisible(false)
	    _node.pass = _pass

		self._leftHouses[i] = _node
		_tmpTb[i] = _node
	end
	table.sort(_tmpTb, function( a, b )
		return a:getPositionY() > b:getPositionY()
	end)
	for k,v in pairs(_tmpTb) do
		_house_ceng:addChild(v)
	end
	_tmpTb = nil

	-- right
	_siteInfos = {
		cc.p(zc.width - 310, 460),
		cc.p(zc.width - 220, 370),
		cc.p(zc.width - 115, 390),
		cc.p(zc.width - 204, 249),
		cc.p(zc.width - 78, 280),
		cc.p(zc.width - 116, 181),
	}
	self._rightHouses = {}
	for i = 1, 6 do
		local _node = cc.Node:create()
		_node:setPosition(_siteInfos[i])
		_house_ceng:addChild(_node)

		local _houseImg = zc.createSprite()
		_node:addChild(_houseImg)
		_node.houseImg = _houseImg


		self._rightHouses[i] = _node
	end


	-- ui
	local _ui_ceng = cc.Node:create()
	_bg:addChild(_ui_ceng)

	local _title = zc.createSprite("res/Main/grabFood/title.png")
	_title:setAnchorPoint(0, 1)
	_title:setPosition(0, zc.height)
	_ui_ceng:addChild(_title)

	for i = 1, 2 do
		local _diNode = cc.Node:create()
		_diNode:setAnchorPoint(1, 0.5)
		_diNode:setPosition(zc.width, zc.height - 80 - (i - 1)*45)
		_ui_ceng:addChild(_diNode)

		local _diSp = zc.createSprite("res/Main/country/countryDart/timeBg.png")
		_diSp:setPositionX(-30)
		_diNode:addChild(_diSp)

		local _signSp = zc.createSprite("res/Main/wushenTower/item.png")
		_signSp:setPositionX(-210)
		_diNode:addChild(_signSp)

		local _tipText = ""
		if i == 1 then
			_tipText = zc.lang("cur_foodroom_level")
		elseif i == 2 then
			_tipText = zc.lang("food") .. zc.lang("nums")
		end

		local _tipLab = zc.createLabel({
			text = _tipText,
			ap = cc.p(0, 0.5),
			fontSize = 18,
			color = cc.c3b(222, 223, 165),
			pos = cc.p(_signSp:getPositionX() + _signSp:getContentSize().width*0.5 + 5, 0)
		})
		_diNode:addChild(_tipLab)

		local _posX = _tipLab:getPositionX() + _tipLab:getContentSize().width + 5
		if i == 1 then
			local _levelLab = zc.createLabel({
				ap = cc.p(0, 0.5),
				fontSize = 18,
				color = display.COLOR_RED,
				pos = cc.p(_posX, 0)
			})
			_diNode:addChild(_levelLab)
			self._levelLab = _levelLab
		elseif i == 2 then
			local _myLimitLab = zc.createRichLabel({
				anchor = cc.p(0, 0.5),
				fontSize = 18,
				color = cc.c3b(222, 223, 165),
				pos = cc.p(_posX, 0)	
			})
			_diNode:addChild(_myLimitLab)
			self._myLimitLab = _myLimitLab
		end
	end
	
	local _resDi = cc.Node:create()
	_resDi:setAnchorPoint(1, 0.5)
	_resDi:setPosition(zc.width, zc.height - 125)
	_ui_ceng:addChild(_resDi)


	local _startBtn = zc.createPushButton({
		normalFile = "res/Main/grabFood/startBtn.png",
		pos = cc.p(zc.width - 90, 85),
		endCallback = function()
			local _currentGID = getGuideManager():getCurrentGID()
        	if _currentGID == GuideKey.KEY_14604 then
        		if self._startBtn.status ~= 0 then
            		zc.setGuideFuncNextStep(_currentGID, false)
		            local function _callBack()
			            getGuideManager():setObjTarget(self._leftHouses[1].houseBtn)
			            getGuideManager():startGuide()
			        end
			        getGuideManager():setHeroFuncCallBack(_callBack)
			        getGuideManager():startGuide()
		            return
		        end
        	end
			if self._startBtn.status == 0 then
		        zc.sendHttp({
		            apiName = "GrabFood_begin",
		            successCallback = function(data)
			            self._ownGrabInfo = data.ownGrabInfo or {}
			            self:freshRight()
			            self:freshUI()
		            	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "grabFood", bubbleData = 0 }})
		            	if _currentGID == GuideKey.KEY_14604 then
		            		zc.setGuideFuncNextStep(_currentGID, false)
		            		local function _callBack()
					            getGuideManager():setObjTarget(self._leftHouses[1].houseBtn)
					            getGuideManager():startGuide()
					        end
					        getGuideManager():setHeroFuncCallBack(_callBack)
					        getGuideManager():startGuide()
		            	end
		            end,
		        })
			elseif self._startBtn.status == 1 then
		        zc.sendHttp({
		            apiName = "GrabFood_levelUp",
		            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "grabFood", bubbleData = 0 }}),
		            successCallback = function(data)
			            self._ownGrabInfo = data.ownGrabInfo or {}
			            self:freshRight()
			            self:freshUI()
		            end,
		        })
			elseif self._startBtn.status == 2 then
				local _nowNum = zc.getNumByTypeId( zc.mainTypeResource, zc.dataTypeMoney)
		        if _nowNum < 5000 then
		        	zc.tipInfo(zc.lang("tips_money_deficiency"))
		        	return
		        end
		        zc.sendHttp({
		            apiName = "GrabFood_flush",
		            successCallback = function(data)
		            	PlayerData:updataData(data)
			            self._target = data.target or {}
			            getGuideManager():addMaskLayer()
			            local _yunSpine = zc.createSpine({
			            	fileName = "guochang_yun",
			            	actName = "animation",
			            	loop = false,
			            	autoRemove = true,
			            	removeCallback = function()
					            getGuideManager():removeMaskLayer()
			            	end
			            })
			            _yunSpine:setPosition(zc.width*0.5, zc.height*0.5)
			            _ui_ceng:addChild(_yunSpine, 1)
			            performWithDelay(self, function()
				            self:freshLeft()
			            end, 1.1)
		            end,
		        })
			end
		end
	})
	_ui_ceng:addChild(_startBtn)
	self._startBtn = _startBtn

	local _btBtnEff = zc.getSpine("speedsudu")
    _btBtnEff:playAction("animation", true)
    _startBtn:addChild(_btBtnEff, -1)
    _btBtnEff:setPosition(_startBtn:getContentSize().width*0.5, _startBtn:getContentSize().height*0.5)
    

	local _costSize = cc.size(80, 24)
	local _costDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _costSize)
    _costDi:setPosition(_startBtn:getPositionX(), _startBtn:getPositionY() - 50)
	_ui_ceng:addChild(_costDi)
	self._costDi = _costDi
	local _costImg = zc.createSprite(zc.getImgByType(zc.dataTypeMoney))
	_costImg:setPosition(0, _costSize.height*0.5)
	_costDi:addChild(_costImg)
    local _costLab = zc.createLabel({
    	text = self._costMoney,
    	pos = cc.p(_costSize.width*0.5, _costSize.height*0.5),
    	fontSize = 18,
	})
    _costDi:addChild(_costLab)

	local _y = 50
	local _x = 255
	local _partW = 100

	-- 成就奖励
	self._meritRewardBtn = self:createBottonBtn({
        src = "res/Main/common/common_icon_shengxing.png",
        pos = cc.p(zc.width - _x, _y), 
        text = zc.lang("merit_reward"),
        listener = function()
	        zc.sendHttp({
	            apiName = "GrabFood_achievementList",
	            successCallback = function( net_data )
			        local _currentGID = getGuideManager():getCurrentGID()
			        if _currentGID == GuideKey.KEY_14610 then
			        	zc.setGuideFuncNextStep(_currentGID, false)
			        end
		            net_data.nowNum = tonumber(self._ownGrabInfo.num) or 0
	            	zc.createSourcePop("GrabFoodReward", "src/layer/grabFood/GrabFoodRewardPop.lua", net_data)
	            end,
	        })
        end,
    })
	_ui_ceng:addChild(self._meritRewardBtn)

	-- 排行
	self._rankBtn = self:createBottonBtn({
        src = "res/Main/common/common_icon_yanwubang.png",
        pos = cc.p(self._meritRewardBtn:getPositionX() - _partW, _y), 
        text = zc.lang("grab_food_rank"),
        listener = function() 
	        zc.sendHttp({
		        apiName = "GrabFood_getRankListType1",
		        successCallback = function (net_data)
			        local _currentGID = getGuideManager():getCurrentGID()
			        if _currentGID == GuideKey.KEY_14608 then
			        	zc.setGuideFuncNextStep(_currentGID, false)
			        end
		        	net_data.times = self._times
		        	net_data.myFoodNums = tonumber(self._ownGrabInfo.num) or 0
		            zc.createSourceScene("GrabFoodRank", "src/layer/grabFood/GrabFoodRankPop.lua", net_data)
		        end
		    })
        end,
    })
	_ui_ceng:addChild(self._rankBtn)

	-- 战报
	self._reportBtn = self:createBottonBtn({
        src = "res/Main/common/common_icon_renwu.png",
        pos = cc.p(self._rankBtn:getPositionX() - _partW, _y), 
        text = LANGUAGE_ARENA.btn_record,
        listener = function () 
	        zc.sendHttp({
	            apiName = "GrabFood_challengeList",
	            successCallback = function( backData )
				    local _selfUid = tonumber(PlayerData["info"]["userId"])
		            local _data = {records = {}, recordType = 2}
	            	for k,v in pairs(backData["1"] or {}) do
	            		v.attackerId = _selfUid
	            		v.attackerInfo = {}
	            		v.defenderInfo = {
	            			userId = v.userId,
	            			level = v.level,
	            			userName = v.userName,
	            			iconId = v.iconId,
	            			fighting = v.fighting,
	            		}
	            		local _num = tonumber(v.num) or 0
	            		v.result = _num > 0 and 1 or 0
	            		v.time = tonumber(v.createTime) or 0
	            		table.insert(_data.records, v)
	            	end
	            	for k,v in pairs(backData["2"] or {}) do
	            		v.defenderId = _selfUid
	            		v.attackerInfo = {
	            			userId = v.userId,
	            			level = v.level,
	            			userName = v.userName,
	            			iconId = v.iconId,
	            			fighting = v.fighting,
		            	}
	            		v.defenderInfo = {}
	            		local _num = tonumber(v.num) or 0
	            		v.result = _num > 0 and 1 or 0
	            		v.time = tonumber(v.createTime) or 0
	            		table.insert(_data.records, v)
	            	end
		            zc.createSourcePop("ArenaRecord", "src/layer/arena/ArenaRecordPop.lua", {data = _data})
	            end,
	        })
        end,
    })
	_ui_ceng:addChild(self._reportBtn)

	--聊天
    self._chatLayer = requires("src/layer/chat/ChatLeadTipsPop.lua").create()
    self._chatLayer:setPosition(0, 0)
    _ui_ceng:addChild(self._chatLayer) 

    local _descBtn = zc.createPushButton({
		normalFile = "res/Main/common/button/exclamation_u.png",
		selectedFile = "res/Main/common/button/exclamation_d.png",
		pos = cc.p(self._chatLayer:getContentSize().width + 20, 38),
		endCallback = function()
			-----玩法说明
            zc.createRulePop(14)
		end
	})
	_ui_ceng:addChild(_descBtn)

	-- 剩余次数背景
    local _challengeBg = cc.Sprite:create("res/Main/copy/leftTimesBg.png")
    _challengeBg:setAnchorPoint(0, 0.5)
    _challengeBg:setPosition(_descBtn:getPositionX() + _descBtn:getContentSize().width*0.5, 38)
    _ui_ceng:addChild(_challengeBg)
    -- 剩余次数文字
    local _challengeText = zc.createLabel({
        text = LANGUAGE_ARENA.times_left,
        fontSize = 20,
        shadow = true,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 35, _challengeBg:getContentSize().height/2 ),
    })
    _challengeBg:addChild( _challengeText )
    -- 剩余次数数字
    local _challengeLabel = zc.createLabel({
        text = 0,
        fontSize = 23,
        color = display.COLOR_GREEN,
        shadow = true,
        ap = cc.p(0, 0.5),
        pos = cc.p( _challengeText:getPositionX() + _challengeText:getContentSize().width + 5, _challengeText:getPositionY() ),
    })
    _challengeBg:addChild( _challengeLabel )
    self._challengeLabel = _challengeLabel

    -- 购买次数按钮
    local challengeBuyBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn2_u.png",
        selectedFile = "res/Main/common/button/common_btn2_d.png",
        disableFile = "res/Main/common/button/common_btn2_g.png",
        endCallback = function()
            local _params = {
            	buyType = 61,
            	nowHave = self._times,
            	nowBuyTimes = self._buyTimes,
            	callBack = function( backInfo )
            		self._buyTimes = self._buyTimes + backInfo.buyTimes
            		self._times = backInfo.times
					self._challengeLabel:setString(self._times)
					zc.tipInfo(zc.lang("tips_buy_success") .. "!")
            	end
        	}
            zc.createSourcePop("ChapterBuy", "src/layer/chapter/ChapterBuyPop.lua", _params)
        end,
        pos = cc.p(_challengeBg:getContentSize().width + 10, _challengeText:getPositionY() ),
    })
    _challengeBg:addChild(challengeBuyBtn) 



	self:freshAll()
end

function GrabFoodMainLayer:onEnter()
	if not self:isVisible() then
        return
    end
    if self._haveInit then
	    self:freshData()
    end
    self._haveInit = true
    performWithDelay(self, function()
	    self:addGuide()
    end, 0.01)

    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_FOODSRED,
        callback = function(data)
        	self:updateRedDot()
        	zc.removeEventListener("EVENT_FOODSRED")
    	end
    })

end

function GrabFoodMainLayer:freshData()
    local data = PlayerData:getLastSceneData() or {}
    if data.lastScene ~= "GrabFight" then
        return
    end

	self._times = tonumber(data.times) or 0
	self._ownGrabInfo = data.ownGrabInfo or {}
	self._target = data.target or {}

    PlayerData:setLastSceneData(nil)
    self:freshAll()
end

function GrabFoodMainLayer:freshAll()
	self:freshLeft()
	self:freshRight()
	self:freshUI()
	self:updateRedDot()
end

function GrabFoodMainLayer:updateRedDot()
	
	local status1 = PlayerData:getRedState(1) 
	
	local status2 = PlayerData:getRedState(2) 

	local status3 = PlayerData:getRedState(3) 

	zc.registerAndRefreshRedDot( self._meritRewardBtn, status3 )

	

	if status1 == 1 or status2 == 1 then
		zc.registerAndRefreshRedDot( self._rankBtn, 1 )
	else
		zc.registerAndRefreshRedDot( self._rankBtn, 0 )
	end
end

function GrabFoodMainLayer:freshLeft()
	for i = 1, #self._leftHouses do
		local _houseNode = self._leftHouses[i]
		local _data = self._target[i] or {}
		_houseNode.nameLab:setString(_data.userName)
		_houseNode.powerLab:setString(_data.fighting)
		local _num = tonumber(_data.num) or 0
		_houseNode.foodNumLab:setString(zc.getWan(_num))
		if tonumber(_data.status) ~= 0 then
			_houseNode.pass:setVisible(true)
		else
			_houseNode.pass:setVisible(false)
		end
	end
end

function GrabFoodMainLayer:freshRight()
	local _startTime = tonumber(self._ownGrabInfo.startTime) or 0
	local _nowLevel = tonumber(self._ownGrabInfo.grabLevel) or 0
	local _nowFlag = 0
	if _startTime == 0 then
		_nowFlag = 0
	else
		_nowFlag = _nowLevel
	end

	for i = 1, #self._rightHouses do
		local _node = self._rightHouses[i]
		local _house = _node.houseImg
		if _house.grabingFlag then
			_house.grabingFlag:removeFromParent()
			_house.grabingFlag = nil
		end
		if _house.spine then
			_house.spine:removeFromParent()
			_house.spine = nil
		end
		if i == _nowFlag then
			local _nowNum = tonumber(self._ownGrabInfo.num) or 0
			local _db = gameData.getDataFromCacheWithPrimaryKey("foodGrabBuild", _nowLevel)
			local _maxNum = tonumber(_db.limit) or 0
			local _db2 = gameData.getDataFromCacheWithPrimaryKey("foodGrabBuild", _nowLevel + 1)
			local _effFlag = false
			if _nowNum >= _maxNum and _maxNum ~= 0 then
				if  next(_db2) ~= nil then
					_house:setTexture("res/Main/grabFood/rightHouse4.png")
				else
					_house:setTexture("res/Main/grabFood/rightHouse5.png")
				end
			else
				_effFlag = true
				_house:setTexture("res/Main/grabFood/rightHouse3.png")
			end
			if _effFlag then
				local _spine = zc.createSpine({
					fileName = "liangcao",
					actName = "animation",
				})
				_spine:setScale(1.5)
				_spine:setPosition(_house:getContentSize().width*0.5 - 5, _house:getContentSize().height*0.5 + 15)
				_house:addChild(_spine)
				_house.spine = _spine
				local _grabingFlag = zc.createSprite("res/Main/grabFood/grabing.png")
				_grabingFlag:setAnchorPoint(1, 0.5)
				_grabingFlag:setPosition(10, 40)
				_node:addChild(_grabingFlag)
				_house.grabingFlag = _grabingFlag
				local _points = {}
				for j = 1, 3 do
					local _point = zc.createSprite("res/Main/grabFood/point.png")
					_point:setPosition(_grabingFlag:getContentSize().width + 6 + (j - 1) * 12, _grabingFlag:getContentSize().height*0.5)
					_point:setOpacity(0)
					_grabingFlag:addChild(_point)
					_points[j] = _point
				end
				local _time = 0.6
				_points[1]:runAction(cc.RepeatForever:create(cc.Sequence:create(
					cc.FadeTo:create(_time, 255),
					cc.CallFunc:create(function()
						_points[2]:runAction(cc.FadeTo:create(_time, 255))
					end),
					cc.DelayTime:create(_time),
					cc.CallFunc:create(function()
						_points[3]:runAction(cc.FadeTo:create(_time, 255))
					end),
					cc.DelayTime:create(_time),
					cc.CallFunc:create(function()
						_points[1]:runAction(cc.FadeTo:create(_time, 0))
						_points[2]:runAction(cc.FadeTo:create(_time, 0))
						_points[3]:runAction(cc.FadeTo:create(_time, 0))
					end),
					cc.DelayTime:create(_time*1.5)
				)))
			end
		elseif i < _nowFlag then
			_house:setTexture("res/Main/grabFood/rightHouse5.png")
		elseif i == _nowFlag + 1 then
			_house:setTexture("res/Main/grabFood/rightHouse2.png")
		else
			_house:setTexture("res/Main/grabFood/rightHouse1.png")
		end

		if i == 1 then
			_node:setScale(0.8)
		elseif i == #self._rightHouses then
			_node:setScale(1.0)
		else
			_node:setScale(0.9)
		end
	end
end

function GrabFoodMainLayer:freshUI()
	self._challengeLabel:setString(self._times)
	local _nowLevel = tonumber(self._ownGrabInfo.grabLevel) or 0
	local _startTime = tonumber(self._ownGrabInfo.startTime) or 0
	self._levelLab:setString(_nowLevel)
	local _db = gameData.getDataFromCacheWithPrimaryKey("foodGrabBuild", _nowLevel)
	self._levelLab:stopAllActions()
	if _startTime == 0 then
		self._startBtn:getStateNormal():setTexture("res/Main/grabFood/startBtn.png")
		self._startBtn.status = 0
		local _nowNum = tonumber(self._ownGrabInfo.num) or 0
		self._myLimitLab:setString("[color=ff00ff00]" .. zc.getWan(_nowNum) .. "[/color]/0")
	else
		
		local function _freshFunc()
			local _nowNum = tonumber(self._ownGrabInfo.num) or 0
			local _maxNum = tonumber(_db.limit) or 0
			self._myLimitLab:setString("[color=ff00ff00]" .. zc.getWan(_nowNum) .. "[/color]/" .. zc.getWan(_maxNum))
			local _db2 = gameData.getDataFromCacheWithPrimaryKey("foodGrabBuild", _nowLevel + 1)
			if _nowNum >= _maxNum and _maxNum ~= 0 and next(_db2) ~= nil then
				self._startBtn:getStateNormal():setTexture("res/Main/grabFood/levelUpBtn.png")
				self._startBtn.status = 1
			else
				self._startBtn:getStateNormal():setTexture("res/Main/grabFood/freshBtn.png")
				self._startBtn.status = 2
			end
			if _nowNum >= _maxNum and _maxNum ~= 0 then
				self._levelLab:stopAllActions()
			end
		end
		_freshFunc()
		schedule(self._levelLab, function()
			self._ownGrabInfo.num = self._ownGrabInfo.num + 1
			_freshFunc()
		end, 60)
	end
	self._costDi:setVisible(self._startBtn.status == 2)
end

function GrabFoodMainLayer:createBottonBtn( params )    
    local _scale1 = 0.5
    local _scale2 = 0.6
    local _btn, _icon 
    _btn = zc.getSprite({
        src = "bottomDi.png",
        plist = true,
        pos = params.pos, 
        scale = 0.9,
    })
    local _di = zc.getSprite({
        src = "btnNameDi.png",
        plist = true,
        pos = cc.p(_btn:getContentSize().width*0.5, 10),
    })
    _btn:addChild(_di)

    local _label = zc.createLabel({
        text = params.text,
        fontSize = 22,
        stroke = true,
        pixel = 2,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(_di:getContentSize().width*0.5, _di:getContentSize().height*0.5),
    })
    _di:addChild(_label)

    _icon = zc.createPushButton({
        normalFile = params.src,
        touchScale = _scale2/_scale1,
        scale = _scale1,
        touchSize = cc.size(95, 95),
        btnEff = params.btnEff == nil and zc.effect.btnOpen or params.btnEff,
        needEnableWhenMoving = true,
        pos = cc.p(_btn:getContentSize().width*0.5, _btn:getContentSize().height*0.5 + 10),
        endCallback = params.listener,
        noScaleAction = true,
    })
    _btn:addChild(_icon)

    if params.spineEffFile then
        _icon:getStateNormal():setVisible(false)
        local _spine = zc.getSpine(params.spineEffFile)
        _spine:playAction(params.spineEffAct or "animation", true)
        _spine:setPosition(_icon:getContentSize().width*0.5, _icon:getContentSize().height*0.5)
        _icon:addChild(_spine)
    end
    _btn._btn = _icon
    if _needAdd then
        if params.tag == 1 then
            table.insert(self._bottomButtonList_1, _btn)
        else
            table.insert(self._bottomButtonList, _btn)
        end
    end
    return _btn
end

function GrabFoodMainLayer:updateChatPanelView()
	if self._chatLayer then
		self._chatLayer:updateTableView()
	end
end

function GrabFoodMainLayer:onExit( ... )
	zc.removeEventListener("EVENT_FOODSRED")
end

function GrabFoodMainLayer:addGuide()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_14602 then
	    getGuideManager():sendFuncGuideTrigger(46)
    	zc.setGuideFuncNextStep(_currentGID, false)
    	self:addGuide()
    elseif _currentGID == GuideKey.KEY_14603 then
    	local function _callBack()
            getGuideManager():setObjTarget(self._startBtn)
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_14608 then
        getGuideManager():setObjTarget(self._rankBtn, 0.8)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_14610 then
        getGuideManager():setObjTarget(self._meritRewardBtn, 0.8)
        getGuideManager():startGuide()
    else
		local _flag = PlayerData:getFuncGuideInfo(46)
	    if _flag then
	        return
	    end
	    getGuideManager():sendFuncGuideTrigger(46)
    	getGuideManager():setCurrentGID(GuideKey.KEY_14603)
    	self:addGuide()
    end
end

return GrabFoodMainLayer