--[[
    将魂升级弹窗
    wangming
    2017.4.12
]]
local HeroSoulUpgradePop = class("HeroSoulUpgradePop", function()
	return zc.createNormalDialog({
        src = "res/Main/heroSoul/bg.jpg",
        showYun = true,
        yunTag = 2,
        yunType = 2,
        yunOffY = {0, -40},
        showFlowerFlag = {1, 0, 1, 1},
        closeCallBack = function()
            LayerManager.removeLayout(true)
        end
    })
end)

function HeroSoulUpgradePop:create( params )
	return HeroSoulUpgradePop.new( params )
end

function HeroSoulUpgradePop:onCleanup()
    if self._haveChange and self._freshCallback then
        self._freshCallback()
    end
end

function HeroSoulUpgradePop:ctor( params )
    self._freshCallback = params.freshCallback
    self._gemData = PlayerData:getHeroSoulInfoById(params.targetSoulId)
    self._heroName = params.heroName

    self._isMax = true
    local _nxtData = gameData.getDataFromCacheWithPrimaryKey("heroSoul", self._gemData.nextLevel)
    if next(_nxtData) then
        self._isMax = false
    end
    -- 宝石经验
    local _gemExpData = gameData.getAllDataWithNoClone("heroSoul_Exp")
    local _quality = self._gemData.quality
    local _gemExp = {}
    for k,v in pairs( _gemExpData ) do
        local _num = tonumber(v["exp" .. self._gemData.quality]) or 0
        if _num ~= 0 then
            _gemExp[tonumber(k)] = tonumber(v["needExp" .. self._gemData.quality]) or 0
        end
    end
    self._gemExp = _gemExp
    -- 总经验值
    self._totalExp = 0
    -- 选中的列表
    self._selectList = {}
    self._selectIcon = {}
    -- 每行显示宝石数量
    self._cellIconNum = 5
    -- 宝石列表
    self._gemList = {}
    -- 最多可选取宝石数量
    self._selectMax = 20

	self:initUI()
	self:refreshListLayer()
	self:refreshInfoLayer()
end

-- 初始化界面
function HeroSoulUpgradePop:initUI()
	self:initInfoLayer()
	self:initListLayer()
end

-- 创建信息弹窗
function HeroSoulUpgradePop:initInfoLayer()
	-- 背景
	local _baseBg = self:getChildByName("background")
    if _baseBg then
        _baseBg:setScaleX(_baseBg:getScaleX()*-1)
    end
    -- 背景
    local _bgWidth = zc.width*0.5
    local _bgHeight = zc.height
    local _bg = cc.Node:create()
    _bg:setContentSize(_bgWidth, _bgHeight)
    _bg:setPosition(0, 0)
    self:addChild( _bg )
    self._infoLayer = _bg

    -- 顶部
    local _topBg = zc.createSprite("res/Main/heroSoul/leftDi.png")
    _topBg:setAnchorPoint(0.5, 0)
    _topBg:setPosition(_bgWidth*0.5 + 15, _bgHeight*0.5 - 80)
    _bg:addChild(_topBg)
    local _topBgWidth = _topBg:getContentSize().width
    local _topBgHeight = _topBg:getContentSize().height

    local _gemIcon = zc.createHeroSoulSpine()
    _gemIcon:setPosition( _topBgWidth*0.5 - 15, _topBgHeight*0.5 - 40 )
    _topBg:addChild( _gemIcon )
    _bg._gemIcon = _gemIcon
    --等级bg 
    local _justY = 15 
    local _level_bg = zc.getSprite({
        src = "res/Main/country/main/country_level_bg.png",
        ap = cc.p(0, 0.5),
        pos = cc.p(_bgWidth*0.5 - 160, _bgHeight*0.5 - 50) 
    })
    _bg:addChild(_level_bg, 1)
    --等级
    local _level_label = zc.createLabel({
        fontSize = 22,
        pos = cc.p(23, 23),
        outLine = true,
    })
    _level_bg:addChild(_level_label)
    _bg._level_label = _level_label
    -- 进度条
    _bg._progress = zc.createProgressWithParams({
        bg = _bg,
        src1 = "res/Main/drillField/drillField_heroExp_bg_1.png",
        src2 = "res/Main/drillField/drillField_heroExp_1.png",
        pos = cc.p(_bgWidth*0.5, _level_bg:getPositionY()),
    })

    -- 经验值
    local _expNum = zc.createLabel({
        fontSize = 18,
        color = zc.COLOR_YELLOW,
        pos = cc.p( _bg._progress:getContentSize().width/2, _bg._progress:getContentSize().height/2 ),
        outLine = true,
    })
    _bg._progress:addChild( _expNum )
    _bg._expNum = _expNum

    -- 底部
    -- 属性背景
    local _attrBg = zc.createSprite("res/Main/heroSoul/attributeDi.png")
    _attrBg:setAnchorPoint( 0.5, 1 )
    _attrBg:setPosition( _bgWidth*0.5, _level_bg:getPositionY() - 20 )
    _bg:addChild( _attrBg )
    local _attrBgWidth = _attrBg:getContentSize().width
    local _attrBgHeight = _attrBg:getContentSize().height

    -- 属性
    local _attrText = zc.createLabel({
        fontSize = 18,
        color = cc.c3b( 203, 183, 123 ),
        pos = cc.p( 100, _attrBgHeight*0.5 + 50 ),
        outLine = true,
    })
    _attrText:setAnchorPoint( 0, 0.5 )
    _attrBg:addChild( _attrText )
    -- 属性值
    local _attrNum = zc.createLabel({
        fontSize = 18,
        pos = cc.p( _attrBgWidth/2 - 40, _attrText:getPositionY() ),
        outLine = true,
    })
    _attrNum:setAnchorPoint( 0, 0.5 )
    _attrBg:addChild( _attrNum )
    -- 增加数字
    local _attrAddNum = zc.createLabel({
        fontSize = 18,
        color = zc.COLOR_GREEN,
        ap = cc.p(0, 0.5),
        pos = cc.p( 360, _attrText:getPositionY() ),
        outLine = true,
    })
    _attrBg:addChild( _attrAddNum )
    -- 箭头
    local _arrow = zc.createSprite( "res/Main/common/arrow_green.png" )
    _arrow:setPosition( 320, _attrText:getPositionY() )
    _arrow:setRotation( -90 )
    _attrBg:addChild( _arrow )

    _bg._attrLabel = {
        _attrText = _attrText,
        _attrNum = _attrNum,
        _attrAddNum = _attrAddNum,
        _arrow = _arrow,
    }

    -- 左按钮，合成
    local _leftBtn = zc.createCommomBtn({
		tag = 2,
		text = zc.lang("upgrade"),
        pos = cc.p( 160, 75 ),
        endCallback = function()
        	self:clickLeftBtn()
    	end
	})
	_attrBg:addChild( _leftBtn )
    _leftBtn:setEnable( false )
	_bg._leftBtn = _leftBtn

	-- 右按钮，卸下
    local _rightBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("unload"),
        pos = cc.p( _attrBgWidth - _leftBtn:getPositionX(), _leftBtn:getPositionY() ),
        endCallback = function()
        	self:clickRightBtn()
    	end
	})
	_attrBg:addChild( _rightBtn )
	_bg._rightBtn = _rightBtn
end
-- 点击左边按钮响应，合成
function HeroSoulUpgradePop:clickLeftBtn()
    local _targetGemId = ""
    for k,v in pairs( self._selectList ) do
        _targetGemId = _targetGemId..k.."|"
    end
    _targetGemId = string.sub(_targetGemId, 0, string.len(_targetGemId)-1)
    zc.sendHttp({
        apiName = "HeroSoul_composer",
        params = {
            soulId = self._gemData.id,
            targetSoulId = _targetGemId,
        },
        successCallback = function( backData )
            musicManager.playEffect(zc.effect["gouyuhecheng"])
            PlayerData:updataData(backData)
            PlayerData:updateHeroSoul(backData.heroSoulEtt)
            self._gemData = PlayerData:getHeroSoulInfoById(self._gemData.id)
            self._haveChange = true
            local _lay = ZCDialog:create(0)
            self:addChild(_lay, 4)
            self:doAnimation(function()
                _lay:removeFromParent()
                -- 是否是顶级宝石
                self._isMax = true
                local _nxtData = gameData.getDataFromCacheWithPrimaryKey("heroSoul", self._gemData.nextLevel)
                if next(_nxtData) then
                    self._isMax = false
                end
                self._totalExp = 0
                self._selectList = {}
                self:refreshListLayer()
                self:refreshInfoLayer()
            end)
        end
    })
end
-- 点击右边按钮响应，卸下
function HeroSoulUpgradePop:clickRightBtn()
	zc.sendHttp({
        apiName = "HeroSoul_unEquipHeroSoul",
        params = {
            soulId = self._gemData.id,
        },
        successCallback = function( backData )
            PlayerData:updateGeneralInfo(backData.heroEtt)
            self._gemData.heroId = 0
            self._gemData.index = 0
            PlayerData:updateHeroSoul(self._gemData)
            self._haveChange = false
            if self._freshCallback then
                self._freshCallback()
            end
            LayerManager.removeLayout(true)
        end
    })
end

-- 刷新信息弹窗
function HeroSoulUpgradePop:refreshInfoLayer()
	local _gemInfo = self._gemData
	local _bg = self._infoLayer
	-- 图标
    local _data = gameData.getDataFromCacheWithPrimaryKey("heroSoul", _gemInfo.heroSoulId)
    zc.createHeroSoulSpine({
        spine = _bg._gemIcon,
        quality = _data.quality,
        iconId = _data.pictureId,
    })
    self:refreshUpgrade()
end

-- 刷新合成之后的属性数据 
function HeroSoulUpgradePop:refreshUpgrade( level, exp )
    local _bg = self._infoLayer
    local _gemInfo = self._gemData
    _bg._attrLabel._attrText:setString( LANGUAGE_getAttributeTextById( _gemInfo.attributeType ) )
    _bg._attrLabel._attrNum:setString( "+" .. zc.getAttributeNumById(_gemInfo.attributeType, _gemInfo.attributeValue))
        
    self._selectNum:setString( table.nums(self._selectList).."/"..self._selectMax )
    self._selectNum:setVisible( not self._isMax )
    if self._isMax then
        _bg._level_label:setString(_gemInfo.level)
        _bg._attrLabel._attrAddNum:setVisible( false )
        _bg._attrLabel._arrow:setVisible( false )

        _bg._progress:stopAllActions()
        _bg._progress:runAction(cc.ProgressTo:create( 0.2, 100 ))
        _bg._expNum:setText("Max")
    else
        local _level_bef = tonumber(_gemInfo.level) or 1
        local _exp_bef = tonumber(_gemInfo.exp) or 0
        local _value_bef = tonumber(_gemInfo.attributeValue) or 0

        local _level_aft = level or _level_bef
        local _exp_aft = exp or _exp_bef

        local _data_aft = gameData.getDataFromCache("heroSoul", {quality = _gemInfo.quality, level = _level_aft, attributeType = _gemInfo.attributeType})
        local _value_aft = tonumber(_data_aft.attributeValue) or 0
        local _levelDif = _level_aft - _level_bef
        local _levelFlag = _levelDif > 0
        local _valueDif = _value_aft - _value_bef
        local _valueFlag = _valueDif > 0


        _bg._level_label:setString(_level_aft)
        _bg._attrLabel._attrAddNum:setString( "+" .. zc.getAttributeNumById(_data_aft.attributeType, _valueDif) )
        _bg._attrLabel._attrAddNum:setVisible( _valueFlag )
        _bg._attrLabel._arrow:setVisible( _valueFlag )

        -- 宝石升级而且经验为0，伪造等级和经验
        local _realLevel = _level_aft
        local _fakeLevel = _level_aft
        local _fakeExp = _exp_aft
        -- if _level_bef ~= _level_aft and _exp_aft == 0 then
        --     _fakeLevel = _level_aft - 1
        --     _fakeExp = self._gemExp[_fakeLevel]
        -- end

        -- 计算进度条
        local _expMax = self._gemExp[_fakeLevel] or 0
        local _pct = 1
        if _expMax ~= 0 then
            _pct = _fakeExp/_expMax
        end
        if self._upgradeMax then
            _pct = 1
        end
        -- local _progressWidth = _bg._progress:getContentSize().width
        _bg._progress:stopAllActions()
        local _action = {}
        local _fakeLevelDif = self._fakeLevel and _fakeLevel - self._fakeLevel  or 0
        if _fakeLevelDif > 0 then
            for i = 1, _fakeLevelDif do
                _action[#_action + 1] = cc.ProgressTo:create( 0.2, 100 )
                _action[#_action + 1] = cc.CallFunc:create(function()
                    _bg._progress:setPercentage(0)
                end)
            end
        elseif _fakeLevelDif < 0 then
            for i = 1, -_fakeLevelDif do
                _action[#_action + 1] = cc.ProgressTo:create( 0.2, 100 )
                _action[#_action + 1] = cc.CallFunc:create(function()
                    _bg._progress:setPercentage(0)
                end)
            end
        end
        _action[#_action + 1] = cc.ProgressTo:create( 0.2, 100*_pct )
        _bg._progress:runAction( cc.Sequence:create( _action ) )
        
        _bg._expNum:stopAllActions()
        _bg._expNum:runAction(
            cc.Sequence:create(
                cc.ScaleTo:create( 0.2, 1.5 ),
                cc.CallFunc:create(function()
                    if self._upgradeMax then
                        _bg._expNum:setText("Max")
                    else
                        _bg._expNum:setText( _fakeExp.."/".._expMax )
                    end
                end),
                cc.ScaleTo:create( 0.2, 1 )
            )
        )
        
        -- 等级变化
        local _realLevelDif = self._realLevel and _realLevel - self._realLevel  or 0
        if _realLevelDif ~= 0 then
            local _animation = zc.createSpine({
                fileName = "chuxiantexiao",
                actName = "idle",
                loop = false,
                autoRemove = true,
            })
            _animation:setPosition( _bg._expNum:getPositionX(), _bg._expNum:getPositionY() )
            _bg._expNum:getParent():addChild( _animation )
        end
        self._fakeLevel = _fakeLevel
        self._realLevel = _realLevel
    end
end

-- 创建列表弹窗
function HeroSoulUpgradePop:initListLayer()
	-- 背景
	local _bgWidth = 510
    local _bgHeight = 560
    local _bg = zc.createNormalPop({
        width = _bgWidth,
        height = _bgHeight,
    })
    _bg:setPosition( zc.width*0.5 + 220, zc.height*0.5 - 20 )
    self:addChild( _bg )
    self._listLayer = _bg

    local _partH = 80
    local _innerW = _bgWidth - 30
    local _innerH = _bgHeight - 60 - _partH
    -- 上层背景
    local _topBg = zc.getScaleNode("res/Main/common/popBg/di_4.png", cc.size(_innerW, _innerH))
    _topBg:setPosition( _bgWidth/2, _bgHeight/2 + 20 )
    _bg:addChild( _topBg )

	-- tableview
    local _gemTableview = zc.ZCTableView:create( cc.size( _innerW, _innerH) )
    _gemTableview._showHeight = _innerH
    _gemTableview:setBounceable( true )
    _gemTableview:setInertia( true )
    _gemTableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    _gemTableview:setPosition( 0, 0 )
    _gemTableview:setDelegate()
    _gemTableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = _innerW
    local cellHeight = 105
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, index, cellWidth, cellHeight )
        end
        self:updateCell( cell, index )

        return cell
    end
    local function numberOfCellsInTableView()
        return math.ceil( #self._gemList/self._cellIconNum )
    end
    _gemTableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _gemTableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    _gemTableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _topBg:addChild( _gemTableview )
    self._gemTableview = _gemTableview

    -- 一键选取
    local _oneKeyBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p( _bgWidth/2, _partH*0.55),
        text = zc.lang("one_key_choose"),
        endCallback = function()
            self:oneKeySelect()
        end
    })
    _bg:addChild( _oneKeyBtn )
    self._oneKeyBtn = _oneKeyBtn


    local _yixuanzhe = zc.createLabel({
        text = zc.lang("already_choosed"),
        outLine = true,
        fontSize = 22,
        ap = cc.p(1, 0.5),
        pos = cc.p(_bgWidth - 80, _partH*0.55),
        color = cc.c3b(203,183,123),
    })
    _bg:addChild(_yixuanzhe)
    -- 数量
    local _selectNum = zc.createLabel({
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(_bgWidth - 80, _partH*0.55),
        color = display.COLOR_GREEN,
    })
    _bg:addChild( _selectNum )
    self._selectNum = _selectNum

    -- 数量
    local _totalNum = zc.createLabel({
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(20, _partH*0.55 + 15),
        color = display.COLOR_GREEN,
    })
    _bg:addChild( _totalNum )
    self._totalNum = _totalNum

    -- 数量
    local _equipTip = zc.createLabel({
        text = zc.lang("include_equiped"),
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(20, _partH*0.55 - 15),
        color = cc.c3b(222, 188, 141),
    })
    _bg:addChild( _equipTip )
    local _equipNum = zc.createLabel({
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(_equipTip:getPositionX() + _equipTip:getContentSize().width + 2, _equipTip:getPositionY()),
        color = display.COLOR_RED,
    })
    _bg:addChild( _equipNum )
    self._equipNum = _equipNum
end

-- 创建cell
function HeroSoulUpgradePop:buildCell( cell, index, cellWidth, cellHeight )
	-- 两边
	local cellSide = 8
	local cellDisX = ( cellWidth - cellSide*2 )/self._cellIconNum
	cell._icon = {}
	for i = 1, self._cellIconNum do
		local _posX = ( i - 0.5 )*cellDisX + cellSide
		-- icon
		local _icon = zc.createIconByData({
	        data = {
	            mainType=zc.mainTypeHeroSoul,
	            type=1,
	            id=1,
	        },
	        pos = cc.p( _posX, cellHeight/2 ), 
	    })
	    _icon:setScale(0.7)
		cell:addChild( _icon )
		cell._icon[i] = _icon
		-- 选中
	    local _selected = zc.getSpine("jiban")
        _selected:playAction("unlock", true)
        _selected:setScale( 1.2 )
	    _selected:setPosition( _icon:getContentSize().width/2, _icon:getContentSize().height/2 )
	    _icon:addChild( _selected )
	    _icon._selected = _selected
	end
end

-- 更新cell
function HeroSoulUpgradePop:updateCell( cell, index )
	cell._index = index
	for i = 1, self._cellIconNum do
		local _gemIndex = index*self._cellIconNum + i
		local _gemInfo = self._gemList[_gemIndex]
		local _icon = cell._icon[i]
		if _gemInfo then
			-- cellBg
			_icon:setVisible( true )
            local _id = _gemInfo.id
            _icon._id = _id
            local _flag = self._selectList[_id]
            if _flag == nil then
                _flag = false
            end
            _icon._selected:setVisible( _flag )
            self._selectIcon[_id] = _flag and _icon or nil
			-- icon
			zc.updateIconByData(_icon, {
				data = {
                    mainType = zc.mainTypeHeroSoul,
                    type = _gemInfo.heroSoulId,
                    id = _gemInfo.heroSoulId,
		            level = zc.getLevelTipShow() .. _gemInfo.level,
		        },
                primaryId = _gemInfo.id,
		        showLevel = true,
		        listener = function()
                    if self._isMax then
                        zc.tipInfo(zc.lang("already_max_level_herosoul"))
                        return
                    end
                    local _flag = self._selectList[_id]
                    if not _flag and self._upgradeMax then
                        zc.tipInfo(zc.lang("already_max_level_herosoul"))
                        return
                    end
                    if not _flag and table.nums(self._selectList) >= self._selectMax then
                        -- 选中且数量达到上限
                        zc.tipInfo(zc.lang("choose_herosoul_to_max_num"))
                        return
                    end
                        -- 其他
                    local _gemInfo = self._gemList[_gemIndex]
                    if not _flag then
                        local _status = tonumber(_gemInfo.status) or 0
                        self:createHeroSoulInfoPop({
                            soulData = _gemInfo,
                            freshCallback = function( status )
                                self._gemList[_gemIndex].status = status
                                if status == 1 then
                                    local __flag = self._selectList[_id]
                                    self._selectList[_id] = nil
                                    self._selectIcon[_id] = nil
                                    _icon._selected:setVisible( false )
                                    if __flag then
                                        self:selectGem( _gemInfo, false )
                                    end
                                end
                                _icon:doLockImg()
                            end
                        })
                        if _status == 1 then
                            return
                        end
                    end
                    _flag = not _flag
                    self._selectList[_id] = _flag or nil
                    self._selectIcon[_id] = _flag and _icon or nil
                    _icon._selected:setVisible( _flag )
                    self:selectGem( _gemInfo, _flag )
		        end
			})
            _icon._info.lockStatus = _gemInfo.status
            _icon:doLockImg()
		else
			_icon:setVisible( false )
		end
	end
end

-- 构造列表数据
function HeroSoulUpgradePop:buildListData()
    local _allGem = PlayerData:getHeroSoul()
	local _gemList = {}
    local _tonumber = tonumber
    local _equipNum = 0
	for k, _gemData in pairs( _allGem ) do
        local _place = _tonumber(_gemData.heroId) or 0
        if _place == 0 then
            _gemList[#_gemList + 1] = _gemData
        else
            _equipNum = _equipNum + 1
        end
	end
   table.sort(_gemList,function(a, b)
        local _numA = _tonumber(a.status) or 0
        local _numB = _tonumber(b.status) or 0
        if _numA ~= _numB then
            return _numA == 0
        end
        local _numA = _tonumber(a.quality) or 0
        local _numB = _tonumber(b.quality) or 0
        if _numA ~= _numB then
            return _numA < _numB
        end
        _numA = _tonumber(a.level) or 0
        _numB = _tonumber(b.level) or 0
        if _numA ~= _numB then
            return _numA < _numB
        end
        _numA = _tonumber(a.exp) or 0
        _numB = _tonumber(b.exp) or 0
        if _numA ~= _numB then
            return _numA < _numB
        end
        _numA = _tonumber(a.heroSoulId) or 0
        _numB = _tonumber(b.heroSoulId) or 0
        return _numA < _numB
    end)
    self._gemList = _gemList

    if self._isMax or #_gemList == 0 then
        self._oneKeyBtn:setEnable( false )
    else
        self._oneKeyBtn:setEnable( true )
    end
    return _equipNum
end
-- 刷新列表弹窗
function HeroSoulUpgradePop:refreshListLayer()
	local _equipNum = self:buildListData()
	self._gemTableview:reloadData()
    local _nums = table.nums(PlayerData:getHeroSoul())
    self._totalNum:setString(_nums .. "/200")
    self._equipNum:setString(_equipNum)
end

-- 点击宝石
function HeroSoulUpgradePop:selectGem( _gemInfo, _flag )
    local _fordExp = gameData.getDataFromCacheWithPrimaryKey("heroSoul_Exp", _gemInfo.level)
    _fordExp = tonumber(_fordExp["exp" .. tostring(_gemInfo.quality)]) or 0
    local _exp = tonumber(_gemInfo.exp) or 0
    if _flag then
        self._totalExp = self._totalExp + _exp + _fordExp
    else
        self._totalExp = self._totalExp - _exp - _fordExp
    end
    print("~~~~~~~~~self._totalExp=", self._totalExp)
    self:setLeftBtn()
    self:calculateExp()
end
-- 计算经验
function HeroSoulUpgradePop:calculateExp()
    local _totalExp = self._totalExp
    local _exp = tonumber(self._gemData.exp) or 0
    _totalExp = _totalExp + _exp

    local _level = tonumber( self._gemData.level ) or 0
    -- 是否满级
    local _max = true
    for _index = _level, #self._gemExp - 1 do
        local _needExp = self._gemExp[_index]
        local _leftExp = _totalExp - _needExp
        print("~~~~~~~_leftExp=",_leftExp,"_index=",_index)
        if _leftExp >= 0 then
            _totalExp = _leftExp
        else
            _level = _index
            _max = false
            break
        end
    end
    if _max then
        -- 合成后满级
        self._upgradeMax = true
        _level = #self._gemExp
        _totalExp = 0
    else
        self._upgradeMax = false
    end
    print("~~~~~~~~~~~~~~~~~~~~~_level=",_level,"_totalExp=",_totalExp)

    self:refreshUpgrade( _level, _totalExp )    
end

-- 一键选取
function HeroSoulUpgradePop:oneKeySelect()
    self._totalExp = 0
    self._selectList = {}

    -- 计算当前宝石升级需要的经验值
    local _level = tonumber(self._gemData.level) or 0
    local _exp = tonumber(self._gemData.exp) or 0
    local _levelUpEx = self._gemExp[_level]
    local _needExp = _levelUpEx - _exp

    local _max = self._selectMax
    local _total = #self._gemList
    local _end = _max > _total and _total or _max
    local i = 1
    while (self._gemList[i] and table.nums(self._selectList) < _end and _needExp > 0) do
        local _gemData = self._gemList[i]
        local _status = tonumber(_gemData.status) or 0
        if _status == 0 then
            local _fordExp = gameData.getDataFromCacheWithPrimaryKey("heroSoul_Exp", _gemData.level)
            _fordExp = tonumber(_fordExp["exp" .. tostring(_gemData.quality)]) or 0
            local __exp = tonumber(_gemData.exp) or 0
            _needExp = _needExp - __exp - _fordExp
            self._totalExp = self._totalExp + __exp + _fordExp
            self._selectList[_gemData.id] = true
        end
        i = i + 1
    end
    print("~~~~~~~~~self._totalExp=",self._totalExp)
    self._gemTableview:reloadData()
    self:setLeftBtn()
    self:calculateExp()
end
-- 设置合成按钮状态
function HeroSoulUpgradePop:setLeftBtn()
    if next(self._selectList) then
        self._infoLayer._leftBtn:setEnable( true )
    else
        self._infoLayer._leftBtn:setEnable( false )
    end
end
-- 合成动画
function HeroSoulUpgradePop:doAnimation(_callback)
    local _bg = self._infoLayer
    -- 飞
    local _tableviewY = self._gemTableview:getContentOffset().y
    local _tableviewHeight = self._gemTableview._showHeight
    local _cellHeight = 112
    local _beginPoss = {}
    for k, v in pairs( self._selectIcon  ) do
        if not tolua.isnull( v ) and v:isVisible() and v._id == k then
            local _parentY = v:getParent():getPositionY()
            local _posY = _parentY + _tableviewY + _cellHeight/2
            if _posY > 0 and _posY < _tableviewHeight then
                local _pos = v:convertToWorldSpaceAR( cc.p( 0, 0 ) )
                _beginPoss[#_beginPoss + 1] = _bg:convertToNodeSpace( _pos )
            end
        end
    end

    musicManager.playEffect(zc.effect["gouyufei"])
    if #_beginPoss > 0 then
        local _endPos = cc.p( 0, 0 )
        do
            local _pos = _bg._gemIcon:convertToWorldSpaceAR( cc.p( 0, 0 ) )
            _endPos = _bg:convertToNodeSpace( _pos )
        end
        -- 间隔
        local _interval = ( 19 + #_beginPoss )/20*0.02

        for i, _beginPos in ipairs( _beginPoss ) do
            local _particle = cc.ParticleSystemQuad:create("res/Main/role/equip/jinjie/jinjie.plist")
            _particle:setPosition( _beginPos )
            -- _particle:setAutoRemoveOnFinish( true ) -- 这个plist特效是循环的，这里设置自动删除是没有效果的
            _bg:addChild( _particle, 6 )
            
            if i == #_beginPoss then
                -- 最后一个
                _particle:runAction(
                    cc.Sequence:create(
                        cc.DelayTime:create( i*_interval ),
                        cc.MoveTo:create( 0.3, _endPos ),
                        cc.CallFunc:create(function()
                            local __spine = zc.createSpine({
                                fileName = "eff_deng",
                                actName = "deng0",
                                loop = false,
                                needInit = false,
                                autoRemove = true,
                                removeCallback = function()
                                    if _callback then
                                        _callback()
                                    end
                                end
                            })
                            __spine:setScale(3)
                            __spine:setPosition( _endPos )
                            _bg:addChild( __spine, 6 )
                        end),
                        cc.RemoveSelf:create(true)
                    )
                )
            else
                _particle:runAction(
                    cc.Sequence:create(
                        cc.DelayTime:create( i*_interval ),
                        cc.MoveTo:create( 0.3, _endPos ),
                        cc.RemoveSelf:create(true)
                    )
                )
            end
        end
    else
        if _callback then
            _callback()
        end
    end
end


function HeroSoulUpgradePop:createHeroSoulInfoPop( params )
    local _infoPop = ZCDialog:create(0)
    _infoPop:setSwallowTouches(false)
    _infoPop:setTouchEndedCallback(function()
        _infoPop:removeFromParent()
    end)
    self:addChild(_infoPop, 5)

    local _soulData = params.soulData
    local _dbId = _soulData.heroSoulId
    local _width, _height = 280, 180
    local _posx = zc.width*0.5 - _width*0.5 - 40
    local _posy = zc.height*0.5 + 165

    local effBg = zc.getScaleNode("res/Main/ornaments/general_tips_s_bg.png", cc.size(_width, _height))
    effBg:setAnchorPoint(0.5, 0.5)
    effBg:setPosition(_posx, _posy)
    _infoPop:addChild(effBg)

    local item = zc.createIconByData({
        data = {
            mainType = zc.mainTypeHeroSoul,
            type = 1,
            id = _dbId,
        },
        pos = cc.p(55, _height - 55), 
    })
    item:setScale(0.6)
    effBg:addChild(item)
    local weaponName = zc.createLabel({
        text = _soulData.name,
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(110, _height - 36),
        pixel = 1.3
    })
    effBg:addChild(weaponName)

    local _lockLab = zc.createLabel({
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        color = cc.c3b(251, 209, 100),
        pos = cc.p(weaponName:getPositionX(), weaponName:getPositionY() - 36),
        pixel = 1.3
    })
    effBg:addChild(_lockLab)

    local _status = tonumber(_soulData.status) or 0
    local function _freshLockStatus()
        local _text = _status == 0 and LANGUAGE_ROLE.not_locked or LANGUAGE_ROLE.have_locked
        local _file = _status == 0 and "unlock" or "lock"
        _lockLab:setString("(" .. _text .. ")")
        _infoPop._lockBtn:setStateNormal(zc.createSprite("res/Main/heroSoul/" .. _file .. ".png"))
    end

    local _lockBtn = zc.createPushButton({
        normalFile = "res/Main/heroSoul/unlock.png",
        pos = cc.p(_width - 30, _height - 30),
        endCallback = function()
            zc.sendHttp({
                apiName = "HeroSoul_soulLock",
                params = {soulId = _soulData.id, type = _status + 1},
                successCallback = function( backData )
                    _status = _status == 0 and 1 or 0
                    _freshLockStatus()
                    _soulData.status = _status
                    PlayerData:updateHeroSoul(_soulData)
                    if params.freshCallback then
                        params.freshCallback(_status)
                    end
                end
            })
        end
    })
    _infoPop._lockBtn = _lockBtn
    effBg:addChild(_lockBtn)
    _freshLockStatus()


    local line1 = zc.createSprite("res/Main/login/login_line2.png")
    line1:setPosition(_width*0.5, _height - 100)
    effBg:addChild(line1)

    local baseEffTitle = zc.createLabel({
        text = zc.lang("base_attribute"),
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(30, _height - 120),
        pixel = 1.3
    })
    effBg:addChild(baseEffTitle)

    local effectStr = LANGUAGE_getAttributeTextById(_soulData.attributeType)
    local effectNum = zc.getAttributeNumById(_soulData.attributeType, _soulData.attributeValue)
    local effectLab = zc.createLabel({
        text = effectStr .. "：" .. effectNum,
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(32, _height - 150),
        color = cc.c3b(238, 98, 3),
        pixel = 1.3
    })
    effBg:addChild(effectLab)
end

return HeroSoulUpgradePop