--[[
-- 农场界面
-- @author wangming
-- Creation  2016-08-08
]]
local MainFarmLayer = class("MainFarmLayer", function (mainCity)
	return zc.createNormalDialog({
    	src = "res/Main/home/farmBg.jpg",
        showFlower = false,
    	closeCallBack = function()
    		-- local _mainCity = zc.getScene("mainCity")
    		if not tolua.isnull(mainCity) then
    			mainCity:removeFarm()
                mainCity:checkShowFuben()
    		end
        end
    })
end)

function MainFarmLayer:create( mainCity )
    return MainFarmLayer.new(mainCity)
end

function MainFarmLayer:ctor(mainCity)
    self._isShow = true
	self._pedestalIds = {
		12, 13, 14, 15,
		16, 17, 18, 19,
		22, 23, 24, 25,
		26, 27, 28, 29,
	}
	self.houseList = {}

	self:initTouchLayer()

	local _startX = zc.width*0.5 - 330
	local _rowX = 110
	local _partX = 100

	local _startY = zc.height*0.5 + 10
	local _lineY = 65
	local _partY = 55

	local _mainCity = mainCity
	local _idx = 0
    local _scale = 0.8
	for i=1, #self._pedestalIds do
		_idx = i - 1
		local _baseData = {
			pedestalId = self._pedestalIds[i], 
			hType = 3,
			par = _mainCity,
		}
		local _sp = requires("src/layer/mainCity/HouseSpriteBase.lua"):create(_baseData)
        local _node = cc.Node:create()
        _node:setContentSize(_sp:getContentSize().width*_scale, _sp:getContentSize().height*_scale)
        _node:setAnchorPoint(0.5, 0.5)
        _node:setPosition(_sp:getContentSize().width*0.5, _sp:getContentSize().height*0.5)
        _sp._touchNode = _node
        _sp:addChild(_node)
        table.insert(self.houseList, _sp)
        local _datas = PlayerData:getHouseInfo().houses
        for k,v in pairs(_datas) do
            if (tonumber(v.pedestalId) == _baseData.pedestalId) then
                _sp:setHousesData(v)
                break
            end
        end
        local _row = math.modf(_idx/4)
        local _line = _idx%4
        local _x = _startX + _rowX*_row + _partX*_line
        local _y = _startY - _lineY*_row + _partY*_line
		_sp:setPosition(_x, _y) 
		-- _sp:setScale(0.85)
	end

	table.sort(self.houseList, function(a, b)
		return a:getPositionY() > b:getPositionY()
	end)

	for k,v in pairs(self.houseList) do
        self:addChild(v, 1)
	end

    table.sort(self.houseList, function(a, b)
        return a:getPedestalId() < b:getPedestalId()
    end)
end

function MainFarmLayer:initTouchLayer()
	local _startX, _startY
    local _canDo
    local _touchLayer = cc.Layer:create()
    self:addChild(_touchLayer)
    self._touchLayer = _touchLayer
    _touchLayer:onTouch(function( event )
        local eventType = event.name
        local x = event.x
        local y = event.y
        if (eventType == "began") then
            _startX = x
            _startY = y
            _canDo = true
            return true
        elseif (eventType == "moved") then
            if math.abs(_startX - x) > 5 or 
              math.abs(_startY - y) > 5 then
                _canDo = false
            end
        elseif (eventType == "ended") then
            if not _canDo then
                return
            end
            -- print("wm----check : ", x, " , ", y)
            local _point = cc.p(x, y)
            for k,v in pairs(self.houseList) do
                if zc.isTouchContainsPoint(v._touchNode, _point) then
                    v:normalTouch()
                    return
                end
            end
        end
    end)
end

function MainFarmLayer:setFarmShow( isShow )
    if self._isShow == isShow then
        return
    end
    self._isShow = isShow
    self:setVisible(self._isShow)
    local _bg = self:getChildByName("background")
    if not _bg then
        return
    end
    if self._isShow then
        self._touchLayer:setTouchEnabled(true)
        _bg:setTexture("res/Main/home/farmBg.jpg")
        local _topInfo = LayerManager.getTopInfoLayer()
        if not tolua.isnull(_topInfo) then
            _topInfo:setPopInfo("farm")
        end
        self:onEnter()
        local _mainCity = zc.getScene("mainCity")
        if _mainCity and _mainCity:isVisible() then
            _mainCity:removeBubble("Bubble_gainResource")
        end
    else
        self._touchLayer:setTouchEnabled(false)
        local _topInfo = LayerManager.getTopInfoLayer()
        if not tolua.isnull(_topInfo) then
            _topInfo:setPopInfo("mainCity")
        end
        _bg:setTexture(nil)
        cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/home/farmBg.jpg")
        
        local _mainCity = zc.getScene("mainCity")
        if _mainCity and _mainCity:isVisible() then
            musicManager.playMusic(zc.bgm.city, true)
        end
    end
end

function MainFarmLayer:isFarmShow()
    return self._isShow
end


function MainFarmLayer:onCleanup()
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/Main/home/farmBg.jpg")
end

function MainFarmLayer:onEnter()
    if not self:isVisible() then
        return
    end
	if self._init then
        for k,v in pairs(self.houseList) do
            if not v._pedestalOpen then
                v._pedestalOpen, v._openLevel = v:isPedestalOpen()
                if v._pedestalOpen then
                    v:loadTextureBegan()
                end
            end
        end
	end
    self._init = true
    self:addGuide()
    musicManager.playMusic(zc.bgm.farm, true)
end

function MainFarmLayer:addGuide()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_6013 then
        local _house = self.houseList[1]
        if _house._houseData then
            getGuideManager():setCurrentGID(GuideKey.KEY_6016)
            self:addGuide()
            return
        end
        getGuideManager():setObjTarget(_house)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_6016 then
        local _house = self.houseList[5]
        if _house._houseData then
            local _mainCity = zc.getScene("mainCity")
            _mainCity:guideFunc(GuideKey.KEY_6019)
            return
        end
        getGuideManager():setObjTarget(_house)
        getGuideManager():startGuide()
    end
end


return MainFarmLayer