--[[
FileName 		MultiCopyMainLayer.lua
ProjectName		HJ2

Created by wangming on 16-03-18
--

]]

local MultiCopyMainLayer = class("MultiCopyMainLayer", function ()
    return zc.createNormalDialog()
end)

function MultiCopyMainLayer:create( params )
    local _houseData = PlayerData:getHouseInfoByHouseId(15)
    self._houseKeyId = _houseData.id
	return MultiCopyMainLayer.new( params )
end

function MultiCopyMainLayer:doEvent( opType, data )
    if opType == "MultiCopy_create" then
        if tonumber(data.data.tollgateId) ~= self._tollgateId then
            return
        end
        self._teamsInfo = data.data.teams or {}
        self:filterTeam()
        self._teamTable:reloadDataAndScrollToCurrentCell()
    elseif opType == "MultiCopy_dismiss" then
        if tonumber(data.data.tollgateId) ~= self._tollgateId then
            return
        end
        self._teamsInfo = data.data.teams or {}
        self:filterTeam()
        self._teamTable:reloadDataAndScrollToCurrentCell()
    elseif opType == "MultiCopy_join" then
        if tonumber(data.data.tollgateId) ~= self._tollgateId then
            return
        end
        self._teamsInfo = data.data.teams or {}
        self:filterTeam()
        self._teamTable:reloadDataAndScrollToCurrentCell()
    elseif opType == "MultiCopy_kickout" then
        if tonumber(data.data.tollgateId) ~= self._tollgateId then
            return
        end
        self._teamsInfo = data.data.teams or {}
        self:filterTeam()
        self._teamTable:reloadDataAndScrollToCurrentCell()
    elseif opType == "MultiCopy_quit" then
        if tonumber(data.data.tollgateId) ~= self._tollgateId then
            return
        end
        self._teamsInfo = data.data.teams or {}
        self:filterTeam()
        self._teamTable:reloadDataAndScrollToCurrentCell()
    elseif opType == "MultiCopy_adjust" then
        if tonumber(data.data.tollgateId) ~= self._tollgateId then
            return
        end
        self._teamsInfo = data.data.teams or {}
        self:filterTeam()
        self._teamTable:reloadDataAndScrollToCurrentCell()
    elseif opType == "MultiCopy_challengeAfter" then
        if tonumber(data.data.tollgateId) ~= self._tollgateId then
            return
        end
        self._teamsInfo = data.data.teams or {}
        self:filterTeam()
        self._teamTable:reloadDataAndScrollToCurrentCell()
    end
end

function MultiCopyMainLayer:ctor( params )
    local _params = params or {}
    self._teamsInfo = _params.teams or {}
    self:filterTeam()
    self._tollgateId = tonumber(_params.tollgateId) or 1

    --添加云动画
    zc.getYunDongTai(nil, 2,function(armUp, armDown)
        if not tolua.isnull(self) then
            self:addChild( armUp ,-1)
            self:addChild( armDown ,-1)
        end
    end)
	-- 背景
    local __bgImg = zc.createNormalPop({
        width = zc.width - 70,
        height = 511,
        showSide = false,
    })
    __bgImg:setAnchorPoint( 1, 0.5 )
    __bgImg:setPosition( zc.width, zc.height/2 )
    self:addChild( __bgImg )
    local _bgImg = cc.Sprite:create()
    _bgImg:setContentSize( zc.width, 511 )
    _bgImg:setPosition( zc.width/2, zc.height/2 )
    self:addChild( _bgImg )
    self:initTeamList( _bgImg )

    -- 卷轴
    local _data = gameData.getDataFromCacheWithPrimaryKey("tollgateTeam", self._tollgateId)
    local _armature = zc.createArmature({
        parentPath = "res/Main/copy/juanzhou/",
        fileName = "juanzhou_" .. _data.image,
        -- loop = true,
        actName = "a_stand_".._data.icon,
        eventCallback = function() end,
    })
    _armature:setPosition(70, 0)
    _bgImg:addChild(_armature, 4)
    -- 推荐战力
    local powerNum = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight.fnt",
        text = _data.fighting,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(_armature:getPositionX(), 180),
        addwidth = -5,
    })
    _bgImg:addChild(powerNum, 4)
    -- 掉落
    local reward = string.split(_data["commonDrop"],",")
    local _normal = zc.createSprite("res/Main/common/button/common_btnSquare1_u.png")
    local _select = zc.createSprite("res/Main/common/button/common_btnSquare1_d.png")
    _normal:setScale(1.2)
    _select:setScale(1.2)
    local item = zc.createPushButton({
        normalNode = _normal,
        selectedNode = _select,
        pos = cc.p(_armature:getPositionX(), 120), 
        endCallback = function()
            -- print("wm----self._curSeatId : ", self._curSeatId, " , ", index)
            if #reward <= 0 then
                return
            end
            zc.createSourcePop("MultiCopyReward","src/layer/multicopy/MultiCopyRewardPop.lua", {reward = reward})
        end
    })
    _bgImg:addChild(item , 4)
    local label = zc.createLabel({
        size = 22,
        width = 50,
        outLine = true,
        color = display.COLOR_YELLOW,
        color2 = display.COLOR_BROWN,
        text = LANGUAGE_ARENA.reward_preview,
        pos = cc.p(item:getContentSize().width/2+2,item:getContentSize().height/2),
    })
    item:addChild(label , 4)

    local _autoBtn = zc.createCommomBtn({
        tag = 1,
        listener = function () 
            self:autoJoin()
        end,
        pos = cc.p(zc.width - 150, 40),
        text = zc.lang("autoJoin"),
    })
    self:addChild(_autoBtn, 4)

    local _createBtn = zc.createCommomBtn({
        tag = 2,
        listener = function () 
            self:createTeam()
        end,
        pos = cc.p(zc.width - 350, 40),
        text = zc.lang("createTeam"),
    })
    self:addChild(_createBtn, 4)
    self._createBtn = _createBtn

    -- 剩余次数
    local _sp = zc.createSprite("res/Main/copy/leftTimesBg.png")
    _sp:setPosition(20, 20)
    _sp:setAnchorPoint(0, 0)
    self:addChild(_sp, 4)

    local _label = zc.createLabel({
        text = LANGUAGE_ARENA.times_left,
        fontSize = 22,
        stroke = true,
        pixel = 3,
        ap = cc.p(0, 0.5),
        pos = cc.p(35, _sp:getBoundingBox().height * 0.5 - 1),
    })
    _sp:addChild(_label)

    local _n1 = tonumber( _params.challengeNum ) or 0
    local _n2 = tonumber( _params.challengeNumLimit ) or 1
    local _n3 = _n2-_n1
    _n3 = _n3 < 0 and 0 or _n3
    local _txt = _n3 .. "/" .. _n2
    local _label2 = zc.createLabel({
        text = _txt,
        fontSize = 22,
        ttf = zc.getFont(1),
        color = display.COLOR_GREEN,
        outLine = true,
        pixel = 1.5,
        ap = cc.p(0, 0.5),
        pos = cc.p(_label:getPositionX() + _label:getContentSize().width + 10, _label:getPositionY()),
    })
    _sp:addChild(_label2)
    self._label2 = _label2

    -- self:initEvent()
end

function MultiCopyMainLayer:initTeamList( bg )
    local _size = bg:getContentSize()

    local _bian = zc.createSprite("res/Main/multyCopy/sideLine.png")
    _bian:setAnchorPoint(1, 0.5)
    _bian:setPosition(_size.width, _size.height*0.5)
    bg:addChild(_bian, 1)

    local _tableSize = cc.size(_size.width - 180, _size.height - 30)
    local _tableView = zc.ZCTableView:create(_tableSize)
    _tableView:setPosition(150, 15)
    _tableView:setInertia(true)
    _tableView:setBounceable(true)
    _tableView:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL)
    _tableView:setDelegate()
    _tableView:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    bg:addChild(_tableView)
    self._teamTable = _tableView

    local _cellSize = cc.size(_tableSize.width, 150)

    local function numberOfCellsInTableView( table )
        return #self._teamsInfo
    end
    local function cellSizeForTable( table, index )
        return _cellSize.height + 5, _cellSize.width
    end
    local function tableCellAtIndex( table, index )
        local cell = table:dequeueCell()
        if cell then
            cell:removeAllChildren()
        else
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(_cellSize)
        end

        local _di = cc.LayerColor:create(cc.c4b(0, 0, 0, 255*0.2), _cellSize.width, _cellSize.height)
        cell:addChild(_di)

        local _title = zc.createSprite("res/Main/multyCopy/teamTitle.png")
        _title:setAnchorPoint(0, 1)
        _title:setPosition(0, _cellSize.height)
        cell:addChild(_title)

        local _label = zc.createLabel({
            text = index + 1,
            fontSize = 18,
            ttf = zc.getFont(1),
            color = display.COLOR_YELLOW,
            stroke = true,
            pixel = 3,
            ap = cc.p(0, 0.5),
            pos = cc.p(70, _title:getBoundingBox().height * 0.5),
        })
        _title:addChild(_label)

        for i=1, 2 do
            local _line = zc.createSprite("res/Main/multyCopy/cellLine.png")
            _line:setPosition(_cellSize.width/3*i, _cellSize.height*0.5)
            cell:addChild(_line)
        end


        self:createOneCell(_di, index)
        return cell
    end
    _tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    _tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    _tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    _tableView:reloadData()
end

function MultiCopyMainLayer:createOneCell( cell, index )
    local _size = cell:getContentSize()
    local _data = self._teamsInfo[index + 1]
    local _userInfo, _posX
    local _onePart = _size.width/6
    local _posY = _size.height*0.5
    for i=1, 3 do
        _userInfo = _data["user" .. i]
        _posX = _onePart + (i-1)*_size.width/3
        if _userInfo and next(_userInfo) ~= nil then
            local _di = zc.createSprite("res/Main/multyCopy/teamBg.png")
            _di:setPosition(_posX, _posY)
            cell:addChild(_di)

            local head = zc.createPlayerHead({iconId = _userInfo.iconId})
            head:setPosition(50, _di:getContentSize().height*0.5)
            _di:addChild(head)

            local _name = zc.createLabel({
                text = _userInfo.userName,
                fontSize = 18,
                outLine = true,
                pos = cc.p(200, 90),
            })
            _di:addChild(_name)

            local _fightName = zc.createSprite("res/Main/role/common/fight_bg.png")
            _fightName:setAnchorPoint(0, 0.5)
            _fightName:setPosition(100, 40)
            _fightName:setScale( 0.7 )
            _di:addChild(_fightName)

            local _fightNum = zc.createFntLabel({
                fnt = "res/Main/common/fnt/fight_change.fnt",
                text = _userInfo.fighting,
                ap = cc.p(0, 0.5),
                pos = cc.p(90, _fightName:getContentSize().height/2 ),
                addwidth = -14,
            })
            _fightNum:setScale( 0.7 )
            _fightName:addChild(_fightNum)
        else
            local _di = zc.createSprite("res/Main/multyCopy/emptyBg.png")
            _di:setPosition(_posX + 32, _posY - 15)
            cell:addChild(_di)

            local _plus = zc.createImageView({
                src = "res/Main/multyCopy/plus.png",
                pos = cc.p(_posX, _posY + 9),
                listener = function()
                    self:JoinTeam(_data.teamId)
                end,
                touchScale = 0.9,
                swallTouch = true
            })
            cell:addChild(_plus)
        end
    end
end

function MultiCopyMainLayer:createTeam()
    zc.sendHttp({
        apiName = "MultiCopy_create",
        params = {tollgateId = self._tollgateId, houseId = self._houseKeyId},
        successCallback = function(result)
            local _data = result
            local _teamInfo = {}
            for k,v in pairs(_data.teams or {}) do
                if tonumber(v.teamId) == _data.selfIeamId then
                    _teamInfo = v
                    break
                end
            end
            _teamInfo.tollgateId = self._tollgateId
            LayerManager.removeLayout()
            zc.createMultiCopyTeamScene(_teamInfo, _data.challengeNum, _data.challengeNumLimit)
        end,
    }) 
end

function MultiCopyMainLayer:countOneTeamMemberNum( team )
    local _count = 0
    for i=1,3 do
        local _user = team["user"..i]
        if next(_user) == nil then
            _count = _count + 1
        end
    end
    return _count
end

function MultiCopyMainLayer:autoJoin()
    if #self._teamsInfo == 0 then
        return zc.tipInfo(zc.lang("tips_have_no_team_to_join"))
    end
    table.sort(self._teamsInfo, function( a, b )
        local num1 = self:countOneTeamMemberNum(a)
        local num2 = self:countOneTeamMemberNum(b)
        if num1 ~= num2 then
            return num1 > num2
        end
        return a.teamId < b.teamId
    end)
    local teamId, _num
    for i = 1, #self._teamsInfo do
        local _data = self._teamsInfo[i]
        _num = self:countOneTeamMemberNum(_data)
        if _num > 0 then
            teamId = _data.teamId
            break
        end
    end
    if teamId then
        self:JoinTeam(teamId)
    else
        return zc.tipInfo(zc.lang("tips_have_no_team_to_join"))
    end
end

function MultiCopyMainLayer:JoinTeam( teamId )
    zc.joinOneMultiCopyTeam(teamId, self._tollgateId, function()
        LayerManager.removeLayout()
    end)
end

-- 过滤没人的队伍
function MultiCopyMainLayer:filterTeam()
    local _teams = {}
    for i, v in ipairs( self._teamsInfo ) do
        for j = 1, 3 do
            local _user = v["user"..j]
            if _user and next( _user ) then
                _teams[#_teams + 1] = v
                break
            end
        end
    end
    self._teamsInfo = _teams
end

function MultiCopyMainLayer:onEnter()
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.DUI_HUA) then 
        local function  _callBack()
            getGuideManager():setObjTarget(self._createBtn)
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end
end


return MultiCopyMainLayer