--[[
    FileName: GeneralCardGetPop.lua
    Author: andong
    Date: 2017-01-05
    Purpose: 武将图鉴界面
]]
local GeneralCardGetPop = class( "GeneralCardGetPop", function ()
    return ZCPopLayer:create({opacityValue=150})
end)
function GeneralCardGetPop:create(parmas)
    return GeneralCardGetPop.new(parmas)
end
function GeneralCardGetPop:ctor(parmas)
    self:initData(parmas)
    self:initUI()
    self:show()
end
function GeneralCardGetPop:initData(parmas)
    local parmas = parmas or {}
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end
    self._parmas = parmas.gData or {}
    self.VipData = gameData.getDataFromCacheWithPrimaryKey("vip",28)
    self.shengwangVipData = gameData.getDataFromCacheWithPrimaryKey("vip",29)
end
function GeneralCardGetPop:initUI()
    --背景
    local popBg = zc.createNormalPop({
        -- src = "",
        tag = 2,
        width = 870,
        height = 522+31,
    })
    popBg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addContent(popBg)

    local popSize = cc.size(870, 522)
    self._popBg = popBg
    self._popSize = popSize

    local close = zc.createBackButton({
        pos = cc.p(popSize.width-10, popSize.height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close, 10)

    local getTitle = zc.createSprite("res/Main/pub/manual/getTitle.png")
    getTitle:setAnchorPoint(0, 0.5)
    getTitle:setPosition(-48, popSize.height-13)
    popBg:addChild(getTitle,10)

    local _left_bg = zc.createSprite("res/Main/country/techinfo/techinfo_bg.jpg")
    _left_bg:setAnchorPoint(0,0)
    _left_bg:setPosition(4, 6)
    popBg:addChild(_left_bg)

    local tab_split_y = zc.createSprite("res/Main/common/tab_split_y.png")
    tab_split_y:setAnchorPoint(0.5, 0)
    tab_split_y:setPosition(_left_bg:getPositionX()+_left_bg:getContentSize().width, 4)
    popBg:addChild(tab_split_y, 1)

    local rightSize = cc.size(497, 464)
    local rightBg = zc.getScaleNode("res/Main/country/main/country_pop_right_bg.png", rightSize)
    rightBg:setAnchorPoint(0,0)
    rightBg:setPosition(367,5)
    popBg:addChild(rightBg, 2)
    self._rightbg = rightBg
    self._rightSize = rightSize

    self:initLeftUI()
    self:initRightUI()

end
function GeneralCardGetPop:initLeftUI()
    local scrollSize = cc.size(357, 464)
    local bodyImgScrollview = zc.createScrollview({
        size = scrollSize,
        innerSize = scrollSize,
        dir = ccui.ScrollViewDir.both,
        bar = false,
        bounceEnable = false,
    })
    self._popBg:addChild(bodyImgScrollview)
    bodyImgScrollview:setPosition(4,6)

    local picture = self._parmas.generalInfo.picture
    local body = zc.createSprite("res/Main/hero/body/"..picture ..".png")
    body:setAnchorPoint(0.5, 0)
    body:setPosition(scrollSize.width/2, 0)
    bodyImgScrollview:addChild(body)
    body:setScale(0.7)

    local yun = zc.createSprite("res/Main/pub/manual/yun.png")
    yun:setAnchorPoint(0, 0)
    yun:setPosition(2, 5)
    self._popBg:addChild(yun, 0)
    
    local skillTable = self:findSkillInfo(self._parmas.generalInfo, self._parmas.generalInfo.id)
    -- dump(skillTable)
    local dis = 85
    
    local skillPos = zc.sortFromMiddle(cc.p(160+25, 83), #skillTable, dis)
    for i=1,#skillTable do
        local item
        local showGray = false
        if skillTable[i].isMax == 3 then
            showGray = true
        end
        item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSkill,
                type = 1, 
                id = skillTable[i].id,
            }, 
            pos = skillPos[i], 
            scale = 0.6,
            listener = function ()
                zc.createSkillInfoPop({id=skillTable[i].id})
            end
        })
        -- item:setScale(88/120)
        item:setName("item_"..i)
        self._popBg:addChild(item)

        if skillTable[i].skillType == 4 then --如果是合体
            local aoyi = zc.createSprite("res/Main/pub/aoyi.png")
            aoyi:setAnchorPoint(0.5, 1)
            aoyi:setPosition( item:getContentSize().width/2 , 10 )
            item:addChild(aoyi)
            if skillTable[i].id == skillTable[i].combineSkillId then
                local num_sprite = zc.createSprite("res/Main/role/1.png")
                num_sprite:setPosition(item:getContentSize().width/1.35,-5)
                item:addChild(num_sprite)
            else
                local num_sprite = zc.createSprite("res/Main/role/2.png")
                num_sprite:setPosition(item:getContentSize().width/1.35,-5)
                item:addChild(num_sprite)
            end
        elseif skillTable[i].skillType == 3 then --如果是大招
            local aoyi = zc.createSprite("res/Main/pub/critical.png")
            aoyi:setAnchorPoint(0.5, 1)
            aoyi:setPosition( item:getContentSize().width/2 , 10 )
            item:addChild(aoyi)
        end
    end

end
function GeneralCardGetPop:initRightUI()
    local rightBg = self._rightbg 
    local rightSize = self._rightSize
    local generalInfo = self._parmas.generalInfo or {}
    local fragmentNum = 0

    local headInfoBg = zc.createPushButton({
        normalFile = "res/Main/pub/manual/infobg.png",
        needSwallow = true,
        anchor = cc.p(0.5, 1),
    })
    headInfoBg:setPosition(rightSize.width/2, rightSize.height - 6)
    rightBg:addChild(headInfoBg, 1)

    local nameBg = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(388, 33))
    nameBg:setAnchorPoint(cc.p(0.5, 1))
    nameBg:setPosition( headInfoBg:getContentSize().width/2,headInfoBg:getContentSize().height - 16 )
    headInfoBg:addChild(nameBg)

    local weaponType = zc.createSprite( zc.getHeroTypeImg(self._parmas.generalInfo.weaponType) )
    weaponType:setAnchorPoint(0.5, 0.5)
    weaponType:setPosition(5, nameBg:getContentSize().height/2)
    nameBg:addChild(weaponType)

    local name = zc.createLabel({
        text = generalInfo.name,
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(91, nameBg:getContentSize().height/2 ),
    })
    nameBg:addChild(name)

    local title = zc.createLabel({
        text = "<"..generalInfo.title..">",
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(267, nameBg:getContentSize().height/2),
        color = zc.COLOR_PURPLE,
    })
    nameBg:addChild(title)
    

    local scaleSize = cc.size(388, 31)

    local bar_bg = zc.getScaleNode("res/Main/copy/progressBg.png", scaleSize)
    bar_bg:setPosition(headInfoBg:getContentSize().width/2, 45)
    headInfoBg:addChild(bar_bg)
    local bar_size = bar_bg:getContentSize()

    local bar_light = zc.getScaleNode("res/Main/copy/progress_light.png", cc.size(scaleSize.width-5, 17))
    bar_light:setPosition(bar_size.width / 2, bar_size.height / 2 + 4)
    bar_bg:addChild(bar_light, 1)

    self._bar_bg = bar_bg

    local exchangeInfo = gameData.getDataFromCacheWithPrimaryKey("hero_change_card",  generalInfo.qualifications) or {}
    local exchangeUseNum = exchangeInfo.compoundNum or 1 --招募需要的总数量

    local loadingProgress = cc.ProgressTimer:create(cc.Sprite:create("res/Main/pub/manual/progress.png"))
    loadingProgress:setType(cc.PROGRESS_TIMER_TYPE_BAR)
    loadingProgress:setMidpoint(cc.p(0, 0))
    loadingProgress:setBarChangeRate(cc.p(1, 0))

    loadingProgress:setAnchorPoint(0,0.5)
    loadingProgress:setPosition(0, bar_size.height / 2)

    loadingProgress:setPercentage(10)
    bar_bg:addChild(loadingProgress)
    self._loadingProgress = loadingProgress
    loadingProgress:setPercentage(tonumber(fragmentNum)/exchangeUseNum * 100)

    loadingProgress:setPercentage(100)


    local myLab1 = zc.createLabel({
        text = fragmentNum.."/"..exchangeUseNum,
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(bar_size.width / 2, bar_size.height / 2+1),
        color = display.COLOR_YELLOW,
        outLine = true,
    })
    bar_bg:addChild(myLab1, 2)
    self._exchangeUseNum = exchangeUseNum
    self._exchangeLab = myLab1

    local touchBtn = zc.createPushButton({
        normalFile = "res/Main/pub/manual/get_btn_normal.png",
        selectedFile = "res/Main/pub/manual/get_btn_normal.png",
        disableFile = "res/Main/pub/manual/get_btn_disable.png",
        needSwallow = true,
        needEnableWhenMoving = true,
        touchScale = 0.9,
        touchSize = cc.size(120, 100),
        endCallback = function()
            local _confirm = ZCConfirmDialog:createWithParams({ 
                title = zc.lang("prompt"),
                showDi = true,
                msg = zc.lang("is_or_not_zhaomu_hero"),
                rightCallback = function()
                    zc.sendHttp({
                        apiName = "Hero_compose",
                        params = {heroId = generalInfo.id},
                        successCallback = function( backData )
                            PlayerData:updataData(backData)
                            zc.createPubShowGetHero({id=generalInfo.id})

                            self:selfFresh()
                        end
                    })
                end
            })
            self:addChild(_confirm, 10)
        end,
        anchor = cc.p(0.5, 0.5),
    })
    touchBtn:setPosition(bar_bg:getPositionX()+bar_bg:getContentSize().width/2-15, bar_bg:getPositionY())
    headInfoBg:addChild(touchBtn)

    self._touchBtn = touchBtn

    local _middleBg = zc.createGeneralPopScale({
        tag = 3,
        width = 481,
        height = 305,
    })
    _middleBg:setAnchorPoint(0.5, 0)
    _middleBg:setPosition(rightSize.width/2, 8)
    rightBg:addChild(_middleBg)

    local infoBg = zc.createGeneralPopScale({
        tag = 2,
        width = 481-22,
        height = 282,
    })
    infoBg:setPosition( _middleBg:getContentSize().width/2, _middleBg:getContentSize().height/2 )
    _middleBg:addChild(infoBg)

    self._infoBg = infoBg

    local dropScrollview = zc.createScrollview({
        size = cc.size(459, 282),
        innerSize = cc.size(459, 282),
        dir = ccui.ScrollViewDir.vertical,
        bar = false,
        bounceEnable = true,
    })
    infoBg:addChild(dropScrollview)
    dropScrollview:setPosition(0,0)

    self._dropScrollview = dropScrollview

    self:initDropList()

    self:selfFresh()
end
--初始化掉落，可能有多个掉落途径
--"way"         = "1|2|3" 1副本掉 2兑换 3十连抽
function GeneralCardGetPop:initDropList()
    local generalInfo = self._parmas.generalInfo or {}
    
    local dropInfoList = {
        [1] = {
            name = zc.lang("copy_drop"),
            size = cc.size(459,110),
            sortId = 20,
            tag = 1,
        },
        [2] = {
            name = zc.lang("duihuan"),
            size = cc.size(459,250),
            sortId = 100,
            tag = 2,
        },
        [3] = {
            name = zc.lang("shilianchou"),
            size = cc.size(459,110),
            sortId = 10,
            tag = 3,
            chest = {},
            distance = 65,
        },
        [4] = {
            name = zc.lang("activity"),
            size = cc.size(459,110),
            sortId = 5,
            tag = 4,
            distance = 65,
        }
    }
    local way = string.split(tostring(self._parmas.way),"|")
    local nowDropList = {}
    local sizeHeight = 0
    local _hasExchangeTag = false
    for i = 1, #way do
        if way[i] then
            if dropInfoList[tonumber(way[i])] then
                local _index = #nowDropList+1
                nowDropList[_index] = dropInfoList[tonumber(way[i])]
                if dropInfoList[tonumber(way[i])].tag == 2 then
                    _hasExchangeTag = true
                elseif dropInfoList[tonumber(way[i])].tag == 3 then
                    local chestTa = string.split(tostring(self._parmas.chest),"|") or {}
                    local GeneralManualLayer = zc.getScene("GeneralManualLayer")
                    local _bookIdTo_hero_handbook = GeneralManualLayer._bookIdTo_hero_handbook
                    local chestTaList = {} --只显示开启的宝箱
                    for j=1,#chestTa do
                        local bookId = chestTa[j]
                        if _bookIdTo_hero_handbook[tostring(bookId)] and _bookIdTo_hero_handbook[tostring(bookId)]._isOpen then
                            chestTaList[#chestTaList+1] = bookId
                        end
                    end
                    nowDropList[_index].chest = chestTaList
                    local chestNum = table.nums(chestTaList)
                    nowDropList[_index].size.height = 110 + nowDropList[_index].distance * (chestNum-1)
                end
                sizeHeight = sizeHeight + dropInfoList[tonumber(way[i])]["size"].height
            end
        end
    end
    table.sort( nowDropList, function(a,b)
        return a.sortId > b.sortId
    end)
    if sizeHeight > 282 then
        self._dropScrollview:setInnerContainerSize(cc.size(459,sizeHeight))
    else
        sizeHeight = 282
    end
    --是否可以回弹
    local _canBounce = false
    if _hasExchangeTag then
        if #nowDropList > 1 then
           _canBounce = true 
        end
    else
        if #nowDropList > 2 then
           _canBounce = true 
        end
    end
    self._dropScrollview:setBounceEnabled(_canBounce)

    local posY = sizeHeight - 1 
    for i = 1, #nowDropList do
        local dropInfo = nowDropList[i]
        local scaleSize = dropInfo.size
        local dropPathBg = zc.createSprite()
        dropPathBg:setContentSize( scaleSize )
        dropPathBg:setAnchorPoint(0.5, 1)
        dropPathBg:setPosition(459/2, posY)
        self._dropScrollview:addChild(dropPathBg)
        posY = posY - scaleSize.height - 1

        local dropTitle = zc.createSprite("res/Main/pub/manual/drop_path_"..dropInfo.tag..".png")
        dropTitle:setPosition(scaleSize.width/2, scaleSize.height-26)
        dropPathBg:addChild(dropTitle)

        local lace_left = zc.createSprite("res/Main/common/lace.png")
        lace_left:setAnchorPoint(1, 0.5)
        lace_left:setPosition(0, dropTitle:getContentSize().height/2 )
        dropTitle:addChild(lace_left)

        local lace_right = zc.createSprite("res/Main/common/lace.png")
        lace_right:setAnchorPoint(0, 0.5)
        lace_right:setPosition(dropTitle:getContentSize().width, lace_left:getPositionY() )
        lace_right:setFlipX(true)
        dropTitle:addChild(lace_right)

        self:createDropInfoByTag(dropInfo, dropPathBg)

        if dropInfo.tag == 1 then

        elseif dropInfo.tag == 2 then
            local exchangeBtn = zc.createCommomBtn({
                tag = 1,
                text = "兑 换",
                pos = cc.p(370, dropPathBg._tipLab1:getPositionY() ),
                touchScale = 0.9,
                needSwallow = false,
                needEnableWhenMoving = true,
                endCallback = function()
                    zc.sendHttp({
                        apiName = "Hero_heroFragmentExchange",
                        params = {id=self._parmas.id ,num=self._userNum },
                        successCallback = function (net_data)
                            PlayerData:updataData(net_data)
                            zc.tipInfo(zc.lang("tips_duihuan_success"))

                            --修改playerdata数据
                            self._handBookInfo[tostring(self._parmas["id"])] = (tonumber(self._handBookInfo[tostring(self._parmas["id"])]) or 0)+self._userNum
                            local fragmentExchangeData = PlayerData:getFragmentExchangeData()
                            --刷新当前数据
                            self._ownNum = self._ownNum - self._userNum
                            if self._ownNum < 0 then self._ownNum = 0 end
                            self._lastTimes = self._lastTimes - self._userNum
                            if self._lastTimes < 0 then self._lastTimes = 0 end

                            dropPathBg._tipLab2:setString(self._lastTimes)
                            --兑换数量重置
                            self._userNum = 1
                            dropPathBg._numLab:setString(self._userNum)

                            self:selfFresh()
                            self:freshConsumeNumLab()
                        end
                    })
                end,
            })

            dropPathBg:addChild(exchangeBtn)
            self.exchangeBtn = exchangeBtn
            -- self.zhaomuBtn = zhaomuBtn
            local _generalInfo = gameData.getDataFromCacheWithPrimaryKey("hero",  self._parmas.generalid) or {}
            local qualifications = tonumber(_generalInfo.qualifications)
            if qualifications and qualifications == 6 then
                local label = zc.createLabel({
                        text = zc.lang("zmkdh"),
                        fontSize = 20,
                        color = cc.c3b(203,183,123),
                        pos = cc.p(exchangeBtn:getPositionX() - 20,exchangeBtn:getPositionY()),
                    })
                dropPathBg:addChild(label)

                self._zhaomuLabel = label
                print("self._touchBtn:isVisible():",self._touchBtn:isVisible())
                if self._touchBtn:isVisible() then -- 招募表示没有这个武将
                    self.exchangeBtn:setVisible(false)
                    self._zhaomuLabel:setVisible(true)
                else -- 不用招募了 
                    self.exchangeBtn:setVisible(true)
                    self._zhaomuLabel:setVisible(false)
                end
            end
            self:freshConsumeNumLab()
        elseif dropInfo.tag == 3 then

        end

    end
end

function GeneralCardGetPop:createDropInfoByTag(dropInfo, dropPathBg)
    local generalInfo = self._parmas.generalInfo or {}
    local scaleSize = dropInfo.size
    local tag = dropInfo.tag
    if tag == 1 then
        --是否有掉落
        local dropTollgateId = tonumber(generalInfo.heroTurn) or 0
        if dropTollgateId > 0 then
            local tollgateInfo = gameData.getDataFromCacheWithPrimaryKey("tollgate", dropTollgateId)

            local fuben = zc.createLabel({
                text = zc.lang("copy") .. "：",
                fontSize = 22,
                ap = cc.p(0, 0.5),
                pos = cc.p(35, scaleSize.height-78),
                color = cc.c3b(203,183,123),
            })
            dropPathBg:addChild(fuben)
            local tollgateBg = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(163, 33))
            tollgateBg:setAnchorPoint(cc.p(0, 0.5))
            tollgateBg:setPosition( 132, fuben:getPositionY() )
            dropPathBg:addChild(tollgateBg)
            local tollgateName = zc.createLabel({
                text = zc.lang("num_di") .. tostring(tollgateInfo.chapterId) .. zc.lang("num_zhang"),
                fontSize = 20,
                ap = cc.p(0.5, 0.5),
                pos = cc.p(163/2, 33/2),
                color = display.COLOR_YELLOW,
            })
            tollgateBg:addChild(tollgateName)
            local gotoGetBtn = zc.createCommomBtn({
                tag = 3,
                needSwallow = false,
                needEnableWhenMoving = true,
                touchScale = 0.9,
                scale = 0.6,
                text = zc.lang("to_get"),
                fontSize = 30,
                endCallback = function()
                    print("-----------log--------ad-------------")
                    self:gotoDrop(dropTollgateId)
                end,
                pos = cc.p( 384, fuben:getPositionY() ),
            })
            dropPathBg:addChild(gotoGetBtn)

        end
    elseif tag == 2 then

        local _icon = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSoldierFragment,
                type = 1,
                id = generalInfo.id,
            },
            pos = cc.p(65, scaleSize.height - 100 ),
        })
        _icon:setScale(94/120)
        dropPathBg:addChild(_icon)

        local consumeLab = zc.createLabel({
            text = zc.lang("consume") .. "：",
            fontSize = 22,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(175, _icon:getPositionY() + 25),
            color = cc.c3b(203,183,123),
        })
        dropPathBg:addChild(consumeLab)

        local consumeNumbg = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(163, 33))
        consumeNumbg:setAnchorPoint(cc.p(0, 0.5))
        consumeNumbg:setPosition( consumeLab:getPositionX()+40,consumeLab:getPositionY() )
        dropPathBg:addChild(consumeNumbg)
        local consumeImg = zc.createSprite(zc.getImgByType(self._parmas.priceid))
        consumeImg:setAnchorPoint(0.5, 0.5)
        consumeImg:setPosition(22, 33/2)
        consumeNumbg:addChild(consumeImg)
        print("self._parmas.pricenum,|",self._parmas.pricenum)
        local consumeNumLab = zc.createLabel({
            text = self._parmas.pricenum,
            fontSize = 22,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(102, 33/2),
            pixel = 1.3
        })
        consumeNumbg:addChild(consumeNumLab)
        self._consumeNumLab = consumeNumLab

        --当前使用
        self._userNum = 1
        --拥有数量可以购买的次数
        self._ownNum = 100
        local ownRes = PlayerData:getResourcesInfoById(self._parmas["priceid"]) or 0
        self._ownNum = math.floor(tonumber(ownRes)/tonumber(self._parmas["pricenum"]))

        local numBg = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(100, 30))
        numBg:setPosition(288, consumeLab:getPositionY() - 55)
        dropPathBg:addChild(numBg)
        local numLab = zc.createLabel({
            text = self._userNum,
            fontSize = 20,
            pos = cc.p(numBg:getContentSize().width/2, numBg:getContentSize().height/2),
            outLine = true,
            color = display.COLOR_YELLOW
        })
        numBg:addChild(numLab)

        local function setNumChange()
            numLab:setString(self._userNum)
            self:freshConsumeNumLab(self._userNum)
        end

        --   -1
        local plusOneBtn = zc.createPushButton({
            normalFile = "res/Main/common/button/common_btn8_u.png",
            selectedFile = "res/Main/common/button/common_btn8_d.png",
            needSwallow = false,
            touchScale = 0.9,
            endCallback = function()
                if self._userNum > 1 then
                    self._userNum = self._userNum - 1
                    setNumChange()
                end
            end,
            pos = cc.p(numBg:getPositionX()-numBg:getContentSize().width/2, numBg:getPositionY()), 
        })
        dropPathBg:addChild(plusOneBtn,2)
        local subTenBtn = zc.createPushButton({
            normalFile = "res/Main/bag/new/bag_max_btn_u.png",  
            selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
            needSwallow = false,
            touchScale = 0.9,
            text = "Min",
            fontSize = 22,
            endCallback = function()
                self._userNum = 1
                setNumChange()
            end,
            pos = cc.p(numBg:getPositionX()-numBg:getContentSize().width-10, numBg:getPositionY()), 
        })
        dropPathBg:addChild(subTenBtn,2)
        --   +1
        local addOneBtn = zc.createPushButton({
            normalFile = "res/Main/common/button/common_btn2_u.png",
            selectedFile = "res/Main/common/button/common_btn2_d.png",
            needSwallow = false,
            touchScale = 0.9,
            endCallback = function()
                if self._userNum < self._ownNum then
                    self._userNum = self._userNum + 1
                    setNumChange()
                end
            end,
            pos = cc.p(numBg:getPositionX()+numBg:getContentSize().width/2, numBg:getPositionY()), 
        })
        dropPathBg:addChild(addOneBtn,2)
        --   +10
        local addTenBtn = zc.createPushButton({
            normalFile = "res/Main/bag/new/bag_max_btn_u.png",
            selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
            needSwallow = false,
            touchScale = 0.9,
            text = "Max",
            fontSize = 22,
            endCallback = function()
                if self._ownNum > 0 then
                    self._userNum = self._ownNum
                end
                setNumChange()
            end,
            pos = cc.p(numBg:getPositionX()+numBg:getContentSize().width +10, numBg:getPositionY()), 
        })
        dropPathBg:addChild(addTenBtn,2)
            

        local tipLab1 = zc.createLabel({
            text = zc.lang("today_can_duihuan_space_ci"),
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(10, 35),
            color = cc.c3b(203,183,123),
        })
        dropPathBg:addChild(tipLab1)

        local _generalInfo = gameData.getDataFromCacheWithPrimaryKey("hero",  self._parmas.generalid) or {}
        local qualifications = tonumber(_generalInfo.qualifications)
        local _canBuy = tonumber(self._parmas.count) or 0
        local fragmentExchangeData = PlayerData:getFragmentExchangeData()
        local _handBook = self._parmas["handbook"] or 1
        local _handBookInfo = fragmentExchangeData["handbook".._handBook] or {}
        self._handBookInfo = _handBookInfo
        local _alreayBuyNum = tonumber(_handBookInfo[tostring(self._parmas["id"])]) or 0

        local viplevel = PlayerData.info.vip or 0
        if qualifications == 6 then
            if tonumber(self._parmas.priceid) == 3 then
                dump(self.shengwangVipData)
                if self.shengwangVipData["vip"..viplevel] then
                    _canBuy = self.shengwangVipData["vip"..viplevel]
                end
            else
                if self.VipData["vip"..viplevel] then
                    _canBuy = self.VipData["vip"..viplevel]
                end
            end
        end
        print("_canBuy:",_canBuy,"viplevel:",viplevel,"_alreayBuyNum:",_alreayBuyNum,"id:",self._parmas.priceid)

        local _lastTimes = _canBuy - _alreayBuyNum
        self._lastTimes = _lastTimes
        if _lastTimes < 0 then _lastTimes = 0 end
        local tipLab2 = zc.createLabel({
            text = _lastTimes,
            outLine = true,
            fontSize = 25,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(118, tipLab1:getContentSize().height/2),
            color = display.COLOR_RED,
        })
        tipLab1:addChild(tipLab2)

        if self._ownNum > self._lastTimes then
            self._ownNum = self._lastTimes
        end
        
        dropPathBg._tipLab1 = tipLab1
        dropPathBg._tipLab2 = tipLab2
        dropPathBg._numLab = numLab
    elseif tag == 3 then
        local baoxiang = zc.createLabel({
            text = zc.lang("goods_box") .. "：",
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(35, scaleSize.height-78),
            color = cc.c3b(203,183,123),
        })
        dropPathBg:addChild(baoxiang)
        local _posY = baoxiang:getPositionY()
        for i = 1, table.nums(dropInfo.chest) do
            local tollgateBg = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(163, 33))
            tollgateBg:setAnchorPoint(cc.p(0, 0.5))
            tollgateBg:setPosition( 132, _posY )
            dropPathBg:addChild(tollgateBg)

            local hero_handbook_card = gameData.getDataFromCacheWithPrimaryKey("hero_handbook_card",  dropInfo.chest[i]) or {}
            local boxName = zc.createLabel({
                text = tostring(hero_handbook_card.name),
                fontSize = 20,
                ap = cc.p(0.5, 0.5),
                pos = cc.p(163/2, 33/2),
                color = display.COLOR_YELLOW,
            })
            tollgateBg:addChild(boxName)
            local gotoGetBtn = zc.createCommomBtn({
                tag = 3,
                needSwallow = false,
                needEnableWhenMoving = true,
                touchScale = 0.9,
                scale = 0.6,
                text = zc.lang("to_get"),
                fontSize = 30,
                endCallback = function()
                    zc.createCardExtract({id=dropInfo.chest[i]})
                end,
                pos = cc.p( 384, _posY ),
            })
            dropPathBg:addChild(gotoGetBtn)

            _posY = _posY - dropInfo.distance
        end
    elseif tag == 4 then
        local baoxiang = zc.createLabel({
            text = zc.lang("drop") .. "：",
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(35, scaleSize.height-78),
            color = cc.c3b(203,183,123),
        })
        dropPathBg:addChild(baoxiang)
        local _posY = baoxiang:getPositionY()
        local _funcs = {39,}
        for i = 1, table.nums(_funcs) do
            local tollgateBg = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(163, 33))
            tollgateBg:setAnchorPoint(cc.p(0, 0.5))
            tollgateBg:setPosition( 132, _posY )
            dropPathBg:addChild(tollgateBg)

            local hero_handbook_card = gameData.getDataFromCacheWithPrimaryKey("functions",  _funcs[i])
            local boxName = zc.createLabel({
                text = tostring(hero_handbook_card.content),
                fontSize = 20,
                ap = cc.p(0.5, 0.5),
                pos = cc.p(163/2, 33/2),
                color = display.COLOR_YELLOW,
            })
            tollgateBg:addChild(boxName)
            local gotoGetBtn = zc.createCommomBtn({
                tag = 3,
                needSwallow = false,
                needEnableWhenMoving = true,
                touchScale = 0.9,
                scale = 0.6,
                text = zc.lang("to_get"),
                fontSize = 30,
                endCallback = function()
                    zc.gotoFunction(_funcs[i], {goIdx = 4})
                end,
                pos = cc.p( 384, _posY ),
            })
            dropPathBg:addChild(gotoGetBtn)

            _posY = _posY - dropInfo.distance

        end
    end
end

--刷新数据
function GeneralCardGetPop:selfFresh()
    local generalInfo = self._parmas.generalInfo
    local conditionId = tonumber(self._parmas.condition) or 0
    local fragmentNum = PlayerData:getFragmentNumByHeroId(generalInfo.id)
    local exchangeUseNum = self._exchangeUseNum

    local conditionList = {}
    local GeneralManualLayer = zc.getScene("GeneralManualLayer")
    if GeneralManualLayer and GeneralManualLayer._listLayer then
        conditionList = GeneralManualLayer._listLayer._mainIdToData or {}
    end

    --如果已经有这个武将了，按钮不可点击
    local _hasGeneral = PlayerData:hasSameGeneral(generalInfo.id)

    local _generalInfo = gameData.getDataFromCacheWithPrimaryKey("hero",  self._parmas.generalid) or {}
    local qualifications = tonumber(_generalInfo.qualifications)

    if _hasGeneral then
        self._touchBtn:setVisible(false)
        self._loadingProgress:setVisible(false)
        self._exchangeLab:setString(fragmentNum)
        if not self._fullProgress then
            local fullProgress = zc.getScaleNode("res/Main/pub/manual/progress.png", cc.size(388, 26))
            fullProgress:setPosition(self._bar_bg:getContentSize().width/2, self._bar_bg:getContentSize().height/2)
            self._bar_bg:addChild(fullProgress)
            self._fullProgress = fullProgress
        end
        
        if qualifications and qualifications == 6 then
            print("----------1 ",self._touchBtn:isVisible())
            if self._touchBtn:isVisible() then -- 招募表示没有这个武将
                self.exchangeBtn:setVisible(false)
                self._zhaomuLabel:setVisible(true)
            else -- 不用招募了 
                self.exchangeBtn:setVisible(true)
                self._zhaomuLabel:setVisible(false)
            end
        end
    else
        if fragmentNum < exchangeUseNum then
            self._touchBtn:setEnable(false)
        else
            if conditionId > 0 then
                local conditionData = conditionList[conditionId] or {}
                local _hasConditionGeneral = PlayerData:hasSameGeneral(conditionData.generalid)
                if _hasConditionGeneral then
                    self._touchBtn:setEnable(true)
                else
                    self._touchBtn:setEnable(false)
                end
            else
                self._touchBtn:setEnable(true)
            end
        end
        if qualifications and qualifications == 6 then
            print("----------2 ",self._touchBtn:isVisible())
            if self._touchBtn:isVisible() then -- 招募表示没有这个武将
                self.exchangeBtn:setVisible(false)
                self._zhaomuLabel:setVisible(true)
                print("-*******-")
            else -- 不用招募了 
                self.exchangeBtn:setVisible(true)
                self._zhaomuLabel:setVisible(false)
                print("1-*******-1")
            end
        end
        self._loadingProgress:setPercentage(tonumber(fragmentNum)/exchangeUseNum * 100)
        self._exchangeLab:setString(fragmentNum.."/"..exchangeUseNum)
    end

end
function GeneralCardGetPop:gotoDrop(dropTollgateId)
    local _chapterId = PlayerData:getChapterIdByEnemyId(dropTollgateId)
    local _chapterData = PlayerData:getCopyInfoByChapterId(_chapterId)
    if not _chapterData then
        zc.tipInfo(zc.lang("tips_chapter_no_open"))
        return
    end
    zc.createTollgateLayer({enemyid = tonumber(dropTollgateId), tollgateId = tonumber(_chapterId), nationId = 1, newScene = true})
end
--查找技能信息
function GeneralCardGetPop:findSkillInfo(heroInfo,heroId)
    local heroId = tonumber(heroId)
    if not heroId then
        return
    end
    if heroInfo._skillInfo then
        return heroInfo._skillInfo
    end
    local _skillInfo = zc.getHeroSkillData({heroId = heroId})
    heroInfo._skillInfo = _skillInfo
    return _skillInfo
end

function GeneralCardGetPop:freshConsumeNumLab( tmpTime )
    local _base = tonumber(self._parmas.pricenum) or 0
    local _more = tonumber(self._parmas.morePrice) or 0
    local _time = tonumber(self._handBookInfo[tostring(self._parmas["id"])]) or 0    
    local _show = 0

    local _tmpTime = tonumber(tmpTime) or 1
    if _tmpTime ~= 0 then
        for i=1, _tmpTime do
            _show = _show + _base + _more*_time
            _time = _time + 1
        end
    end

    self._consumeNumLab:setString(_show)
end

function GeneralCardGetPop:onEnter()
    if self._init then
        self:selfFresh()
    end
    self._init = true
end

function GeneralCardGetPop:onCleanup()
    if self._callback and type(self._callback) == "function" then
        self._callback()
    end
end

return GeneralCardGetPop