--[[
    FileName: BingFaMainLayer.lua
    Author: andong
    Date: 2016-04-13
    Purpose: 研究院兵法界面
]]
local BingFaMainLayer = class( "BingFaMainLayer", function ()
    return zc.createNormalDialog()
end)
function BingFaMainLayer:create(parmas)
    return BingFaMainLayer.new(parmas)
end
function BingFaMainLayer:ctor(parmas)
    self:initData(parmas)
    self:initUI()
end

function BingFaMainLayer:initData(parmas)
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end
    self.EffectNum = 10 --效果个数 统一定义
    self._activeMainId = parmas.activeId --
    self._tag = parmas.tag or 1 --初始tag
    self._openInfo = {}
    for i=1, #parmas.books do
        self._openInfo[tonumber(parmas.books[i].bookId)] = parmas.books[i]
    end
    self._adConsumeType = 9 --进阶消耗物品（9木材）
    self._leConsumeType = 11  --升级消耗物品（11武魂）
end


function BingFaMainLayer:initUI()
    --界面信息
    self:createInterFace()
    --基本信息
    self:createBaseInfo()
end
function BingFaMainLayer:createInterFace()
    local centerBg = zc.createSprite()
    centerBg:setContentSize(cc.size(zc.width,509))
    centerBg:setAnchorPoint(0.5, 0.5)
    centerBg:setPosition(zc.width/2, zc.height/2-10)
    self:addChild(centerBg)
    self._centerBg = centerBg
    self._centerBgPosY = self._centerBg:getPositionY() --中心点坐标
end

function BingFaMainLayer:createBaseInfo()
    -- 底墨
    local _inkBottom = cc.Sprite:create( "res/Main/role/common/ink_bottom.png" )
    _inkBottom:setAnchorPoint( 0, 1 )
    _inkBottom:setPosition( -370, zc.height )
    self._centerBg:addChild( _inkBottom)

    local centerSize = self._centerBg:getContentSize()
    local leftSize = cc.size(zc.width-650, centerSize.height)
    -- local leftBg = zc.getScaleNode("res/Main/setting/scale9_1.png", leftSize)
    local leftBg = zc.createSprite()
    leftBg:setContentSize( leftSize )
    leftBg:setAnchorPoint(cc.p(0, 0.5))
    leftBg:setPosition(cc.p(0, centerSize.height/2))
    self._centerBg:addChild(leftBg)
    self._leftBg = leftBg

    local rightInflBg = zc.createNormalPop({
        srcTag = 2,
        width = 593,
        height = 499+31,
    })
    rightInflBg:setAnchorPoint(cc.p(1, 0.5))
    rightInflBg:setPosition(cc.p(centerSize.width-59, centerSize.height/2))
    self._centerBg:addChild(rightInflBg)
    -- 顶部
    local _topBg = cc.Sprite:create( "res/Main/role/common/top_bg.jpg" )
    _topBg:setAnchorPoint( 0.5, 1 )
    _topBg:setPosition( cc.p(rightInflBg:getContentSize().width/2,rightInflBg:getContentSize().height-5 ) )
    rightInflBg:addChild( _topBg)
    _topBg:setScaleX( 585/_topBg:getContentSize().width )

    local nameBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(407,32) )
    nameBg:setPosition(cc.p(_topBg:getPositionX(), _topBg:getPositionY()- _topBg:getContentSize().height/2))
    rightInflBg:addChild(nameBg)
    local titleName = zc.createLabel({
        text = zc.lang("bingfa_2"),
        outLine = true,
        fontSize = 22,
        pos = cc.p(nameBg:getContentSize().width/2, nameBg:getContentSize().height/2),
    })
    nameBg:addChild(titleName)

    local rightBg = zc.createSprite()
    rightBg:setContentSize(cc.size(593,441))
    rightBg:setAnchorPoint(cc.p(0.5,0))
    rightBg:setPosition(cc.p(rightInflBg:getContentSize().width/2, 5))
    rightInflBg:addChild(rightBg)
    self._rightBg = rightBg
    self:createLeftInfo(leftBg) --左界面

    if self._myTable then
        self._myTable:scrollToCell(self._tag-1, false)
    end
end

function BingFaMainLayer:createLeftInfo(leftBg) --左界面
    local leftSize = leftBg:getContentSize()
    leftBg:removeAllChildren()
    local _datas = gameData.getAllDataWithNoClone("book")
    local seatNum = table.nums(_datas)
    self._index = 0 --从0开始 
    --
    local tableSize = leftSize
    local tableNode = leftBg
    
    local myTableBg = zc.createSprite()
    myTableBg:setContentSize( tableSize )
    myTableBg:setAnchorPoint(cc.p(0.5, 0.5))
    myTableBg:setPosition(cc.p(leftSize.width/2, leftSize.height/2))
    tableNode:addChild(myTableBg)

    local info_bg = zc.createSprite("res/Main/research/bingfa/info_bg.png")
    info_bg:setPosition(tableSize.width/2, tableSize.height/2+30)
    myTableBg:addChild(info_bg)
    
    local myTable = zc.ZCTableView:create(tableSize)
    myTable:ignoreAnchorPointForPosition(false)
    myTable:setAnchorPoint(cc.p(0.5, 0.5))
    -- myTable:setPosition(tableSize.width*0.5, tableSize.height*0.5)
    myTable:setPosition(tableSize.width*0.5, tableSize.height*0.5)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(false)
    myTable:setAutoAlign(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_HORIZONTAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    
    myTableBg:addChild(myTable)


    local cellSize = cc.size(tableSize.width, tableSize.height)
    local function scorllviewScriptScroll(table)
        local currentPage = table:getCurrentPage()
        self._scrolling = true
    end
    local function tablePageAfterSliding(table, cell)
        self._scrolling = false
        local currentPage = table:getCurrentPage()
        self:afterScroll()
        self._currentPage = currentPage
    end
    local function cellSizeForTable(table,idx)
        return cellSize.height, cellSize.width
    end
    local function numberOfCellsInTableView(table)
        return seatNum
    end
    local function tableTouchEnded(table, cell)
        scorllviewScriptScroll(table)
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(cellSize.width, cellSize.height))
        else
            cell:removeAllChildren()
        end
    
        self:updateCell(cell, nowIdx)
        return cell
    end

    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(scorllviewScriptScroll,zctech.SCROLLVIEW_SCRIPT_SCROLL)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    myTable:registerScriptHandler(tableTouchEnded,zctech.TABLEVIEW_TOUCH_ENDED)
    myTable:registerScriptHandler(tablePageAfterSliding,zctech.TABLECELL_AFTER_SLIDING)
    
    myTable:reloadData()
    self._myTable = myTable

    
    local leftBtn = zc.createPushButton({
        normalFile = "res/Main/arena/hallFame/arrow_up.png",
        selectFile = "res/Main/arena/hallFame/arrow_down.png",
        needSwallow = true,
        touchSize = cc.size(50, 50),
        endCallback = function()
            -- local nowIdx = myTable:getCurrentPage()
            -- if nowIdx > 0 then
            --     myTable:scrollToCell(nowIdx-1, true)
            -- end
            -- print("nowIdx:",nowIdx,"leftBtn:",leftBtn)
        end,
        anchor = cc.p(0, 0.5),
        pos = cc.p(40, leftSize.height/2)
    })
    leftBg:addChild(leftBtn) 

    local _normal = zc.createSprite("res/Main/arena/hallFame/arrow_up.png")
    local _select = zc.createSprite("res/Main/arena/hallFame/arrow_down.png")
    _normal:setFlipX(true)
    _select:setFlipX(true)
    local rightBtn = zc.createPushButton({
        normalNode = _normal,
        selectedNode = _select,
        needSwallow = true,
        touchSize = cc.size(50, 50),
        endCallback = function()
            -- local nowIdx = myTable:getCurrentPage()
            -- if nowIdx < seatNum-1 then
            --     myTable:scrollToCell(nowIdx+1, true)
            -- end
            -- print("nowIdx:",nowIdx,"rightBtn:",rightBtn)
        end,
        anchor = cc.p(1, 0.5),
        pos = cc.p(leftSize.width-40, leftSize.height/2)
    })
    leftBg:addChild(rightBtn) 

    leftBtn:runAction(cc.RepeatForever:create(cc.Sequence:create(
        cc.MoveBy:create(0.8, cc.p(20,0)),
        cc.MoveBy:create(0.8, cc.p(-20,0))
    )))
    rightBtn:runAction(cc.RepeatForever:create(cc.Sequence:create(
        cc.MoveBy:create(0.8, cc.p(-20,0)),
        cc.MoveBy:create(0.8, cc.p(20,0))
    )))

    rightBtn:setTouchEndedCall(function ( ... )
        local nowIdx = myTable:getCurrentPage()
        if nowIdx < seatNum-1 then
            myTable:scrollToCell(nowIdx+1, true)
        end
        if nowIdx == seatNum-2 then
            rightBtn:setVisible(false)
            leftBtn:setVisible(true)
        else
            rightBtn:setVisible(true)
            leftBtn:setVisible(true)
        end
        print("nowIdx:",nowIdx,"rightBtn:",rightBtn)
    end)
    leftBtn:setTouchEndedCall(function ( ... )
        local nowIdx = myTable:getCurrentPage()
        if nowIdx > 0 then
            myTable:scrollToCell(nowIdx-1, true)
        end
        if nowIdx == 1 then
            rightBtn:setVisible(true)
            leftBtn:setVisible(false)
        else
            rightBtn:setVisible(true)
            leftBtn:setVisible(true)
        end
        print("nowIdx:",nowIdx,"rightBtn:",rightBtn)
    end)

    --
    local pos = zc.sortFromMiddle(cc.p(leftSize.width/2, 57), 2, 250)

    local resetBtn = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("reset_2"),
        needSwallow = true,
        endCallback = function()
            self:clickButton(1)
        end,
        anchor = cc.p(0.5, 0.5),
        pos = pos[1]
    })
    leftBg:addChild(resetBtn)

    local startBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("use_bingfa"),
        needSwallow = true,
        endCallback = function()
            --功能引导结束
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_12006 then
                getGuideManager():setFuncGuideOver()
            end
            self:clickButton(2)
        end,
        anchor = cc.p(0.5, 0.5),
        pos = pos[2]
    })
    leftBg:addChild(startBtn)

    self._resetBtn = resetBtn
    self._startBtn = startBtn

end

function BingFaMainLayer:updateCell(cell, indx)

    local cellSize = cell:getContentSize()
    local cellData = gameData.getDataFromCacheWithPrimaryKey("book", indx)

    local am = "close_"..indx
    if self._openInfo[tonumber(cellData.id)] then
        am = "open_"..indx
    end
    local armature = zc.getSpine("bingfajuanzhou")
    armature:playAction(am, false)

    local scaleSize = cc.size(cellSize.width - 2, cellSize.height-10)
    local book = zc.createSprite()
    book:setContentSize( scaleSize )
    book:setPosition(cellSize.width/2, cellSize.height/2+30)
    cell:addChild(book)

    armature:setScale(0.8)
    armature:setPosition(scaleSize.width/2, scaleSize.height/2)
    book:addChild(armature)

    local nameBg = zc.createSprite("res/Main/research/bingfa/name_bg.png")
    nameBg:setAnchorPoint(0.5, 1)
    nameBg:setPosition(book:getContentSize().width/2+60, book:getContentSize().height-40)
    book:addChild(nameBg, 1)

    local name = zc.createLabel({
        text = cellData.name,
        outLine = true,
        fontSize = 30,
        ap = cc.p(0.5, 1),
        pos = cc.p(nameBg:getContentSize().width/2, nameBg:getContentSize().height-20),
        width = 30,
    })
    nameBg:addChild(name)

    local myLab = zc.createLabel({
        text = "book "..indx,
        outLine = true,
        fontSize = 22,
        ap = cc.p(0.5, 0),
        pos = cc.p(book:getContentSize().width/2, 0),
    })
    
    if not self._openInfo[tonumber(cellData.id)] then
        zc.setGray(book)
        zc.setGray(nameBg)
        name:setColor(display.COLOR_DEEPGRAY)
    else
        if tonumber(self._activeMainId) == tonumber(self._openInfo[tonumber(cellData.id)].id) then
            local qiyongzhong  = zc.createSprite("res/Main/research/bingfa/qiyong.png")
            qiyongzhong:setAnchorPoint(0.5, 0)
            qiyongzhong:setPosition(book:getContentSize().width/2, 34)
            book:addChild(qiyongzhong, 1)
        end
    end
end

function BingFaMainLayer:afterScroll()
    local currentPage = self._myTable:getCurrentPage()
    currentPage = currentPage + 1

    self:createRightInfo() --右界面
end

function BingFaMainLayer:createRightInfo() --右界面
    local rightBg = self._rightBg
    local rightSize = rightBg:getContentSize()
    rightBg:removeAllChildren()

    local currentPage = self._myTable:getCurrentPage() + 1
    local curBook = gameData.getDataFromCacheWithPrimaryKey("book", currentPage)
    local selfOpenInfo = self._openInfo[tonumber(curBook.id)] --是否已经激活

    if not selfOpenInfo then
        self._resetBtn:setVisible(false)
        self._startBtn:setVisible(false)  
        local tipLab = zc.createLabel({
            text = zc.lang("tips_bingfa_un_active"),
            outLine = true,
            fontSize = 22,
            pos = cc.p(rightSize.width/2, rightSize.height/2+15),
            color = cc.c3b(219,212,167),
        })
        rightBg:addChild(tipLab)
        local captainName = LANGUAGE_KEY_GETQUNXIONGNAME_BY_ID(curBook.captainId)
        local captainOpen = curBook.combineNum
        local _tipBg = ccui.Scale9Sprite:create( cc.rect( 15, 12, 163, 8 ), "res/Main/common/popBg/di_properties.png" )
        _tipBg:setContentSize( 320, 32 )
        _tipBg:setPosition( rightSize.width/2, rightSize.height/2-15 )
        rightBg:addChild( _tipBg )
        cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
        local _tipSp = zc.getSprite({
            src = "home_icon_info.png",
            plist = true,
            pos = cc.p( 15, 32/2 ),
            scale = 0.5,
        })
        _tipBg:addChild( _tipSp )
        local _tipLabel = zc.createRichLabel({
            fontSize = 22,
            pos = cc.p( 40, 32/2 ),
        })
        _tipBg:addChild( _tipLabel )
        _tipLabel:setAnchorPoint( 0, 0.5 )
        _tipLabel:setString( "[color=ff746548]"..captainName.."激活[/color][color=ffff3644]"..captainOpen.."[/color][color=ff746548]个可激活[/color]" )
        return 
    end
    self._resetBtn:setVisible(true)
    self._startBtn:setVisible(true)
    local btnStr = zc.lang("use_bingfa")
    if tonumber(selfOpenInfo.id) == tonumber(self._activeMainId) then
        btnStr = zc.lang("tingzhi_2")
    end
    self._startBtn:setText(btnStr)
    --兵书特性
    local scaleSize1 = cc.size(569, 173)
    local advanceInfobg = zc.getScaleNode("res/Main/role/common/shadow_bg.png", scaleSize1)
    advanceInfobg:setAnchorPoint(cc.p(0.5, 1))
    advanceInfobg:setPosition(cc.p(rightSize.width/2, rightSize.height - 43))
    rightBg:addChild(advanceInfobg)
    local advanceTitleBg = zc.createSprite("res/Main/research/bingfa/title_bg.png")
    advanceTitleBg:setAnchorPoint(0, 0.5)
    advanceTitleBg:setPosition(3, scaleSize1.height+21)
    advanceInfobg:addChild(advanceTitleBg)
    local advanceTitleLab = zc.createLabel({
        text = zc.lang("bingshutexing"),
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(40, advanceTitleBg:getContentSize().height/2),
    })
    advanceTitleBg:addChild(advanceTitleLab)

    local advanceNumBg = zc.createSprite("res/Main/research/bingfa/advance_bg.png")
    advanceNumBg:setAnchorPoint(1, 0.5)
    advanceNumBg:setPosition(scaleSize1.width+15, advanceTitleBg:getPositionY()+15)
    advanceInfobg:addChild(advanceNumBg)


    local advanceBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("shengjie_2"),
        needSwallow = false,
        endCallback = function()
            if self._openInfo[tonumber(curBook.id)] then
                local function refresh(data)
                    for k,v in pairs(self._openInfo) do
                        if tonumber(data.id) == tonumber(v.id) then
                            v.advancedLevel = data.advancedLevel
                            break
                        end
                    end
                    self:createRightInfo()
                end
                zc.createSourcePop("BingFaAdvanceUp", "src/layer/research/BingFaAdvanceUpPop.lua", {
                    info = self._openInfo[tonumber(curBook.id)],
                    callback = refresh
                })
            else
                zc.tipInfo(zc.lang("tips_bingfa_un_active"))
            end
        end,
        pos = cc.p(scaleSize1.width-96, 70)
    })
    advanceInfobg:addChild(advanceBtn)
    
    --是否能进阶 
    -- dump(selfOpenInfo)
    -- selfOpenInfo.canAdVance = false -- 不能进阶
    selfOpenInfo.canAdVance = tonumber(selfOpenInfo.isAdvance) == 1 and true or false 
    
    local showAdvanceBtn = true
    if selfOpenInfo.canAdVance then
        advanceBtn:setVisible(true)
    else
        showAdvanceBtn = false
        advanceBtn:setEnable(false)
        local captainName = LANGUAGE_KEY_GETQUNXIONGNAME_BY_ID(curBook.captainId)
        local captainOpen = curBook.combineNum
        local tipLab = zc.createLabel({
            text = "("..captainName.. zc.lang("all_active_can_jinjie") .. "!)",
            outLine = true,
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(190, advanceTitleBg:getPositionY() ),
            color = display.COLOR_RED,
        })
        advanceInfobg:addChild(tipLab)
    end

    local nowAdLevel = tonumber(selfOpenInfo.advancedLevel)
    local adPriceTa = gameData.getDataFromCache("book_advanced_level", {["bookId"]=curBook.id})
    if nowAdLevel >= #adPriceTa then --已经是最大进阶等级
        advanceBtn:setVisible(false)
        showAdvanceBtn = false
         local maxLab = zc.createLabel({
            text = zc.lang("already_full_jie"),
            outLine = true,
            fontSize = 22,
            pos = cc.p(scaleSize1.width-96, 70),
            color = display.COLOR_GREEN,
        })
        advanceInfobg:addChild(maxLab) 
    else
        local priceString = tostring(adPriceTa[nowAdLevel+1].spendNum)
        local priceTa = string.split(priceString, "|")
        local conSume1 = zc.createSprite(zc.getImgByType(priceTa[2]))
        conSume1:setAnchorPoint(0.5, 0.5)
        conSume1:setPosition(advanceBtn:getPositionX()-30, advanceBtn:getPositionY()+55)
        advanceInfobg:addChild(conSume1)
        local ownNum1 = tonumber(self:getResourceNum(priceTa[2]))
        local priceNum1 = tonumber(priceTa[3])
        local priceColor1 = ownNum1>=priceNum1 and display.COLOR_WHITE or display.COLOR_RED
        local priceLab1 = zc.createLabel({
            text = zc.getWan(priceNum1),
            outLine = true,
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(conSume1:getContentSize().width+5, conSume1:getContentSize().height/2),
            color = priceColor1,
        })
        conSume1:addChild(priceLab1)
        conSume1:setVisible(showAdvanceBtn)
        priceLab1:setVisible(showAdvanceBtn)
    end

    --兵书等级
    local scaleSize2 = cc.size(569, 173)
    local levelInfoBg = zc.getScaleNode("res/Main/role/common/shadow_bg.png", scaleSize2)
    levelInfoBg:setAnchorPoint(cc.p(0.5, 0))
    levelInfoBg:setPosition(cc.p(rightSize.width/2, 5))
    rightBg:addChild(levelInfoBg)

    local levelTitleBg = zc.createSprite("res/Main/research/bingfa/title_bg.png")
    levelTitleBg:setAnchorPoint(0, 0.5)
    levelTitleBg:setPosition(3, scaleSize2.height+21)
    levelInfoBg:addChild(levelTitleBg)
    local levelLab = zc.createLabel({
        text = zc.lang("fubing_level"),
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(40, levelTitleBg:getContentSize().height/2),
    })
    levelTitleBg:addChild(levelLab)

    local levelNumBg = zc.createSprite("res/Main/research/bingfa/level_bg2.png")
    levelNumBg:setAnchorPoint(1, 0.5)
    levelNumBg:setPosition(scaleSize1.width+15, levelTitleBg:getPositionY()+15)
    levelInfoBg:addChild(levelNumBg)

    local levelBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("upgrade_2"),
        needSwallow = false,
        endCallback = function()
            if self._openInfo[tonumber(curBook.id)] then
                local function refresh(data)
                    for k,v in pairs(self._openInfo) do
                        if tonumber(data.id) == tonumber(v.id) then
                            v.level = data.level
                            break
                        end
                    end
                    self:createRightInfo()
                end
                zc.createSourcePop("BingFaLevelUp", "src/layer/research/BingFaLevelUpPop.lua", {
                    info = self._openInfo[tonumber(curBook.id)],
                    callback = refresh
                })
            else
                zc.tipInfo(zc.lang("tips_bingfa_un_active"))
            end
        end,
        pos = cc.p(scaleSize1.width-96, 70)
    })
    levelInfoBg:addChild(levelBtn)

    local nowLevel = tonumber(selfOpenInfo.level)
    local lePriceTa = gameData.getDataFromCache("book_level", {["bookId"]=curBook.id})
    if nowLevel >= #lePriceTa then --已经是最大进阶等级
        levelBtn:setVisible(false)
         local maxLab = zc.createLabel({
            text = zc.lang("already_full_level"),
            outLine = true,
            fontSize = 22,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(scaleSize1.width-96, 70),
            color = display.COLOR_GREEN,
        })
        levelInfoBg:addChild(maxLab) 
    else
        local priceString2 = tostring(lePriceTa[nowLevel+1].spendNum)
        local priceTa2 = string.split(priceString2, "|")

        local conSume2 = zc.createSprite(zc.getImgByType(priceTa2[2]))
        conSume2:setAnchorPoint(0.5, 0.5)
        conSume2:setPosition(levelBtn:getPositionX() -30, levelBtn:getPositionY()+55)
        levelInfoBg:addChild(conSume2)
        local ownNum2 = tonumber(self:getResourceNum( priceTa2[2] ))
        local priceNum2 = tonumber( priceTa2[3] )
        local priceColor2 = ownNum2>=priceNum2 and display.COLOR_WHITE or display.COLOR_RED
        local priceLab2 = zc.createLabel({
            text = zc.getWan(priceNum2),
            outLine = true,
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(conSume2:getContentSize().width+5, conSume2:getContentSize().height/2),
            color = priceColor2,
            color2 = display.COLOR_BLACK,
        })
        conSume2:addChild(priceLab2)
    end

    --创建具体信息
    if curBook then
        self:createInfo(advanceInfobg, curBook, "advance")
        self:createInfo(levelInfoBg, curBook, "level")
    end

    --等级
    --进阶等级
    local advanceImgId = selfOpenInfo.advancedLevel or 1
    local advanceNum = zc.createSprite("res/Main/research/bingfa/advance_"..advanceImgId..".png")
    advanceNum:setAnchorPoint(0.5, 0.5)
    advanceNum:setPosition(advanceNumBg:getContentSize().width/2, advanceNumBg:getContentSize().height/2-15)
    advanceNumBg:addChild(advanceNum)
    --升级等级
    local levelNumImgId = selfOpenInfo.level or 1
    local levelNum = zc.createFntLabel({
        fnt = "res/Main/research/bingfa/num/nums.fnt",
        text = levelNumImgId,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(levelNumBg:getContentSize().width/2, levelNumBg:getContentSize().height/2-18),
        addwidth = -12,
    })
    levelNumBg:addChild( levelNum )
    local ji = zc.createSprite("res/Main/research/bingfa/num/ji.png")
    ji:setAnchorPoint(0, 0.5)
    ji:setPosition(levelNum:getPositionX()+levelNum:getContentSize().width/2, levelNum:getPositionY()+3)
    levelNumBg:addChild(ji)
    levelNum:setPositionX(levelNumBg:getContentSize().width/2-ji:getContentSize().width/2)
    ji:setPositionX(levelNum:getPositionX()+levelNum:getContentSize().width/2-1)
end
--作用类型具体信息
function BingFaMainLayer:createInfo(infoBg, bookInfo, _type)
    local parmas = {
        ["level"] = {
            staticName = "book_level",
            baseEfName = "effectId",
            baseEfLayer= "effectLayer",
            openEfName = "openEffectId",
            openEfLayer= "openEffectLayer",
            openTitle  = zc.lang("use_effect") .. "：",
            levelName  = "level",
        },
        ["advance"] = {
            staticName = "book_advanced_level",
            baseEfName = "advancedEffectId",
            baseEfLayer= "advancedEffectLayer",
            openEfName = "advancedOpenEffectId",
            openEfLayer= "advancedOpenEffectLayer",
            openTitle  = zc.lang("use_special") .. "：",
            levelName  = "advancedLevel",
        },
    }
    local tyPa = parmas[_type]
    if not tyPa then
        return
    end
    local Info_bg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(368,155) )
    Info_bg:setAnchorPoint(cc.p(0,0.5))
    Info_bg:setPosition( cc.p(8,infoBg:getContentSize().height/2) )
    infoBg:addChild(Info_bg)

    local infoBg = Info_bg
    local adSize = Info_bg:getContentSize()
    local curOwnInfo = self._openInfo[tonumber(bookInfo.id)] or {} --自己已经激活的兵书
    local staticInfo = gameData.getDataFromCache(tyPa.staticName, {["bookId"]=curOwnInfo.bookId, ["level"]=curOwnInfo[tyPa.levelName]})
        
    --固定作用类型
    local baseInfo = {}
    for i = 1, self.EffectNum do
        if bookInfo[tyPa.baseEfName..i] and tonumber(bookInfo[tyPa.baseEfName..i]) > 0 then
            if staticInfo["effectValue"..i] and tonumber(staticInfo["effectValue"..i]) ~=0 then
                local idx = #baseInfo + 1
                baseInfo[idx] = {}
                baseInfo[idx].effectId      = bookInfo[tyPa.baseEfName..i]
                baseInfo[idx].effectLayer   = bookInfo[tyPa.baseEfLayer..i]
                baseInfo[idx].value         = staticInfo["effectValue"..i]
            end
        else
            break
        end
    end
    --开启作用类型
    local openInfo = {}
    for i = 1, self.EffectNum do
        if bookInfo[tyPa.openEfName..i] and tonumber(bookInfo[tyPa.openEfName..i]) > 0 then
            if staticInfo["openEffectValue"..i] and tonumber(staticInfo["openEffectValue"..i]) ~= 0 then
                local idx = #openInfo + 1
                openInfo[idx] = {}
                openInfo[idx].effectId      = bookInfo[tyPa.openEfName..i]
                openInfo[idx].effectLayer   = bookInfo[tyPa.openEfLayer..i]
                openInfo[idx].value         = staticInfo["openEffectValue"..i]
            end
        else
            break
        end
    end

    local posY = 0
    for i = 1, #baseInfo do
        local modI = i <= 2 and (i-1) or ((i-1)%2)
        local posX = 15+(modI)*204
        posY = adSize.height-25-30*( math.floor((i-1)/2) )
        local effectText = LANGUAGE_getAttributeTextById(baseInfo[i].effectId)
        if tonumber(baseInfo[i].effectLayer) == 1 or tonumber(baseInfo[i].effectLayer) == 2 then
            effectText = zc.lang("base") ..effectText
        end
        local myLab = zc.createRichLabel({
            text = effectText.."：",
            fontSize = 20,
        })
        myLab:setAnchorPoint(0, 0.5)
        myLab:setPosition( cc.p(posX, posY) )
        myLab:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
        infoBg:addChild(myLab)
        local num = zc.createLabel({
            text = "+"..zc.getAttributeNumById(baseInfo[i].effectId, baseInfo[i].value),
            outLine = true,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(myLab:getPositionX()+myLab:getContentSize().width-8, myLab:getPositionY()+2),
        })
        infoBg:addChild(num)
    end

    local qiyingPosY = 12 + (#openInfo-1)*28
    local qiyong = zc.createLabel({
        text = tyPa.openTitle,
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(15, qiyingPosY),
    })
    infoBg:addChild(qiyong)

    for i = 1, #openInfo do
        local posX = 119
        local posY = qiyingPosY-28*( i-1 )
        local addStr = ""
        local numColor = tonumber(openInfo[i].value) > 0 and display.COLOR_GREEN or display.COLOR_RED
        local effectText = LANGUAGE_getAttributeTextById(openInfo[i].effectId)
        if tonumber(openInfo[i].effectLayer) == 1 or tonumber(openInfo[i].effectLayer) == 2 then
            effectText = zc.lang("base") ..effectText
        end
        local myLab = zc.createLabel({
            text = effectText..addStr,
            outLine = true,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(posX, posY),
        })
        infoBg:addChild(myLab)
        local attrNumStr = zc.getAttributeNumById(openInfo[i].effectId, openInfo[i].value)
        if tonumber( openInfo[i].value) > 0 then
            attrNumStr = "+"..attrNumStr
        end
        local num = zc.createLabel({
            text = ""..attrNumStr,
            outLine = true,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(myLab:getPositionX()+myLab:getContentSize().width, myLab:getPositionY()),
            color = numColor,
        })
        infoBg:addChild(num) 
    end
    
end

--重置和启用兵书  1重置 2启用
function BingFaMainLayer:clickButton(_type) 
    if self._scrolling then --还在滑动的过程中不处理
        zc.tipInfo(zc.lang("tips_choose_one_bingfa"))
    else
        local currentPage = self._myTable:getCurrentPage() + 1 --兵书的id就是顺序
        local curBook = gameData.getDataFromCacheWithPrimaryKey("book", currentPage)

        if self._openInfo[tonumber(curBook.id)] then
            local staticId = self._openInfo[tonumber(curBook.id)].bookId
            local mainId = self._openInfo[tonumber(curBook.id)].id
            local openInfo = self._openInfo[tonumber(curBook.id)]
            print("staticId --> ", staticId)
            if _type == 1 then --1重置
                if tonumber(openInfo.level) == 1 and tonumber(openInfo.advancedLevel) == 1 then
                    zc.tipInfo(zc.lang("tips_now_cannot_reset"))
                    return
                end
                local function refresh(data)
                    if data and data.level and data.advancedLevel and data.id then
                        for k,v in pairs(self._openInfo) do
                            if tonumber(data.id) == tonumber(v.id) then
                                v.level = data.level
                                v.advancedLevel = data.level
                            end
                        end 
                        self:createRightInfo()
                    end
                end
                zc.createSourcePop("BingFaReset", "src/layer/research/BingFaResetPop.lua", {info=self._openInfo[tonumber(curBook.id)],callback=refresh})
            elseif _type == 2 then --2启用
                if tonumber(mainId) ~= tonumber(self._activeMainId) then
                    zc.sendHttp({
                        apiName = "Captain_enable",
                        params = {id=staticId},
                        successCallback = function (net_data)
                            PlayerData:updataData(net_data)
                            zc.tipInfo(zc.lang("tips_use_success"))
                            self._activeMainId = net_data.activeId
                            self._myTable:reloadData()
                            self._myTable:scrollToCell(self._currentPage, false)
                            self._startBtn:setText(zc.lang("tingzhi_2"))
                            self._scrolling = false --这是一个特殊处理，再次点击table会滑动但却没有结束
                        end,
                    })
                else
                    zc.tipInfo(zc.lang("tips_tingyong_bingfa"))
                    zc.sendHttp({
                        apiName = "Captain_stop",
                        params = {id=staticId},
                        successCallback = function (net_data)
                            self._activeMainId = 0 
                            self._startBtn:setText(zc.lang("use_bingfa"))
                            self._myTable:reloadData()
                            self._myTable:scrollToCell(self._currentPage, false)
                            self._scrolling = false
                        end,
                    })
                end
            end
        else
            zc.tipInfo(zc.lang("tips_bingfa_un_active"))
        end
    end
end

function BingFaMainLayer:getResourceNum(_type)
    return tonumber(PlayerData:getResourcesInfo()[zc.getTypeByType(_type)])
end

function BingFaMainLayer:onCleanup()
    if self._callback and type(self._callback) == "function" then
        self._callback({id=self._activeMainId, openInfo = self._openInfo})
    end
end

function BingFaMainLayer:onEnter( ... )
    --新手引导
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.DUI_HUA) then
        local function _callBack()
            getGuideManager():setObjTarget(self._startBtn)
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end
end

return BingFaMainLayer