--[[
    FileName: RoleFettersRegionalRewardPop.lua
    Author: wangming
    Date: 2016-11-22
    Purpose: 羁绊解锁奖励弹窗
]]
local RoleFettersRegionalRewardPop = class( "RoleFettersRegionalRewardPop", function ()
    return ZCPopLayer:create()
end)

function RoleFettersRegionalRewardPop:create(params)
    return RoleFettersRegionalRewardPop.new(params)
end

function RoleFettersRegionalRewardPop:ctor(params)
    self:initData(params)
    self:initUI()
    self:show()
end

function RoleFettersRegionalRewardPop:initData(params)
    local _params = params or {}

    self._callback = _params.callback
    local _info = _params.data or {}
    self._info = _info
    self._fettersId = _info.fettersId
    self._status = tonumber(_info.status) or 0

    local _fetterDb = gameData.getDataFromCacheWithPrimaryKey("region_fetters", self._fettersId)
    self._rewardData = {}
    local _rewardsGroup = string.split(_fetterDb.reward or "", ",")
    for k,v in pairs(_rewardsGroup) do
        local _rewardInfo = string.split(v or "", "|")
        local _table = {}
        _table.mainType = _rewardInfo[1]
        _table.type = _rewardInfo[2]
        _table.itemId = _rewardInfo[2]
        _table.num = _rewardInfo[3]
        self._rewardData[#self._rewardData + 1] = _table
    end
end
function RoleFettersRegionalRewardPop:initUI()
    local popBg = zc.createSprite("res/Main/wushenTower/pop_reward.png")
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    self._popBg = popBg
    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close)

    self:createReward()

    local getBtn = zc.createCommomBtn({
        tag = 1,
        btnText = "",
        needSwallow = false,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(popBg:getContentSize().width/2, 65),
        endCallback = function() 
            if self._status ~= 1 then   
                return
            end 
            zc.sendHttp({
                apiName = "RegionalFetters_get",
                params = {id = self._info.id},
                successCallback = function( backData )
                    local _callback = self._callback
                    self:hide()
                    if _callback then
                        _callback(backData)
                    end
                end
            })
        end,
    })
    popBg:addChild(getBtn)

    if self._status == 2 then
        getBtn:setEnable(false)
        getBtn:setText(LANGUAGE_TOLLGATEHERO.fetched)
    elseif self._status == 0 then
        getBtn:setEnable(false)
        getBtn:setText(zc.lang("un_achieve"))
    else
        getBtn:setText(zc.lang("fetch_2"))
    end
end

function RoleFettersRegionalRewardPop:createReward()
    local tableHeight = 132
    local _length = table.nums(self._rewardData)
    if _length > 4 then
        tableHeight = 132 + 100
    end
    local tableSize = cc.size(435, tableHeight)
    local tableNode = self._popBg
    local myTableBg = ccui.Scale9Sprite:create(cc.rect(26,25,1,1), "res/Main/wushenTower/pop_tableBg.png")
    myTableBg:setContentSize(tableSize)
    myTableBg:setAnchorPoint(cc.p(0.5, 0.5))
    myTableBg:setPosition(cc.p(tableNode:getContentSize().width/2, tableNode:getContentSize().height/2 + 20))
    tableNode:addChild(myTableBg)    

    local innerHeight = tableHeight
    for i = 1, _length do
        local modI = i <= 4 and (i-1) or ((i-1)%4)
        local posX = 72 + modI*98
        local posY = innerHeight-66-100*( math.floor((i-1)/4) )

        local reward = self._rewardData[i]
        local item, info = zc.createIconByData({
            data = {
                mainType = reward.mainType,
                type = reward.type, 
                id = reward.itemId,
                num = reward.num,
            }, 
            showDetailPop = true,
            pos = cc.p(posX, posY), 
        })
        local _scale = 87/125
        item:setScale(_scale)
        myTableBg:addChild(item)

        if reward.random then
            local random = zc.createSprite("res/Main/wushenTower/drop_random.png")
            random:setAnchorPoint(cc.p(0,1))
            local itemSize = item:getBoundingBox()
            random:setPosition( posX-itemSize.width/2-1, posY + itemSize.height/2+1)
            random:setScale(0.9)
            myTableBg:addChild(random)
        end
    end
end

return RoleFettersRegionalRewardPop