--[[
    饰品属性弹窗
    唐实聪
    2016.5.24
]]
local RoleTrinketInfoPop = class("RoleTrinketInfoPop", function()
    return ZCPopLayer:create()
end)

function RoleTrinketInfoPop:create( params )
    return RoleTrinketInfoPop.new( params )
end

function RoleTrinketInfoPop:ctor( params )
    self:initData( params )
    self:show()
end

function RoleTrinketInfoPop:initData( params )
    -- 创建容器
    local container = cc.Sprite:create()
    container:setContentSize( zc.width, zc.height )
    container:setPosition( zc.width/2, zc.height/2 )
    self:addContent( container )
    local hideLayer = zc.createPushButton({
        touchSize = cc.size( zc.width, zc.height ),
        pos = cc.p( zc.width/2, zc.height/2 ),
        endCallback = function()
            self:hide()
        end
    })
    container:addChild( hideLayer )
    -- 已穿戴饰品信息
    self._equipedTrinket = {}
    for i, v in ipairs( PlayerData:getTrinketsInfo() ) do
        if tonumber( v.status or 0 ) == 5 then
            -- 已穿戴
            self._equipedTrinket[tonumber( v.trinketId )] = true
        end
    end

    -- 各种回调
    -- 显示饰品数据
    if params.item then
        local trinketList = gameData.getDataFromCacheWithPrimaryKey("trinket", params.item.trinketId)

        if params.item.NowState then
            self._canEquip = params.item.NowState["isCanEquip"] or false
        end
        local _params = {
            leftOrRight = "left",
            trinketList = trinketList,
            trinketData = params.item,
            equiped = false,
            leftText = zc.lang("sell"),
            leftCallback = function()
                -- 出售
                local rightFuncConfirm = function ()
                    --info :1|2|3,1|2|3 // 出售物品信息(物品类型|主键id|数量,物品类型|主键id|数量)
                    local selldata = "9|" .. params.item.id .."|1"
                    zc.sendHttp({
                        apiName = "Bag_sell",
                        params = {info = selldata}, 
                        successCallback = function (data)
                           --卖出成功-- 增加银币
                            PlayerData:updataData(data)
                            PlayerData:subTrinketsInfo(params.item.id)
                            if params.sellCallBack then
                                params.sellCallBack()
                            end
                        end,
                    })
                end
                self:hide()
                zc.createPop("sellConfirmOther", {title = "chushou",info = trinketList, rightFunc = rightFuncConfirm})
                
            end,
            rightText = zc.lang("equip"),
            rightCallback = function()
                -- 装备
                self:hide()
                if params.confirmFunc then 
                    params.confirmFunc()
                end
            end,
        }
        local left = self:initUI( _params )
        left:setAnchorPoint( 1, 0.5 )
        left:setPosition( zc.width/2 - 82, zc.height/2 )
        container:addChild( left )
    end
    -- 当前正穿戴饰品数据
    if params.curItem then
        local trinketList = gameData.getDataFromCacheWithPrimaryKey("trinket", params.curItem.trinketId)
        local _params = {
            leftOrRight = "right",
            trinketList = trinketList,
            trinketData = params.curItem,
            equiped = true,
        }
        if params.item then
            -- 可以洗练转移按钮
            local color = tonumber( trinketList.color ) or 0
            local _trinketList = gameData.getDataFromCacheWithPrimaryKey("trinket", params.item.trinketId)
            local _color = tonumber( _trinketList.color ) or 0
            if color >= 3 and _color >= 3 then
                -- 洗练
                _params.leftText = zc.lang("xilian")
                _params.leftCallback = function()
                    self:hide()
                    if params.replaceAttrFunc then 
                        params.replaceAttrFunc()
                    end
                end
            end
            local _curEffectNum=0
            local _itemEffectNum=0
            for i = 1, 6 do
                if params.item["effectId"..i] and tonumber(params.item["effectId"..i]) > 0 then
                    _itemEffectNum = _itemEffectNum + 1
                end
                if params.curItem["effectId"..i] and tonumber(params.curItem["effectId"..i]) > 0 then
                    _curEffectNum = _curEffectNum + 1
                end
            end
            -- if color >= 4 and _color >= 4 then
            if _itemEffectNum > _curEffectNum then --被洗练饰品附加属性多，就可转移
                self._canReplace = true --可转移
                -- 转移
                _params.rightText = zc.lang("transfer")
                _params.rightCallback = function()
                    self:hide()
                    if params.transferAttrFunc then 
                        params.transferAttrFunc()
                    end
                end
            end
        end
        local right = self:initUI( _params )
        right:setAnchorPoint( 0, 0.5 )
        right:setPosition( zc.width/2 - 76, zc.height/2 )
        container:addChild( right )
    end
end

function RoleTrinketInfoPop:initUI( _params )
    local bg = ccui.Scale9Sprite:create( cc.rect( 15, 15, 70, 70 ), "res/Main/common/common_inner17.png" )
    local _trinketList = _params.trinketList
    local _trinketData = _params.trinketData

    local _suitId = tonumber( _trinketList.suitId ) or 0
    local _width = 405
    local _height = 0
    -- 左按钮
    if _params.leftCallback then
        _height = 50
        local leftButton = zc.createCommomBtn({
            tag = 1,
            endCallback = function() 
                _params.leftCallback()
            end,
            pos = cc.p( _params.rightCallback and 100 or _width/2, _height),
            text = _params.leftText,
        })
        bg:addChild(leftButton)
         --新手引导
        local _currentGID = getGuideManager():getCurrentGID()
        if _currentGID == GuideKey.KEY_11514 then
            self._guide_replace = leftButton
        end
        if _params.leftOrRight == "right" then
            if not self._canEquip and not self._canReplace then
                local button_light = zc.createSprite("res/Main/common/button_light.png")
                button_light:setAnchorPoint(0.5, 0.5)
                button_light:setPosition(leftButton:getContentSize().width/2, leftButton:getContentSize().height/2)
                leftButton:addChild(button_light,100)
                button_light:runAction(cc.RepeatForever:create(cc.Spawn:create(
                    cc.Sequence:create(
                        cc.FadeOut:create(1.0),
                        cc.FadeIn:create(1.0)
                    )
                )))
            end
        end
    end
    -- 右按钮
    if _params.rightCallback then
        _height = 50
        local rightButton = zc.createCommomBtn({
            tag = 1,
            endCallback = function() 
                _params.rightCallback()
            end,
            pos = cc.p( _params.leftCallback and _width - 100 or _width/2, _height ),
            text = _params.rightText,
        })
        bg:addChild(rightButton)
        self._rightButton = rightButton
         --新手引导
        local _currentGID = getGuideManager():getCurrentGID()
        if _currentGID == GuideKey.KEY_11512 then
            self._guide_equip = self._guide_equip or rightButton
        end
        if _params.leftOrRight == "left" then
            if self._canEquip then
                local button_light = zc.createSprite("res/Main/common/button_light.png")
                button_light:setAnchorPoint(0.5, 0.5)
                button_light:setPosition(rightButton:getContentSize().width/2, rightButton:getContentSize().height/2)
                rightButton:addChild(button_light,100)
                button_light:runAction(cc.RepeatForever:create(cc.Spawn:create(
                    cc.Sequence:create(
                        cc.FadeOut:create(1.0),
                        cc.FadeIn:create(1.0)
                    )
                )))
            end
        elseif _params.leftOrRight == "right" then
            if not self._canEquip and self._canReplace then
                local button_light = zc.createSprite("res/Main/common/button_light.png")
                button_light:setAnchorPoint(0.5, 0.5)
                button_light:setPosition(rightButton:getContentSize().width/2, rightButton:getContentSize().height/2)
                rightButton:addChild(button_light,100)
                button_light:runAction(cc.RepeatForever:create(cc.Spawn:create(
                    cc.Sequence:create(
                        cc.FadeOut:create(1.0),
                        cc.FadeIn:create(1.0)
                    )
                )))
            end
        end
    end
    _height = _height + 50
    -- 套装相关
    if _suitId ~= 0 then
        -- 有套装
        local _suitList = gameData.getDataFromCacheWithPrimaryKey("trinket_suit", _suitId)
        if _suitList then
            -- 套装的饰品id
            local suitTrinketData = {}
            -- 已穿戴的套装饰品数量
            local _equipedNum = 0
            for i = 1, 6 do
                local _trinketId = tonumber( _suitList["trinketId"..i] ) or 0
                if _trinketId ~= 0 then
                    suitTrinketData[#suitTrinketData + 1] = {
                        trinketId = _trinketId,
                        equiped = self._equipedTrinket[tonumber( _trinketId )],
                    }
                    _equipedNum = _equipedNum + ( self._equipedTrinket[tonumber( _trinketId )] and 1 or 0 )
                end
            end
            -- dump( suitTrinketData, "suitTrinketData" )
            -- 套装效果数据
            local suitEffectData = {}
            for i = 1, 6 do
                local _effectId = tonumber( _suitList["effectId"..i] ) or 0
                local _effectValue = tonumber( _suitList["effectValue"..i] ) or 0
                if _effectId ~= 0 and _effectValue ~= 0 then
                    suitEffectData[#suitEffectData + 1] = {
                        num = i,
                        effectId = _effectId,
                        effectValue = _effectValue,
                    }
                end
            end
            -- dump( suitEffectData, "suitEffectData" )
            -- 套装效果
            _height = _height + 30*#suitEffectData
            for i, v in ipairs( suitEffectData ) do
                local _effectText = zc.getEquipAttriNameByEffectType( v.effectId, true, false ).."+"..zc.getAttributeNumById( v.effectId, v.effectValue )
                local _color = cc.c3b( 150, 150, 149 )
                if _equipedNum >= v.num then
                    -- 满足条件
                    _color = cc.c3b( 223, 179, 92 )
                end
                -- 套装条件
                local _suitEffect = zc.createLabel({
                    text = v.num .. zc.lang("piece")..":" .. _effectText,
                    fontSize = 22,
                    ttf = zc.getFont(1),
                    ap = cc.p(0, 0.5),
                    pos = cc.p(40, _height-i*30),
                    color = _color,
                    outLine = true,
                })
                bg:addChild( _suitEffect )
            end
            -- 套装包含饰品
            _height = _height + 10 + 30*math.ceil( #suitTrinketData/2 )
            for i, v in ipairs( suitTrinketData ) do
                local _color = cc.c3b( 150, 150, 149 )
                if v.equiped then
                    _color = cc.c3b( 223, 179, 92 )
                end
                --套装饰品名称
                local _trinketName = zc.createLabel({
                    text = gameData.getDataFromCacheWithPrimaryKey("trinket", v.trinketId).name,
                    fontSize = 22,
                    ttf = zc.getFont(1),
                    ap = cc.p(0, 0.5),
                    pos = cc.p(210 - ( i%2 )*170, _height - 30*math.ceil( i/2 )),
                    color = _color,
                    outLine = true,
                })
                bg:addChild( _trinketName )
            end
            -- 套装文字
            local _suitTitle = zc.createLabel({
                text = zc.lang("suit")..":".._equipedNum .. "/"..#suitTrinketData,
                fontSize = 22,
                ttf = zc.getFont(1),
                ap = cc.p(0, 0.5),
                pos = cc.p(40, _height),
                color = cc.c3b( 223, 179, 92 ),
                outLine = true,
            })
            bg:addChild( _suitTitle )
            -- 属性分割线
            _height = _height + 20
            local _split_suit = cc.Sprite:create( "res/Main/ornaments/trinket_cut_line.png" )
            _split_suit:setPosition( _width/2, _height )
            _split_suit:setScaleX(16)
            bg:addChild( _split_suit )
            _height = _height + 20
        end
    end

    -- 属性
    for i = 6, 1, -1 do
        local _effectId = tonumber( _trinketData["effectId" .. i] ) or 0
        local _effectValue = tonumber( _trinketData["effectValue" .. i] ) or 0
        local _effectColor = tonumber( _trinketData["effectColor" .. i] ) or 0
        local _left_extAttr_text = ""
        if _effectId ~= 0 and _effectValue ~= 0 then
            _effectText = zc.getEquipAttriNameByEffectType( _effectId, false, false )..":+"..zc.getAttributeNumById( _effectId, _effectValue )
            -- 属性
            local _effect = zc.createLabel({
                text = _effectText,
                fontSize = 22,
                ttf = zc.getFont(1),
                ap = cc.p(0, 0.5),
                pos = cc.p(40, _height),
                color = zc.getColorByQuality( _effectColor ),
                outLine = true,
            })
            bg:addChild( _effect )
            _height = _height + 30
        end
    end
    -- 属性分割线
    _height = _height - 10
    local _split_attr = cc.Sprite:create( "res/Main/ornaments/trinket_cut_line.png" )
    _split_attr:setPosition( _width/2, _height )
    _split_attr:setScaleX(16)
    bg:addChild( _split_attr )

    -- 主属性
    _height = _height + 20
    local _mainAttrText = zc.getEquipAttriNameByEffectType( _trinketList.effectId, true )..":+"..zc.getAttributeNumById( _trinketList.effectId, _trinketList.effectValue )
    local _mainAttr = zc.createLabel({
        text = _mainAttrText,
        fontSize = 22,
        ttf = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(40, _height),
        color = cc.c3b(218,91,6),
        outLine = true,
    })
    bg:addChild( _mainAttr )
    -- 需求等级
    _height = _height + 30
    local _needLevelText = zc.lang("need_level")..":".. _trinketList.needLevel
    local _needLevel = zc.createLabel({
        text = _needLevelText,
        fontSize = 22,
        ttf = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(40, _height),
        color = cc.c3b(249,199,100),
        outLine = true,
    })
    bg:addChild( _needLevel )
    -- 饰品名字
    _height = _height + 30
    local _name = zc.createLabel({
        text = _trinketList.name,
        fontSize = 25,
        ttf = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(40, _height),
        outLine = true,
        color = zc.getColorByQuality( _trinketList.color ),
    })
    bg:addChild( _name )
    -- 已装备
    if _params.equiped then
        local _equiped = zc.createLabel({
            text = "("..zc.lang("equiped")..")",
            fontSize = 25,
            ttf = zc.getFont(1),
            ap = cc.p(1, 0.5),
            pos = cc.p(_width - 30, _height),
            outLine = true,
            color = zc.getColorByQuality( _trinketList.color ),
        })
        bg:addChild( _equiped )
    end

    local _height = _height + 50
    bg:setContentSize( _width, _height )

    -- swallow
    local swallow = zc.createPushButton({
        touchSize = cc.size( _width, _height ),
        pos = cc.p( _width/2, _height/2 ),
        swallow = true,
    })
    bg:addChild( swallow, -1 )

    return bg
end
function RoleTrinketInfoPop:onCleanup()
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/Main/common/button_light.png")
end
function RoleTrinketInfoPop:onEnter()
    getGuideManager():addMaskLayer()
    --新手引导
    performWithDelay(self, function ()
        local _currentGID = getGuideManager():getCurrentGID()
        if _currentGID == GuideKey.KEY_11514 then
            getGuideManager():setObjTarget(self._guide_replace)
            getGuideManager():startGuide()
        elseif _currentGID == GuideKey.KEY_11512 then
            getGuideManager():setObjTarget(self._guide_equip)
            getGuideManager():startGuide()
        end
        getGuideManager():removeMaskLayer()
    end,0.3)
end
return RoleTrinketInfoPop