--[[
	修改玩家名称 改名
]]
local ChangeNamePop = class( "ChangeNamePop", function ()
    return ZCPopLayer:create()
end)

function ChangeNamePop:create(params)
    return ChangeNamePop.new(params)
end

function ChangeNamePop:ctor(params)
	local popSize = cc.size(500, 300)
    local popBg = cc.Sprite:create("res/Main/common/popBg/popup_Bg_blue.png")
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    local _bgSize = popBg:getContentSize()

    local middleBg = zc.getScaleNode("res/Main/common/popBg/bg2.jpg", cc.size(504, 300))
    middleBg:setPosition(_bgSize.width * 0.5, _bgSize.height * 0.5)
    popBg:addChild(middleBg)

    local mid_di_1 = zc.getScaleNode("res/Main/common/popBg/di_4.png", cc.size(480, 240))
    mid_di_1:setAnchorPoint(cc.p(0.5, 1))
    mid_di_1:setPosition(middleBg:getContentSize().width * 0.5, middleBg:getContentSize().height - 10)
    middleBg:addChild(mid_di_1)

    local mid_di_2 = zc.getScaleNode("res/Main/common/popBg/di_3.png", cc.size(460, 220))
    mid_di_2:setAnchorPoint(cc.p(0.5, 1))
    mid_di_2:setPosition(mid_di_1:getContentSize().width * 0.5, mid_di_1:getContentSize().height - 10)
    mid_di_1:addChild(mid_di_2)

    -- 头像背景
    local _icon_bg = zc.createSprite("res/Main/role/fetter/heroBg.png")
    _icon_bg:setPosition(cc.p(100, mid_di_2:getContentSize().height * 0.5))
    mid_di_2:addChild(_icon_bg)
    -- 人物头像
    local _info = {}
    local hero_id = PlayerData.info["heroId"]
    for i, v in ipairs( PlayerData:getGeneralInfo() ) do
        if tonumber( v.id ) == hero_id then
            _info = v
        end
    end
    local headIcon = zc.createIconByData({
                data = {
                    mainType = zc.mainTypeSoldier,
                    type = 1, 
                    id = _info.heroId,
                },
                showLevel = false,
                })
    headIcon:setPosition(_icon_bg:getPosition())
    mid_di_2:addChild(headIcon)

 	-- 输入框
    local box_di = zc.getScaleNode("res/Main/role/common/name_bg.png",cc.size(230,30))
    box_di:setAnchorPoint(cc.p(0, 0.5))
    box_di:setPosition(cc.p(_icon_bg:getPositionX() + _icon_bg:getContentSize().width * 0.5 + 10, _icon_bg:getPositionY() + 45))
 	mid_di_2:addChild(box_di)

    local function editBoxTextEventHandle(strEventName,sender)
        if strEventName == "began" then --编辑框开始编辑时调用
            
        elseif strEventName == "ended" then --编辑框完成时调用
            print("editBox ended!")
        elseif strEventName == "return" then --编辑框return时调用
            print("editBox return!")
        elseif strEventName == "changed" then --编辑框内容改变时调用
            print("editBox changed!")
            local txt = sender:getText()
            if txt == "" then
                self._inputBox:setPositionX(20)
                return 
            end
            local label = zc.createLabel({
                text = txt,
                })
            local input_txt_width = label:getContentSize().width
            local box_width = box_di:getContentSize().width
            local oringinX = (box_width - input_txt_width) / 2
            self._inputBox:setPositionX(oringinX)
        end
    end
    local inputBoxSize = cc.size(230, 30) 
    local inputBox = ccui.EditBox:create(inputBoxSize, "res/Main/common/img_empty.png") 
    inputBox:setContentSize(inputBoxSize)
    inputBox:setAnchorPoint(cc.p(0, 0))
    inputBox:setFontSize(20)
    inputBox:setPlaceHolder(zc.lang("tip_change_name"))
    inputBox:setMaxLength(7)
    inputBox:setPosition(cc.p(20, -2))
    inputBox:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE ) 
    inputBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
    inputBox:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    inputBox:setPlaceholderFontColor(cc.c3b(176, 176, 176))
    box_di:addChild(inputBox)
    self._inputBox = inputBox
    inputBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
    
    -- 多少天可以刷新一次
    local _refresh_tip = zc.createLabel({
    	text = "111",
    	color = cc.c3b(255, 222, 0),
    	ap = cc.p(0.5, 0.5),
    	pos = cc.p(box_di:getPositionX() + box_di:getContentSize().width * 0.5, box_di:getPositionY() - 35),
    	fontSize = 19,
    	})
    mid_di_2:addChild(_refresh_tip)
    self._refresh_tip = _refresh_tip

    local time = tonumber(PlayerData.info.editUserNameTime)
    self._isCanEdit = false
    if tonumber(time) == 0 then
        self._refresh_tip:setString(zc.lang("tip_change_name_tip"))
        self._isCanEdit = true
    else
        local _next_time = time + 3600 * 24 * 7
        _time = _next_time - tonumber(PlayerData:getTime())
        self._isCanEdit = false
        self._refresh_tip:setString(zc.getTimer(_time, 1)..zc.lang("change_name_ke"))
        schedule(self._refresh_tip, function()
                _time = _time - 1
                self._refresh_tip:setString(zc.getTimer(_time, 1) ..  zc.lang("change_name_ke"))
                if _time <= 0 then
                    self._refresh_tip:setString(zc.lang("tip_change_name_tip"))
                    self._isCanEdit = true
                end
            end, 1)
    end 

    -- 花费什么来修改
    local label_card = zc.createLabel({
        text = zc.lang("change_name_card"),
        pos = cc.p(_refresh_tip:getPositionX() - 14, _refresh_tip:getPositionY() - 35),
        color = display.COLOR_RED,
        outLine = true,
        fontSize = 22,
        })
    mid_di_2:addChild(label_card)

    local label_use = zc.createLabel({
        text = zc.lang("use"),
        ap = cc.p(1, 0.5),
        pos = cc.p(label_card:getPositionX() - label_card:getContentSize().width * 0.5, label_card:getPositionY()),
        color = cc.c3b(184, 161, 111),
        fontSize = 20,
        })
    mid_di_2:addChild(label_use)

    local label_hou = zc.createLabel({
        text = zc.lang("change_name_hou"),
        ap = cc.p(0, 0.5),
        pos = cc.p(label_card:getPositionX() + label_card:getContentSize().width * 0.5, label_card:getPositionY()),
        color = cc.c3b(184, 161, 111),
        fontSize = 20,
        })
    mid_di_2:addChild(label_hou)


    local _bottomBg = ccui.Scale9Sprite:create(cc.rect( 20, 10, 549, 71), "res/Main/role/trinket/sellDi.png")
    _bottomBg:setContentSize(_bgSize.width - 15, 100)
    _bottomBg:setAnchorPoint(cc.p(0.5, 0))
    _bottomBg:setPosition(cc.p(_bgSize.width * 0.5, 10))
    popBg:addChild(_bottomBg)

    -- 右上关闭
    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close)

    local title = zc.getTipPopTitle( "change_name" )
    title:setPosition( popBg:getContentSize().width/2, popBg:getContentSize().height-30 )
    popBg:addChild(title)
    -- 取消
    local btn_cancel = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("cancel2"),
        needSwallow = false,
        pos = cc.p(popBg:getContentSize().width/2 - 125, 60),
        ap = cc.p(0.5, 0.5),
        endCallback = function()
            self:hide()
        end
    })
    popBg:addChild(btn_cancel)
    
    -- 区分消耗改名卡或者元宝
    local _data_ = gameData.getDataFromCache("consume_price", {type = 68}) or {}
    local costNum = tostring(_data_["price"]) or 0
    self.change_card_info = PlayerData:getBagInfoByID(671) or nil
    -- 确定
    local btn_sure = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("confirm2_"),
        needSwallow = false,
        pos = cc.p(popBg:getContentSize().width/2 + 145, 60),
        ap = cc.p(0.5, 0.5),
        endCallback = function()
            if  self._isCanEdit == false then
                zc.tipInfo(zc.lang("tip_changename_4"))
                return
            end

            if self.change_card_info == nil then
                local comfirm =  ZCConfirmDialog:createWithParams({
                            title = zc.lang("tishi"),
                            msg = string.format(zc.lang("tip_buy_card"),costNum),
                            showDi = true,
                            rightCallback = function(backData)
                                zc.sendHttp({
                                apiName = "buyEditUserName",
                                params = {},
                                successCallback = function (backData)
                                    zc.tipInfo(zc.lang("tips_buy_success"))
                                    -- dump(backData, "购买改名卡接口返回：")
                                    PlayerData:updataData(backData)
                                    self.change_card_info = PlayerData:getBagInfoByID(671)
                                end,
                                }) 
                            end
                        })
                self:addChild(comfirm)
            else
                -- dump(self.change_card_info, "请求改名，改名卡信息：")
                local box_txt = inputBox:getText()
                if box_txt == "" then
                    zc.tipInfo(zc.lang("tip_changename_2"))
                else
                    zc.sendHttp({
                    apiName = "editUserName",
                    params = {userName=inputBox:getText()},
                    successCallback = function (backData)
                        zc.tipInfo(zc.lang("tip_changename_3"))
                        -- dump(backData, "修改名称接口：")
                        PlayerData:updataData(backData)
                        self:hide()
                    end,
                    }) 
                end
            end
        end
    })
    popBg:addChild(btn_sure)
    self:show()
end

function ChangeNamePop:onCleanup()
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REFRESH_NAME_SELFINFO})
end


return ChangeNamePop