--[[
    FileName: ExchangePop.lua
    Author: andong
    Date: 2016-03-17
    Purpose: 兑换码
]]
local ExchangePop = class( "ExchangePop", function ()
    return ZCPopLayer:create()
end)
function ExchangePop:create(params)
    return ExchangePop.new(params)
end
function ExchangePop:ctor(params)
    self:setOpacity(127)
    self:getContainerLayer():setTouchEndedCallback(function() end)

    local scaleSize = cc.size(400, 260)
    local popBg = zc.getScaleNode("res/Main/common/popBg/popup_Bg_blue.png", scaleSize)
    popBg:setAnchorPoint(cc.p(0.5, 0.5))
    popBg:setPosition(cc.p(zc.width/2, zc.height/2))
    self:addContent(popBg)

    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close)

    local title = zc.getTipPopTitle( "jihuomaduihuan" )
    title:setPosition( popBg:getContentSize().width/2, popBg:getContentSize().height-30 )
    popBg:addChild(title)

    local tipLab = zc.createLabel({
        text = zc.lang("enter_active_code") .. "：",
        fontSize = 24,
        ap = cc.p(0, 0),
        pos = cc.p(30, 150),
        color = cc.c3b(67, 45, 26),
    })
    popBg:addChild(tipLab)
    
    --输入框背景 
    local editSize = cc.size(283+46, 47)
    local inputBoxBg = zc.getScaleNode("res/Main/friend/edit_box.png", editSize)
    -- local inputBoxBg = cc.Sprite:create("res/Main/friend/edit_box.png")
    inputBoxBg:setAnchorPoint(0, 0)
    inputBoxBg:setPosition(30, 90)
    popBg:addChild(inputBoxBg, 2)
    --输入框 
    local _size = inputBoxBg:getContentSize()
    local editbox_account = ccui.EditBox:create(cc.size(_size.width-15, _size.height-5), ccui.Scale9Sprite:create(), nil, nil)
    editbox_account:setFontColor(display.COLOR_WHITE)
    editbox_account:setFontSize(22)
    editbox_account:setPlaceholderFont(zc.getFont(1), 22 )
    editbox_account:setPlaceHolder(zc.lang("enter_text"))-------"请输入信息")
    editbox_account:setAnchorPoint(0,0.5)
    editbox_account:setMaxLength(50)
    editbox_account:setPosition(10 , inputBoxBg:getContentSize().height*0.43)
    editbox_account:setPlaceholderFontColor(display.COLOR_BLACK)
    editbox_account:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE ) 
    editbox_account:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
    editbox_account:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    inputBoxBg:addChild(editbox_account)
    
    local comfirm = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("confirm"),
        needSwallow = false,
        pos = cc.p(popBg:getContentSize().width/2, 50),
        ap = cc.p(0.5, 0.5),
        endCallback = function()
           zc.sendHttp({
                apiName = "Exchange_code",
                params = {code=tostring(editbox_account:getText())},
                successCallback = function (net_data)
                    editbox_account:setText("")
                    zc.createShowReward({
                        clientItems = net_data.clientItems,
                        clientResources = net_data.clientResources,
                    })
                    net_data.noAnimation = true
                    PlayerData:updataData(net_data)
                end,
            })
        end
    })
    popBg:addChild(comfirm)

end

return ExchangePop