--[[
	查看属性弹窗
]]

local ViewProperties = class("ViewProperties",function()
    return ZCPopLayer:create()
end)

function ViewProperties:create(data)
    return ViewProperties.new(data)
end

function ViewProperties:ctor(data)
    self:initData(data)
    self:initUI()
end

function ViewProperties:initData( data )
	self._roleWeapons = data._roleWeapons
	self._id = data._id
	local baseInfo = PlayerData:getBaseInfo()
    local _sexId = tonumber(baseInfo["seigniorId"]) or 1
    local _initModel = {[1]="nanzhu",[2]="nvzhujue"}
    local _nowModel = _initModel[_sexId]
    self._nowModel = _nowModel --当前玩家的模型
    if _nowModel == "nanzhu" then
        zc.createArmature({fileName = "nanzhu_shan" , async = true, asyncCallback = function() end})
    elseif _nowModel == "nvzhujue" then
        zc.createArmature({fileName = "nvzhuqiang", async = true, asyncCallback = function() end})
    end

end

function ViewProperties:initUI( )
    local bg = zc.createNormalPop({
        width = 588,
        height = 410,
        src = "res/Main/common/popBg/bg4.png",
        showSide = false,
        })
	-- local bg = zc.createSprite("res/Main/common/popBg/bg4.png")
	-- bg:setPosition(cc.p(zc.width / 2, zc.height / 2))
	-- self:addContent(bg)
    bg:setPosition(cc.p(zc.width / 2, zc.height / 2))
    self:addContent(bg)

	local weaponInfo = self._roleWeapons[self._id]
	-- 动画
    local armature = zc.battle.createHeroArmature({
        fileName = self._nowModel , 
        async = true, 
        actName = "idle",
        loop = true,
        heroDataWeaponId = weaponInfo["weaponId"],
        asyncCallback = function ( _armature )
            if _armature then
                --换兵器
                _armature:getAnimation():play("idle", -1, 1)
                zc.soldierChangeWeapon(_armature, weaponInfo["weaponId"])
            end
        end,
    })
    armature:setScaleX( -1.0 )
    armature:setPosition(cc.p(150, 150))
    bg:addChild(armature)


    -------------------------
    -----------------------
    self._skillItemList = {}
    self._effectBgList = {}
    self._costItemList = {}
    ------------------------------
    --技能
    local skilltitle = zc.createSprite("res/Main/smithy/shenbing/skilltitle.png")
    skilltitle:setPosition(418, 340)
    bg:addChild(skilltitle)
    self._skillMiddlePos = cc.p(426, 270) --技能中间位置
    self._skillNums = 3
    self._skillDistance = 105
    local skillPos = zc.sortFromMiddle( self._skillMiddlePos, self._skillNums, self._skillDistance )


    for i = 1, 3 do
        local item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSkill,
                type = 1, 
                id = 1,
            }, 
            pos = skillPos[i], 
        })
        item:setScale(0.7)
        bg:addChild(item)
        self._skillItemList[#self._skillItemList+1] = item

        local bisha = zc.createSprite("res/Main/pub/critical.png")
        bisha:setAnchorPoint(0.5, 1)
        bisha:setPosition( item:getContentSize().width/2 , 10 )
        item:addChild(bisha)
        item.bisha = bisha
    end

    --属性背景
    local attrtitle = zc.createSprite("res/Main/smithy/shenbing/attrtitle.png")
    attrtitle:setPosition(418, 190)
    bg:addChild(attrtitle)
    local _attrInfoBg = ccui.Scale9Sprite:create( cc.rect( 11, 10, 30, 30 ), "res/Main/common/img_empty.png" )
    _attrInfoBg:setContentSize( cc.size(300, 150) )
    _attrInfoBg:setAnchorPoint( 0.5, 0 )
    _attrInfoBg:setPosition( bg:getContentSize().width/2, 160 )
    bg:addChild( _attrInfoBg )

    local posDis = _attrInfoBg:getContentSize().width / 2
    for i = 1, 6 do
        local modI = i <= 2 and (i-1) or ((i-1)%2)
        local posX = 125 + posDis*modI
        local posY = -15 - 42*( math.floor((i-1)/2) )
        local effectBg = zc.getScaleNode("res/Main/smithy/attribute_di.png", cc.size(140, 33))
        effectBg:setAnchorPoint(cc.p(0, 0.5))
        effectBg:setPosition(posX,posY)
        _attrInfoBg:addChild(effectBg)
        self._effectBgList[#self._effectBgList+1] = effectBg
        local _effecttext = zc.createLabel({
            fontSize = 20,
            color = cc.c3b(255,198,57),
            outLine = true,
        })
        _effecttext:enableOutline(cc.c4b(112,42,42, 255), 2)
        _effecttext:setAnchorPoint(0, 0.5)
        _effecttext:setPosition( cc.p(8, effectBg:getContentSize().height/2) )
        effectBg:addChild(_effecttext)
        local _valueLabel = zc.createLabel({
            fontSize = 18,
            ap = cc.p(1, 0.5),
            pos = cc.p(effectBg:getContentSize().width-8,effectBg:getContentSize().height/2),
            outLine = true,
            color = display.COLOR_GREEN
        })
        effectBg:addChild(_valueLabel)
        effectBg._effect = _effecttext
        effectBg._effectValue = _valueLabel
    end

    -- 神兵特性text
    local _shengbingtexing_txt = zc.createSprite("res/Main/smithy/shenbing/shenbingtexing.png")
    _shengbingtexing_txt:setPosition(cc.p(150, 110))
    bg:addChild(_shengbingtexing_txt)

    -- 武器的描述
    local _weaponId_chushi = tonumber(weaponInfo["weaponId"])
    local descInfo = gameData.getDataFromCacheWithPrimaryKey("weapon", _weaponId_chushi).desc
    -- descInfo = "阿里的房间辣坚实的疯狂拉升剪短发的类似飞机啊两地分居拉丝机打发第三方就拉屎的附加按时间段发牢骚"
    local describe = zc.createLabel({
        text = descInfo,
        width = 520,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(bg:getContentSize().width / 2, 45),
        fontSize = 18,
        color = cc.c3b(214,193,150),
        align = cc.TEXT_ALIGNMENT_LEFT,
        })
    bg:addChild(describe)

    self:refreshAttributeState(weaponInfo)
    self:refresSkillState(weaponInfo)
end
--设置属性状态
function ViewProperties:refreshAttributeState(weaponInfo)
    local attributeInfo = {}
    if weaponInfo["ISOPEN"] then
        for i = 1, 6 do
            -- print("weaponInfo[effectInfo..i] ",weaponInfo["effectInfo"..i],weaponInfo["effectInfo"..i]["effectId"])
            if weaponInfo["effectInfo"..i] and weaponInfo["effectInfo"..i]["effectId"] then
                local idx = #attributeInfo + 1
                attributeInfo[idx] = {}
                attributeInfo[idx].effectId = weaponInfo["effectInfo"..i]["effectId"]
                attributeInfo[idx].effectValue = weaponInfo["effectValue"..i]
            end
        end
    else

        local attrInfo = gameData.getDataFromCache("weapon_effect", {weaponId=weaponInfo["weaponId"]} )
        if attrInfo and attrInfo["effectId"] then
            attrInfo = {attrInfo}
        end
        for i = 1, table.nums(attrInfo) do
            attributeInfo[i] = {}
            attributeInfo[i].effectId = attrInfo[i]["effectId"]
            attributeInfo[i].effectValue = attrInfo[i]["valueMin"] --基础值下限
        end
    end
    for i = 1, 6 do
        local effectBg = self._effectBgList[i]
        local v = attributeInfo[i]
        if v and v["effectId"] then
            effectBg:setVisible(true)
            local effect = effectBg._effect
            local effectValue = effectBg._effectValue
            local effectStr = LANGUAGE_getAttributeTextById(v["effectId"])
            local effectNum = zc.getAttributeNumById( v["effectId"], v["effectValue"])

            effect:setString(effectStr..":")
            effectValue:setString("+"..effectNum)
        else
            effectBg:setVisible(false)
        end
    end
end

--设置技能状态
function ViewProperties:refresSkillState(weaponInfo)
    local skillInfo = self:getSkllInfo(weaponInfo)
    local skillPos = zc.sortFromMiddle( self._skillMiddlePos, #skillInfo, self._skillDistance )
    for i = 1, #self._skillItemList do
        local skillItem = self._skillItemList[i]
        if i <= #skillInfo then
            skillItem:setVisible(true)
            local newParmas = {
                data = {
                    mainType = zc.mainTypeSkill,
                    type = 1, 
                    id = skillInfo[i].skillid,
                }, 
                pos = skillPos[i], 
                listener = function ()
                    zc.createSkillInfoPop({id = skillInfo[i].skillid, level=skillInfo[i].skillLevel})
                end
            }
            zc.updateIconByData(skillItem,newParmas)

            if skillInfo[i].isBisha then
                skillItem.bisha:setVisible(true)
            else
                skillItem.bisha:setVisible(false)
            end
        else
            skillItem:setVisible(false)
        end
    end
end

function ViewProperties:getSkllInfo(weaponInfo)
    local skillInfo = {}
    if weaponInfo["ISOPEN"] then
        for i = 1, 3 do
            if weaponInfo["commonSkillId"..i] and tonumber(weaponInfo["commonSkillId"..i]) > 0 then
                local static = gameData.getDataFromCacheWithPrimaryKey("skill", weaponInfo["commonSkillId"..i] )
                if static["subType"] and tonumber(static["subType"]) ~= 1 then
                    local idx = #skillInfo + 1
                    skillInfo[idx] = {}
                    skillInfo[idx].skillid = tonumber(weaponInfo["commonSkillId"..i])
                    skillInfo[idx].skillname = static["name"] or ""
                    skillInfo[idx].skillLevel = tonumber(weaponInfo["commonSkillLevel"..i])
                    skillInfo[idx].isBisha = false
                end
            end
        end
        if tonumber(weaponInfo["moraleSkillId"]) ~= 0 then 
            local _data = gameData.getDataFromCacheWithPrimaryKey("skill", weaponInfo["moraleSkillId"])
            if next(_data) ~= nil then
                local idx = #skillInfo + 1
                skillInfo[idx] = {}
                skillInfo[idx].skillid = tonumber(weaponInfo["moraleSkillId"])
                skillInfo[idx].skillname = _data["name"] or ""
                skillInfo[idx].skillLevel = tonumber(weaponInfo["moraleSkillLevel"])
                skillInfo[idx].isBisha = true
            end
        end
    else
        if not weaponInfo["skillInfo"] then
            skillInfo[1] = {}
            local static = gameData.getDataFromCache("weapon_skill", {weaponId=weaponInfo["weaponId"]} )
            if static then 
                skillInfo[1].skillid = static["skillId"]
                local skilldata = gameData.getDataFromCacheWithPrimaryKey("skill", static["skillId"])
                -- dump(skilldata, "skilldata = ")
                skillInfo[1].skillname = skilldata["name"] or ""
                skillInfo[1].skillLevel = 0
                skillInfo[1].isBisha = false

            end
            if tonumber(weaponInfo["moraleSkillId"]) ~= 0 then 
                local _data = gameData.getDataFromCacheWithPrimaryKey("skill", weaponInfo["moraleSkillId"])
                if next(_data) ~= nil then
                    local idx = #skillInfo + 1
                    skillInfo[idx] = {}
                    skillInfo[idx].skillid = tonumber(weaponInfo["moraleSkillId"])
                    skillInfo[idx].skillname = _data["name"] or ""
                    skillInfo[idx].skillLevel = 0
                    skillInfo[idx].isBisha = true
                end
            end
            weaponInfo["skillInfo"] = skillInfo
        else
            skillInfo = weaponInfo["skillInfo"]
        end
    end
    return skillInfo
end
return ViewProperties