--[[
    FileName: RewardPreviewPop.lua
    Author: lipenghan
    Date: 2016-05-31
    Purpose: 奖励预览
]]
local RewardPreviewPop = class( "RewardPreviewPop", function ()
    return ZCPopLayer:create()
end)
function RewardPreviewPop:create(params)
    return self.new(params)
end
function RewardPreviewPop:ctor(params)
    -- dump(params, "params=====")
    self:initData(params)
    self:initUI()
    self:show()
end
function RewardPreviewPop:initData(params)
    self._callback = params.callback
    self._rewardData = string.split(params.award, ",") 

end
function RewardPreviewPop:initUI()
    local popBg = cc.Sprite:create("res/Main/wushenTower/pop_reward.png")
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    self._popBg = popBg
    -- local close = zc.createBackButton({
    --     pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
    --     listener = function () 
    --         self:hide()
    --     end,
    -- })
    -- popBg:addChild(close)

    local closeBtn = zc.createCommomBtn({
        tag = 1,
        btnText = zc.lang("close2"),
        needSwallow = false,
        endCallback = function()
            self:hide()
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(popBg:getContentSize().width/2, 70)
    })
    popBg:addChild(closeBtn)

    self:createTableView()
end
function RewardPreviewPop:createTableView()
    local tableSize = cc.size(435, 200)
    local tableNode = self._popBg
    local myTableBg = ccui.Scale9Sprite:create(cc.rect(26,25,1,1), "res/Main/wushenTower/pop_tableBg.png")
    myTableBg:setContentSize(435, 140)
    myTableBg:setAnchorPoint(cc.p(0.5, 0.5))
    myTableBg:setPosition(cc.p(tableNode:getContentSize().width/2, tableNode:getContentSize().height/2 + 20))
    tableNode:addChild(myTableBg)

    local _widthMax = 435
    local _realWidth = #self._rewardData * 125 or 0

    local _canBounce = false
    if _realWidth >= _widthMax then
        _realWidth = _widthMax
        _canBounce = true
    end

    local myTable = zc.ZCTableView:create(cc.size(_realWidth, 140))
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(_canBounce)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_HORIZONTAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setAnchorPoint(cc.p(0.5,0))
    myTable:setPosition(_widthMax/2,2)
    myTable:ignoreAnchorPointForPosition(false)
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    
    myTableBg:addChild(myTable)
    
    local function cellSizeForTable(table,idx)
        return 140, 125
    end
    local function numberOfCellsInTableView(table)
        return #self._rewardData
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(125, 140))
        else
            cell:removeAllChildren()
        end
        self:updateCell(cell, nowIdx)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    
    myTable:reloadData()
end

function RewardPreviewPop:updateCell(cell, indx)
    local cellData = self._rewardData[indx]
    -- dump(cellData, "cellData =================== ")
    -- local cellImg = cc.Sprite:create("res/Main/wushenTower/pop_cell_img.png")
    -- cellImg:setAnchorPoint(0.5, 0.5)
    -- cellImg:setPosition(cell:getContentSize().width/2, cell:getContentSize().height/2)
    -- cell:addChild(cellImg)
    local cellSize = cell:getContentSize()
    
    -- local name = zc.createLabel({
    --     text = "奖励 "..indx,
    --     outLine = true,
    --     fontSize = 30,
    --     fontName = zc.getFont(1),
    --     ap = cc.p(0.5, 0.5),
    --     pos = cc.p(100, cellSize.height/2 ),
    --     color = display.COLOR_WHITE,
    --     color2 = display.COLOR_BLACK,
    --     align = kCCTextAlignmentCenter,
    --     pixel = 1.3
    -- })
    -- cellImg:addChild(name)
    local reward = string.split(cellData, "|")
    local item, info = zc.createIconByData({
        data = {
            mainType = reward[1],
            type = reward[2], 
            id = reward[2],
            num = reward[3],
        }, 
        pos = cc.p(cellSize.width/2, cellSize.height/2), 
    })
    item:setTouchEndedShowTip(true)
    item:setScale(100/120)
    cell:addChild(item)

end

function RewardPreviewPop:onEnter()
end
function RewardPreviewPop:onCleanup()
end
function RewardPreviewPop:onExit()
end

return RewardPreviewPop