--[[
铁匠铺返还
wcc
smithyRebatesPop
]]

local smithyRebatesPop = class("smithyRebatesPop",function()
    return ZCPopLayer:create()
end);

function smithyRebatesPop:create(data)
    self._data = data.data
    self._coin = tonumber(data.coin) - tonumber(PlayerData.resourcesInfo.money)
    if self._coin > 0 then
        self._data[#self._data + 1] = {type = 1, itemId = 2, changeNum = self._coin}
    end

    local layer = self.new(data)
    return layer
end

function smithyRebatesPop:ctor(data)
	self:initUI()
    self:show()
end
function smithyRebatesPop:initUI()
	local bg =  zc.createScale9Sprite({
		file = "res/Main/common/common_inner17.png",
        size = cc.size(420, 260),
        pos = cc.p(zc.width/2, zc.height/2),
    })
	self:addChild(bg)
	self.bg = bg
    local name =  zc.createLabel({
        text = zc.lang("back_pay"),
        fontSize = 28,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(bg:getContentSize().width/2, 220),
        shadow = true,
        color = display.COLOR_YELLOW
    })
    bg:addChild(name)

    local itemsNum = #self._data
    local itemScrollview = zc.createScrollview({
        pos = cc.p(10, 90),
        size = cc.size(400, 110),
        innerSize = cc.size(100*itemsNum, 110),
        dir = ccui.ScrollViewDir.horizontal,
        bar = true,
        bounceEnable = true,
    })
    bg:addChild(itemScrollview)
    for i=1, itemsNum do 
        local iconcolor = PlayerData:getBagDBInfoByID(self._data[i].itemId).color or 1
        local item = zc.createIconByData({
            data = {
                mainType = self._data[i].type,
                type = self._data[i].itemId,
                id = self._data[i].itemId,
                num = self._data[i].changeNum,
                quality = iconcolor
            }, 
            pos = cc.p(100*(i - 1/2), 55), 
        })
        item:setScale(0.75)
        itemScrollview:addChild(item)
    end
   
	local Btn = zc.createCommomBtn({
        tag = 1,
	    pos = cc.p(bg:getContentSize().width/2, 45), 
	    text = zc.lang("confirm"),
	    listener = function () 
            self:hide()
	    end,
	})
	bg:addChild(Btn)
end

return smithyRebatesPop